-- hds header_start
--
-- VHDL Entity TIM_fft.basictfb_big.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:01:34 02/12/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity basictfb_big is
   port( 
      Reg3A      : in     std_logic;
      Reg3C      : in     std_logic;
      Reg3E      : in     std_logic;
      clk        : in     std_logic;
      rst        : in     std_logic;
      trig_OA_i  : in     std_logic;
      vmeRD      : in     std_logic;
      vmeWR      : in     std_logic;
      freqbusy_o : out    std_logic;
      db         : inout  std_logic_vector (15 downto 0)
   );

-- Declarations

end basictfb_big ;

-- hds interface_end
--
-- VHDL Architecture TIM_fft.basictfb_big.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:01:34 02/12/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library TIM_fft;

architecture struct of basictfb_big is

   -- Architecture declarations

   -- Internal signal declarations
   signal TFB_Control         : std_logic_vector(15 downto 0);
   signal TFB_DetectWindow    : std_logic_vector(15 downto 0);
   signal TFB_Duration        : std_logic_vector(15 downto 0);
   signal busy_duration       : std_logic_vector(25 downto 0);
   signal period_match_mask   : std_logic_vector(15 downto 0);
   signal period_match_thresh : std_logic_vector(5 downto 0);
   signal period_max          : std_logic_vector(15 downto 0);
   signal period_min          : std_logic_vector(15 downto 0);


   -- Component Declarations
   component basictfb
   port (
      rst                   : in     std_logic ;
      clk                   : in     std_logic ;
      trig_i                : in     std_logic ;
      busy_o                : out    std_logic ;
      period_min_i          : in     std_logic_vector ;
      period_max_i          : in     std_logic_vector ;
      period_match_mask_i   : in     std_logic_vector ;
      period_match_thresh_i : in     std_logic_vector ;
      busy_duration_i       : in     std_logic_vector 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : basictfb use entity TIM_fft.basictfb;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 interface_and_control
   -- Bits    Clocks       Period(ns)       Freq(Hz)
   --  1             2               50      20,000,000
   --  2             4              100      10,000,000
   --  3             8              200       5,000,000
   --  4            16              400       2,500,000
   --  5            32              800       1,250,000
   --  6            64             1600           625,000
   --  7           128             3200           312,500
   --  8           256             6400           156,250
   --  9           512            12800            78,125
   -- 10          1024            25600            39,062.5
   -- 11          2048            51200            19,531.3
   -- 12          4096           102400             9,765.6
   -- 13          8192           204800             4,882.8
   -- 14         16384           409600             2,441.4
   -- 15         32768           819200             1,220.7
   -- 16         65536          1638400             610.4
   -- 17        131072          3276800             305.1
   -- 18        262144          6553600             152.5
   -- 19        524288         13107200              76.2
   -- 20       1048576         26214400              38.1
   -- 21       2097152         52428800              19.0
   -- 22       4194304        104857600               9.5
   -- 23       8388608        209715200               4.7
   -- 24      16777216        419430400               2.3
   -- 25      33554432        838860800               1.1
   -- 26      67108864       1677721600               0.6
   
   
   
      ------------------------------------------------------------
      period_min(15 downto 13) <= "000";
      period_min(12 downto 5) <= TFB_DetectWindow(15 downto 8);
      period_min( 4 downto 0) <= "00000";
   
      period_max(15 downto 13) <= "000";
      period_max(12 downto 5) <= TFB_DetectWindow( 7 downto 0);
      period_max( 4 downto 0) <= "11111";
   
   
      
      
   
                             
      ------------------------------------------------------------
      period_match_mask(15 downto 8) <= "11111111";
      period_match_mask( 7 downto 0) <= TFB_Control(15 downto 8); 
   
      period_match_thresh <= TFB_Control(5 downto 0);                         
      
   
      
      ------------------------------------------------------------
      busy_duration(25 downto 10) <= TFB_Duration; 
      busy_duration( 9 downto  0) <= "0000000000";      
   
   
   
   
   
      --   Registers
      ----------------------------------------------------
   
       -- 3A - TFB Control
       --      (15:8)  Period Count LSB Mask - Slop Factor!
       --      (5:0) - Repetition Count 
       --
      --   3C - TFB Detect Window
      --      (15:9)  Min Period Count (in  32-clock units) [=p_count (12:5) ]
       --       (8:0)  Max Period Count (in  32-clock units) [=p_count (12:5) ]
   
       --
      -- 3E - TFB Duration
      --      (15:0) TFBusy Pulse width (in 1024-clock units)
   
   
      process (rst, clk)
      begin
         if rising_edge(clk) then
         
            if   (rst = '1') then                       -- Defaults:
               TFB_Control       <= "1111111000001001"; -- lsb slop, 9 count busy
               TFB_DetectWindow    <= "0000000011111111"; -- All
               TFB_Duration       <= "0000000000000100"; -- 4 clk busy duration
      
            else 
               if      (Reg3A and vmeWR)   = '1'   then
                  TFB_Control <= db;
      
               elsif   (Reg3C and vmeWR)   = '1'   then
                  TFB_DetectWindow <= db;
      
               elsif   (Reg3E and vmeWR)   = '1'   then
                  TFB_Duration <= db;
      
               end if;
            end if;
         end if;
      end process;
   
   
      --   Data Bus
      ----------------------------------------------------
   
      db <= TFB_Control       when ((Reg3A and vmeRD) = '1') else
            TFB_DetectWindow  when ((Reg3C and vmeRD) = '1') else
             TFB_Duration       when ((Reg3E and vmeRD) = '1') else  
             (others => 'Z');

   -- Instance port mappings.
   I0 : basictfb
      port map (
         rst                   => rst,
         clk                   => clk,
         trig_i                => trig_OA_i,
         busy_o                => freqbusy_o,
         period_min_i          => period_min,
         period_max_i          => period_max,
         period_match_mask_i   => period_match_mask,
         period_match_thresh_i => period_match_thresh,
         busy_duration_i       => busy_duration
      );

end struct;
