-- hds header_start
--
-- VHDL Entity TIM_fft.basictfb_sml.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:02:20 02/12/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity basictfb_sml is
   port( 
      clk    : in     std_logic;
      rst    : in     std_logic;
      trig_i : in     std_logic;
      busy_o : out    std_logic
   );

-- Declarations

end basictfb_sml ;

-- hds interface_end
--
-- VHDL Architecture TIM_fft.basictfb_sml.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:02:20 02/12/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library TIM_fft;

architecture struct of basictfb_sml is

   -- Architecture declarations

   -- Internal signal declarations
   signal busy_duration       : std_logic_vector(25 downto 0);
   signal period_match_mask   : std_logic_vector(15 downto 0);
   signal period_match_thresh : std_logic_vector(5 downto 0);
   signal period_max          : std_logic_vector(15 downto 0);
   signal period_min          : std_logic_vector(15 downto 0);


   -- Component Declarations
   component basictfb
   port (
      rst                   : in     std_logic ;
      clk                   : in     std_logic ;
      trig_i                : in     std_logic ;
      busy_o                : out    std_logic ;
      period_min_i          : in     std_logic_vector ;
      period_max_i          : in     std_logic_vector ;
      period_match_mask_i   : in     std_logic_vector ;
      period_match_thresh_i : in     std_logic_vector ;
      busy_duration_i       : in     std_logic_vector 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : basictfb use entity TIM_fft.basictfb;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 control_constants
   -- Integers in 25ns units
   period_min          <= CONV_STD_LOGIC_VECTOR( 400, 16); -- 100kHz
   period_max          <= CONV_STD_LOGIC_VECTOR(1000, 16); -- 40khz
   period_match_thresh <= CONV_STD_LOGIC_VECTOR(   4,  6);
   busy_duration       <= CONV_STD_LOGIC_VECTOR(1000, 26); -- 40000000 = 1s
   
   -- Binary
   period_match_mask   <= "1111111111111000";

   -- Instance port mappings.
   I0 : basictfb
      port map (
         rst                   => rst,
         clk                   => clk,
         trig_i                => trig_i,
         busy_o                => busy_o,
         period_min_i          => period_min,
         period_max_i          => period_max,
         period_match_mask_i   => period_match_mask,
         period_match_thresh_i => period_match_thresh,
         busy_duration_i       => busy_duration
      );

end struct;
