-- hds header_start
--
-- VHDL Entity TIM_fftv.fftv_main_tb.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 18:00:03 05/23/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end


entity fftv_main_tb is
-- Declarations

end fftv_main_tb ;

-- hds interface_end
--
-- VHDL Architecture TIM_fftv.fftv_main_tb.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 18:00:03 05/23/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.ALL;

library TIM_fftv;

architecture struct of fftv_main_tb is

   -- Architecture declarations

   -- Internal signal declarations
   signal clk40                 : std_logic;
   signal fftv_busy_o           : std_logic;
   signal fftv_count            : std_logic_vector(19 downto 0);
   signal fftv_count_clr_i      : std_logic;
   signal fftv_count_rollover_o : std_logic;
   signal fftv_disable_i        : std_logic;
   signal fftv_emergency_clr_i  : std_logic;
   signal fftv_emergency_o      : std_logic;
   signal fftv_id               : std_logic_vector(4 downto 0);
   signal fftv_id_clr_i         : std_logic;
   signal fftv_id_rollover_o    : std_logic;
   signal fftv_match_lvl_i      : std_logic_vector(3 downto 0);
   signal fftv_match_lvl_o      : std_logic_vector(3 downto 0);
   signal rst                   : std_logic;
   signal trigger_i             : std_logic;
   signal trigger_o             : std_logic;


   -- Component Declarations
   component fftv_main
   generic (
      ROD_TRIGGER_MODE : std_logic := '1';
      COUNT_WIDTH      : integer   := 24;
      ID_WIDTH         : integer   := 8;
      PERIOD_MIN       : integer   := 80;
      PERIOD_MAX       : integer   := 2666;
      PERIOD_OVERFLOW  : integer   := 3076;
      PERIOD_DELTAT    : integer   := 40;
      VETO_DURATION    : integer   := 40000
   );
   port (
      rst                   : in     std_logic ;
      clk40                 : in     std_logic ;
      fftv_match_lvl_i      : in     std_logic_vector (3 downto 0);
      fftv_match_lvl_o      : out    std_logic_vector (3 downto 0);
      fftv_count_o          : out    std_logic_vector ((COUNT_WIDTH-1) downto 0);
      fftv_count_clr_i      : in     std_logic ;
      fftv_count_rollover_o : out    std_logic ;
      fftv_id_o             : out    std_logic_vector ((ID_WIDTH-1) downto 0);
      fftv_id_clr_i         : in     std_logic ;
      fftv_id_rollover_o    : out    std_logic ;
      fftv_emergency_o      : out    std_logic ;
      fftv_emergency_clr_i  : in     std_logic ;
      trigger_i             : in     std_logic ;
      trigger_o             : out    std_logic ;
      fftv_busy_o           : out    std_logic ;
      fftv_disable_i        : in     std_logic 
   );
   end component;
   component fftv_main_tester
   generic (
      ROD_TRIGGER_MODE : std_logic := '0'
   );
   port (
      fftv_busy_o          : in     std_logic ;
      fftv_emergency_o     : in     std_logic ;
      trigger_o            : in     std_logic ;
      clk40                : out    std_logic ;
      fftv_count_clr_i     : out    std_logic ;
      fftv_disable_i       : out    std_logic ;
      fftv_emergency_clr_i : out    std_logic ;
      fftv_id_clr_i        : out    std_logic ;
      fftv_match_lvl_i     : out    std_logic_vector (3 downto 0);
      rst                  : out    std_logic ;
      trigger_i            : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : fftv_main use entity TIM_fftv.fftv_main;
   for all : fftv_main_tester use entity TIM_fftv.fftv_main_tester;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   fftv_main_1 : fftv_main
      generic map (
         ROD_TRIGGER_MODE => '1',
         COUNT_WIDTH      => 20,
         ID_WIDTH         => 5,
         PERIOD_MIN       => 80,
         PERIOD_MAX       => 2666,
         PERIOD_OVERFLOW  => 3076,
         PERIOD_DELTAT    => 40,
         VETO_DURATION    => 40000
      )
      port map (
         rst                   => rst,
         clk40                 => clk40,
         fftv_match_lvl_i      => fftv_match_lvl_i,
         fftv_match_lvl_o      => fftv_match_lvl_o,
         fftv_count_o          => fftv_count(19 DOWNTO 0),
         fftv_count_clr_i      => fftv_count_clr_i,
         fftv_count_rollover_o => fftv_count_rollover_o,
         fftv_id_o             => fftv_id,
         fftv_id_clr_i         => fftv_id_clr_i,
         fftv_id_rollover_o    => fftv_id_rollover_o,
         fftv_emergency_o      => fftv_emergency_o,
         fftv_emergency_clr_i  => fftv_emergency_clr_i,
         trigger_i             => trigger_i,
         trigger_o             => trigger_o,
         fftv_busy_o           => fftv_busy_o,
         fftv_disable_i        => fftv_disable_i
      );
   fftv_main_tester_1 : fftv_main_tester
      generic map (
         ROD_TRIGGER_MODE => '1'
      )
      port map (
         fftv_busy_o          => fftv_busy_o,
         fftv_emergency_o     => fftv_emergency_o,
         trigger_o            => trigger_o,
         clk40                => clk40,
         fftv_count_clr_i     => fftv_count_clr_i,
         fftv_disable_i       => fftv_disable_i,
         fftv_emergency_clr_i => fftv_emergency_clr_i,
         fftv_id_clr_i        => fftv_id_clr_i,
         fftv_match_lvl_i     => fftv_match_lvl_i,
         rst                  => rst,
         trigger_i            => trigger_i
      );

end struct;
