-- hds header_start
--
-- VHDL Entity TIM_fftv.fftv_tim.symbol
--
-- Created:
--          by - warren.UNKNOWN (POSITRON)
--          at - 16:39:01 10/23/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;


entity fftv_tim is
   port( 
      clk                   : in     std_logic;
      fftv_disable_link     : in     std_logic;
      fftv_emergency_clr_i  : in     std_logic;
      fv_disable_i          : in     std_logic;
      l1a_fast_i            : in     std_logic;
      l1a_i                 : in     std_logic;
      reg_fftv_p_deltat_i   : in     std_logic_vector (15 downto 0);
      reg_fftv_p_max_i      : in     std_logic_vector (15 downto 0);
      reg_fftv_p_min_i      : in     std_logic_vector (15 downto 0);
      reg_fftv_p_oflow_i    : in     std_logic_vector (15 downto 0);
      reg_fftv_vetolen_i    : in     std_logic_vector (15 downto 0);
      reg_fv_count_clr_i    : in     std_logic;
      reg_fv_id_clr_i       : in     std_logic;
      reg_fv_match_i        : in     std_logic_vector (15 downto 0);
      rst                   : in     std_logic;
      fftv_busy_o           : out    std_logic;
      fftv_count_rollover_o : out    std_logic;
      fftv_emergency_o      : out    std_logic;
      fftv_id_rollover_o    : out    std_logic;
      fv_matchlvl_o         : out    std_logic_vector (3 downto 0);
      l1a_fast_o            : out    std_logic;
      l1a_o                 : out    std_logic;
      reg_fv_count_o        : out    std_logic_vector (47 downto 0);
      reg_fv_id_o           : out    std_logic_vector (31 downto 0)
   );

-- Declarations

end fftv_tim ;

-- hds interface_end
--
-- VHDL Architecture TIM_fftv.fftv_tim.struct
--
-- Created:
--          by - warren.UNKNOWN (POSITRON)
--          at - 16:39:02 10/23/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.ALL;

library TIM_fftv;
library TIM_lib;

architecture struct of fftv_tim is

   -- Architecture declarations

   -- Internal signal declarations
   signal fftv_active_n : std_logic;
   signal fftv_disable  : std_logic;
   signal reg_fv_match  : std_logic_vector(15 downto 0);

   -- Implicit buffer signal declarations
   signal fftv_emergency_o_internal : std_logic;


   -- Component Declarations
   component fftv_main
   generic (
      ROD_TRIGGER_MODE : std_logic := '1';
      COUNT_WIDTH      : integer   := 24;
      ID_WIDTH         : integer   := 8;
      PERIOD_MIN       : integer   := 85;
      PERIOD_MAX       : integer   := 2666;
      PERIOD_OVERFLOW  : integer   := 3076;
      PERIOD_DELTAT    : integer   := 40;
      VETO_DURATION    : integer   := 40000
   );
   port (
      rst                   : in     std_logic ;
      clk40                 : in     std_logic ;
      fftv_match_lvl_i      : in     std_logic_vector (3 downto 0);
      fftv_match_lvl_o      : out    std_logic_vector (3 downto 0);
      fftv_count_o          : out    std_logic_vector ((COUNT_WIDTH-1) downto 0);
      fftv_count_clr_i      : in     std_logic ;
      fftv_count_rollover_o : out    std_logic ;
      fftv_id_o             : out    std_logic_vector ((ID_WIDTH-1) downto 0);
      fftv_id_clr_i         : in     std_logic ;
      fftv_id_rollover_o    : out    std_logic ;
      fftv_emergency_o      : out    std_logic ;
      fftv_emergency_clr_i  : in     std_logic ;
      trigger_i             : in     std_logic ;
      trigger_o             : out    std_logic ;
      fftv_busy_o           : out    std_logic ;
      fftv_disable_i        : in     std_logic 
   );
   end component;
   component m_and2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_buff16
   port (
      I : in     std_logic_vector (15 downto 0);
      O : out    std_logic_vector (15 downto 0)
   );
   end component;
   component m_inv
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : fftv_main use entity TIM_fftv.fftv_main(rtl);
   for all : m_and2 use entity TIM_lib.m_and2(rtl);
   for all : m_buff16 use entity TIM_lib.m_buff16(rtl);
   for all : m_inv use entity TIM_lib.m_inv(rtl);
   -- exemplar synthesis_on


begin
   -- Instance port mappings.
   fftv_main_1 : fftv_main
      generic map (
         ROD_TRIGGER_MODE => '0',
         COUNT_WIDTH      => 48,
         ID_WIDTH         => 32,
         PERIOD_MIN       => 85,
         PERIOD_MAX       => 2666,
         PERIOD_OVERFLOW  => 3076,
         PERIOD_DELTAT    => 40,
         VETO_DURATION    => 40000
      )
      port map (
         rst                   => rst,
         clk40                 => clk,
         fftv_match_lvl_i      => reg_fv_match(3 DOWNTO 0),
         fftv_match_lvl_o      => fv_matchlvl_o,
         fftv_count_o          => reg_fv_count_o,
         fftv_count_clr_i      => reg_fv_count_clr_i,
         fftv_count_rollover_o => fftv_count_rollover_o,
         fftv_id_o             => reg_fv_id_o,
         fftv_id_clr_i         => reg_fv_id_clr_i,
         fftv_id_rollover_o    => fftv_id_rollover_o,
         fftv_emergency_o      => fftv_emergency_o_internal,
         fftv_emergency_clr_i  => fftv_emergency_clr_i,
         trigger_i             => l1a_i,
         trigger_o             => l1a_o,
         fftv_busy_o           => fftv_busy_o,
         fftv_disable_i        => fftv_disable
      );
   I0 : m_and2
      port map (
         I1 => fv_disable_i,
         I2 => fftv_disable_link,
         O  => fftv_disable
      );
   I1 : m_and2
      port map (
         I1 => fftv_active_n,
         I2 => l1a_fast_i,
         O  => l1a_fast_o
      );
   I3 : m_buff16
      port map (
         I => reg_fv_match_i,
         O => reg_fv_match
      );
   I2 : m_inv
      port map (
         I => fftv_emergency_o_internal,
         O => fftv_active_n
      );

   -- Implicit buffered output assignments
   fftv_emergency_o <= fftv_emergency_o_internal;

end struct;
