-- hds header_start
--
-- VHDL Entity TIM_fft.freqbusy.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 23:50:19 02/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

-- -----------------------------------------------------------------------------
--    ENTITY
-- -----------------------------------------------------------------------------
-- 
entity freqbusy is
   port( 
      reset      : in     std_logic;
      clk        : in     std_logic;
      db         : inout  std_logic_vector (15 downto 0);
      vmeRD      : in     std_logic;
      vmeWR      : in     std_logic;
      Reg3A      : in     std_logic;
      Reg3C      : in     std_logic;
      Reg3E      : in     std_logic;
      trig_OA_i  : in     std_logic;
      
      --  Spare Signals
      DebugBus   : out    std_logic_vector (15 downto 0);
      freqbusy_o : out    std_logic
   );

-- Declarations

end freqbusy ;

-- hds interface_end
architecture rtl of freqbusy is

-------------------------------------------------------------------------------
--	SIGNAL DECLARATIONS
-------------------------------------------------------------------------------

	signal TFB_Control 			: std_logic_vector(15 downto 0);
	signal TFB_DetectWindow 	: std_logic_vector(15 downto 0);
	signal TFB_Duration 			: std_logic_vector(15 downto 0);




	
	signal p_buffer  				: std_logic_vector(15 downto 0);
	
	signal p_count  				: std_logic_vector(15 downto 0);
	signal p_count_max			: std_logic_vector(15 downto 0);
	signal p_count_min			: std_logic_vector(15 downto 0);
	signal p_under					: std_logic;
	signal p_over					: std_logic;
	
	signal p_match_mask			: std_logic_vector(15 downto 0);
	signal p_match					: std_logic;
	
	signal p_match_count 		: std_logic_vector(5 downto 0);
	signal p_match_count_max	: std_logic_vector(5 downto 0);


	
	signal trig						: std_logic;
	signal tfbusy_set				: std_logic;
	
	signal tfbusy					: std_logic;
	signal tfbusy_count			: std_logic_vector(25 downto 0);
	
	
	--constant P_MATCH_COUNT_MAX : std_logic_vector(3 downto 0) := "1001";	


-------------------------------------------------------------------------------
--	MAIN CODE
-------------------------------------------------------------------------------
begin

-- Bits    Clocks		 Period(ns)	    Freq(Hz)
--  1			    2					50		20,000,000
--  2			    4				  100		10,000,000
--  3			    8				  200		 5,000,000
--  4			   16				  400		 2,500,000
--  5			   32				  800		 1,250,000
--  6			   64				 1600		  	625,000
--  7			  128				 3200		  	312,500
--  8			  256				 6400		  	156,250
--  9			  512				12800		  	 78,125
-- 10			 1024				25600		  	 39,062.5
-- 11			 2048				51200		  	 19,531.3
-- 12			 4096			  102400	     	  9,765.6
-- 13			 8192			  204800	     	  4,882.8
-- 14			16384			  409600	     	  2,441.4
-- 15			32768			  819200	     	  1,220.7
-- 16			65536			 1638400	          610.4
-- 17		  131072			 3276800				 305.1
-- 18		  262144			 6553600				 152.5
-- 19		  524288			13107200				  76.2
-- 20		 1048576			26214400				  38.1
-- 21		 2097152			52428800				  19.0
-- 22		 4194304		  104857600			      9.5
-- 23		 8388608		  209715200			      4.7
-- 24		16777216		  419430400				   2.3
-- 25		33554432		  838860800				   1.1
-- 26		67108864		 1677721600				   0.6


	trig <= trig_OA_i;
	freqbusy_o <= tfbusy;

	------------------------------------------------------------
	period_buffer : process (clk)
	begin

		if	rising_edge(clk) then
			if	(reset = '1') then
				p_buffer <= (others => '0');

			elsif (trig = '1') then
				p_buffer <= p_count;

			end if;
		end if;
	end process;


	------------------------------------------------------------
	p_count_min(15 downto 13) <= "000";
	p_count_min(12 downto 5) <= TFB_DetectWindow(15 downto 8);
	p_count_min( 4 downto 0) <= "00000";

	p_count_max(15 downto 13) <= "000";
	p_count_max(12 downto 5) <= TFB_DetectWindow( 7 downto 0);
	p_count_max( 4 downto 0) <= "11111";


   
   period_under_over : process (clk)
	begin

		if	rising_edge(clk) then
			if	(reset = '1') then
				p_under <= '1'; 
				p_over  <= '0';
			
			else 
			
				if (p_count < p_count_min) then
					p_under <= '1';
				else
					p_under <= '0';
				end if;
	
				if (p_count > p_count_max) then
					p_over <= '1';
				else
					p_over <= '0';
				end if; 
								
			end if;
		end if;
	end process;

	
	period_counter : process (clk)
	begin

		if	rising_edge(clk) then
			if	(reset = '1') then
				p_count <= (others => '0');
				
			elsif (trig = '1') and (p_over = '0') and (p_under = '0') then
				p_count <= (others => '0');
							
			else -- *** counter just rolls over -- maybe p_overflow?
				p_count <= p_count + '1';

			end if;
		end if;
	end process;


	-----------------------------------------------------------
	

								  
	------------------------------------------------------------
	p_match_mask(15 downto 8) <= "11111111";
	p_match_mask( 7 downto 0) <= TFB_Control(15 downto 8); 

	p_match_count_max <= TFB_Control(5 downto 0); 							   
	
	tfbusy_set_gen : process (clk)
	begin
		if	rising_edge(clk) then

			if	(reset = '1') then
				p_match_count <= (others => '0');	
				p_match 	  <= '0';
				tfbusy_set <= '0';

			elsif (trig = '1') then			
				if ( (p_buffer and p_match_mask )=(p_count and p_match_mask) 
				    and (p_over = '0') and (p_under = '0') ) then
    
    				p_match_count <= p_match_count + '1';
    				p_match <= '1';

				else
					p_match_count <= (others => '0');
    				p_match <= '0';
				
				end if;
					
			elsif (p_match = '1') then 
				p_match    <= '0';
				
				if (p_match_count = p_match_count_max) then
						tfbusy_set <= '1';
						p_match_count <= (others => '0');	
								
				end if;

			else
				p_match 	  <= '0';
				tfbusy_set <= '0';
				
			end if;
		end if;
	end process;
	

	-----------------------------------------------------------------

	tfbusy_duration_counter : process (clk)
	begin

		if	rising_edge(clk) then
			if	(reset = '1') then
				tfbusy <= '0';
				tfbusy_count <= (others => '0');
				
			elsif (tfbusy_set = '1') then
				tfbusy <= '1';
				tfbusy_count <= (others => '0');
				
			elsif (tfbusy_count(25 downto 10) = TFB_Duration ) then
				tfbusy <= '0';
				tfbusy_count <= (others => '0');

			elsif (tfbusy = '1') then
				tfbusy_count <= tfbusy_count + '1';

			end if;
		end if;
	end process;





	--	Registers
	----------------------------------------------------

 	-- 3A - TFB Control
 	--      (15:8)  Period Count LSB Mask - Slop Factor!
 	--      (5:0) - Repetition Count 
 	--
	--	3C - TFB Detect Window
	--      (15:9)  Min Period Count (in  32-clock units) [=p_count (12:5) ]
 	--       (8:0)  Max Period Count (in  32-clock units) [=p_count (12:5) ]

 	--
   -- 3E - TFB Duration
   --      (15:0) TFBusy Pulse width (in 1024-clock units)


	process (reset, clk)
	begin
		if rising_edge(clk) then
		
			if	(reset = '1') then                       -- Defaults:
				TFB_Control 		<= "1111111000001001"; -- lsb slop, 9 count busy
				TFB_DetectWindow 	<= "0000000011111111"; -- All
				TFB_Duration 		<= "0000000000000100"; -- 4 clk busy duration
	
			else 
				if	   (Reg3A and vmeWR)	= '1'	then
					TFB_Control <= db;
	
				elsif	(Reg3C and vmeWR)	= '1'	then
					TFB_DetectWindow <= db;
	
				elsif	(Reg3E and vmeWR)	= '1'	then
					TFB_Duration <= db;
	
				end if;
			end if;
		end if;
	end process;


	--	Data Bus
	----------------------------------------------------

	db <= TFB_Control 		when ((Reg3A and vmeRD) = '1') else
		   TFB_DetectWindow  when ((Reg3C and vmeRD) = '1') else
 		   TFB_Duration 		when ((Reg3E and vmeRD) = '1') else  
 		   (others => 'Z');



   -- Debug Bus
  	----------------------------------------------------

	DebugBus <= (others => '0');

end rtl;

-------------------------------------------------------------------------------