-- hds header_start
--
-- VHDL Architecture TIM_lib.trigfreq_tester.tim
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 18:20:54 09/06/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.ALL;

entity freqbusy_tester is
   port( 
      DebugBus   : in     std_logic_vector (15 downto 0);
      freqbusy_o : in     std_logic;
      Reg3A      : out    std_logic;
      Reg3C      : out    std_logic;
      Reg3E      : out    std_logic;
      clk        : out    std_logic;
      reset      : out    std_logic;
      trig_OA_i  : out    std_logic;
      vmeRD      : out    std_logic;
      vmeWR      : out    std_logic;
      db         : inout  std_logic_vector (15 downto 0)
   );

-- Declarations

end freqbusy_tester ;

-- hds interface_end
architecture test of freqbusy_tester is

	signal clk_osc : std_logic := '1';
	
begin

	-- clock generator
	-----------------------------------------------------------------------
	clk_osc <= not clk_osc after 12500 ps;
	clk <= clk_osc;
	
	
	

	-- Main Simulation
	----------------------------------------------------------------------
	simulation: process
	begin
	
		trig_OA_i <= '0';
		
		Reg3A <= '0';      
		Reg3C <= '0';            
		Reg3E <= '0';            
           
		vmeRD <= '0';            
		vmeWR <= '0';            
				
		reset <= '1';
		wait for 75 ns;		
		reset <= '0';
		wait for 25 ns;
		
		
		-- Write to registers
		-------------------------------------------------------------------
					
		vmeWR <= '1';            
		wait for 25 ns;
		
		Reg3A <= '1';
		db <= "1111000000000100"; -- 16 clock count-slop, 4 count busy
		wait for 50 ns;				-- i.e. +(0-400ns)
		Reg3A <= '0';
		wait for 25 ns;

		Reg3C <= '1';
		db <= "0000000100000011"; -- 1*32 clock to 3*32 clock only (
		wait for 50 ns;			  --  i.e. 800ns to 2400ns 
		Reg3C <= '0';				  --  i.e. 1250kHz to 417kHz
		wait for 25 ns;

		Reg3E <= '1';
		db <= "0000000000000001"; -- 1*1024 clock busy pulse width
		wait for 50 ns;
		Reg3E <= '0';
		wait for 25 ns;
				
		vmeWR <= '0';
		wait for 25 ns;
		
		-- Readback Registers (for fun)
		-------------------------------
		vmeRD <= '1';            
		wait for 25 ns;
		
		Reg3A <= '1';
		wait for 50 ns;
		Reg3A <= '0';
		wait for 25 ns;

		Reg3C <= '1';
		wait for 50 ns;
		Reg3C <= '0';
		wait for 25 ns;

		Reg3E <= '1';
		wait for 50 ns;
		Reg3E <= '0';
		wait for 25 ns;
	
		vmeRD <= '0';            
		wait for 25 ns;
		

		
		-- Start Sending Triggers
		-------------------------------------------------------------------		
	
		for n in 1 to 5 loop
			trig_OA_i <= '0';
			wait for 200 ns;
			trig_OA_i <= '1';
		   wait for 25 ns;
		end loop;
		   
		for n in 1 to 5 loop
			trig_OA_i <= '0';
			wait for 900 ns;
			trig_OA_i <= '1';
		   wait for 25 ns;
		end loop;
		 
		for n in 1 to 5 loop
			trig_OA_i <= '0';
			wait for 2300 ns;
			trig_OA_i <= '1';
		   wait for 25 ns; 
		end loop;
		 		   
		for n in 1 to 5 loop
			trig_OA_i <= '0';
			wait for 500 ns;
			trig_OA_i <= '1';
		   wait for 25 ns;
		end loop;
		
		for n in 1 to 5 loop
			trig_OA_i <= '0';
			wait for 3000 ns;
			trig_OA_i <= '1';
		   wait for 25 ns; 
		end loop;

		for n in 1 to 5 loop
			trig_OA_i <= '0';
			wait for 100 ns;
			trig_OA_i <= '1';
		   wait for 25 ns;
		end loop;

		for n in 1 to 5 loop
			trig_OA_i <= '0';
			wait for 100000 ns;
			trig_OA_i <= '1';
		   wait for 25 ns;
		end loop;
		     
      wait;
	end process;

end test;
