-- hds header_start
--
-- VHDL Entity TIM_fft.tfb2_reg_top.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:52:19 02/16/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity tfb2_reg_top is
   port( 
      clk       : in     std_logic;
      reg40     : in     std_logic;
      reg42     : in     std_logic;
      reg44     : in     std_logic;
      reg46     : in     std_logic;
      reg48     : in     std_logic;
      reg4A     : in     std_logic;
      rst       : in     std_logic;
      trig_i    : in     std_logic;
      vmeRD     : in     std_logic;
      vmeWR     : in     std_logic;
      busy_tf_o : out    std_logic;
      db        : inout  std_logic_vector (15 downto 0)
   );

-- Declarations

end tfb2_reg_top ;

-- hds interface_end
--
-- VHDL Architecture TIM_fft.tfb2_reg_top.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:52:19 02/16/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


library TIM_fft;
library TIM_lib;

architecture struct of tfb2_reg_top is

   -- Architecture declarations

   -- Internal signal declarations
   signal busy_duration       : std_logic_vector(15 downto 0);
   signal busy_tf             : std_logic;
   signal busy_tf_n           : std_logic;
   signal period_deltat_max   : std_logic_vector(15 downto 0);
   signal period_match_thresh : std_logic_vector(15 downto 0);
   signal period_max          : std_logic_vector(15 downto 0);
   signal period_min          : std_logic_vector(15 downto 0);
   signal period_oflow        : std_logic_vector(15 downto 0);
   signal trigger             : std_logic;


   -- Component Declarations
   component m_and2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_minibuff
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_mininv
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component tfb2
   port (
      rst                   : in     std_logic ;
      clk                   : in     std_logic ;
      trigger_i             : in     std_logic ;
      busy_o                : out    std_logic ;
      period_min_i          : in     std_logic_vector (15 downto 0);
      period_max_i          : in     std_logic_vector (15 downto 0);
      period_oflow_i        : in     std_logic_vector (15 downto 0);
      period_deltat_max_i   : in     std_logic_vector (15 downto 0);
      busy_duration_i       : in     std_logic_vector (15 downto 0);
      period_match_thresh_i : in     std_logic_vector (15 downto 0)
   );
   end component;
   component tfb2_control
   port (
      rst                   : in     std_logic ;
      clk                   : in     std_logic ;
      db                    : inout  std_logic_vector (15 downto 0);
      reg40                 : in     std_logic ;
      reg42                 : in     std_logic ;
      reg44                 : in     std_logic ;
      reg46                 : in     std_logic ;
      reg48                 : in     std_logic ;
      reg4A                 : in     std_logic ;
      vmeRD                 : in     std_logic ;
      vmeWR                 : in     std_logic ;
      period_min_o          : out    std_logic_vector (15 downto 0);
      period_max_o          : out    std_logic_vector (15 downto 0);
      period_oflow_o        : out    std_logic_vector (15 downto 0);
      period_deltat_max_o   : out    std_logic_vector (15 downto 0);
      period_match_thresh_o : out    std_logic_vector (15 downto 0);
      busy_duration_o       : out    std_logic_vector (15 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : m_and2 use entity TIM_lib.m_and2;
   for all : m_minibuff use entity TIM_lib.m_minibuff;
   for all : m_mininv use entity TIM_lib.m_mininv;
   for all : tfb2 use entity TIM_fft.tfb2;
   for all : tfb2_control use entity TIM_fft.tfb2_control;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   I2 : m_and2
      port map (
         I1 => busy_tf_n,
         I2 => trig_i,
         O  => trigger
      );
   I4 : m_minibuff
      port map (
         I => busy_tf,
         O => busy_tf_o
      );
   I3 : m_mininv
      port map (
         I => busy_tf,
         O => busy_tf_n
      );
   I0 : tfb2
      port map (
         rst                   => rst,
         clk                   => clk,
         trigger_i             => trigger,
         busy_o                => busy_tf,
         period_min_i          => period_min,
         period_max_i          => period_max,
         period_oflow_i        => period_oflow,
         period_deltat_max_i   => period_deltat_max,
         busy_duration_i       => busy_duration,
         period_match_thresh_i => period_match_thresh
      );
   I1 : tfb2_control
      port map (
         rst                   => rst,
         clk                   => clk,
         db                    => db,
         reg40                 => reg40,
         reg42                 => reg42,
         reg44                 => reg44,
         reg46                 => reg46,
         reg48                 => reg48,
         reg4A                 => reg4A,
         vmeRD                 => vmeRD,
         vmeWR                 => vmeWR,
         period_min_o          => period_min,
         period_max_o          => period_max,
         period_oflow_o        => period_oflow,
         period_deltat_max_o   => period_deltat_max,
         period_match_thresh_o => period_match_thresh,
         busy_duration_o       => busy_duration
      );

end struct;
