-- hds header_start
--
-- VHDL Architecture TIM_fftv.fftv_main_tester.test
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 10:24:54 05/11/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity fftv_main_tester is
   generic( 
      ROD_TRIGGER_MODE : std_logic := '0'
   );
   port( 
      fftv_busy_o          : in     std_logic;
      
      fftv_emergency_o     : in     std_logic;
      
      trigger_o            : in     std_logic;
      clk40                : out    std_logic;
      fftv_count_clr_i     : out    std_logic;
      fftv_disable_i       : out    std_logic;
      fftv_emergency_clr_i : out    std_logic;
      fftv_id_clr_i        : out    std_logic;
      fftv_match_lvl_i     : out    std_logic_vector (3 downto 0);
      rst                  : out    std_logic;
      trigger_i            : out    std_logic
   );

-- Declarations

end fftv_main_tester ;

-- hds interface_end
architecture test of fftv_main_tester is
	signal clk 	 : std_logic := '1';


begin
------------------------------------------------------------------------------

	-- clock generator
	clk <= not clk after 12500 ps;
	clk40 <= clk;

	---------------------------------------------------------------------------
	sim : process	
		
		--------------------------------------------------
		-- Procedures 
		--------------------------------------------------
		procedure WaitClk(n : in integer) is
		begin
			for i in 1 to n loop
	  	   	wait until rising_edge(clk);
	   	end loop;
	   	wait for 1 ns;
	   end procedure;
	   ----------------------------------------------------
		procedure Reset is
		begin
			rst <= '1';
	   	WaitClk(4);		
		   rst <= '0';
		end procedure;
	   ----------------------------------------------------
	   procedure SendTrigger is
		begin
			if (ROD_TRIGGER_MODE = '1') then
				WaitClk(1);		
				trigger_i <= '0';
	   		WaitClk(1);
	   		trigger_i <= '1';
	   		WaitClk(1);		
	   		trigger_i <= '1';
	   		WaitClk(1);		
	   		trigger_i <= '0';
	   		WaitClk(1);				
	   		
	   	else
	   		WaitClk(1);		
	   		trigger_i <= '1';
	   		WaitClk(1);		
	   		trigger_i <= '0';
	   		WaitClk(1);		
	   	
	   	end if;

		end procedure;
	   ----------------------------------------------------
	   procedure ClearEmergency is
		begin
			trigger_i <= '1';
	   	WaitClk(1);		
		   trigger_i <= '0';
		end procedure;
		----------------------------------------------------

	----------------------------------------------------------------------
	-- Simulation
	----------------------------------------------------------------------	
	begin	
	
		-- Start-up values
		-------------------------------------------------------------------
		
      fftv_count_clr_i     <= '0';
      fftv_disable_i       <= '0';
      fftv_emergency_clr_i <= '0';
      fftv_id_clr_i        <= '0';
      fftv_match_lvl_i     <= conv_std_logic_vector(10,4);
      rst                  <= '1';
      trigger_i            <= '0';
      
      Reset;
      
      WaitClk(2000);
		
		for n in 1 to 1000 loop
		
			for b in 1 to 12 loop
				WaitClk(100);
				SendTrigger;
			end loop;
		
			WaitClk(40500);
			
		end loop;
						
		SendTrigger;
		
		WaitClk(80);
		SendTrigger;
		
		
		
		fftv_emergency_clr_i <= '1';
		WaitClk(1);
		fftv_emergency_clr_i <= '0';
		
		WaitClk(60000);
		
		fftv_emergency_clr_i <= '1';
		WaitClk(1);
		fftv_emergency_clr_i <= '0';
		
      


 	   wait;
   ---------------------------------------------------------------------------		
	end process;

------------------------------------------------------------------------------	
end test;
