-- hds header_start
--
-- VHDL Entity TIM_fpga1.clk_rst_mgr.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:58:07 03/05/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity clk_rst_mgr is
   port( 
      dll_clk_in : in     std_logic;
      reset1_i   : in     std_logic;
      reset2_i   : in     std_logic;
      reset3_i   : in     std_logic;
      clk0       : out    std_logic;
      clk180     : out    std_logic;
      clk2x      : out    std_logic;
      clk2x180   : out    std_logic;
      reset_o    : out    std_logic
   );

-- Declarations

end clk_rst_mgr ;


-- hds interface_end

--
-- VHDL Architecture TIM_fpga1.clk_rst_mgr.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:58:10 03/05/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library unisim;
use unisim.vpkg.all;
use IEEE.VITAL_Timing.ALL;
library STD;
use STD.TEXTIO.ALL;

library TIM_fpga1;
library TIM_lib;
library unisim;

architecture struct of clk_rst_mgr is

   -- Architecture declarations

   -- Internal signal declarations
   signal CLK181     : std_logic := '0';
   signal CLK2X1     : std_logic := '0';
   signal CLK2X181   : std_logic := '0';
   signal ONE        : std_logic;
   signal ZERO       : std_logic;
   signal clk0a      : std_logic := '0';
   signal clk0b      : std_logic;
   signal dll_locked : std_logic;
   signal dll_reset  : std_logic;
   signal init_pulse : STD_ULOGIC;


   -- Component Declarations
   component BUFG
   generic (
      TimingChecksOn : Boolean          := TRUE;
      InstancePath   : STRING           := "*";
      Xon            : Boolean          := True;
      MsgOn          : Boolean          := False;
      tpd_I_O        : VitalDelayType01 := (0.100 ns, 0.100 ns);
      tipd_I         : VitalDelayType01 := (0.000 ns, 0.000 ns)
   );
   port (
      O : out    STD_ULOGIC ;
      I : in     STD_ULOGIC 
   );
   end component;
   component FDS
   generic (
      TimingChecksOn             : Boolean          := TRUE;
      InstancePath               : STRING           := "*";
      Xon                        : Boolean          := True;
      MsgOn                      : Boolean          := False;
      INIT                       : bit              := '1';
      tpd_C_Q                    : VitalDelayType01 := (0.100 ns, 0.100 ns);
      tsetup_D_C_posedge_posedge : VitalDelayType   := 0.010 ns;
      tsetup_D_C_negedge_posedge : VitalDelayType   := 0.010 ns;
      thold_D_C_posedge_posedge  : VitalDelayType   := 0.010 ns;
      thold_D_C_negedge_posedge  : VitalDelayType   := 0.010 ns;
      tsetup_S_C_posedge_posedge : VitalDelayType   := 0.010 ns;
      tsetup_S_C_negedge_posedge : VitalDelayType   := 0.010 ns;
      thold_S_C_posedge_posedge  : VitalDelayType   := 0.010 ns;
      thold_S_C_negedge_posedge  : VitalDelayType   := 0.010 ns;
      tpw_C_posedge              : VitalDelayType   := 0.010 ns;
      tpw_C_negedge              : VitalDelayType   := 0.010 ns;
      tipd_D                     : VitalDelayType01 := (0.000 ns, 0.000 ns);
      tipd_C                     : VitalDelayType01 := (0.000 ns, 0.000 ns);
      tipd_S                     : VitalDelayType01 := (0.000 ns, 0.000 ns)
   );
   port (
      Q : out    STD_ULOGIC ;
      C : in     STD_ULOGIC ;
      D : in     STD_ULOGIC ;
      S : in     STD_ULOGIC 
   );
   end component;
   component m_minibuff
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_power
   port (
      Vcc : out    std_logic ;
      Gnd : out    std_logic 
   );
   end component;
   component reset_gen
   generic (
      RESET_LENGTH : integer := 255
   );
   port (
      clk_in       : in     std_logic ;
      reset1_i     : in     std_logic ;
      reset2_i     : in     std_logic ;
      reset3_i     : in     std_logic ;
      dll_locked_i : in     std_logic ;
      dll_reset_o  : out    std_logic ;
      reset_o      : out    std_logic ;
      init_i       : in     std_logic 
   );
   end component;
   component xilinx_clkdlle
   port (
      clkin    : in     std_logic ;
      clkfb    : in     std_logic ;
      rst      : in     std_logic ;
      clk0     : out    std_logic ;
      clk90    : out    std_logic ;
      clk180   : out    std_logic ;
      clk270   : out    std_logic ;
      clk2x    : out    std_logic ;
      clk2x180 : out    std_logic ;
      clkdv    : out    std_logic ;
      locked   : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : BUFG use entity unisim.BUFG;
   for all : FDS use entity unisim.FDS;
   for all : m_minibuff use entity TIM_lib.m_minibuff;
   for all : m_power use entity TIM_lib.m_power;
   for all : reset_gen use entity TIM_fpga1.reset_gen;
   for all : xilinx_clkdlle use entity TIM_lib.xilinx_clkdlle;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   BUFG_1 : BUFG
      generic map (
         TimingChecksOn => TRUE,
         InstancePath   => "*",
         Xon            => True,
         MsgOn          => False,
         tpd_I_O        => (0.100 ns, 0.100 ns),
         tipd_I         => (0.000 ns, 0.000 ns)
      )
      port map (
         O => clk0b,
         I => clk0a
      );
   BUFG_2 : BUFG
      generic map (
         TimingChecksOn => TRUE,
         InstancePath   => "*",
         Xon            => True,
         MsgOn          => False,
         tpd_I_O        => (0.100 ns, 0.100 ns),
         tipd_I         => (0.000 ns, 0.000 ns)
      )
      port map (
         O => clk180,
         I => CLK181
      );
   BUFG_3 : BUFG
      generic map (
         TimingChecksOn => TRUE,
         InstancePath   => "*",
         Xon            => True,
         MsgOn          => False,
         tpd_I_O        => (0.100 ns, 0.100 ns),
         tipd_I         => (0.000 ns, 0.000 ns)
      )
      port map (
         O => clk2x,
         I => CLK2X1
      );
   BUFG_4 : BUFG
      generic map (
         TimingChecksOn => TRUE,
         InstancePath   => "*",
         Xon            => True,
         MsgOn          => False,
         tpd_I_O        => (0.100 ns, 0.100 ns),
         tipd_I         => (0.000 ns, 0.000 ns)
      )
      port map (
         O => clk2x180,
         I => CLK2X181
      );
   FDS_1 : FDS
      generic map (
         TimingChecksOn             => TRUE,
         InstancePath               => "*",
         Xon                        => True,
         MsgOn                      => False,
         INIT                       => '1',
         tpd_C_Q                    => (0.100 ns, 0.100 ns),
         tsetup_D_C_posedge_posedge => 0.010 ns,
         tsetup_D_C_negedge_posedge => 0.010 ns,
         thold_D_C_posedge_posedge  => 0.010 ns,
         thold_D_C_negedge_posedge  => 0.010 ns,
         tsetup_S_C_posedge_posedge => 0.010 ns,
         tsetup_S_C_negedge_posedge => 0.010 ns,
         thold_S_C_posedge_posedge  => 0.010 ns,
         thold_S_C_negedge_posedge  => 0.010 ns,
         tpw_C_posedge              => 0.010 ns,
         tpw_C_negedge              => 0.010 ns,
         tipd_D                     => (0.000 ns, 0.000 ns),
         tipd_C                     => (0.000 ns, 0.000 ns),
         tipd_S                     => (0.000 ns, 0.000 ns)
      )
      port map (
         Q => init_pulse,
         C => dll_clk_in,
         D => ZERO,
         S => ZERO
      );
   m_minibuff_1 : m_minibuff
      port map (
         I => clk0b,
         O => clk0
      );
   m_power_2 : m_power
      port map (
         Vcc => ONE,
         Gnd => ZERO
      );
   reset_gen_1 : reset_gen
      generic map (
         RESET_LENGTH => 255
      )
      port map (
         clk_in       => dll_clk_in,
         reset1_i     => reset1_i,
         reset2_i     => reset2_i,
         reset3_i     => reset3_i,
         dll_locked_i => dll_locked,
         dll_reset_o  => dll_reset,
         reset_o      => reset_o,
         init_i       => init_pulse
      );
   xilinx_clkdlle_1 : xilinx_clkdlle
      port map (
         clkin    => dll_clk_in,
         clkfb    => clk0b,
         rst      => dll_reset,
         clk0     => clk0a,
         clk90    => open,
         clk180   => CLK181,
         clk270   => open,
         clk2x    => CLK2X1,
         clk2x180 => CLK2X181,
         clkdv    => open,
         locked   => dll_locked
      );

end struct;
