-- hds header_start
--
-- VHDL Entity TIM_fpga1.db_interface_f1.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 16:56:19 09/07/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity db_interface_f1 is
   port( 
      clk                : in     std_logic;
      clk2x              : in     std_logic;
      pre_reset_i        : in     std_logic;
      rst                : in     std_logic;
      vme_AB_i           : in     std_logic_vector (31 downto 0);
      vme_AMb_i          : in     std_logic_vector (5 downto 0);
      vme_ASb_ni         : in     std_logic;
      vme_BErrb_ni       : in     std_logic;
      vme_BaseAddr_i     : in     std_logic_vector (31 downto 16);
      vme_BaseAddr_sel_i : in     std_logic;
      vme_DS0b_ni        : in     std_logic;
      vme_DS1b_ni        : in     std_logic;
      vme_GAPb_ni        : in     std_logic;
      vme_GAb_ni         : in     std_logic_vector (4 downto 0);
      vme_IAckInb_ni     : in     std_logic;
      vme_IAckb_ni       : in     std_logic;
      vme_LWordb_ni      : in     std_logic;
      vme_Writeb_ni      : in     std_logic;
      ab16_o             : out    std_logic_vector (15 downto 0);
      bp_GAoutEn_o       : out    std_logic;
      db_d32_o           : out    std_logic;
      db_rd_o            : out    std_logic;
      db_wr_o            : out    std_logic;
      ram1000_en_o       : out    std_logic;
      reg_en_o           : out    std_logic_vector (127 downto 0);
      v_reset            : out    std_logic;
      vmeD32_o           : out    std_logic;
      vmeF2SEL_o         : out    std_logic;
      vmeRD_o            : out    std_logic;
      vmeWR_o            : out    std_logic;
      vme_Ack_o          : out    std_logic;
      vme_ErrorLED_no    : out    std_logic;
      vme_IAckOutb_no    : out    std_logic;
      vme_IRQb_no        : out    std_logic_vector (7 downto 1);
      vme_LE1_no         : out    std_logic;
      vme_LE2_no         : out    std_logic;
      vme_LRD_no         : out    std_logic;
      vme_LWR_no         : out    std_logic;
      vme_OEin_no        : out    std_logic;
      vme_OEout_no       : out    std_logic;
      dbh_io             : inout  std_logic_vector (15 downto 0);
      dbl_io             : inout  std_logic_vector (15 downto 0);
      vme_db_io          : inout  std_logic_vector (31 downto 0)
   );

-- Declarations

end db_interface_f1 ;


-- hds interface_end

--
-- VHDL Architecture TIM_fpga1.db_interface_f1.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 16:56:20 09/07/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library TIM_fpga1;
library TIM_fpga2;
library TIM_lib;

architecture struct of db_interface_f1 is

   -- Architecture declarations

   -- Internal signal declarations
   signal ONE       : std_logic;
   signal ZERO      : std_logic;
   signal db_rd0    : std_logic;
   signal f1_sel    : std_logic;
   signal f2_db_wr  : std_logic;
   signal f2_dbh_io : std_logic_vector(15 downto 0);
   signal f2_dbl_io : std_logic_vector(15 downto 0);
   signal f2_reg_en : std_logic_vector(127 downto 0);
   signal f2_sel    : std_logic;
   signal reg02_wr  : std_logic;
   signal vmeBDSEL  : std_logic;
   signal vmeD32    : std_logic;
   signal vmeRD     : std_logic;
   signal vmeWR     : std_logic;


   -- Component Declarations
   component addr_decoder
   port (
      rst     : in     std_logic ;
      clk     : in     std_logic ;
      enable  : in     std_logic ;
      addr    : in     std_logic_vector (15 downto 0);
      --addr_latch : in     std_logic;
      ram8_en : out    std_logic ;
      ren2_o  : out    std_logic_vector (127 downto 0);
      f2_sel  : out    std_logic ;
      f1_sel  : out    std_logic ;
      ren1_o  : out    std_logic_vector (127 downto 0);
      ram1_en : out    std_logic ;
      ab16_o  : out    std_logic_vector (15 downto 0)
   );
   end component;
   component db_control
   generic (
      PD_FACTOR : integer := 0
   );
   port (
      clk       : in     std_logic ;
      rst       : in     std_logic ;
      sel       : in     std_logic ;
      vmeRD     : in     std_logic ;
      vmeWR     : in     std_logic ;
      vmeD32    : in     std_logic ;
      dbh_io    : inout  std_logic_vector (15 downto 0);
      dbl_io    : inout  std_logic_vector (15 downto 0);
      vme_db_io : inout  std_logic_vector (31 downto 0);
      db_rd     : out    std_logic ;
      db_rd0    : out    std_logic ;
      db_d32    : out    std_logic ;
      db_wr     : out    std_logic 
   );
   end component;
   component db_interface_f2
   port (
      clk          : in     std_logic ;
      rst          : in     std_logic ;
      vmeD32_i     : in     std_logic ;
      vmeF2SEL_i   : in     std_logic ;
      vmeRD_i      : in     std_logic ;
      vmeWR_i      : in     std_logic ;
      vme_ab_i     : in     std_logic_vector (15 downto 0);
      ab16_o       : out    std_logic_vector (15 downto 0);
      db_d32_o     : out    std_logic ;
      db_rd0_o     : out    std_logic ;
      db_rd_o      : out    std_logic ;
      db_wr_o      : out    std_logic ;
      ram8000_en_o : out    std_logic ;
      ren_o        : out    std_logic_vector (127 downto 0);
      dbh_io       : inout  std_logic_vector (15 downto 0);
      dbl_io       : inout  std_logic_vector (15 downto 0);
      vme_db_io    : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component m_and2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_buff
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_dffe_ar
   port (
      D   : in     std_logic ;
      en  : in     std_logic ;
      clk : in     std_logic ;
      rst : in     std_logic ;
      Q   : out    std_logic 
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;
   component vme
   port (
      rst            : in     std_logic ;
      clk            : in     std_logic ;
      clk2x          : in     std_logic ;
      AM_i           : in     std_logic_vector (5 downto 0);
      AS_ni          : in     std_logic ;
      BErr_ni        : in     std_logic ;
      BaseAddr_Sel_i : in     std_logic ;
      BaseAddr_i     : in     std_logic_vector (31 downto 16);
      DS0_ni         : in     std_logic ;
      DS1_ni         : in     std_logic ;
      GAP_ni         : in     std_logic ;
      GA_ni          : in     std_logic_vector (4 downto 0);
      IAck_ni        : in     std_logic ;
      IAckin_ni      : in     std_logic ;
      LWord_ni       : in     std_logic ;
      Write_ni       : in     std_logic ;
      AB_i           : in     std_logic_vector (31 downto 0);
      Ack_o          : out    std_logic ;
      ErrorLED_no    : out    std_logic ;
      GAoutEn_o      : out    std_logic ;
      IAckout_no     : out    std_logic ;
      Irq_no         : out    std_logic_vector (7 downto 1);
      LE1_no         : out    std_logic ;
      LE2_no         : out    std_logic ;
      LRD_no         : out    std_logic ;
      LWR_no         : out    std_logic ;
      OEin_no        : out    std_logic ;
      OEout_no       : out    std_logic ;
      vmeBDSEL_o     : out    std_logic ;
      vmeD32_o       : out    std_logic ;
      vmeRD_o        : out    std_logic ;
      vmeWR_o        : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : addr_decoder use entity TIM_lib.addr_decoder;
   for all : db_control use entity TIM_lib.db_control;
   for all : db_interface_f2 use entity TIM_fpga2.db_interface_f2;
   for all : m_and2 use entity TIM_lib.m_and2;
   for all : m_buff use entity TIM_lib.m_buff;
   for all : m_dffe_ar use entity TIM_lib.m_dffe_ar;
   for all : m_power use entity TIM_lib.m_power;
   for all : vme use entity TIM_fpga1.vme;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   addr_decoder_1 : addr_decoder
      port map (
         rst     => rst,
         clk     => clk,
         enable  => vmeBDSEL,
         addr    => vme_AB_i(15 DOWNTO 0),
         ram8_en => open,
         ren2_o  => open,
         f2_sel  => f2_sel,
         f1_sel  => f1_sel,
         ren1_o  => reg_en_o,
         ram1_en => ram1000_en_o,
         ab16_o  => ab16_o
      );
   db_control_1 : db_control
      generic map (
         PD_FACTOR => 1
      )
      port map (
         clk       => clk,
         rst       => rst,
         sel       => f1_sel,
         vmeRD     => vmeRD,
         vmeWR     => vmeWR,
         vmeD32    => vmeD32,
         dbh_io    => dbh_io,
         dbl_io    => dbl_io,
         vme_db_io => vme_db_io,
         db_rd     => db_rd_o,
         db_rd0    => db_rd0,
         db_d32    => db_d32_o,
         db_wr     => db_wr_o
      );
   db_interface_f2_1 : db_interface_f2
      port map (
         clk          => clk,
         rst          => pre_reset_i,
         vmeD32_i     => vmeD32,
         vmeF2SEL_i   => f2_sel,
         vmeRD_i      => ZERO,
         vmeWR_i      => vmeWR,
         vme_ab_i     => vme_AB_i(15 DOWNTO 0),
         ab16_o       => open,
         db_d32_o     => open,
         db_rd0_o     => open,
         db_rd_o      => open,
         db_wr_o      => f2_db_wr,
         ram8000_en_o => open,
         ren_o        => f2_reg_en,
         dbh_io       => f2_dbh_io,
         dbl_io       => f2_dbl_io,
         vme_db_io    => vme_db_io
      );
   I1 : m_and2
      port map (
         I1 => f2_reg_en(1),
         I2 => f2_db_wr,
         O  => reg02_wr
      );
   I0 : m_buff
      port map (
         I => vmeRD,
         O => vmeRD_o
      );
   I3 : m_buff
      port map (
         I => vmeWR,
         O => vmeWR_o
      );
   I4 : m_buff
      port map (
         I => vmeBDSEL,
         O => vmeF2SEL_o
      );
   I6 : m_buff
      port map (
         I => vmeD32,
         O => vmeD32_o
      );
   I2 : m_dffe_ar
      port map (
         D   => f2_dbl_io(15),
         en  => reg02_wr,
         clk => clk,
         rst => pre_reset_i,
         Q   => v_reset
      );
   m_power_2 : m_power
      port map (
         ONE  => ONE,
         ZERO => ZERO
      );
   vme_1 : vme
      port map (
         rst            => rst,
         clk            => clk,
         clk2x          => clk2x,
         AM_i           => vme_AMb_i,
         AS_ni          => vme_ASb_ni,
         BErr_ni        => vme_BErrb_ni,
         BaseAddr_Sel_i => vme_BaseAddr_sel_i,
         BaseAddr_i     => vme_BaseAddr_i,
         DS0_ni         => vme_DS0b_ni,
         DS1_ni         => vme_DS1b_ni,
         GAP_ni         => vme_GAPb_ni,
         GA_ni          => vme_GAb_ni,
         IAck_ni        => vme_IAckb_ni,
         IAckin_ni      => vme_IAckInb_ni,
         LWord_ni       => vme_LWordb_ni,
         Write_ni       => vme_Writeb_ni,
         AB_i           => vme_AB_i,
         Ack_o          => vme_Ack_o,
         ErrorLED_no    => vme_ErrorLED_no,
         GAoutEn_o      => bp_GAoutEn_o,
         IAckout_no     => vme_IAckOutb_no,
         Irq_no         => vme_IRQb_no,
         LE1_no         => vme_LE1_no,
         LE2_no         => vme_LE2_no,
         LRD_no         => vme_LRD_no,
         LWR_no         => vme_LWR_no,
         OEin_no        => vme_OEin_no,
         OEout_no       => vme_OEout_no,
         vmeBDSEL_o     => vmeBDSEL,
         vmeD32_o       => vmeD32,
         vmeRD_o        => vmeRD,
         vmeWR_o        => vmeWR
      );

end struct;
