-- hds header_start
--
-- VHDL Architecture fpga1.f1_pcb_top_tester.test
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:42:53 10/03/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity f1_pcb_top_tester is
   port( 
      ack             : in     std_logic;
      OA_reset        : in     std_logic;
      --bRead           : in     std_logic;
      --bWrite          : in     std_logic;
      debug1_bus      : in     std_logic_vector (15 downto 0);
      dl0             : in     std_logic;
      fpga1_tp        : in     std_logic_vector (16 downto 1);
      j_xck           : in     std_logic;
      j_xdo           : in     std_logic;
      j_xms           : in     std_logic;
      jtagx_en        : in     std_logic;
      nErrorLED       : in     std_logic;
      nGAoutEn        : in     std_logic;
      nIAckOutb       : in     std_logic;
      nIRQb           : in     std_logic_vector (7 downto 1);
      --nLE1            : in     std_logic;
      --nLE2            : in     std_logic;
      nOA_reset       : in     std_logic;
      --nOEin           : in     std_logic;
      --nOEout          : in     std_logic;
      sigCLK_XOX      : in     std_logic;
      vmeCLK_XOX      : in     std_logic;
      AMb             : out    std_logic_vector (5 downto 0);
      B_select        : out    std_logic;
      BaseAddr_Select : out    std_logic;
      ab              : out    std_logic_vector (31 downto 0);
      base_addr       : out    std_logic_vector (31 downto 16);
      debug_mode      : out    std_logic_vector (3 downto 0);
      dl1             : out    std_logic;
      dl2             : out    std_logic;
      dl3             : out    std_logic;
      fpga2ok         : out    std_logic;
      j_xdi           : out    std_logic;
      nASb            : out    std_logic;
      nBErrb          : out    std_logic;
      nDS0b           : out    std_logic;
      nDS1b           : out    std_logic;
      nGAPb           : out    std_logic;
      nGAb            : out    std_logic_vector (4 downto 0);
      nIAckInb        : out    std_logic;
      nIAckb          : out    std_logic;
      nLWordb         : out    std_logic;
      nVCCINT_error   : out    std_logic;
      nWriteb         : out    std_logic;
      sReset          : out    std_logic;
      sigCLK          : out    std_logic;
      spare_bus       : out    std_logic_vector (15 downto 0);
      timCLK1         : out    std_logic;
      vmeCLK          : out    std_logic;
      bp_db           : inout  std_logic_vector (31 downto 0);
      spareCLK1       : out    std_logic;
      tim_ID          : out    std_logic_vector (7 downto 0);
      PO_RESET        : out    std_logic;
      f2_done         : out    std_logic;
      f1_spare_inL    : out    std_logic
   );

-- Declarations

end f1_pcb_top_tester ;


-- hds interface_end

architecture test of f1_pcb_top_tester is

	signal clk 	 : std_logic := '1';
	
	constant AM_A24S : std_logic_vector(5 downto 0) := "111101"; -- 0x3D SSDA:Standard supervisory data access   
	constant AM_A24  : std_logic_vector(5 downto 0) := "111001"; -- 0x39 SNDA:Standard non-privileged data access
	constant AM_A32S : std_logic_vector(5 downto 0) := "001101"; -- 0x0D ESDA:Extended supervisory data access   
	constant AM_A32  : std_logic_vector(5 downto 0) := "001001"; -- 0x09 ENDA:Extended non-privileged data access
	

begin
-------------------------------------------------------

	-- clock generator
	clk <= not clk after 12500 ps;
	timclk1 <= clk;

	--------------------------------------------------------
	vme_sim : process
	
		-- Procedures
		-------------------------------------------------------------
		procedure VME_Write(
				iaddr : in integer;
				idata : in integer;
				addr_modifier : in std_logic_vector(5 downto 0)
			) is
			variable addr : std_logic_vector(31 downto 0);
			variable data : std_logic_vector(31 downto 0);
		begin
			addr := conv_std_logic_vector(iaddr, 32);
			data := conv_std_logic_vector(idata, 32);	wait for 10 ns;
			
			nWriteb 	<= '0'; 
			ab      	<= addr;					wait for   5 ns;    
			AMb     	<= addr_modifier;		wait for  15 ns;
			nASb 		<= '0';					wait for   5 ns;
			bp_db  	<= data;					wait for   5 ns;
			nDS0b 	<= '0';					wait for   5 ns;
			nDS1b 	<= '0';					wait for 130 ns;
			nASb 		<= '1';					wait for  10 ns;
			ab  		<= (others => 'Z');	wait for  55 ns;
			nDS0b 	<= '1';					wait for   5 ns;
			nDS1b 	<= '1';					wait for   5 ns;
			bp_db  	<= (others => 'Z');	wait for 160 ns;
			wait until rising_edge(clk);  
			
		end procedure; 

		--------------------------------------------------------------
		procedure VME_Read(
					iaddr 			: in integer;
					addr_modifier 	: in std_logic_vector(5 downto 0)) is
			variable addr : std_logic_vector(31 downto 0);
		begin
			addr := conv_std_logic_vector(iaddr, 32);
			
			nWriteb	<= '1';					wait for   5 ns;
			ab      	<= addr;					wait for   5 ns;
			AMb     	<= addr_modifier;		wait for  25 ns;
			nASb 		<= '0';					wait for  10 ns;
			nDS0b 	<= '0';					wait for   5 ns;
			nDS1b 	<= '0';					wait for 200 ns;
			nASb  	<= '1';					wait for  15 ns;
			ab  		<= (others => 'Z');	wait for  30 ns;
			nDS0b 	<= '1';					wait for   5 ns;			
			nDS1b 	<= '1';					wait for 155 ns;
			wait until rising_edge(clk);  
			
		end procedure; 
		
	-------------------------------------------------------------------
	
	---------------------------------------------------------------------------
	-- Main Simulation
	---------------------------------------------------------------------------	
	begin	
	
		-- Start-up values
		----------------------------------------------------------
		j_xdi           <= '0';
      nVCCINT_error   <= '1';
      sReset          <= '0';
      PO_RESET        <= '0';
      sigCLK          <= '0';
      spareCLK1       <= '0';
      spare_bus       <= (others => '0');
      tim_ID          <= (others => '0');
      debug_mode		 <= (others => '0');
      
      vmeCLK          <= '0';
      
      bp_db           <= (others => 'Z');

		B_select        <= '1';
		f2_done         <= '1';
		
		ab              <= "00000000000000000000000000000000";
		BaseAddr_Select <= '0';
		base_addr       <= "1111000011111111";  -- 0xf0ff
		AMb             <= "000000";
		nLWordb         <= '1';
		nDS1b           <= '1';
		nGApb           <= '1';
		nGAb            <= "11111";
		nIAckInb        <= '1';
		nIAckb          <= '1';
		nASb            <= '1';
		nBErrb          <= '1';
		nDS0b           <= '1';
		nWriteb         <= '1';
		
		
		
		wait for 40 * 25 ns;
				
		-- Reset
		----------------------------------------------------------
		wait for 5 ns;
		
      sReset <= '1';
		wait for  80 ns;
      sReset <= '0';
      
      wait for  15 ns;
      
		
		wait for  2000 ns;	-- allow reset delay to finish
		
		
		wait for 5 ns;
		
      sReset <= '1';
		wait for  80 ns;
      sReset <= '0';
      
      wait for  150 ns;
      
      wait until rising_edge(clk);  

		
		

		-- Simulation
		-------------------------------------------------------------------------
		baseaddr_select <= '0';  --non geogaddr mode  
		
		
		-- VME_Write(16#f0ff8002#, 16#2008#, AM_A32S);
		-- wait for 50 ns;
		   
		-- VME_Write(16#f0ff8004#, 16#4008#, AM_A32S);
		-- wait for 50 ns;
         
		-- VME_Write(16#f0ff8006#, 16#6008#, AM_A32S);
		-- wait for 50 ns;

 
		 
		-- VME_Read(16#f0ff8002#, AM_A32S);
		--	wait for 50 ns;
      -- 
		-- VME_Read(16#f0ff8004#, AM_A32S);
		-- wait for 50 ns;
		-- 
		-- VME_Read(16#f0ff8006#, AM_A32S);
		-- wait for 150 ns;
      -- 
      -- 
         
		-- VME_Write(16#f0ff1002#, 16#2001#, AM_A32S);
		-- wait for 50 ns;
         
		-- VME_Write(16#f0ff1004#, 16#4001#, AM_A32S);
		-- wait for 50 ns;
		   
		-- VME_Read(16#f0ff1002#, AM_A32S);
		-- wait for 50 ns;
      -- 
		-- VME_Read(16#f0ff1004#, AM_A32S);
		-- wait for 2000 ns;
         
      -- 
		-- 
		-- VME_Read(16#f0ff007C#, AM_A32S);
		-- wait for 100 ns;
      -- 
		-- VME_Read(16#f0ff007E#, AM_A32);
      -- 
		-- wait for 200 ns;
		
		--VME_Read(16#f0ff017C#, AM_A32S);
		--wait for 100 ns;

		--VME_Read(16#f0ff017E#, AM_A32);
		--wait for 200 ns;




		--VME_Write(16#f0ff1000#, 16#aaaa#, AM_A32);
		--wait for 100 ns;
				
		--VME_Write(16#f0ff0002#, 16#2222#, AM_A32);
		--wait for 100 ns;

		--VME_Write(16#f0ff0100#, 16#1010#, AM_A32);
		--wait for 150 ns;
		

		--VME_Read(16#f0ff1000#, AM_A32);
		--wait for 100 ns;
		
		--VME_Read(16#f0ff0002#, AM_A32);
		--wait for 100 ns;

		--VME_Read(16#f0ff0100#, AM_A32);
		
	
		--for n in 1 to 50 loop
		--	wait for n * 500 ps;

		--	VME_Write(16#f0ff0100#, n, AM_A32);
		--	wait for 50 ns;

		--	VME_Read(16#f0ff0100#, AM_A32);
		--	wait for 50 ns;
			
		--end loop;
		
		--wait for 1000 ns;

		
		-- send some trigs
 		VME_Write(16#f0ff0002#, 16#2#, AM_A32);
		VME_Write(16#f0ff0002#, 16#0#, AM_A32);
 		VME_Write(16#f0ff0002#, 16#2#, AM_A32);
		VME_Write(16#f0ff0002#, 16#0#, AM_A32);
 		VME_Write(16#f0ff0002#, 16#2#, AM_A32);
		VME_Write(16#f0ff0002#, 16#0#, AM_A32);
 		VME_Write(16#f0ff0002#, 16#2#, AM_A32);
		VME_Write(16#f0ff0002#, 16#0#, AM_A32);
 		

		
		-- Now for some D32 tests
		--============================================
		nLWordb         <= '0';
		
		
		VME_Read(16#f0ff0080#, AM_A32);
		wait for 11 * 25 ns;
		
		VME_Read(16#f0ff0080#, AM_A32);
		wait for 11 * 25 ns;
		
		VME_Read(16#f0ff0080#, AM_A32);
		wait for 11 * 25 ns;
				

		VME_Read(16#f0ff0094#, AM_A32);
		wait for 11 * 25 ns;
				
		
		VME_Read(16#f0ff0094#, AM_A32);
		wait for 12 * 25 ns;
		
		VME_Read(16#f0ff0094#, AM_A32);
		wait for 13 * 25 ns;
		
		
		nLWordb         <= '1';
		
		
		
		
-- 	VME_Write(16#f0ff0002#, 16#4321#, AM_A32);
--		wait for 182 ns;

--		VME_Read(16#f0ff0040#, AM_A32);
--		wait for 182 ns;
		
--		VME_Write(16#f0ff009C#, 16#1133#, AM_A32);
--		wait for 182 ns;
		
		
		
--		VME_Write(16#FF0040#, 16#00EE00AA#, AM_A24S);
--		wait for 177 ns;
		
--		VME_Read(16#f0ff0042#, AM_A32);
--		wait for 122 ns;
		
--		baseaddr_select <= '0';  --non geogaddr mode 
--		VME_Write(16#FF0100#, 16#12345678#, AM_A24);     
		
--		wait for 66 ns;
		
		
		-- non access
		-----------
--		VME_Read(16#10100102#, AM_A32);
--		wait for 166 ns;
		
		
		-- geog addr vme
		--------------
--		baseaddr_select <= '1';  -- geogaddr mode
--		VME_Read(16#000000102#, AM_A32);
--		wait for 99 ns;
		
--		VME_Write(16#00000002#, 16#76543210#, AM_A32);
--		wait for 33 ns;

		
		wait;
	end process;

end test;
