-- hds header_start
--
-- VHDL Entity TIM_fpga1.f1_top.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:50:51 09/07/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library TIM_lib;

entity f1_top is
   port( 
      bp_GAoutEn_o       : out    std_logic;
      VCCINT_error_i     : in     std_logic;
      vme_Ack_o          : out    std_logic;
      vme_AMb_i          : in     std_logic_vector (5 downto 0);
      vme_ASb_ni         : in     std_logic;
      f1_spare_link_i    : in     std_logic;
      vme_BaseAddr_i     : in     std_logic_vector (31 downto 16);
      vme_BaseAddr_sel_i : in     std_logic;
      vme_BErrb_ni       : in     std_logic;
      vme_dl1_i          : in     std_logic;
      vme_dl2_i          : in     std_logic;
      vme_dl3_i          : in     std_logic;
      vme_DS0b_ni        : in     std_logic;
      vme_DS1b_ni        : in     std_logic;
      vme_ErrorLED_no    : out    std_logic;
      vme_GAb_ni         : in     std_logic_vector (4 downto 0);
      vme_GAPb_ni        : in     std_logic;
      vme_IAckb_ni       : in     std_logic;
      vme_IAckInb_ni     : in     std_logic;
      vme_IAckOutb_no    : out    std_logic;
      vme_IRQb_no        : out    std_logic_vector (7 downto 1);
      vme_LE1_no         : out    std_logic;
      vme_LE2_no         : out    std_logic;
      vme_LWR_no         : out    std_logic;
      vme_LRD_no         : out    std_logic;
      vme_LWordb_ni      : in     std_logic;
      vme_OEin_no        : out    std_logic;
      vme_OEout_no       : out    std_logic;
      vme_AB_i           : in     std_logic_vector (31 downto 0);   -- note ab(0) not conn'd to backplane.
      vme_Writeb_ni      : in     std_logic;
      debug_mode_i       : in     std_logic_vector (3 downto 0);
      spare_bus_i        : in     std_logic_vector (15 downto 0);
      fpga2ok_i          : in     std_logic;
      tim_ID_i           : in     std_logic_vector (7 downto 0);
      j_xdi_i            : in     std_logic;
      vme_db_io          : inout  std_logic_vector (31 downto 0);
      vmeD32_o           : out    std_logic;
      vmeF2SEL_o         : out    std_logic;
      vmeWR_o            : out    std_logic;
      vmeRD_o            : out    std_logic;
      jtagx_en_o         : out    std_logic;
      j_xms_o            : out    std_logic;
      j_xck_o            : out    std_logic;
      j_xdo_o            : out    std_logic;
      fpga1_tp_o         : out    std_logic_vector (16 downto 1);
      vme_dl0_o          : out    std_logic;
      sigCLK_o           : out    std_logic;
      debug1_bus_o       : out    std_logic_vector (15 downto 0);
      sigCLK_i           : in     std_logic;
      spareCLK1_i        : in     std_logic;
      reset_OA_i         : in     std_logic;
      ext_Reset_sw_i     : in     std_logic;
      vmeCLK_i           : in     std_logic;
      reset_out_o        : out    std_logic;
      timCLK1_i          : in     std_logic;
      po_reset_i         : in     std_logic;
      f2_program_o       : out    std_logic;
      f2_done_i          : in     std_logic;
      f1_spare_inL       : in     std_logic
   );

-- Declarations

end f1_top ;


-- hds interface_end

--
-- VHDL Architecture TIM_fpga1.f1_top.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:50:51 09/07/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library TIM_fpga1;
library TIM_lib;
library Timestamp;

architecture struct of f1_top is

   -- Architecture declarations

   -- Internal signal declarations
   signal ONE          : std_logic;
   signal ZERO         : std_logic;
   signal clk          : std_logic;
   signal db           : std_logic_vector(15 downto 0);
   signal db_rd        : std_logic;
   signal db_wr        : std_logic;
   signal led4         : std_logic;
   signal led7         : std_logic;
   signal led6         : std_logic;
   signal led5         : std_logic;
   signal led3         : std_logic;
   signal led0         : std_logic;
   signal led2         : std_logic;
   signal led1         : std_logic;
   signal pre_rst      : std_logic;
   signal ram_en       : std_logic;
   signal reg_test     : std_logic_vector(15 downto 0);
   signal ren          : std_logic_vector(127 downto 0);
   signal rst          : std_logic;
   signal rst_vme      : std_logic;
   signal epoc_secs_32 : std_logic_vector(31 downto 0);
   signal cfg_rst      : std_logic;
   signal ab           : std_logic_vector(15 downto 0);
   signal clk2x        : std_logic;
   signal db_d32       : std_logic;
   signal dbh          : std_logic_vector(15 downto 0);


   -- Component Declarations
   component clk_rst_mgr
   generic (
      RST_DEADTIME  : integer := 255;
      CLKDV_DIVIDER : real    := 2.0
   );
   port (
      dll_clk_in      : in     std_logic ;
      reset1_i        : in     std_logic ;
      reset2_i        : in     std_logic ;
      reset3_i        : in     std_logic ;
      reset4_i        : in     std_logic ;
      cfg_rst_o       : out    std_logic ;
      clk0            : out    std_logic ;
      clk180_nobufg   : out    std_logic ;
      clk2x           : out    std_logic ;
      clk2x180_nobufg : out    std_logic ;
      clkdv_nobufg    : out    std_logic ;
      dll_locked_o    : out    std_logic ;
      reset_o         : out    std_logic 
   );
   end component;
   component db_interface_f1
   port (
      clk                : in     std_logic ;
      clk2x              : in     std_logic ;
      pre_reset_i        : in     std_logic ;
      rst                : in     std_logic ;
      vme_AB_i           : in     std_logic_vector (31 downto 0);
      vme_AMb_i          : in     std_logic_vector (5 downto 0);
      vme_ASb_ni         : in     std_logic ;
      vme_BErrb_ni       : in     std_logic ;
      vme_BaseAddr_i     : in     std_logic_vector (31 downto 16);
      vme_BaseAddr_sel_i : in     std_logic ;
      vme_DS0b_ni        : in     std_logic ;
      vme_DS1b_ni        : in     std_logic ;
      vme_GAPb_ni        : in     std_logic ;
      vme_GAb_ni         : in     std_logic_vector (4 downto 0);
      vme_IAckInb_ni     : in     std_logic ;
      vme_IAckb_ni       : in     std_logic ;
      vme_LWordb_ni      : in     std_logic ;
      vme_Writeb_ni      : in     std_logic ;
      ab16_o             : out    std_logic_vector (15 downto 0);
      bp_GAoutEn_o       : out    std_logic ;
      db_d32_o           : out    std_logic ;
      db_rd_o            : out    std_logic ;
      db_wr_o            : out    std_logic ;
      ram1000_en_o       : out    std_logic ;
      reg_en_o           : out    std_logic_vector (127 downto 0);
      v_reset            : out    std_logic ;
      vmeD32_o           : out    std_logic ;
      vmeF2SEL_o         : out    std_logic ;
      vmeRD_o            : out    std_logic ;
      vmeWR_o            : out    std_logic ;
      vme_Ack_o          : out    std_logic ;
      vme_ErrorLED_no    : out    std_logic ;
      vme_IAckOutb_no    : out    std_logic ;
      vme_IRQb_no        : out    std_logic_vector (7 downto 1);
      vme_LE1_no         : out    std_logic ;
      vme_LE2_no         : out    std_logic ;
      vme_LRD_no         : out    std_logic ;
      vme_LWR_no         : out    std_logic ;
      vme_OEin_no        : out    std_logic ;
      vme_OEout_no       : out    std_logic ;
      dbh_io             : inout  std_logic_vector (15 downto 0);
      dbl_io             : inout  std_logic_vector (15 downto 0);
      vme_db_io          : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component flasher
   generic (
      FLASH_PERIOD : integer := 40000000
   );
   port (
      clk : in     std_logic ;
      rst : in     std_logic ;
      o   : out    std_logic 
   );
   end component;
   component led_drv
   port (
      clk : in     std_logic ;
      i   : in     std_logic ;
      o   : out    std_logic 
   );
   end component;
   component m_buff
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;
   component ram_block_2k
   port (
      addr_i   : in     std_logic_VECTOR (9 downto 0);
      clk      : in     std_logic ;
      db_rd_i  : in     std_logic ;
      db_wr_i  : in     std_logic ;
      ram_en_i : in     std_logic ;
      db_io    : inout  std_logic_vector (15 downto 0)
   );
   end component;
   component regblock
   generic (
      FIRMWARE_ID : integer := 0
   );
   port (
      rst             : in     std_logic ;
      clk             : in     std_logic ;
      db_rd           : in     std_logic ;
      db_wr           : in     std_logic ;
      ren             : in     std_logic_vector (127 downto 0);
      db_d32          : in     std_logic ;
      db              : inout  std_logic_vector (15 downto 0);
      dbh             : inout  std_logic_vector (15 downto 0);
      debug_mode_i    : in     std_logic_vector (3 downto 0);
      spare_bus       : in     std_logic_vector (15 downto 0);
      tim_id_i        : in     std_logic_vector (7 downto 0);
      fpga2ok_i       : in     std_logic ;
      reg_debug1ctl_o : out    std_logic_vector (15 downto 0);
      f2_program_o    : out    std_logic ;
      f2_done_i       : in     std_logic ;
      jtagx_en_o      : out    std_logic ;
      j_xms_o         : out    std_logic ;
      j_xdo_o         : out    std_logic ;
      j_xck_o         : out    std_logic ;
      j_xdi_i         : in     std_logic ;
      f1_spare_link_i : in     std_logic ;
      timestamp_i     : in     std_logic_vector (31 downto 0)
   );
   end component;
   component timestamp
   port (
      epoc_secs : out    std_logic_vector (31 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : clk_rst_mgr use entity TIM_lib.clk_rst_mgr;
   for all : db_interface_f1 use entity TIM_fpga1.db_interface_f1;
   for all : flasher use entity TIM_lib.flasher;
   for all : led_drv use entity TIM_lib.led_drv;
   for all : m_buff use entity TIM_lib.m_buff;
   for all : m_power use entity TIM_lib.m_power;
   for all : ram_block_2k use entity TIM_lib.ram_block_2k;
   for all : regblock use entity TIM_fpga1.regblock;
   for all : timestamp use entity Timestamp.timestamp;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 6 debug_map
   debug1_bus_o(0) <= not led0;
   debug1_bus_o(1) <= not led1;
   debug1_bus_o(2) <= not led2;
   debug1_bus_o(3) <= not led3;
   debug1_bus_o(4) <= not led4;
   debug1_bus_o(5) <= not led5;
   debug1_bus_o(6) <= not led6;
   debug1_bus_o(7) <= not led7;
   debug1_bus_o(15 downto 8) <= not reg_test(15 downto 8);

   -- Instance port mappings.
   clk_rst_mgr_1 : clk_rst_mgr
      generic map (
         RST_DEADTIME  => 7,
         CLKDV_DIVIDER => 2.0
      )
      port map (
         dll_clk_in      => timCLK1_i,
         reset1_i        => ext_Reset_sw_i,
         reset2_i        => VCCINT_error_i,
         reset3_i        => po_reset_i,
         reset4_i        => rst_vme,
         cfg_rst_o       => cfg_rst,
         clk0            => open,
         clk180_nobufg   => open,
         clk2x           => clk2x,
         clk2x180_nobufg => open,
         clkdv_nobufg    => open,
         dll_locked_o    => open,
         reset_o         => pre_rst
      );
   db_interface_f1_1 : db_interface_f1
      port map (
         clk                => clk,
         clk2x              => clk2x,
         pre_reset_i        => pre_rst,
         rst                => rst,
         vme_AB_i           => vme_AB_i,
         vme_AMb_i          => vme_AMb_i,
         vme_ASb_ni         => vme_ASb_ni,
         vme_BErrb_ni       => vme_BErrb_ni,
         vme_BaseAddr_i     => vme_BaseAddr_i,
         vme_BaseAddr_sel_i => vme_BaseAddr_sel_i,
         vme_DS0b_ni        => vme_DS0b_ni,
         vme_DS1b_ni        => vme_DS1b_ni,
         vme_GAPb_ni        => vme_GAPb_ni,
         vme_GAb_ni         => vme_GAb_ni,
         vme_IAckInb_ni     => vme_IAckInb_ni,
         vme_IAckb_ni       => vme_IAckb_ni,
         vme_LWordb_ni      => vme_LWordb_ni,
         vme_Writeb_ni      => vme_Writeb_ni,
         ab16_o             => ab,
         bp_GAoutEn_o       => bp_GAoutEn_o,
         db_d32_o           => db_d32,
         db_rd_o            => db_rd,
         db_wr_o            => db_wr,
         ram1000_en_o       => ram_en,
         reg_en_o           => ren,
         v_reset            => rst_vme,
         vmeD32_o           => vmeD32_o,
         vmeF2SEL_o         => vmeF2SEL_o,
         vmeRD_o            => vmeRD_o,
         vmeWR_o            => vmeWR_o,
         vme_Ack_o          => vme_Ack_o,
         vme_ErrorLED_no    => vme_ErrorLED_no,
         vme_IAckOutb_no    => vme_IAckOutb_no,
         vme_IRQb_no        => vme_IRQb_no,
         vme_LE1_no         => vme_LE1_no,
         vme_LE2_no         => vme_LE2_no,
         vme_LRD_no         => vme_LRD_no,
         vme_LWR_no         => vme_LWR_no,
         vme_OEin_no        => vme_OEin_no,
         vme_OEout_no       => vme_OEout_no,
         dbh_io             => dbh,
         dbl_io             => db,
         vme_db_io          => vme_db_io
      );
   flasher_1 : flasher
      generic map (
         FLASH_PERIOD => 16#FFFFFF#
      )
      port map (
         clk => timCLK1_i,
         rst => ZERO,
         o   => led0
      );
   flasher_2 : flasher
      generic map (
         FLASH_PERIOD => 16#FFFFFF#
      )
      port map (
         clk => clk,
         rst => ZERO,
         o   => led1
      );
   led_drv_6 : led_drv
      port map (
         clk => clk,
         i   => rst_vme,
         o   => led7
      );
   led_drv_5 : led_drv
      port map (
         clk => clk,
         i   => VCCINT_error_i,
         o   => led6
      );
   led_drv_4 : led_drv
      port map (
         clk => clk,
         i   => po_reset_i,
         o   => led5
      );
   led_drv_3 : led_drv
      port map (
         clk => clk,
         i   => ext_Reset_sw_i,
         o   => led4
      );
   led_drv_2 : led_drv
      port map (
         clk => clk,
         i   => pre_rst,
         o   => led3
      );
   led_drv_1 : led_drv
      port map (
         clk => clk,
         i   => rst,
         o   => led2
      );
   I3 : m_buff
      port map (
         I => pre_rst,
         O => reset_out_o
      );
   I2 : m_buff
      port map (
         I => timCLK1_i,
         O => clk
      );
   I1 : m_buff
      port map (
         I => reset_OA_i,
         O => rst
      );
   m_power_1 : m_power
      port map (
         ONE  => ONE,
         ZERO => ZERO
      );
   ram_block_2k_1 : ram_block_2k
      port map (
         addr_i   => ab(10 DOWNTO 1),
         clk      => clk,
         db_rd_i  => db_rd,
         db_wr_i  => db_wr,
         ram_en_i => ram_en,
         db_io    => db
      );
   regblock_1 : regblock
      generic map (
         FIRMWARE_ID => 3
      )
      port map (
         rst             => rst,
         clk             => clk,
         db_rd           => db_rd,
         db_wr           => db_wr,
         ren             => ren,
         db_d32          => db_d32,
         db              => db,
         dbh             => dbh,
         debug_mode_i    => debug_mode_i,
         spare_bus       => spare_bus_i,
         tim_id_i        => tim_ID_i,
         fpga2ok_i       => fpga2ok_i,
         reg_debug1ctl_o => reg_test,
         f2_program_o    => f2_program_o,
         f2_done_i       => f2_done_i,
         jtagx_en_o      => jtagx_en_o,
         j_xms_o         => j_xms_o,
         j_xdo_o         => j_xdo_o,
         j_xck_o         => j_xck_o,
         j_xdi_i         => j_xdi_i,
         f1_spare_link_i => f1_spare_link_i,
         timestamp_i     => epoc_secs_32
      );
   timestamp_1 : timestamp
      port map (
         epoc_secs => epoc_secs_32
      );

end struct;
