-- hds header_start
--
-- VHDL Entity TIM_fpga1.fpga1.symbol
--
-- Created:
--          by - warren.UNKNOWN (PC44)
--          at - 12:44:57 01/27/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library TIM_lib;

ENTITY fpga1 IS
   PORT( 
      reset_OA_ni        : IN     std_logic;
      bp_GAoutEn_no      : OUT    std_logic;
      spareCLK1_i        : IN     std_logic;
      timCLK1_i          : IN     std_logic;
      sigCLK_i           : IN     std_logic;
      vmeCLK_i           : IN     std_logic;
      vmeBDSEL_o         : OUT    std_logic;
      vmeCLK_o           : OUT    std_logic;
      vmeRD_o            : OUT    std_logic;
      vmeWR_o            : OUT    std_logic;
      ext_Reset_sw_i     : IN     std_logic;
      reset_Out_no       : OUT    std_logic;
      reset_Out_o        : OUT    std_logic;
      VCCINT_error_ni    : IN     std_logic;
      vme_Ack_o          : OUT    std_logic;
      vme_AMb_i          : IN     std_logic_vector (5 DOWNTO 0);
      vme_ASb_ni         : IN     std_logic;
      vme_B_select_i     : IN     std_logic;
      vme_BaseAddr_i     : IN     std_logic_vector (31 DOWNTO 16);
      vme_BaseAddr_sel_i : IN     std_logic;
      vme_BErrb_ni       : IN     std_logic;
      vme_dl0_o          : OUT    std_logic;
      vme_dl1_i          : IN     std_logic;
      vme_dl2_i          : IN     std_logic;
      vme_dl3_i          : IN     std_logic;
      vme_DS0b_ni        : IN     std_logic;
      vme_DS1b_ni        : IN     std_logic;
      vme_ErrorLED_no    : OUT    std_logic;
      vme_GAb_ni         : IN     std_logic_vector (4 DOWNTO 0);
      vme_GAPb_ni        : IN     std_logic;
      vme_IAckb_ni       : IN     std_logic;
      vme_IAckInb_ni     : IN     std_logic;
      vme_IAckOutb_no    : OUT    std_logic;
      vme_IRQb_no        : OUT    std_logic_vector (7 DOWNTO 1);
      vme_LE1_no         : OUT    std_logic;
      vme_LE2_no         : OUT    std_logic;
      vme_LRD_no         : OUT    std_logic;
      vme_LWR_no         : OUT    std_logic;
      vme_LWordb_ni      : IN     std_logic;
      vme_OEin_no        : OUT    std_logic;
      vme_OEout_no       : OUT    std_logic;
      vme_Writeb_ni      : IN     std_logic;
      vme_ab_i           : IN     std_logic_vector (31 DOWNTO 0);   -- note ab(0) not conn'd to backplane.
      debug_mode_i       : IN     std_logic_vector (3 DOWNTO 0);
      spare_bus_i        : IN     std_logic_vector (15 DOWNTO 0);
      fpga2ok_i          : IN     std_logic;
      tim_ID_i           : IN     std_logic_vector (7 DOWNTO 0);
      j_xdi_i            : IN     std_logic;
      jtagx_en_o         : OUT    std_logic;
      j_xdo_o            : OUT    std_logic;
      j_xck_o            : OUT    std_logic;
      j_xms_o            : OUT    std_logic;
      sigCLK_o           : OUT    std_logic;
      debug1_bus_o       : OUT    std_logic_vector (15 DOWNTO 0);
      fpga1_tp_o         : OUT    std_logic_vector (16 DOWNTO 1);
      vme_db_io          : INOUT  std_logic_vector (31 DOWNTO 0)
   );

-- Declarations

END fpga1 ;

-- hds interface_end
--
-- VHDL Architecture TIM_fpga1.fpga1.struct
--
-- Created:
--          by - warren.UNKNOWN (PC44)
--          at - 12:44:57 01/27/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
library ieee;
use ieee.std_logic_1164.ALL;
use ieee.std_logic_arith.ALL;

LIBRARY TIM_fpga1;

ARCHITECTURE struct OF fpga1 IS

   -- Architecture declarations

   -- Internal signal declarations
   SIGNAL clk           : std_logic;
   SIGNAL rst           : std_logic;
   SIGNAL vmeWR         : std_logic;
   SIGNAL stop_clk      : std_logic;
   SIGNAL reg_en        : std_logic_vector(63 DOWNTO 0);
   SIGNAL reset_Out     : std_logic;
   SIGNAL vmeReset      : std_logic;
   SIGNAL reg_debugtest : std_logic_vector(15 DOWNTO 0);
   SIGNAL vmeBDSEL      : std_logic;
   SIGNAL fpga2ok       : std_logic;
   SIGNAL j_xdi         : std_logic;
   SIGNAL tim_ID        : std_logic_vector(7 DOWNTO 0);
   SIGNAL vmeCLK_in     : std_logic;
   SIGNAL vmeCLK_out    : std_logic;
   SIGNAL dl0           : std_logic;
   SIGNAL ab            : std_logic_vector(31 DOWNTO 1);
   SIGNAL fpga1_tp      : std_logic_vector(16 DOWNTO 1);
   SIGNAL debugbus_vme  : std_logic_vector(15 DOWNTO 0);
   SIGNAL RAMselect     : std_logic;
   SIGNAL vmeRD         : std_logic;
   SIGNAL dl3           : std_logic;
   SIGNAL spare_bus     : std_logic_vector(15 DOWNTO 0);
   SIGNAL debug_mode    : std_logic_vector(3 DOWNTO 0);
   SIGNAL dl2           : std_logic;
   SIGNAL dl1           : std_logic;
   SIGNAL sigCLK_in     : std_logic;
   SIGNAL sigCLK_out    : std_logic;
   SIGNAL spareCLK      : std_logic;
   SIGNAL jtagx_en      : std_logic;
   SIGNAL j_xdo         : std_logic;
   SIGNAL j_xck         : std_logic;
   SIGNAL j_xms         : std_logic;


   -- Component Declarations
   COMPONENT regblock
   PORT (
      clk           : IN     std_logic ;
      debug_mode    : IN     std_logic_vector (3 DOWNTO 0);
      fpga1_tp      : IN     std_logic_vector (15 DOWNTO 0);
      reg_en        : IN     std_logic_vector (63 DOWNTO 0);
      reset         : IN     std_logic ;
      spare_bus     : IN     std_logic_vector (15 DOWNTO 0);
      tim_ID        : IN     std_logic_vector (7 DOWNTO 0);
      vmeRD         : IN     std_logic ;
      vmeWR         : IN     std_logic ;
      dl0           : OUT    std_logic ;
      j_xck         : OUT    std_logic ;
      j_xdo         : OUT    std_logic ;
      j_xms         : OUT    std_logic ;
      jtagx_en      : OUT    std_logic ;
      reg_debugtest : OUT    std_logic_vector (15 DOWNTO 0);
      sigCLK_out    : OUT    std_logic ;
      stop_clk      : OUT    std_logic ;
      vmeReset      : OUT    std_logic ;
      db            : INOUT  std_logic_vector (31 DOWNTO 0)
   );
   END COMPONENT;
   COMPONENT reset_gen
   PORT (
      clk            : IN     std_logic ;
      VCCINT_error_n : IN     std_logic ;
      ext_Reset_sw   : IN     std_logic ;
      vmeReset       : IN     std_logic ;
      reset_Out      : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT vme
   PORT (
      AM_i           : IN     std_logic_vector (5 DOWNTO 0);
      AS_ni          : IN     std_logic ;
      BErr_ni        : IN     std_logic ;
      B_select_i     : IN     std_logic ;
      BaseAddr_Sel_i : IN     std_logic ;
      BaseAddr_i     : IN     std_logic_vector (31 DOWNTO 16);
      DS0_ni         : IN     std_logic ;
      DS1_ni         : IN     std_logic ;
      GAP_ni         : IN     std_logic ;
      GA_ni          : IN     std_logic_vector (4 DOWNTO 0);
      IAck_ni        : IN     std_logic ;
      IAckin_ni      : IN     std_logic ;
      LWord_ni       : IN     std_logic ;
      Write_ni       : IN     std_logic ;
      ab_i           : IN     std_logic_vector (31 DOWNTO 1);
      clk            : IN     std_logic ;
      rst            : IN     std_logic ;
      Ack_o          : OUT    std_logic ;
      DebugBus_o     : OUT    std_logic_vector (15 DOWNTO 0);
      ErrorLED_no    : OUT    std_logic ;
      GAoutEn_no     : OUT    std_logic ;
      IAckout_no     : OUT    std_logic ;
      Irq_no         : OUT    std_logic_vector (7 DOWNTO 1);
      LE1_no         : OUT    std_logic ;
      LE2_no         : OUT    std_logic ;
      LRD_no         : OUT    std_logic ;
      LWR_no         : OUT    std_logic ;
      OEin_no        : OUT    std_logic ;
      OEout_no       : OUT    std_logic ;
      --Stop_Clk_o   	: out std_logic;
      RAMselect_o    : OUT    std_logic ;
      RegBus_o       : OUT    std_logic_vector (63 DOWNTO 0);
      vmeBDSEL_o     : OUT    std_logic ;
      vmeCLK_o       : OUT    std_logic ;
      vmeRD_o        : OUT    std_logic ;
      vmeWR_o        : OUT    std_logic 
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : regblock USE ENTITY TIM_fpga1.regblock;
   FOR ALL : reset_gen USE ENTITY TIM_fpga1.reset_gen;
   FOR ALL : vme USE ENTITY TIM_fpga1.vme;
   -- pragma synthesis_on


BEGIN
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 in_sigs_map
   fpga2ok     <= fpga2ok_i;
   j_xdi       <= j_xdi_i;
   tim_ID      <= tim_ID_i;
   
   spareCLK    <= spareCLK1_i;
   sigCLK_in   <= sigCLK_i;
   vmeCLK_in   <= vmeCLK_i;
   
   dl1         <= vme_dl1_i;
   dl2         <= vme_dl2_i;
   dl3         <= vme_dl3_i;
   
   ab <= vme_ab_i(31 downto 1);
   -- vme_ab_i(0) is unused & spare.
   
   debug_mode  <= debug_mode_i;
   spare_bus   <= spare_bus_i;
   
   clk         <= TIMCLK1_i;
   rst         <= (not reset_OA_ni);

   -- HDL Embedded Text Block 3 out_sigs_map
   reset_Out_o  <= reset_Out;
   reset_Out_no <= not reset_Out;
   
   vmeBDSEL_o <= vmeBDSEL;
   vmeRD_o    <= vmeRD;
   vmeWR_o    <= vmeWR;
   
   vmeclk_o <= vmeclk_out;
   
   jtagx_en_o <= jtagx_en;
   j_xck_o <= j_xck;
   j_xdo_o <= j_xdo;
   j_xms_o <= j_xms;
   
   sigclk_o <= sigclk_out;
   vme_dl0_o <= dl0;
   
   fpga1_tp_o <= fpga1_tp;

   -- HDL Embedded Text Block 5 debug_testpoint_map
   -- Debug Bus & Test Points
   
   fpga1_tp(15) <= j_xdi;
   fpga1_tp(14) <= VCCINT_error_ni;
   fpga1_tp(13) <= spareCLK;
   fpga1_tp(12) <= sigCLK_in;
   fpga1_tp(11) <= vmeCLK_in;
   fpga1_tp(10) <= dl1;
   fpga1_tp( 9) <= dl2;
   fpga1_tp( 8) <= dl3;
   fpga1_tp( 7) <= vmeRD;
   fpga1_tp( 6) <= vmeWR;
   fpga1_tp( 5) <= vmeBDSEL;
   fpga1_tp( 4) <= Stop_clk;
   fpga1_tp( 3) <= RAMselect;
   fpga1_tp( 2) <= fpga2ok;
   fpga1_tp( 1) <= reset_Out;
   
   debug1_bus_o(15 downto 8) <= debugbus_vme(7 downto 0);
   debug1_bus_o( 7 downto 0) <= not reg_debugtest(7 downto 0);

   -- Instance port mappings.
   I0 : regblock
      PORT MAP (
         clk           => clk,
         debug_mode    => debug_mode,
         fpga1_tp      => fpga1_tp,
         reg_en        => reg_en,
         reset         => rst,
         spare_bus     => spare_bus,
         tim_ID        => tim_ID,
         vmeRD         => vmeRD,
         vmeWR         => vmeWR,
         dl0           => dl0,
         j_xck         => j_xck,
         j_xdo         => j_xdo,
         j_xms         => j_xms,
         jtagx_en      => jtagx_en,
         reg_debugtest => reg_debugtest,
         sigCLK_out    => sigCLK_out,
         stop_clk      => stop_clk,
         vmeReset      => vmeReset,
         db            => vme_db_io
      );
   I2 : reset_gen
      PORT MAP (
         clk            => clk,
         VCCINT_error_n => VCCINT_error_ni,
         ext_Reset_sw   => ext_Reset_sw_i,
         vmeReset       => vmeReset,
         reset_Out      => reset_Out
      );
   I1 : vme
      PORT MAP (
         AM_i           => vme_AMb_i,
         AS_ni          => vme_ASb_ni,
         BErr_ni        => vme_BErrb_ni,
         B_select_i     => vme_B_select_i,
         BaseAddr_Sel_i => vme_BaseAddr_sel_i,
         BaseAddr_i     => vme_BaseAddr_i,
         DS0_ni         => vme_DS0b_ni,
         DS1_ni         => vme_DS1b_ni,
         GAP_ni         => vme_GAPb_ni,
         GA_ni          => vme_GAb_ni,
         IAck_ni        => vme_IAckb_ni,
         IAckin_ni      => vme_IAckInb_ni,
         LWord_ni       => vme_LWordb_ni,
         Write_ni       => vme_Writeb_ni,
         ab_i           => ab,
         clk            => clk,
         rst            => rst,
         Ack_o          => vme_Ack_o,
         DebugBus_o     => debugbus_vme,
         ErrorLED_no    => vme_ErrorLED_no,
         GAoutEn_no     => bp_GAoutEn_no,
         IAckout_no     => vme_IAckOutb_no,
         Irq_no         => vme_IRQb_no,
         LE1_no         => vme_LE1_no,
         LE2_no         => vme_LE2_no,
         LRD_no         => vme_LRD_no,
         LWR_no         => vme_LWR_no,
         OEin_no        => vme_OEin_no,
         OEout_no       => vme_OEout_no,
         RAMselect_o    => RAMselect,
         RegBus_o       => reg_en,
         vmeBDSEL_o     => vmeBDSEL,
         vmeCLK_o       => vmeCLK_out,
         vmeRD_o        => vmeRD,
         vmeWR_o        => vmeWR
      );

END struct;
