-- hds header_start
--
-- VHDL Architecture TIM_fpga1.oldsigs_fpga1_tester.test
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:42:53 10/03/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;


entity oldsigs_fpga1_tester is
   port( 
      ack             : in     std_logic;
      OA_reset        : in     std_logic;
      bRead           : in     std_logic;
      bWrite          : in     std_logic;
      debug1_bus      : in     std_logic_vector (15 downto 0);
      dl0             : in     std_logic;
      fpga1_tp        : in     std_logic_vector (16 downto 1);
      j_xck           : in     std_logic;
      j_xdo           : in     std_logic;
      j_xms           : in     std_logic;
      jtagx_en        : in     std_logic;
      nErrorLED       : in     std_logic;
      nGAoutEn        : in     std_logic;
      nIAckOutb       : in     std_logic;
      nIRQb           : in     std_logic_vector (7 downto 1);
      nLE1            : in     std_logic;
      nLE2            : in     std_logic;
      nOA_reset       : in     std_logic;
      nOEin           : in     std_logic;
      nOEout          : in     std_logic;
      sigCLK_XOX      : in     std_logic;
      vmeBDSEL        : in     std_logic;
      vmeCLK_XOX      : in     std_logic;
      vmeRD           : in     std_logic;
      vmeWR           : in     std_logic;
      AMb             : out    std_logic_vector (5 downto 0);
      B_select        : out    std_logic;
      BaseAddr_Select : out    std_logic;
      ab              : out    std_logic_vector (31 downto 0);
      base_addr       : out    std_logic_vector (31 downto 16);
      debug_mode      : out    std_logic_vector (3 downto 0);
      dl1             : out    std_logic;
      dl2             : out    std_logic;
      dl3             : out    std_logic;
      fpga2ok         : out    std_logic;
      j_xdi           : out    std_logic;
      nASb            : out    std_logic;
      nBErrb          : out    std_logic;
      nDS0b           : out    std_logic;
      nDS1b           : out    std_logic;
      nGAPb           : out    std_logic;
      nGAb            : out    std_logic_vector (4 downto 0);
      nIAckInb        : out    std_logic;
      nIAckb          : out    std_logic;
      nLWordb         : out    std_logic;
      nVCCINT_error   : out    std_logic;
      nWriteb         : out    std_logic;
      sReset          : out    std_logic;
      sigCLK          : out    std_logic;
      spare_bus       : out    std_logic_vector (15 downto 0);
      timCLK1         : out    std_logic;
      vmeCLK          : out    std_logic;
      db              : inout  std_logic_vector (31 downto 0);
      spareCLK1       : out    std_logic;
      tim_ID          : out    std_logic_vector (7 downto 0)
   );

-- Declarations

end oldsigs_fpga1_tester ;

-- hds interface_end
architecture test of oldsigs_fpga1_tester is

	signal clk 	 : std_logic := '1';

begin
-------------------------------------------------------

	-- clock generator
	clk <= not clk after 12500 ps;
	timclk1 <= clk;

	--------------------------------------------------------
	fpga1_sim : process
	begin
	
	
		j_xdi           <= '0';
      nVCCINT_error   <= '0';
      sReset          <= '0';
      sigCLK          <= '0';
      spareCLK1       <= '0';
      spare_bus       <= (others => '0');
      tim_ID          <= (others => '0');
      debug_mode		 <= (others => '0');
      
      
      vmeCLK          <= '0';
      
      db              <= (others => 'Z');

		B_select        <= '1';
		ab              <= "00000000000000000000000000000000";
		BaseAddr_Select <= '0';
		base_addr       <= "1111000011111111";  -- 0xf0ff
		AMb             <= "000000";
		nLWordb         <= '1';
		nDS1b           <= '1';
		nGApb           <= '1';
		nGAb            <= "11111";
		nIAckInb        <= '1';
		nIAckb          <= '1';
		nASb            <= '1';
		nBErrb          <= '1';
		nDS0b           <= '1';
		nWriteb         <= '1';
		
		
		wait for 12 ns;
		
      sReset <= '1';
		wait for  70 ns;
      sReset <= '0';
		
		wait for 22 ns;                    -- allow settling (esp. delay_unit)
		
		
		
		---------------------------------------------------------------------------
		-- vme read
		---------------------------------------------------------------------------
		
		nWriteb <= '1';                                -- read
		ab      <= "11110000111111111000000000000010";  -- f0ff8002h a32 base addr, ram
		AMb     <= "001101";                           -- 0dh = a32
		
		wait for 23 ns;
		
		nASb <= '0';
		
		wait for 2 ns;
		
		--db  <= "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
		wait for 5 ns;
		
		nDS0b <= '0';
		nDS1b <= '0';
		
		wait for 93 ns;
		
		nASb <= '1';                        -- not sure if this is right time
		
		wait for 16 ns;
		
		ab  <= (others => 'U');
		
		wait for 34 ns;
		
		nDS0b <= '1';
		nDS1b <= '1';
		
		wait for 133 ns;
		
		
		
		
		
		---------------------------------------------------------------------------
		-- procedure vme write
		---------------------------------------------------------------------------
		
		baseaddr_select <= '0';  --non geogaddr mode      
		
		wait for 12 ns;
		
		nWriteb <= '0';                                 -- write
		ab      <= "00000000111111110000000001000000";   -- a24: ff0040 (f1 reg)   
		wait for 1 ns;    
		AMb     <= "111101";                              -- 3dh = a24
		
		wait for 17 ns;
		
		nASb <= '0';
		
		wait for 3 ns;

		--db  <= "11110000111000001101000011000001"; -- F0E0D0C1
		wait for 5 ns;

		
		nDS0b <= '0';
		wait for 3 ns;
		nDS1b <= '0';
		
		wait for 108 ns;
		
		nASb <= '1';                        -- not sure if this is right time
		
		wait for 12 ns;
		
		ab  <= (others => 'U');
		
		wait for 45 ns;
		
		nDS0b <= '1';
		nDS1b <= '1';
		
		wait for 165 ns;
		
		
		---------------------------------------------------------------------------
		-- vme read
		---------------------------------------------------------------------------
		
		nWriteb <= '1';                                 -- read
		ab      <= "11110000111111110000000001000010";  -- f0ff0042h a32 base addr, reg00
		AMb     <= "001101";                            -- 0dh = a32
		
		wait for 23 ns;
		
		nASb <= '0';
		
		wait for 2 ns;
		
		--db  <= "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
		wait for 5 ns;
				
		nDS0b <= '0';
		nDS1b <= '0';
		
		wait for 93 ns;
		
		nASb <= '1';                        -- not sure if this is right time
		
		wait for 16 ns;
		
		ab  <= (others => 'U');
		
		wait for 34 ns;
		
		nDS0b <= '1';
		nDS1b <= '1';
		
		wait for 154 ns;
		
		
		
		
		
		---------------------------------------------------------------------------
		-- procedure vme write
		---------------------------------------------------------------------------
		
		baseaddr_select <= '0';  --non geogaddr mode      
		
		wait for 12 ns;
		
		nWriteb <= '0';                                 -- write
		ab      <= "00000000111111110000000001000000";   -- a24: ff0040   
		wait for 1 ns;
		AMb     <= "111101";                              -- 3dh = a24
		
		wait for 17 ns;
		
		nASb <= '0';
		
		wait for 1 ns;
		
		--db  <= "00010010001101000101011001111000"; -- 12345678
		wait for 4 ns;
		
		nDS0b <= '0';
		wait for 1 ns;
		nDS1b <= '0';
		
		wait for 108 ns;
		
		nASb <= '1';                        -- not sure if this is right time
		
		wait for 12 ns;
		
		ab  <= (others => 'U');
		
		wait for 45 ns;
		
		nDS0b <= '1';
		nDS1b <= '1';
		
		wait for 182 ns;
		
		
		---------------------------------------------------------------------------
		-- non access (read)
		---------------------------------------------------------------------------
		wait for 201 ns;
		
		nWriteb <= '1';                                 -- read
		ab      <= "00010000000100010000000001000010";  -- 10100042h a32 base addr, reg42
		AMb     <= "001101";                            -- 0dh = a32
		
		wait for 23 ns;
		
		nASb <= '0';
		
		wait for 3 ns;
		
		--db  <= "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
		wait for 5 ns;
		
		nDS0b <= '0';
		nDS1b <= '0';
		
		wait for 93 ns;
		
		nASb <= '1';                        -- not sure if this is right time
		
		wait for 16 ns;
		
		ab  <= (others => 'U');
		
		wait for 34 ns;
		
		nDS0b <= '1';
		nDS1b <= '1';
		
		wait for 221 ns;
		
		
		---------------------------------------------------------------------------
		-- geag addr vme read
		---------------------------------------------------------------------------
		
		baseaddr_select <= '1';  -- geogaddr mode
		
		wait for 43 ns;
		
		nWriteb <= '1';                                 -- read
		ab      <= "00001101000000000000000001000010";  -- 0d000042h a32 base addr, reg42
		AMb     <= "001101";                            -- 0dh = a32
		
		wait for 22 ns;
		
		nASb <= '0';
		
		--db  <= "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
		wait for 5 ns;
		
		wait for 2 ns;
		
		nDS0b <= '0';
		nDS1b <= '0';
		
		wait for 103 ns;
		
		nASb <= '1';                        -- not sure if this is right time
		
		wait for 17 ns;
		
		ab  <= (others => 'U');
		
		
		wait for 39 ns;
		
		nDS0b <= '1';
		nDS1b <= '1';
		
		wait for 99 ns;
		
		wait;
	end process;

end test;
