-- hds header_start
--
-- VHDL Architecture TIM_fpga1.regblock.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:34:28 10/03/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

library TIM_fpga1;
use TIM_fpga1.f1_globals.all;


entity regblock is
   generic( 
      FIRMWARE_ID : integer := 0
   );
   port( 
      rst             : in     std_logic;
      clk             : in     std_logic;
      db_rd           : in     std_logic;
      db_wr           : in     std_logic;
      ren             : in     std_logic_vector (127 downto 0);
      db_d32          : in     std_logic;
      db              : inout  std_logic_vector (15 downto 0);
      dbh             : inout  std_logic_vector (15 downto 0);
      debug_mode_i    : in     std_logic_vector (3 downto 0);
      spare_bus       : in     std_logic_vector (15 downto 0);
      tim_id_i        : in     std_logic_vector (7 downto 0);
      fpga2ok_i       : in     std_logic;
      reg_debug1ctl_o : out    std_logic_vector (15 downto 0);
      f2_program_o    : out    std_logic;
      f2_done_i       : in     std_logic;
      jtagx_en_o      : out    std_logic;
      j_xms_o         : out    std_logic;
      j_xdo_o         : out    std_logic;
      j_xck_o         : out    std_logic;
      j_xdi_i         : in     std_logic;
      f1_spare_link_i : in     std_logic;
      timestamp_i     : in     std_logic_vector (31 downto 0)
   );

-- Declarations

end regblock ;


-- hds interface_end
architecture rtl of regblock is

	subtype  d16            is std_logic_vector(15 downto 0);
   type     d16_reg_array  is array (15 downto 0) of d16;
   
   signal 	reg : d16_reg_array;

	
	alias dbhi is dbh(15 downto 0);	
	alias dblo is db(15 downto  0);
	
	constant HIZ16 : std_logic_vector(15 downto 0) := "ZZZZZZZZZZZZZZZZ";
	
begin


	-- Reg Output maps
	-------------------

	reg_debug1ctl_o	<= reg(DEBUG1CTL);
	
	jtagx_en_o 		<= '0';
	j_xck_o    		<= '0';
	j_xdo_o			<= '0';
	j_xms_o    		<= '0';
	f2_program_o	<= '0';


	-- Reg input maps
	-------------------
	
	reg(STATUS1)(15 downto 8)	<= (others => '0');
	reg(STATUS1)( 7 downto 4) 	<= debug_mode_i;
	reg(STATUS1)(3) 				<= f1_spare_link_i;
	reg(STATUS1)(2) 				<= fpga2ok_i;	
	reg(STATUS1)(1)				<= j_xdi_i;  
	reg(STATUS1)(0)				<= f2_done_i;
	
	reg(TIM_ID1)(15 downto 8)	<= conv_std_logic_vector(FIRMWARE_ID,8); 
	reg(TIM_ID1)( 7 downto 0) 	<= tim_id_i; 
	
	reg(TSTAMP1H) 					<= timestamp_i(31 downto 16);
   reg(TSTAMP1L)					<= timestamp_i(15 downto  0);
   
   reg(DEBUG1STAT)				<= (others => '0');

	---------------------------------------------------
	-- Some registers
	---------------------------------------------
	
	-- WRITESs
	----------
	process (clk)
	begin

		if rising_edge(clk) then
		   if (rst = '1') then
		      reg(ENABLES1	)  <= (others => '0');
		      reg(COMMAND1	)  <= (others => '0');
		      reg(DEBUG1CTL	) 	<= (others => '0');
		      	
			else
				if (db_wr = '1') then
			   	if (ren(ENABLES1	) = '1') then reg(ENABLES1	   ) <= dblo; end if;
			   	if (ren(COMMAND1	) = '1') then reg(COMMAND1	   ) <= dblo; end if;
			   	
			   	
			   	if (ren(DEBUG1CTL	) = '1') then reg(DEBUG1CTL	) <= dblo; end if;
  		      	
  		      end if;
			end if;
	   end if;
	end process;
	


	-- READs
	--------
			
	dblo <= reg(ENABLES1	   )		when ((db_rd and ren(ENABLES1	   )) = '1') else HIZ16;
	dblo <= reg(COMMAND1	   )		when ((db_rd and ren(COMMAND1	   )) = '1') else HIZ16;
	dblo <= reg(STATUS1 		)		when ((db_rd and ren(STATUS1 		)) = '1') else HIZ16;
	dblo <= reg(TIM_ID1		)		when ((db_rd and ren(TIM_ID1		)) = '1') else HIZ16;
	dblo <= reg(TSTAMP1L		)		when ((db_rd and ren(TSTAMP1L		)) = '1') else HIZ16;
	dblo <= reg(TSTAMP1H		)		when ((db_rd and ren(TSTAMP1H		)) = '1') else HIZ16;
	dblo <= reg(DEBUG1CTL	)		when ((db_rd and ren(DEBUG1CTL	)) = '1') else HIZ16;
	dblo <= reg(DEBUG1STAT	)		when ((db_rd and ren(DEBUG1STAT	)) = '1') else HIZ16;
	

end rtl;
