-- hds header_start
--
-- VHDL Architecture TIM_fpga1.vme.untitled
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 13:56:45 02/04/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity vme is
   port( 
      clk            : in     std_logic;
      rst            : in     std_logic;
      AM_i           : in     std_logic_vector (5 downto 0);
      AS_ni          : in     std_logic;
      BErr_ni        : in     std_logic;
      B_select_i     : in     std_logic;
      BaseAddr_Sel_i : in     std_logic;
      BaseAddr_i     : in     std_logic_vector (31 downto 16);
      DS0_ni         : in     std_logic;
      DS1_ni         : in     std_logic;
      GAP_ni         : in     std_logic;
      GA_ni          : in     std_logic_vector (4 downto 0);
      IAck_ni        : in     std_logic;
      IAckin_ni      : in     std_logic;
      LWord_ni       : in     std_logic;
      Write_ni       : in     std_logic;
      AB_i           : in     std_logic_vector (31 downto 0);
      Ack_o          : out    std_logic;
      DebugBus_o     : out    std_logic_vector (15 downto 0);
      ErrorLED_no    : out    std_logic;
      GAoutEn_no     : out    std_logic;
      IAckout_no     : out    std_logic;
      Irq_no         : out    std_logic_vector (7 downto 1);
      LE1_no         : out    std_logic;
      LE2_no         : out    std_logic;
      LRD_no         : out    std_logic;
      LWR_no         : out    std_logic;
      OEin_no        : out    std_logic;
      OEout_no       : out    std_logic;
      vmeBDSEL_o     : out    std_logic;
      vmeCLK_o       : out    std_logic;
      vmeRD_o        : out    std_logic;
      vmeWR_o        : out    std_logic
   );

-- Declarations

end vme ;

-- hds interface_end

architecture rtlold of vme is

	signal Write			: std_logic;
	signal AS 	       	: std_logic;
	signal DS				: std_logic;
	signal GA           	: std_logic_vector( 4 downto 0);
	signal GAP    			: std_logic;
	signal GA_GAP     	: std_logic_vector( 5 downto 0);
	signal IAck   	      : std_logic;
--	signal IAckin 	      : std_logic;
	signal LWord  	      : std_logic;
	signal BErr				: std_logic;

	signal GeogA_mode	   : std_logic;
	signal geoga_slot13  : std_logic;
	signal geoga_error   : std_logic;


	signal am_base_ok		: std_logic;
	signal bdsel			: std_logic;
	signal addr         	: std_logic_vector(31 downto 0);

	signal ds_rising1    : std_logic;
--	signal ds_rising2    : std_logic;
	signal ds_falling 	: std_logic;

	signal a24				: std_logic; 
	signal a32				: std_logic; 
                                     
	signal baseaddr24_ok	: std_logic; 
	signal baseaddr32_ok	: std_logic; 


begin

 	-- Negative Logic Conversions
	-----------------------------
	Write		<= not Write_ni;
	DS 		<= (not DS0_ni) or (not DS1_ni);
	AS 		<= not AS_ni;
	BErr 		<= not BErr_ni;
	GA     	<= not GA_ni;
	GAP    	<= not GAP_ni;
	IAck   	<= not IAck_ni;
--	IAckin 	<= not IAckin_ni;
	LWord		<= not LWord_ni;


	---------------------------------------------------------------------------
	-- Address Setup Block
	---------------------------------------------------------------------------
	base_address : block

		signal BaseAddr32		: std_logic_vector (31 downto 16);
		signal BaseAddr24		: std_logic_vector (23 downto 16);

		signal IAck_AM			: std_logic_vector ( 6 downto 0);
		
		signal bdaddr32		: std_logic_vector (31 downto 16);
		signal bdaddr24	 	: std_logic_vector (23 downto 16);

		

	
	---------------------------------------------------------------------------
	begin

		GA_GAP 		<= GA & GAP;
		GeogA_mode 	<= BaseAddr_Sel_i; -- zero = switch set addr
		
		IAck_AM		<= IAck  &  AM_i(5 downto 0);
		
		BaseAddr32 	<= BaseAddr_i(31 downto 16);
		BaseAddr24 	<= BaseAddr_i(23 downto 16);
	
		process (rst, clk)
		begin
		
			if (rst = '1') then 
				geoga_slot13 <= '0';
				geoga_error  <= '0';

				a24 <= '0';
				a32 <= '0';
				
				bdaddr32 <= "0000000000000000"; 
            bdaddr24 <= "00000000"; 
            
				baseaddr32_ok  <= '0';
				baseaddr24_ok  <= '0';
				
				am_base_ok <= '0';
			
			elsif rising_edge(clk) then
			
				-- Geographical Address Setup
				-------------------------------------------------------------------------
				if (GA_GAP = "011010") then
					geoga_slot13 <= '1';
					geoga_error  <= '0';
	
				elsif (GA_GAP = "000000") then
					geoga_slot13 <= '0';
					geoga_error  <= '0'; 
	
				else
					geoga_slot13 <= '0';
					geoga_error  <= '1';
					
				end if;						


				-- Address Mode Decoder
				------------------------------------------------------
				if 	(IAck_AM = "0111101") or (IAck_AM = "0111001") then
					a24 <= '1';
					a32 <= '0';
				
				elsif (IAck_AM = "0001101") or (IAck_AM = "0001001") then
					a24 <= '0';
					a32 <= '1';
				
				else
					a24 <= '0';
					a32 <= '0';
				
				end if;	


				-- Base Address Setup
				--------------------------------------------------------------------------
					
				if (GeogA_mode = '1') then
					bdaddr32 <= "0000110100000000"; 
					bdaddr24 <=         "00001101";
				
				else
					bdaddr32 <= BaseAddr32;
					bdaddr24 <= BaseAddr24;

				end if;
				
				-- Base Decoder
				--------------------
				
				if (ab_i(31 downto 16) = bdaddr32) then
					baseaddr32_ok <= '1';
				else
				 	baseaddr32_ok <= '0';
				end if;
				
				if (ab_i(23 downto 16) = bdaddr24) then
					baseaddr24_ok <= '1';
				else
				 	baseaddr24_ok <= '0';
				end if;
			
				am_base_ok	<= (a24 and baseaddr24_ok) or (a32 and baseaddr32_ok);
								
			end if;
		end process;
		

		GAoutEn_no 	 <= not geoga_slot13;
		
		
		
		-- Board Select Latch
		----------------------------------------------------------------
		
		process (rst, clk)
		begin
			if (rst = '1') then
				bdsel <= '0';
			
			elsif rising_edge(clk) then
			
				if (ds_rising1 = '1') then
					bdsel <= am_base_ok;
				
				elsif (ds_falling = '1') then
					bdsel <= '0';
				
				end if;
			end if;
		end process;
		
	end block;
	---------------------------------------------------------------------------




	---------------------------------------------------------------------------
	-- VME IO Control
	---------------------------------------------------------------------------
	io_control : block

		signal dsq0			: std_logic;
		signal dsq1   	  	: std_logic;
		signal dsq2   	  	: std_logic;
		signal dsq3   	  	: std_logic;
		signal dsq4   	  	: std_logic;
		signal dsq5   	  	: std_logic;
                        
		signal wrq0			: std_logic;
		signal rdq0			: std_logic;

		signal vmebdsel	: std_logic;
		signal vmewr		: std_logic;
		signal vmerd 		: std_logic;
		signal le1			: std_logic;
		signal le2    		: std_logic;
		signal oein   		: std_logic;
		signal oeout  		: std_logic;
		signal Ack  		: std_logic;

	begin
		-- DS synchroniser
		-------------------------
		-- *** note internal delay generating pipeling -- ***25ns steps

		process (rst, clk)
		begin
			if (rst = '1') then
				dsq0 <= '0';
				dsq1 <= '0';
				dsq2 <= '0';
				dsq3 <= '0';
				dsq4 <= '0';
				dsq5 <= '0';

			elsif rising_edge(clk) then
				dsq0 <= DS;
				dsq1 <= dsq0;
				dsq2 <= dsq1;
				dsq3 <= dsq2;
				dsq4 <= dsq3;
				dsq5 <= dsq4;

			end if;
		end process;

		ds_rising1 <= dsq0 and (not dsq1);
	--	ds_rising2 <= dsq1 and (not dsq2);
		ds_falling <= dsq1 and (not dsq0);


		-- I/O Control --
		------------------
		process (rst, clk)
		begin
			if (rst = '1') then
				wrq0 		<= '0';
				rdq0 		<= '0';
				vmebdsel <= '0';
				vmewr 	<= '0';
				vmerd 	<= '0';
				le1		<= '1';
				le2 		<= '0';
				ack   	<= '0';

			elsif rising_edge(clk) then
				wrq0 		<= Write;
				rdq0 		<= not Write;
				vmebdsel <= bdsel;
				vmewr 	<= bdsel and wrq0;
				vmerd 	<= bdsel and rdq0;
				le1 		<= not (bdsel and dsq5);
				le2 		<= bdsel and dsq5 and wrq0;
				ack 		<= bdsel and dsq5;

			end if;
		end process;

		oein 	<= vmewr;
		oeout	<= vmerd;

		Ack_o	     <= ack;
		vmeWR_o    <= vmewr;
		vmeRD_o    <= vmerd;
		vmeBDSEL_o <= vmebdsel;
		vmeCLK_o   <= le2; 
		LRD_no	  <= not (vmerd); -- old bRead but goes to latches only
		LWR_no	  <= not (vmewr); -- old bWrite   ditto
		LE1_no     <= not (le1);
		LE2_no     <= not (le2);
		OEin_no    <= not (oein);
		OEout_no   <= not (oeout);

	end block;

	ErrorLED_no <= not (BErr or geoga_error);

	---------------------------------------------------------------------------
	-- IRQ Stuff - disabled for now
	---------------------------------------------------------------------------

  	Irq_no     <= "1111111";
  	IAckout_no <= IAckin_ni;




	---------------------------------------------------------------------------
	-- DebugBus
	---------------------------------------------------------------------------

	DebugBus_o(15 downto 8) <= addr(8 downto 1);
  	DebugBus_o( 7) <= geoga_slot13;
  	DebugBus_o( 6) <= geoga_error;
  	DebugBus_o( 5) <= a24;
  	DebugBus_o( 4) <= a32;
  	DebugBus_o( 3) <= baseaddr32_ok;
  	DebugBus_o( 2) <= baseaddr24_ok;
  	DebugBus_o( 1) <= am_base_ok;
  	DebugBus_o( 0) <= GeogA_mode;


end rtlold;
