-- hds header_start
--
-- VHDL Entity TIM_fpga2.db_interface_f2.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 18:21:43 05/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library TIM_fpga2;
use TIM_fpga2.f2_globals.all;

ENTITY db_interface_f2 IS
   PORT( 
      clk          : IN     std_logic;
      rst          : IN     std_logic;
      vmeD32_i     : IN     std_logic;
      vmeF2SEL_i   : IN     std_logic;
      vmeRD_i      : IN     std_logic;
      vmeWR_i      : IN     std_logic;
      vme_ab_i     : IN     std_logic_vector (15 DOWNTO 0);
      ab16_o       : OUT    std_logic_vector (15 DOWNTO 0);
      db_d32_o     : OUT    std_logic;
      db_rd0_o     : OUT    std_logic;
      db_rd_o      : OUT    std_logic;
      db_wr_o      : OUT    std_logic;
      ram8000_en_o : OUT    std_logic;
      ren_o        : OUT    std_logic_vector (127 DOWNTO 0);
      dbh_io       : INOUT  std_logic_vector (15 DOWNTO 0);
      dbl_io       : INOUT  std_logic_vector (15 DOWNTO 0);
      vme_db_io    : INOUT  std_logic_vector (31 DOWNTO 0)
   );

-- Declarations

END db_interface_f2 ;

-- hds interface_end
--
-- VHDL Architecture TIM_fpga2.db_interface_f2.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 18:21:43 05/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library TIM_fpga2;
use TIM_fpga2.f2_globals.all;

LIBRARY TIM_lib;

ARCHITECTURE struct OF db_interface_f2 IS

   -- Architecture declarations

   -- Internal signal declarations
   SIGNAL ONE    : std_logic;
   SIGNAL f2_sel : std_logic;


   -- Component Declarations
   COMPONENT addr_decoder
   PORT (
      rst     : IN     std_logic ;
      clk     : IN     std_logic ;
      enable  : IN     std_logic ;
      addr    : IN     std_logic_vector (15 DOWNTO 0);
      --addr_latch : in     std_logic;
      ram8_en : OUT    std_logic ;
      ren2_o  : OUT    std_logic_vector (127 DOWNTO 0);
      f2_sel  : OUT    std_logic ;
      f1_sel  : OUT    std_logic ;
      ren1_o  : OUT    std_logic_vector (127 DOWNTO 0);
      ram1_en : OUT    std_logic ;
      ab16_o  : OUT    std_logic_vector (15 DOWNTO 0)
   );
   END COMPONENT;
   COMPONENT db_control
   GENERIC (
      PD_FACTOR : integer := 0
   );
   PORT (
      clk       : IN     std_logic ;
      rst       : IN     std_logic ;
      sel       : IN     std_logic ;
      vmeRD     : IN     std_logic ;
      vmeWR     : IN     std_logic ;
      vmeD32    : IN     std_logic ;
      dbh_io    : INOUT  std_logic_vector (15 DOWNTO 0);
      dbl_io    : INOUT  std_logic_vector (15 DOWNTO 0);
      vme_db_io : INOUT  std_logic_vector (31 DOWNTO 0);
      db_rd     : OUT    std_logic ;
      db_rd0    : OUT    std_logic ;
      db_d32    : OUT    std_logic ;
      db_wr     : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT m_power
   PORT (
      ONE  : OUT    std_logic ;
      ZERO : OUT    std_logic 
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : addr_decoder USE ENTITY TIM_lib.addr_decoder;
   FOR ALL : db_control USE ENTITY TIM_lib.db_control;
   FOR ALL : m_power USE ENTITY TIM_lib.m_power;
   -- pragma synthesis_on


BEGIN
   -- Instance port mappings.
   addr_decoder_1 : addr_decoder
      PORT MAP (
         rst     => rst,
         clk     => clk,
         enable  => vmeF2SEL_i,
         addr    => vme_ab_i,
         ram8_en => ram8000_en_o,
         ren2_o  => ren_o,
         f2_sel  => f2_sel,
         f1_sel  => OPEN,
         ren1_o  => OPEN,
         ram1_en => OPEN,
         ab16_o  => ab16_o
      );
   db_control_1 : db_control
      GENERIC MAP (
         PD_FACTOR => 1
      )
      PORT MAP (
         clk       => clk,
         rst       => rst,
         sel       => f2_sel,
         vmeRD     => vmeRD_i,
         vmeWR     => vmeWR_i,
         vmeD32    => vmeD32_i,
         dbh_io    => dbh_io,
         dbl_io    => dbl_io,
         vme_db_io => vme_db_io,
         db_rd     => db_rd_o,
         db_rd0    => db_rd0_o,
         db_d32    => db_d32_o,
         db_wr     => db_wr_o
      );
   I0 : m_power
      PORT MAP (
         ONE  => ONE,
         ZERO => OPEN
      );

END struct;
