-- hds header_start
--
-- VHDL Architecture TIM_fpga2.db_interface.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:21:37 01/14/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity db_interface is
   port( 
      clk        : in     std_logic;
      rst        : in     std_logic;
      db_id_io   : inout  std_logic_vector (15 downto 0);
      db_mix_io  : inout  std_logic_vector (15 downto 0);
      db_rb_io   : inout  std_logic_vector (15 downto 0);
      db_sam_io  : inout  std_logic_vector (15 downto 0);
      db_seq_io  : inout  std_logic_vector (15 downto 0);
      db_ser_io  : inout  std_logic_vector (15 downto 0);
      db_trx_io  : inout  std_logic_vector (15 downto 0);
      tim_id_i   : in     std_logic_vector (7 downto 0);
      vme_db_io  : inout  std_logic_vector (31 downto 0);
      reg_en_o   : out    std_logic_vector (35 downto 0);
      ab_o       : out    std_logic_vector (15 downto 0);
      vme_ab_i   : in     std_logic_vector (15 downto 0);
      vmeRD_i    : in     std_logic;
      vmeWR_i    : in     std_logic;
      rd_o       : out    std_logic;
      wr_o       : out    std_logic;
      vmeF2SEL_i : in     std_logic;
      RAMsel_o   : out    std_logic;
      RegTIMID   : out    std_logic_vector (15 downto 0);
      debugout   : out    std_logic_vector (15 downto 0)
   );

-- Declarations

end db_interface ;

-- hds interface_end
architecture rtl of db_interface is

	signal db 				: std_logic_vector(15 downto 0);
	signal reg_en 			: std_logic_vector(35 downto 0);
	
	signal register200	: std_logic_vector(15 downto 0);
	signal register201	: std_logic_vector(15 downto 0);
	signal register202	: std_logic_vector(15 downto 0);
	
	signal ab : std_logic_vector(15 downto 0);
	
	signal vmeRD :  std_logic;
	signal vmeWR : std_logic;
	signal vmeF2SEL : std_logic;
	
	signal db_read_ok : std_logic;
	signal RAMselect  : std_logic;
	

	
begin


ab_o <= ab;
rd_o <= vmeRD;
wr_o <= vmeWR;

RAMsel_o <= RAMselect;

reg_en_o <= reg_en;

db_read_ok <= vmeRD and vmeF2SEL;

-- Local Data-Bus  -  tristating done in each module
-----------------------------------------------------
db <= db_id_io;
db <= db_mix_io;
db <= db_rb_io;
db <= db_sam_io;
db <= db_seq_io;
db <= db_ser_io;
db <= db_trx_io;

-- I think '<=' is more of a 'connected-to' here - like '<=>' ...????
vme_db_io(15 downto  0) <= db when (db_read_ok = '1') else (others => 'Z');
vme_db_io(31 downto 16) <= (others => 'Z');

db <= register200 when ((vmeRD and reg_en(30)) = '1') else
      register201 when ((vmeRD and reg_en(31)) = '1') else
      register202 when ((vmeRD and reg_en(32)) = '1') else
      (others => 'Z');

	debugout <= register201;
   
   register202(7 downto 0) <= tim_ID_i;
   

   -- Some registers (for PAR only at the mo)
   -------------------------------------------

   process (rst, clk)
   begin
      if (rst = '1') then 
         register200 <= (others => '0');
         register201 <= (others => '0'); 

      elsif rising_edge(clk) then
      
         if ((vmeWR and reg_en(30)) = '1') then
            register200 <= db;
         end if; 
            
         if ((vmeWR and reg_en(31)) = '1') then
            register201 <= db;
         end if; 

      end if;
       
   end process;
 
 
   -- Clock VME sigs in, use vmeRD/WE_i as strobe for ab
   -------------------------------------------------------
 
 	-- Discard AB(0) to ensure it is ignored
   ab(0) <= '0';
       
	process (rst, clk)
   begin
   	if (rst = '1') then 
      	ab(15 downto 1) <= (others => '0');
         vmeRD    <= '0';
         vmeWR    <= '0';
         
      elsif rising_edge(clk) then
         vmeRD    <= vmeRD_i;
         vmeWR    <= vmeWR_i;
         vmeF2SEL <= vmeF2SEL_i;
      
         ab(15 downto 1) <= vme_ab_i(15 downto 1);
            
		end if;
   end process;

   



---------------------------------------------------------------------------------
   -- Address Decoder (was*** async for now)
   ---------------------------------------------------------------------------------
   process (rst, clk) --, vmeBDSEL_i, ab)
   begin

      if (rst = '1') then
         reg_en      <= (others => '0');
         RAMselect   <= '0';
 
      elsif rising_edge(clk) then

         if (vmeF2SEL_i = '1') then

            if (ab(15) = '0') then
               RAMselect <= '0';

               case ab(14 downto 0) is
                  when "000000000000000" => reg_en <= "000000000000000000000000000000000001";--00-00
                  when "000000000000010" => reg_en <= "000000000000000000000000000000000010";--01-02
                  when "000000000000100" => reg_en <= "000000000000000000000000000000000100";--02-04
                  when "000000000000110" => reg_en <= "000000000000000000000000000000001000";--03-06
                  when "000000000001000" => reg_en <= "000000000000000000000000000000010000";--04-08
                  when "000000000001010" => reg_en <= "000000000000000000000000000000100000";--05-0a
                  when "000000000001100" => reg_en <= "000000000000000000000000000001000000";--06-0c
                  when "000000000001110" => reg_en <= "000000000000000000000000000010000000";--07-0e
                  when "000000000010000" => reg_en <= "000000000000000000000000000100000000";--08-10
                  when "000000000010010" => reg_en <= "000000000000000000000000001000000000";--09-12
                  when "000000000010100" => reg_en <= "000000000000000000000000010000000000";--10-14
                  when "000000000010110" => reg_en <= "000000000000000000000000100000000000";--11-16
                  when "000000000011000" => reg_en <= "000000000000000000000001000000000000";--12-18
                  when "000000000011010" => reg_en <= "000000000000000000000010000000000000";--13-1a
                  when "000000000011100" => reg_en <= "000000000000000000000100000000000000";--14-1c
                  when "000000000011110" => reg_en <= "000000000000000000001000000000000000";--15-1e
                  when "000000000100000" => reg_en <= "000000000000000000010000000000000000";--16-20
                  when "000000000100010" => reg_en <= "000000000000000000100000000000000000";--17-22
                  when "000000000100100" => reg_en <= "000000000000000001000000000000000000";--18-24
                  when "000000000100110" => reg_en <= "000000000000000010000000000000000000";--19-26
                  when "000000000101000" => reg_en <= "000000000000000100000000000000000000";--20-28
                  when "000000000101010" => reg_en <= "000000000000001000000000000000000000";--21-2a
                  when "000000000101100" => reg_en <= "000000000000010000000000000000000000";--22-2c
                  when "000000000101110" => reg_en <= "000000000000100000000000000000000000";--23-2e
                  when "000000000110000" => reg_en <= "000000000001000000000000000000000000";--24-30
                  when "000000000110010" => reg_en <= "000000000010000000000000000000000000";--25-32
                                                       
                  when "000000000110100" => reg_en <= "000000000100000000000000000000000000";--26-34
                  when "000000000110110" => reg_en <= "000000001000000000000000000000000000";--27-36
                  when "000000000111000" => reg_en <= "000000010000000000000000000000000000";--28-38
                  when "000000000111010" => reg_en <= "000000100000000000000000000000000000";--29-3a
                  when "000000000111100" => reg_en <= "000001000000000000000000000000000000";--30-3c
                  when "000000000111110" => reg_en <= "000010000000000000000000000000000000";--31-3e
                  when "000000001000000" => reg_en <= "000100000000000000000000000000000000";--32-40                  
                  when "000000001000010" => reg_en <= "001000000000000000000000000000000000";--33-42
                  when "000000001000100" => reg_en <= "010000000000000000000000000000000000";--34-44
                  when "000000001000110" => reg_en <= "100000000000000000000000000000000000";--35-46

                  when others => reg_en <= (others => '0');

               end case;

            else
               reg_en <= (others => '0');
               RAMselect <= '1';

            end if;

         else
            reg_en <= (others => '0');
            RAMselect <= '0';

         end if;
      end if;
   end process;


end rtl;
