-- hds header_start
--
-- VHDL Architecture TIM_fpga2.evttid.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 15:44:17 03/23/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity evttid is
   port( 
      rst            : in     std_logic;
      clk            : in     std_logic;
      runmode        : in     std_logic;
      db             : inout  std_logic_vector (15 downto 0);
      db_rd          : in     std_logic;
      db_wr          : in     std_logic;
      Reg10          : in     std_logic;
      Reg12          : in     std_logic;
      Reg14          : in     std_logic;
      Reg16          : in     std_logic;
      Reg2A          : in     std_logic;
      TTCL1ID_i      : in     std_logic_vector (23 downto 0);
      TTCL1ID_strb_i : in     std_logic;
      TTCBCID_i      : in     std_logic_vector (11 downto 0);
      TTCBCID_strb_i : in     std_logic;
      TTCTTID_i      : in     std_logic_vector (9 downto 0);
      TTCTTID_strb_i : in     std_logic;
      AllL1A_i       : in     std_logic;
      AllBCR_i       : in     std_logic;
      AllECR_i       : in     std_logic;
      Ev_Strobe_o    : out    std_logic;
      EvID_o         : out    std_logic_vector (43 downto 0);
      TT_Strobe_o    : out    std_logic;
      TTID_o         : out    std_logic_vector (9 downto 0);
      enSABCR2_i     : in     std_logic;
      SABCR2_o       : out    std_logic;
      enSAECR2_i     : in     std_logic;
      SAECR2_o       : out    std_logic;
      DebugBus       : out    std_logic_vector (15 downto 0)
   );

-- Declarations

end evttid ;


-- hds interface_end

architecture rtl of evttid is


		signal AllL1A_q      : std_logic;
		
		signal L1ID          : std_logic_vector(23 downto 0);
		signal BCID          : std_logic_vector(11 downto 0);
		signal TTID          : std_logic_vector( 9 downto 0);
	   signal ECRID         : std_logic_vector( 7 downto 0);
	   
	   --signal L1_strobe     : std_logic;
	   --signal BC_strobe     : std_logic;
  	   --signal TT_strobe     : std_logic; 
  	   
  		signal RegL1ID 	   : std_logic_vector(23 downto 0);
  		signal RegBCID 	   : std_logic_vector(11 downto 0);
  		signal RegTTCBCID    : std_logic_vector(11 downto 0);
  		signal RegTTID       : std_logic_vector( 9 downto 0);
      signal RegBCIDoffset : std_logic_vector( 3 downto 0);


------------------------------------------------------------------------------
-- MAIN CODE
------------------------------------------------------------------------------
begin

	------------------------------------------------------------------------
  	-- Global
	------------------------------------------------------------------------
	
	process (rst, clk)
	begin
		if (rst = '1') then 
			AllL1A_q <= '0';
	   
	   elsif rising_edge(clk) then 
	   	AllL1A_q <= AllL1A_i;

		end if;
	end process;


		   	
   -- Outputs to Serialiser/Fifo
   
   EVID_o(43 downto 36) <= ECRID;
	EVID_o(35 downto 12) <= L1ID;
	EVID_o(11 downto  0) <= BCID;
	
	TTID_o <= TTID;
	
	  

	
	---------------------------------------------------------------------------
	-- L1ID BLOCK
	---------------------------------------------------------------------------
	l1id_blk : block
	
		-- Strobes
		signal TTCL1ID_strb_q	: std_logic_vector( 2 downto 0);
		
		-- L1ID register and counter
		signal CountL1ID 			: std_logic_vector(23 downto 0);
	
		signal ECRIDcounter		: std_logic_vector( 7 downto 0);
	

	---------------------------------------------------------------------------
	begin

      -- Ev Strobes -- used L1 Strobe from TTC as this is the last one
		-----------------------------------------------------------------------

	   TTCL1ID_strb_q(0) <=	TTCL1ID_strb_i;
	
		process (rst, clk)
		begin
			if (rst = '1') then 				
				TTCL1ID_strb_q(2 downto 1)	<=	"00";
	
	         Ev_Strobe_o <= '0';
		
		   elsif rising_edge(clk) then
				TTCL1ID_strb_q(2 downto 1)	<=	TTCL1ID_strb_q(1 downto 0);
					
				if (RunMode = '1') then
					Ev_Strobe_o <= TTCL1ID_strb_q(0);
					
				else
					Ev_Strobe_o <= AllL1A_i;
						
				end if;
			   	
			end if;
		end process;
	
		
	  	-- CountL1ID
		------------------------------------------------------------------------
		process (rst, clk)
	   begin
		
			if (rst = '1') then
				CountL1ID <= (others => '0');
	         					
			elsif rising_edge(clk) then
			
				if (RunMode = '1') then
					if (TTCL1ID_strb_q(0) = '1') then
						CountL1ID <= TTCL1ID_i;
	            end if;
					
				else
					if (AllL1A_i = '1') then
						CountL1ID <= CountL1ID + '1';
						
					elsif (AllECR_i = '1') then
						CountL1ID(15 downto 0) <= (others => '0');

					elsif (db_wr = '1') then
						if (Reg10 = '1') then
							CountL1ID(15 downto 0) <= db;
	               
						elsif (Reg12 = '1') then
							CountL1ID(23 downto 16) <= db(7 downto 0);

						end if;
	            
	            end if;
 				end if;
			end if;
	   end process;
	
   	L1ID <= CountL1ID;


	  	-- RegisterL1ID
		------------------------------------------------------------------------
		process (rst, clk)
		begin
		
			if (rst = '1') then
				RegL1ID <= (others => '1');
				
			elsif rising_edge(clk) then
				if (RunMode = '1') then 
					if	(TTCL1ID_strb_q(1) = '1') then
						RegL1ID <= TTCL1ID_i;

					end if;
					
				else
					if (AllL1A_q = '1') then -- Copies L1ID AFTER increment
						RegL1ID <= CountL1ID;
					
					elsif (db_wr = '1') then
						if    (Reg10 = '1') then
							RegL1ID(15 downto  0) <= db;
						
						elsif (Reg12 = '1') then
							RegL1ID(23 downto 16) <= db(7 downto 0);
				
						end if;
					end if;
				end if;
			end if;
		end process;
					
		

		-- SAECR2 output
		------------------------------------------------------------------------
	
		-- *** The problem here might be that the SAECR2 happens at the same time
		--  as the idTRIG that rolls the L1ID counter over. We need to probably
		--  use a delay of x clks
	
	   process (rst, clk)
	   begin
	
	      if (rst = '1') then
	         SAECR2_o <= '0';
	
	         
	      elsif rising_edge(clk) then
	      
		      if (CountL1ID = "111111111111111111111111") then
		      
		      	if (AllL1A_i = '1') and (enSAECR2_i = '1') then
		      		SAECR2_o <= '1';
		
		         end if;
		      end if;
		   end if;
		end process;
	      
	      

	  -- ECRCounter
	  -------------------------------------------------------------------------
	
	   process (rst, clk)
	   begin
	
	      if (rst = '1') then
	         ECRIDcounter <= "00000000";
	         
	      elsif rising_edge(clk) then
	      
	      	if (db_wr = '1') and (Reg10 = '1') and (RunMode = '0') then
					ECRIDcounter <= "00000000";
	
	         elsif (AllECR_i = '1') then
					ECRIDcounter <= ECRIDcounter + '1';
	
	         end if;
	      end if;
	   end process;
	   
	   ECRID <= ECRIDcounter;

   end block;



	---------------------------------------------------------------------------
	-- BCID BLOCK
	---------------------------------------------------------------------------
	bcid_blk : block
	
		-- Strobes
		signal TTCBCID_strb_q	: std_logic_vector(2 downto 0);
				
      signal BCIDcounter      : std_logic_vector(11 downto 0);
      
      signal SABCR2				: std_logic;
	

	

	---------------------------------------------------------------------------
	begin
	
	   -- BC Strobe (local) -- not used for Ev Strobe gen
		-----------------------------------------------------------------------

	   TTCBCID_strb_q(0) <=	TTCBCID_strb_i;
	
		process (rst, clk)
		begin
			if (rst = '1') then 				
				TTCBCID_strb_q(2 downto 1)	<=	"00";
	
	      elsif rising_edge(clk) then
				TTCBCID_strb_q(2 downto 1)	<=	TTCBCID_strb_q(1 downto 0);
						   	
			end if;
		end process;
		
		
	  	-- BCIDcounter
		------------------------------------------------------------------------
		process (rst, clk)
	   begin
		
			if (rst = '1') then
				BCIDcounter <= (others => '0');
				
			elsif rising_edge(clk) then
			
			   if Runmode = '1' then
			   
			      BCIDcounter <= RegTTCBCID + RegBCIDoffset;
			      			   
			   else
		         					
				   if (AllBCR_i = '1') then
					   BCIDcounter <= (others => '0');
					            
				   elsif (BCIDcounter = "111111111111") then
				      BCIDcounter <= (others => '0');
				      			   
				   else
				      BCIDcounter <= BCIDcounter + '1';
            					       
			      end if;
			   end if;
			end if;
	   end process;
	   
	  
	  	-- RegBCID, RegTTCBCID  (read-only)
		------------------------------------------------------------------------
		process (rst, clk)
		begin
		
			if (rst = '1') then
				RegBCID     <= (others => '0');
				RegTTCBCID  <= (others => '0');
			
			elsif rising_edge(clk) then
			   
		      if (AllL1A_i = '1') then
					RegBCID <= BCIDcounter;
            end if;


            if (TTCBCID_strb_q(0) = '1') then
               RegTTCBCID <= TTCBCID_i;
				end if;

			end if;
		end process;
		
		BCID <= RegBCID;
		
		
		-- RegBCIDoffset
		------------------------------------------------------------------------
		process (rst, clk)
		begin
		
			if (rst = '1') then
				RegBCIDoffset <= (others => '0');
			
			elsif rising_edge(clk) then
			   
		      if (db_wr and Reg14) = '1' then
		         RegBCIDoffset <= db(15 downto 12);
            
            end if;
			end if;
		end process;
		
		
	 	-- SABCR2
		------------------------------------------------------------------------
		process (rst, clk)
	   begin
		
			if (rst = '1') then
				SABCR2 <= '0';
				
			elsif rising_edge(clk) then
			
			   if Runmode = '1' then
			      SABCR2 <= '0';
			      			   
			   elsif (BCIDcounter = "111111111111") then
				   SABCR2 <= '1';
				   
				else
				   SABCR2 <= '0';
				
			   end if;
			end if;
	   end process;
	   
	   SABCR2_o <= SABCR2 and enSABCR2_i;
	
		
	end block;

	


   ---------------------------------------------------------------------------
	-- TTID BLOCK
	---------------------------------------------------------------------------
	ttid_blk : block
	
		-- Strobe
		signal TTCTTID_strb_q   : std_logic_vector(2 downto 0);
		
		
	---------------------------------------------------------------------------
	begin
			

		-- Strobes (TT Local)
		------------------------------------------------------------------------

      TTCTTID_strb_q(0) <=	TTCTTID_strb_i;      

		process (rst, clk)
		begin
		
			if (rst = '1') then 				
				TTCTTID_strb_q(2 downto 1)	<=	"00";

            TT_Strobe_o <= '0';
	
		   elsif rising_edge(clk) then
				TTCTTID_strb_q(2 downto 1)	<=	TTCTTID_strb_q(1 downto 0);
				
				if (RunMode = '1') then
					TT_Strobe_o <= TTCTTID_strb_q(1);
				
				else
					TT_Strobe_o <= AllL1A_i;
					
				end if;
		   	
			end if;
		end process;
  		     
      
      -- TTID - incl. register
      -------------------------------------------------------------------------
      process (rst, clk)
      begin
   
         if (rst = '1') then
            TTID <= (others => '0');
            
         elsif rising_edge(clk) then
         
         	if (RunMode = '1') then
         		if (TTCTTID_strb_q(0) = '1') then
   					TTID <= TTCTTID_i;
   				end if;
   
            elsif (db_wr and Reg16) = '1' then
            
   				TTID <= db( 9 downto 0);
   
            end if;
         end if;
      end process;
      
      RegTTID <= TTID;

   end block;
   ---------------------------------------------------------------------------   
   
   
					


   -- Data Read
   -----------------------------------------------------------------------------

   read_db : block
		signal Reg10_db	: std_logic_vector(15 downto 0);
   	signal Reg12_db	: std_logic_vector(15 downto 0);
   	signal Reg14_db	: std_logic_vector(15 downto 0);
   	signal Reg16_db	: std_logic_vector(15 downto 0);
   	signal Reg2A_db	: std_logic_vector(15 downto 0);

   begin
   	Reg10_db					 <= RegL1ID(15 downto 0);
   
   	Reg12_db(15 downto 8) <= ECRID;
   	Reg12_db( 7 downto 0) <= RegL1ID(23 downto 16);
   	
   	Reg14_db(15 downto 12) <= RegBCIDoffset; 
   	Reg14_db(11 downto  0) <= RegBCID;          	

   	Reg16_db(15 downto 10) <= "000000";    
   	Reg16_db( 9 downto 0)  <= RegTTID;     
   		
		Reg2A_db(15 downto 12) <= "0000";    
		Reg2A_db(11 downto  0) <= RegTTCBCID;
		
	   	
   	db <= Reg10_db when ((db_rd and Reg10) = '1') else
   			Reg12_db when ((db_rd and Reg12) = '1') else
		   	Reg14_db when ((db_rd and Reg14) = '1') else
   			Reg16_db when ((db_rd and Reg16) = '1') else
   			Reg2A_db when ((db_rd and Reg2A) = '1') else (others => 'Z');

	end block;

   
   -- Debug Bus
  	----------------------------------------------------

	DebugBus <= "0000000000000000";

end rtl;
