-- hds header_start
--
-- VHDL Architecture TIM_fpga2.evttid_ser_tester.test
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 16:32:04 03/23/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity evttid_ser_tester is
   port( 
      AllBCR       : out    std_logic;
      AllECR       : out    std_logic;
      AllL1A       : out    std_logic;
      Reg10        : out    std_logic;
      Reg12        : out    std_logic;
      Reg14        : out    std_logic;
      Reg16        : out    std_logic;
      Reg2A        : out    std_logic;
      RunMode      : out    std_logic;
      TTCBCID      : out    std_logic_vector (11 downto 0);
      TTCBCID_strb : out    std_logic;
      TTCL1ID      : out    std_logic_vector (23 downto 0);
      TTCL1ID_strb : out    std_logic;
      TTCTTID      : out    std_logic_vector (9 downto 0);
      TTCTTID_strb : out    std_logic;
      clk          : out    std_logic;
      enSABCR2     : out    std_logic;
      enSAECR2     : out    std_logic;
      rst          : out    std_logic;
      db_rd        : out    std_logic;
      db_wr        : out    std_logic;
      db           : inout  std_logic_vector (15 downto 0);
      Reg0E        : out    std_logic
   );

-- Declarations

end evttid_ser_tester ;


-- hds interface_end

architecture test of evttid_ser_tester is
	signal clkosc 	 		: std_logic := '1';   

	constant DB_REG10 	: std_logic_vector(5 downto 0) := "000001";
	constant DB_REG12 	: std_logic_vector(5 downto 0) := "000010";
	constant DB_REG14 	: std_logic_vector(5 downto 0) := "000100";
	constant DB_REG16 	: std_logic_vector(5 downto 0) := "001000";
	constant DB_REG2A 	: std_logic_vector(5 downto 0) := "010000";
	constant DB_REG0E 	: std_logic_vector(5 downto 0) := "100000";



	
begin
-------------------------------------------------------
   
	-- clock generator
	------------------
	clkosc	<= not clkosc after 12500 ps;
	clk 		<= clkosc;

	--------------------------------------------------------
	sim : process
	
		-- Procedures
		----------------------------------------------------------------
		procedure DB_Write(
				reg_en	: in std_logic_vector(5 downto 0);  
				idata 	: in integer
			) is

			variable data : std_logic_vector(15 downto 0);

		begin

			data := conv_std_logic_vector(idata, 16);
			
			Reg10	<= reg_en(0);
      	Reg12	<= reg_en(1);
      	Reg14	<= reg_en(2);
      	Reg16	<= reg_en(3);
      	Reg2A	<= reg_en(4);
      	Reg0E	<= reg_en(5);

      	      	
			wait for 25 ns;
			
			db  	<= data;
			wait for 25 ns;

			db_wr	<= '1';
			wait for 25 ns;

			db_wr	<= '0';
			wait for 25 ns;
			
      	Reg10	<= '0';
      	Reg12	<= '0';
      	Reg14	<= '0';
      	Reg16	<= '0';
      	Reg2A	<= '0';
      	Reg0E	<= '0';
			
			db    <= (others => 'Z');
			
			wait for 25 ns;
			
		end procedure; 
		
		----------------------------------------------------------------
		procedure DB_Read(
				reg_en	: in std_logic_vector(5 downto 0)  
			) is
			
			
		begin
		
			Reg10	<= reg_en(0);
      	Reg12	<= reg_en(1);
      	Reg14	<= reg_en(2);
      	Reg16	<= reg_en(3);
      	Reg2A	<= reg_en(4);
      	Reg0E	<= reg_en(5);

			wait for 25 ns;

			db_rd	<= '1';
			wait for 25 ns;

			db_rd	<= '0';
			wait for 25 ns;
			
	    	Reg10	<= '0';
      	Reg12	<= '0';
      	Reg14	<= '0';
      	Reg16	<= '0';
      	Reg2A	<= '0';
      	Reg0E	<= '0';
      				
			wait for 25 ns;

		end procedure; 

	----------------------------------------------------------------------
	-- Simulation
	----------------------------------------------------------------------	
	begin	
	
		-- Start-up values
		----------------------------------------------------------

		rst      		<= '0';    

      db_rd    		<= '0';
      db_wr    		<= '0';      
      db       		<= (others => 'Z');
      
      RunMode        <= '0';

      TTCBCID        <= (others => '0');
      TTCBCID_strb   <= '0';
      TTCL1ID        <= (others => '0');
      TTCL1ID_strb   <= '0';
      TTCTTID        <= (others => '0');
      TTCTTID_strb   <= '0';

      enSABCR2       <= '0';
      enSAECR2       <= '0';
      
      AllBCR       <= '0';
      AllECR       <= '0';
      AllL1A       <= '0';

   
      
    	Reg10	<= '0';
     	Reg12	<= '0';
     	Reg14	<= '0';
     	Reg16	<= '0';
     	Reg2A	<= '0';
     	Reg0E	<= '0';
      	      

      -----------------------------------------------------
      -- Main Simulation
		-----------------------------------------------------
	   
		-- Reset
		wait for 25 ns;		
	   rst <= '1';
	   wait for 100 ns;		
	   rst <= '0';
	   
	   wait for 105 ns; -- Setup signals to arrive just after the clock
	   
	   
   	--Write L1ID Value
 		DB_Write(DB_REG12, 16#00A0#);
  		DB_Write(DB_REG10, 16#000D#);


	   -- Send Some L1As
	   -----------------
	   for n in 1 to 4 loop
	   	AllL1A <= '1';
	   	wait for 25 ns;
	   	AllL1A <= '0';
	   	
	   	wait for 100 ns; -- high freq trigs

	   end loop;


		-- Send an ECR
	   --------------
   	AllECR <= '1';
   	wait for 25 ns;
   	AllECR <= '0';
   	wait for 25 ns;
   	
   	
   	--Write Trigger-Type Value
  		DB_Write(DB_REG16, 16#A00F#);


	   -- Send Some L1As
	   -----------------
	   for n in 1 to 4 loop
	   	AllL1A <= '1';
	   	wait for 25 ns;
	   	AllL1A <= '0';
   	
	   	wait for 50 ns;  -- high freq trigs
	   end loop;
	      

		-- Send some ECRs
	   -----------------
	   for n in 1 to 4 loop
	   	AllECR <= '1';
   		wait for 25 ns;
   		AllECR <= '0';
   		wait for 100 ns;
		end loop;


	   
	   -- Data IO
	   ----------
	   
	   --DB_Write(DB_REG10, 16#8000#);
  	   --DB_Write(DB_REG12, 16#ABCD#);
  	   
   	--DB_Read(DB_REG10);
 	   --DB_Read(DB_REG12);
 	   
 	   wait;
   
	end process;

end test;