-- hds header_start
--
-- VHDL Architecture TIM_fft.tfb2_reg_top_tester.test
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 13:19:19 02/15/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity fftv_reg_top_tester is
   port( 
      busy_tf_o : in     std_logic;
      clk       : out    std_logic;
      reg40     : out    std_logic;
      reg42     : out    std_logic;
      reg44     : out    std_logic;
      reg46     : out    std_logic;
      reg48     : out    std_logic;
      reg4A     : out    std_logic;
      rst       : out    std_logic;
      trig_i    : out    std_logic;
      vmeRD     : out    std_logic;
      vmeWR     : out    std_logic;
      db        : inout  std_logic_vector (15 downto 0)
   );

-- Declarations

end fftv_reg_top_tester ;


-- hds interface_end
architecture test of fftv_reg_top_tester is

	signal clk_osc : std_logic := '1';
	constant CLKPERIOD : time :=  25 ns;
	
begin

	-- clock generator
	-----------------------------------------------------------------------
	clk_osc <= not clk_osc after CLKPERIOD/2;
	clk <= clk_osc;
	
	
	

	-- Main Simulation
	----------------------------------------------------------------------
	simulation: process
	begin
	
		trig_i <= '0';
      
				
		rst <= '1';
		wait for 3*CLKPERIOD;		
		rst <= '0';
		wait for 1*CLKPERIOD;
		
	
		-- Start Sending Triggers
		-------------------------------------------------------------------		
	
	

	   -- Send Triggers with slightly varied periods
		for n in 2 to 14 loop
			wait for 2600*CLKPERIOD + n*n*CLKPERIOD;
			trig_i <= '1';
		   wait for 1*CLKPERIOD;
		   trig_i <= '0';

			wait for 2600*CLKPERIOD - n*n*CLKPERIOD;
			trig_i <= '1';
		   wait for 1*CLKPERIOD;
		   trig_i <= '0';
		   
		end loop;

	
		-----------------------------------------------------------------
		-- Send Uniform Trigs
		---------------------
		--for n in 1 to 20 loop
			--wait for 250*CLKPERIOD;
			--trig_i <= '1';
		   --wait for 1*CLKPERIOD;
  		   --trig_i <= '0';
		--end loop;
		
		wait for 10000*CLKPERIOD;
		
		
		-- Send Same Period Trigs * 2 With 1 Offset 
		---------------------------------------
		for n in 1 to 20 loop
			wait for 2400*CLKPERIOD;
			trig_i <= '1';
		   wait for CLKPERIOD;
  		   trig_i <= '0';

			wait for 400*CLKPERIOD;
			trig_i <= '1';
		   wait for CLKPERIOD;
  		   trig_i <= '0';
		end loop;
		
		
		-----------------------------------------------------------------
		-- Send Uniform Trigs
		---------------------
		--for n in 1 to 20 loop
			--wait for 250*CLKPERIOD;
			--trig_i <= '1';
		   --wait for CLKPERIOD;
  		   --trig_i <= '0';
		--end loop;
		
		wait for 10000*CLKPERIOD;
		

		-- Send Below Thresh Trigs 
		--------------------------
		for n in 1 to 10 loop
			wait for 3900*CLKPERIOD;
			trig_i <= '1';
		   wait for CLKPERIOD;
  		   trig_i <= '0';
		end loop;
		
		
		-- Send Above Thresh Trigs 
		--------------------------
		for n in 1 to 10 loop
			wait for 1500*CLKPERIOD;
			trig_i <= '1';
		   wait for CLKPERIOD;
  		   trig_i <= '0';
		end loop;

	
		trig_i <= '0';
		     
      wait;
	end process;
end test;
