-- hds header_start
--
-- VHDL Entity TIM_fpga2.i2c_ttc.symbol
--
-- Created:
--          by - warren.UNKNOWN (POSITRON)
--          at - 10:06:35 08/28/07
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

entity i2c_ttc is
   port( 
      db_rd       : in     std_logic;
      db_wr       : in     std_logic;
      i2c_rst     : in     std_logic;
      iclk40      : in     std_logic;
      reg2C       : in     std_logic;
      ttc_ready_i : in     std_logic;
      db          : inout  std_logic_vector (15 downto 0);
      scl         : inout  std_logic;
      sda         : inout  std_logic
   );

-- Declarations

end i2c_ttc ;

-- hds interface_end
--
-- VHDL Architecture TIM_fpga2.i2c_ttc.struct
--
-- Created:
--          by - warren.UNKNOWN (POSITRON)
--          at - 10:06:36 08/28/07
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;
use ieee.std_logic_arith.ALL;
use ieee.std_logic_unsigned.ALL;

library TIM_fpga2;
library TIM_lib;

architecture struct of i2c_ttc is

   -- Architecture declarations
   --attribute no_buff: boolean;
   --attribute noopt: boolean;

   -- Internal signal declarations
   signal ONE            : std_logic;
   signal ZERO           : std_logic;
   signal ce_i2c         : std_logic;
   signal ce_i2c_rcv     : std_logic;
   signal data_from_ttc  : std_logic_vector(7 downto 0);
   signal data_to_ttc    : std_logic_vector(7 downto 0);
   signal dir_sda        : std_logic;
   signal dir_sda_n      : std_logic;
   signal en_sr_in       : std_logic;
   signal en_sr_out      : std_logic;
   signal i2c_abort      : std_logic;
   signal i2c_busy       : std_logic;
   signal i2c_err        : std_logic;
   signal i2c_init       : std_logic;
   signal i2c_rd_nwr     : std_logic;
   signal ipb_low        : std_logic;
   signal ld_sr_out      : std_logic;
   signal pda_out        : std_logic_vector(15 downto 0);
   signal scl_en         : std_logic;
   signal scl_int        : std_logic;
   signal scl_out        : std_logic;
   signal scl_out_n      : std_logic;
   signal scl_source     : std_logic;
   signal sda_in         : std_logic;
   signal sda_out        : std_logic;
   signal sel_pointer    : std_logic;
   signal set_vme_status : std_logic;
   signal sr_out         : std_logic;
   signal ttc_data_addr  : std_logic_vector(6 downto 0);
   signal ttc_i2c_id     : std_logic_vector(5 downto 0);
   signal ttc_pointer    : std_logic_vector(4 downto 0);
   signal ttc_ptr_addr   : std_logic_vector(6 downto 0);


constant firmware_id: std_logic_vector := "0100";
constant revision_id: std_logic_vector := "00000100";

--attribute no_buff of ds : signal is TRUE;
--attribute noopt of ds : signal is TRUE;

   -- Component Declarations
   component i2c_clk_gen
   port (
      clk40      : in     std_logic ;
      i2c_rst    : in     std_logic ;
      scl_source : out    std_logic ;
      ce_i2c     : out    std_logic ;
      ce_i2c_rcv : out    std_logic 
   );
   end component;
   component i2c_ff
   generic (
      q_rst : std_logic := '0'
   );
   port (
      d   : in     std_logic ;
      clk : in     std_logic ;
      rst : in     std_logic ;
      q   : out    std_logic 
   );
   end component;
   component i2c_sr_input
   port (
      en_sr_in    : in     std_logic ;
      i2c_rst     : in     std_logic ;
      iclk40      : in     std_logic ;
      sda_in      : in     std_logic ;
      i2c_data_in : out    std_logic_vector (7 downto 0)
   );
   end component;
   component i2c_sr_ps
   generic (
      width : integer := 16
   );
   port (
      clk         : in     std_logic ;
      din_para    : in     std_logic_vector (width-1 downto 0);
      din_serial  : in     std_logic ;
      en_shift    : in     std_logic ;
      load_para   : in     std_logic ;
      rst         : in     std_logic ;
      dout_serial : out    std_logic 
   );
   end component;
   component i2c_ttc_engine
   port (
      ce_i2c         : in     std_logic ;
      ce_i2c_rcv     : in     std_logic ;
      data_to_ttc    : in     std_logic_vector (7 downto 0);
      i2c_abort      : in     std_logic ;
      i2c_init       : in     std_logic ;
      i2c_rd_nwr     : in     std_logic ;
      i2c_rst        : in     std_logic ;
      iclk40         : in     std_logic ;
      scl_source     : in     std_logic ;
      sda_in         : in     std_logic ;
      sr_out         : in     std_logic ;
      ttc_pointer    : in     std_logic_vector (4 downto 0);
      dir_sda        : out    std_logic ;
      en_sr_in       : out    std_logic ;
      en_sr_out      : out    std_logic ;
      i2c_busy       : out    std_logic ;
      i2c_err        : out    std_logic ;
      ld_sr_out      : out    std_logic ;
      scl_en         : out    std_logic ;
      sda_out        : out    std_logic ;
      sel_pointer    : out    std_logic ;
      set_vme_status : out    std_logic 
   );
   end component;
   component i2c_ttc_sda_out
   port (
      data_to_ttc   : in     std_logic_vector (7 downto 0);
      i2c_rd_nwr    : in     std_logic ;
      sel_pointer   : in     std_logic ;
      ttc_data_addr : in     std_logic_vector (6 downto 0);
      ttc_pointer   : in     std_logic_vector (4 downto 0);
      ttc_ptr_addr  : in     std_logic_vector (6 downto 0);
      pda_out       : out    std_logic_vector (15 downto 0)
   );
   end component;
   component i2c_ttc_vme
   port (
      rst           : in     std_logic ;
      clk           : in     std_logic ;
      db            : inout  std_logic_vector (15 downto 0);
      db_rd         : in     std_logic ;
      db_wr         : in     std_logic ;
      reg2C         : in     std_logic ;
      i2c_go_o      : out    std_logic ;
      i2c_busy_i    : in     std_logic ;
      i2c_err_i     : in     std_logic ;
      ttcrx_data_i  : in     std_logic_vector (7 downto 0);
      ttcrx_data_o  : out    std_logic_vector (7 downto 0);
      i2c_abort_o   : out    std_logic ;
      i2c_rd_nwr_o  : out    std_logic ;
      i2c_pointer_o : out    std_logic_vector (4 downto 0);
      ttc_ready_i   : in     std_logic 
   );
   end component;
   component m_buff
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_inv
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : i2c_clk_gen use entity TIM_fpga2.i2c_clk_gen(rtl);
   for all : i2c_ff use entity TIM_fpga2.i2c_ff(rtl);
   for all : i2c_sr_input use entity TIM_fpga2.i2c_sr_input(rtl);
   for all : i2c_sr_ps use entity TIM_fpga2.i2c_sr_ps(rtl);
   for all : i2c_ttc_engine use entity TIM_fpga2.i2c_ttc_engine(fsm);
   for all : i2c_ttc_sda_out use entity TIM_fpga2.i2c_ttc_sda_out(rtl);
   for all : i2c_ttc_vme use entity TIM_fpga2.i2c_ttc_vme(rtl);
   for all : m_buff use entity TIM_lib.m_buff(rtl);
   for all : m_inv use entity TIM_lib.m_inv(rtl);
   for all : m_power use entity TIM_lib.m_power(rtl);
   -- exemplar synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 3 eb3
   ttc_ptr_addr <= ttc_i2c_id & '0';
   ttc_data_addr <= ttc_i2c_id & '1';

   -- HDL Embedded Text Block 5 eb5
   -- eb5 5
   ttc_i2c_id <= "000000";

   -- HDL Embedded Text Block 7 eb7
   -- eb7 7
   scl_int <= not (scl_en and not scl_source);


   -- ModuleWare code for instance 'I0' of 'tribuf'
   
   I0combo: process (sda_out, dir_sda_n)
   begin
      if (dir_sda_n = '0') then
         sda <= 'Z';
      elsif (dir_sda_n = '1') then
         sda <= sda_out;
      else
         sda <= 'X';
      end if;
   end process I0combo;

   -- ModuleWare code for instance 'I1' of 'tribuf'
   
   I1combo: process (ZERO, scl_out_n)
   begin
      if (scl_out_n = '0') then
         scl <= 'Z';
      elsif (scl_out_n = '1') then
         scl <= ZERO;
      else
         scl <= 'X';
      end if;
   end process I1combo;
   -- Instance port mappings.
   I5 : i2c_clk_gen
      port map (
         clk40      => iclk40,
         i2c_rst    => i2c_rst,
         scl_source => scl_source,
         ce_i2c     => ce_i2c,
         ce_i2c_rcv => ce_i2c_rcv
      );
   I7 : i2c_ff
      generic map (
         q_rst => '1'
      )
      port map (
         d   => scl_int,
         clk => iclk40,
         rst => i2c_rst,
         q   => scl_out
      );
   I4 : i2c_sr_input
      port map (
         en_sr_in    => en_sr_in,
         i2c_rst     => i2c_rst,
         iclk40      => iclk40,
         sda_in      => sda_in,
         i2c_data_in => data_from_ttc
      );
   I3 : i2c_sr_ps
      generic map (
         width => 16
      )
      port map (
         clk         => iclk40,
         din_para    => pda_out,
         din_serial  => ipb_low,
         en_shift    => en_sr_out,
         load_para   => ld_sr_out,
         rst         => i2c_rst,
         dout_serial => sr_out
      );
   I6 : i2c_ttc_engine
      port map (
         ce_i2c         => ce_i2c,
         ce_i2c_rcv     => ce_i2c_rcv,
         data_to_ttc    => data_to_ttc,
         i2c_abort      => i2c_abort,
         i2c_init       => i2c_init,
         i2c_rd_nwr     => i2c_rd_nwr,
         i2c_rst        => i2c_rst,
         iclk40         => iclk40,
         scl_source     => scl_source,
         sda_in         => sda_in,
         sr_out         => sr_out,
         ttc_pointer    => ttc_pointer,
         dir_sda        => dir_sda,
         en_sr_in       => en_sr_in,
         en_sr_out      => en_sr_out,
         i2c_busy       => i2c_busy,
         i2c_err        => i2c_err,
         ld_sr_out      => ld_sr_out,
         scl_en         => scl_en,
         sda_out        => sda_out,
         sel_pointer    => sel_pointer,
         set_vme_status => set_vme_status
      );
   I2 : i2c_ttc_sda_out
      port map (
         data_to_ttc   => data_to_ttc,
         i2c_rd_nwr    => i2c_rd_nwr,
         sel_pointer   => sel_pointer,
         ttc_data_addr => ttc_data_addr,
         ttc_pointer   => ttc_pointer,
         ttc_ptr_addr  => ttc_ptr_addr,
         pda_out       => pda_out
      );
   i2c_ttc_vme_1 : i2c_ttc_vme
      port map (
         rst           => i2c_rst,
         clk           => iclk40,
         db            => db,
         db_rd         => db_rd,
         db_wr         => db_wr,
         reg2C         => reg2C,
         i2c_go_o      => i2c_init,
         i2c_busy_i    => i2c_busy,
         i2c_err_i     => i2c_err,
         ttcrx_data_i  => data_from_ttc,
         ttcrx_data_o  => data_to_ttc,
         i2c_abort_o   => i2c_abort,
         i2c_rd_nwr_o  => i2c_rd_nwr,
         i2c_pointer_o => ttc_pointer,
         ttc_ready_i   => ttc_ready_i
      );
   I11 : m_buff
      port map (
         I => sda,
         O => sda_in
      );
   I8 : m_inv
      port map (
         I => dir_sda,
         O => dir_sda_n
      );
   I9 : m_inv
      port map (
         I => scl_out,
         O => scl_out_n
      );
   m_power_1 : m_power
      port map (
         ONE  => ONE,
         ZERO => ZERO
      );

end struct;
