-- hds header_start
--
-- VHDL Entity TIM_fpga2.mixer.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:40:11 04/01/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity mixer is
   port( 
      clk               : in     std_logic;
      rst               : in     std_logic;
      db                : inout  std_logic_vector (15 downto 0);
      db_rd             : in     std_logic;                       -- was bReadb
      db_wr             : in     std_logic;                       -- was bWriteb
      Reg18             : in     std_logic;
      Reg30             : in     std_logic;
      SATRIG_i          : in     std_logic;
      SABCR_i           : in     std_logic;
      SAECR_i           : in     std_logic;
      SACAL_i           : in     std_logic;
      SAFER_i           : in     std_logic;
      SASPR_i           : in     std_logic;
      SABCR2_i          : in     std_logic;
      SAECR2_i          : in     std_logic;
      TTCL1A_i          : in     std_logic;
      TTCBCR_i          : in     std_logic;
      TTCECR_i          : in     std_logic;
      TTCCAL_i          : in     std_logic;
      TTCFER_i          : in     std_logic;
      TTCSPR_i          : in     std_logic;
      SerEXS_i          : in     std_logic;
      SerTTS_i          : in     std_logic;
      SeqTRIG_i         : in     std_logic;
      SeqBCR_i          : in     std_logic;
      SeqECR_i          : in     std_logic;
      SeqCAL_i          : in     std_logic;
      SeqFER_i          : in     std_logic;
      SeqSPR_i          : in     std_logic;
      SeqEXS_i          : in     std_logic;
      SeqTTS_i          : in     std_logic;
      enSABCR2_o        : out    std_logic;
      enSAECR2_o        : out    std_logic;
      --enSerEVS_o		: out	std_logic;
      --enSerTTS_o		: out	std_logic;
      ext_RodBUSYinen_o : out    std_logic;
      RCBUSYen_o        : out    std_logic;
      setTTCClk_o       : out    std_logic;
      AllL1A_o          : out    std_logic;                       -- Combined Signals
      AllBCR_o          : out    std_logic;                       -- Also FrontPanel	(ECL/NIM) Signals
      AllECR_o          : out    std_logic;
      AllCAL_o          : out    std_logic;
      AllFER_o          : out    std_logic;
      AllSPR_o          : out    std_logic;
      AllEVS_o          : out    std_logic;
      AllTTS_o          : out    std_logic;
      TTCbus_o          : out    std_logic_vector (7 downto 0);
      DebugBus          : out    std_logic_vector (15 downto 0)
   );

-- Declarations

end mixer ;


-- hds interface_end


-------------------------------------------------------------------------------
--	ARCHITECTURE
-------------------------------------------------------------------------------
architecture tim of mixer is

-------------------------------------------------------------------------------
--	SIGNAL DECLARATIONS
-------------------------------------------------------------------------------

	signal L1A					: std_logic;
	signal BCR					: std_logic;
	signal ECR					: std_logic;
	signal CAL					: std_logic;
	signal FER					: std_logic;
	signal SPR					: std_logic;
	signal TTS					: std_logic;
	signal EXS					: std_logic;
	signal enTTCSPR			: std_logic;
	signal enTTCFER			: std_logic;
	signal enTTCCAL			: std_logic;
	signal enTTCBCR			: std_logic;
	signal enTTCECR			: std_logic;
	signal enTTCL1A			: std_logic;
	signal enSerEXS			: std_logic;	
	signal enSerTTS			: std_logic;		
	signal RegEnTTC			: std_logic_vector(15 downto 0);
	signal RegTestTTCbus		: std_logic_vector(15 downto 0);

-------------------------------------------------------------------------------
--	MAIN CODE
-------------------------------------------------------------------------------
begin


	L1A <= SATRIG_i or				 (TTCL1A_i and	enTTCL1A) or SeqTRIG_i;
	BCR <= SABCR_i	 or SABCR2_i or (TTCBCR_i and	enTTCBCR) or SeqBCR_i;
	ECR <= SAECR_i	 or SAECR2_i or (TTCECR_i and	enTTCECR) or SeqECR_i;
	CAL <= SACAL_i	 or				 (TTCCAL_i and	enTTCCAL) or SeqCAL_i;
	FER <= SAFER_i	 or				 (TTCFER_i and	enTTCFER) or SeqFER_i;
	SPR <= SASPR_i	 or				 (TTCSPR_i and	enTTCSPR) or SeqSPR_i;
	
	EXS <=                         (SerEXS_i and enSerEXS) or SeqEXS_i; -- *** this may no be the understood 
	TTS <=                         (SerTTS_i and enSerTTS) or SeqTTS_i; --     effect of these enables



	--	Unclocked for backplane	(done	externally on the	NOT clk)
	TTCbus_o(0)	<=	L1A;
	TTCbus_o(1)	<=	ECR;
	TTCbus_o(2)	<=	BCR;
	TTCbus_o(3)	<=	CAL;
	TTCbus_o(4)	<=	EXS;
	TTCbus_o(5)	<=	TTS;
	TTCbus_o(6)	<=	FER;
	TTCbus_o(7)	<=	SPR;


	--	Clocked for	on	board	use
	process (rst, clk) --,	L1A, BCR, ECR,	CAL, FER, SPR,	EXS, TTS)
	begin

		--	Clocked signals
		if	(rst = '1') then

			AllL1A_o	 <= '0';
			AllBCR_o	 <= '0';
			AllECR_o	 <= '0';
			AllCAL_o	 <= '0';
			AllFER_o	 <= '0';
			AllSPR_o	 <= '0';
			AllEXS_o	 <= '0';
			AllTTS_o	 <= '0';

		elsif	rising_edge(clk) then

			AllL1A_o	<=	L1A;
			AllBCR_o	<=	BCR;
			AllECR_o	<=	ECR;
			AllCAL_o	<=	CAL;
			AllFER_o	<=	FER;
			AllSPR_o	<=	SPR;
			AllEXS_o	<=	EXS;
			AllTTS_o	<=	TTS;

		end if;

	end process;



	--	RegEnTTC
	----------------------------------------------------

	process (rst, clk) --, Reg18, db_wr)
	begin

		if (rst = '1') then						--	async	reset
			RegEnTTC <= "0000000000000000";

		elsif rising_edge(clk) then
		
			if	(Reg18 and db_wr)	= '1'	then
				RegEnTTC <= db;

			end if;

		end if;

	end process;

	enSABCR2_o		   <=	RegEnTTC(15);
	enSAECR2_o		   <=	RegEnTTC(14);
	enSerTTS			   <=	RegEnTTC(10);
	enSerEXS			   <=	RegEnTTC( 9);
	ext_RodBUSYinen_o	<=	RegEnTTC( 8);
	RCBUSYen_o			<=	RegEnTTC( 7);
	enTTCSPR			   <=	RegEnTTC( 6);
	enTTCFER			   <=	RegEnTTC( 5);
	enTTCCAL			   <=	RegEnTTC( 4);
	enTTCBCR			   <=	RegEnTTC( 3);
	enTTCECR			   <=	RegEnTTC( 2);
	enTTCL1A			   <=	RegEnTTC( 1);
	setTTCClk_o		   <=	RegEnTTC( 0);

	--	Reg_TestTTCbus	(was TTCbus) -- self-holding
	----------------------------------------------------
	process (clk)
	begin

		if rising_edge(clk) then
		
			if	(rst = '1') then
				RegTestTTCbus	<=	(others => '0');

			else
				if (Reg30 and db_wr) = '1' then
					RegTestTTCbus <= (others => '0');

				else	--	Self Holding Test Register
					RegTestTTCbus(0) <= L1A or RegTestTTCbus(0);
					RegTestTTCbus(1) <= ECR or RegTestTTCbus(1);
					RegTestTTCbus(2) <= BCR or RegTestTTCbus(2);
					RegTestTTCbus(3) <= CAL or RegTestTTCbus(3);
					RegTestTTCbus(4) <= EXS or RegTestTTCbus(4);
					RegTestTTCbus(5) <= TTS or RegTestTTCbus(5);
					RegTestTTCbus(6) <= FER or RegTestTTCbus(6);
					RegTestTTCbus(7) <= SPR or RegTestTTCbus(7);
		
	      	end if;
	      end if;
	   end if;
	end process;


	--	Data Bus
	----------------------------------------------------

	db <= RegEnTTC 	  when ((Reg18 and db_rd) = '1') else 
		   RegTestTTCbus when ((Reg30 and db_rd) = '1') else (others => 'Z');

	
   
   -- Debug Bus
  	----------------------------------------------------

	DebugBus <= "0000000000000000";

end tim;

-------------------------------------------------------------------------------
