-- hds header_start
--
-- VHDL Architecture TIM_fpga2.db_interface.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:21:37 01/14/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity passive_regs is
   generic( 
      FIRMWARE_ID : integer := 0
   );
   port( 
      clk                 : in     std_logic;
      rst                 : in     std_logic;
      db_rd_i             : in     std_logic;
      db_wr_i             : in     std_logic;
      reg_en_i            : in     std_logic_vector (63 downto 0);
      db_io               : inout  std_logic_vector (15 downto 0);
      -----------------------------------------------------------------------------
      -----------------------------------------------------------------------------
      reg_enables_o       : out    std_logic_vector (15 downto 0);
      reg_command_o       : out    std_logic_vector (15 downto 0);
      reg_burstcount_o    : out    std_logic_vector (15 downto 0);
      reg_frequency_o     : out    std_logic_vector (15 downto 0);
      reg_window_o        : out    std_logic_vector (15 downto 0);
      reg_delay_o         : out    std_logic_vector (15 downto 0);
      --
      --
      --
      --
      --
      --
      reg_run_enables_o   : out    std_logic_vector (15 downto 0);
      reg_seq_ctrl_o      : out    std_logic_vector (15 downto 0);
      reg_seq_end_o       : out    std_logic_vector (15 downto 0);
      reg_rb_mask_o       : out    std_logic_vector (15 downto 0);
      --
      --
      --
      --
      reg_ttc_select_o    : out    std_logic_vector (15 downto 0);
      --
      --
      --
      --
      --
      --
      --
      --
      --
      --
      --
      reg_f2_enables_o    : out    std_logic_vector (15 downto 0);
      reg_f2_command_o    : out    std_logic_vector (15 downto 0);
      --
      reg_qpll_control_o  : out    std_logic_vector (15 downto 0);
      reg_fftv_vetolen_o  : out    std_logic_vector (15 downto 0);
      reg_fftv_matchlvl_o : out    std_logic_vector (15 downto 0);
      reg_fftv_p_min_o    : out    std_logic_vector (15 downto 0);
      reg_fftv_p_max_o    : out    std_logic_vector (15 downto 0);
      reg_fftv_oflow_o    : out    std_logic_vector (15 downto 0);
      reg_fftv_deltat_o   : out    std_logic_vector (15 downto 0);
      --
      --
      --
      --
      --
      --
      --
      --
      --
      --
      --
      --
      --
      --
      --
      --
      --
      --
      reg_test_o          : out    std_logic_vector (15 downto 0);
      --
      --
      --
      -----------------------------------------------------------------------------
      -----------------------------------------------------------------------------
      
      -- *** NEW Passive Active
      -------------------------
      reg_window_wr_o     : out    std_logic;
      -- Status bits in
      -----------------
      tim_id_i            : in     std_logic_vector (7 downto 0);
      timestamp_i         : in     std_logic_vector (31 downto 0);
      fftv_enable_link    : in     std_logic;
      f2_spare_link       : in     std_logic;
      ffveto_i            : in     std_logic;
      --  QPPL Status
      ---------------
      qpll_error_i        : in     std_logic;
      qpll_locked_i       : in     std_logic;
      -- Clock Status
      ---------------
      cc_ExtClkOn_i       : in     std_logic;
      cc_SAClkOn_i        : in     std_logic;
      cc_TTCClkOn_i       : in     std_logic;
      -- Control Bits Out
      -------------------
      fftv_en_o           : out    std_logic
   );

-- Declarations

end passive_regs ;


-- hds interface_end
architecture rtl of passive_regs is

	subtype 	slv16 is std_logic_vector(15 downto 0);
   
   type 	  	slv16_64 is array (0 to 63) of slv16;
   signal  	reg 				: slv16_64; 
   	

	--------------------------------------------------------------------------
	-- Constants


		--REMEMBER to change f2_top declaration too!
		-----------------------------------------------------------------------------
		-----------------------------------------------------------------------------
		constant ENABLES : integer := 0 ;
		constant COMMAND : integer := 1 ;
		constant BURSTCOUNT : integer := 2 ;
		constant FREQUENCY : integer := 3 ;
		constant WINDOW : integer := 4 ;
		constant DELAY : integer := 5 ;
		constant STATUS : integer := 6 ;
		constant FIFO : integer := 7 ;
		constant TRIGID_LO : integer := 8 ;
		constant TRIGID_HI : integer := 9 ;
		constant BUNCHID : integer := 10 ;
		constant TTYPE : integer := 11 ;
		constant RUN_ENABLES : integer := 12 ;
		constant SEQ_CTRL : integer := 13 ;
		constant SEQ_END : integer := 14 ;
		constant RB_MASK : integer := 15 ;
		constant RB_STAT : integer := 16 ;
		constant RB_LATCH : integer := 17 ;
		constant RB_MON : integer := 18 ;
		constant TTC_DATA : integer := 19 ;
		constant TTC_SELECT : integer := 20 ;
		constant TTC_BUNCHID : integer := 21 ;
		constant TTCRX_ACCESS : integer := 22 ;
		constant TTC_STATUS : integer := 23 ;
		constant TIM_OUTPUT : integer := 24 ;
		constant TIM_ID : integer := 25 ;
		--
		--
		--
		--
		--
		--
		constant F2_ENABLES : integer := 32 ;
		constant F2_COMMAND : integer := 33 ;
		constant STATUS_T3 : integer := 34 ;
		constant QPLL_CONTROL : integer := 35 ;
		constant FFTV_VETOLEN : integer := 36 ;
		constant FFTV_MATCHLVL : integer := 37 ;
		constant FFTV_P_MIN : integer := 38 ;
		constant FFTV_P_MAX : integer := 39 ;
		constant FFTV_OFLOW : integer := 40 ;
		constant FFTV_DELTAT : integer := 41 ;
		constant FFTV_COUNT_LO : integer := 42 ;
		constant FFTV_COUNT_HI : integer := 43 ;
		constant FFTV_COUNT_EX : integer := 44 ;
		--
		--
		--
		--
		--
		--
		--
		--
		--
		constant BUSY_COUNT_LO : integer := 54 ;
		constant BUSY_COUNT_HI : integer := 55 ;
		constant BUSY_COUNT_EX : integer := 56 ;
		--
		constant SEQ_SRC_COUNT : integer := 58 ;
		constant SEQ_SINK_COUNT : integer := 59 ;
		constant TEST : integer := 60 ;
		constant TESTSTAT : integer := 61 ;
		constant TIMESTAMP_LO : integer := 62 ;
		constant TIMESTAMP_HI : integer := 63 ;
		------------------------------------------------------------------------
		------------------------------------------------------------------------

	signal rd	: std_logic;
	signal en	: std_logic_vector(63 downto 0);
	
	

	-- Status signal inputs
	-----------------------------------------------------
	--	signal bp_laser_ilock_i	: std_logic;
	--	signal busy_test_i		: std_logic;     
	--	signal tim_ok_i			: std_logic;        
	--	signal extclkon_i			: std_logic;       
	--	signal samode_i			: std_logic;        
	--	signal runmode_i			: std_logic;       
	--	signal saclkon_i			: std_logic;       
	--	signal ttcclkon_i			: std_logic;      
	--	signal rcbusy_i			: std_logic;        
	--	signal sink_busy_i		: std_logic;     
	--	signal src_busy_i			: std_logic;      
	--	signal burst_busy_i		: std_logic;    
	--	signal busyout_i			: std_logic;       
	--	signal intbusy_i			: std_logic;       
	--	signal busyin_masked_i	: std_logic; 
	--	signal busyin_i			: std_logic;        



	
begin
   
	rd <= db_rd_i;
	en <= reg_en_i;
   
	------------------------------------------------------------------
	------------------------------------------------------------------		
   -- WRITEs		
   --------		
   process (clk)		
   begin		
			if rising_edge(clk) then	
			if (rst = '1') then	
				reg(ENABLES) <= conv_std_logic_vector(0, 16);
				reg(COMMAND) <= conv_std_logic_vector(0, 16);
				reg(BURSTCOUNT) <= conv_std_logic_vector(0, 16);
				reg(FREQUENCY) <= conv_std_logic_vector(0, 16);
				reg(WINDOW) <= conv_std_logic_vector(0, 16);
				reg(DELAY) <= conv_std_logic_vector(0, 16);
				--
				--
				--
				--
				--
				--
				reg(RUN_ENABLES) <= conv_std_logic_vector(0, 16);
				reg(SEQ_CTRL) <= conv_std_logic_vector(0, 16);
				reg(SEQ_END) <= conv_std_logic_vector(0, 16);
				reg(RB_MASK) <= conv_std_logic_vector(0, 16);
				--
				--
				--
				--
				reg(TTC_SELECT) <= conv_std_logic_vector(0, 16);
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				reg(F2_ENABLES) <= conv_std_logic_vector(0, 16);
				reg(F2_COMMAND) <= conv_std_logic_vector(0, 16);
				--
				reg(QPLL_CONTROL) <= conv_std_logic_vector(16#B0#, 16);
				reg(FFTV_VETOLEN) <= conv_std_logic_vector(40000, 16);
				reg(FFTV_MATCHLVL) <= conv_std_logic_vector(10, 16);
				reg(FFTV_P_MIN) <= conv_std_logic_vector(533, 16);
				reg(FFTV_P_MAX) <= conv_std_logic_vector(2666, 16);
				reg(FFTV_OFLOW) <= conv_std_logic_vector(2766, 16);
				reg(FFTV_DELTAT) <= conv_std_logic_vector(40, 16);
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				reg(TEST) <= conv_std_logic_vector(0, 16);
				--
				--
				--
				
				
			elsif (db_wr_i = '1') then	
				if(en(ENABLES) = '1') then reg(ENABLES) <= db_io; end if;
				if(en(COMMAND) = '1') then reg(COMMAND) <= db_io; end if;
				if(en(BURSTCOUNT) = '1') then reg(BURSTCOUNT) <= db_io; end if;
				if(en(FREQUENCY) = '1') then reg(FREQUENCY) <= db_io; end if;
				if(en(WINDOW) = '1') then reg(WINDOW) <= db_io; end if;
				if(en(DELAY) = '1') then reg(DELAY) <= db_io; end if;
				--
				--
				--
				--
				--
				--
				if(en(RUN_ENABLES) = '1') then reg(RUN_ENABLES) <= db_io; end if;
				if(en(SEQ_CTRL) = '1') then reg(SEQ_CTRL) <= db_io; end if;
				if(en(SEQ_END) = '1') then reg(SEQ_END) <= db_io; end if;
				if(en(RB_MASK) = '1') then reg(RB_MASK) <= db_io; end if;
				--
				--
				--
				--
				if(en(TTC_SELECT) = '1') then reg(TTC_SELECT) <= db_io; end if;
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				if(en(F2_ENABLES) = '1') then reg(F2_ENABLES) <= db_io; end if;
				if(en(F2_COMMAND) = '1') then reg(F2_COMMAND) <= db_io; end if;
				--
				if(en(QPLL_CONTROL) = '1') then reg(QPLL_CONTROL) <= db_io; end if;
				if(en(FFTV_VETOLEN) = '1') then reg(FFTV_VETOLEN) <= db_io; end if;
				if(en(FFTV_MATCHLVL) = '1') then reg(FFTV_MATCHLVL) <= db_io; end if;
				if(en(FFTV_P_MIN) = '1') then reg(FFTV_P_MIN) <= db_io; end if;
				if(en(FFTV_P_MAX) = '1') then reg(FFTV_P_MAX) <= db_io; end if;
				if(en(FFTV_OFLOW) = '1') then reg(FFTV_OFLOW) <= db_io; end if;
				if(en(FFTV_DELTAT) = '1') then reg(FFTV_DELTAT) <= db_io; end if;
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				--
				if(en(TEST) = '1') then reg(TEST) <= db_io; end if;
				--
				--
				--
		
			end if;	
      end if;		
   end process;		


	-- READs	
	--------	
	db_io <=	
		reg(ENABLES) when ((rd and en(ENABLES))= '1') else
		reg(COMMAND) when ((rd and en(COMMAND))= '1') else
		reg(BURSTCOUNT) when ((rd and en(BURSTCOUNT))= '1') else
		reg(FREQUENCY) when ((rd and en(FREQUENCY))= '1') else
		reg(WINDOW) when ((rd and en(WINDOW))= '1') else
		reg(DELAY) when ((rd and en(DELAY))= '1') else
		--
		--
		--
		--
		--
		--
		reg(RUN_ENABLES) when ((rd and en(RUN_ENABLES))= '1') else
		reg(SEQ_CTRL) when ((rd and en(SEQ_CTRL))= '1') else
		reg(SEQ_END) when ((rd and en(SEQ_END))= '1') else
		reg(RB_MASK) when ((rd and en(RB_MASK))= '1') else
		--
		--
		--
		--
		reg(TTC_SELECT) when ((rd and en(TTC_SELECT))= '1') else
		--
		--
		--
		--
		reg(TIM_ID) when ((rd and en(TIM_ID))= '1') else
		--
		--
		--
		--
		--
		--
		reg(F2_ENABLES) when ((rd and en(F2_ENABLES))= '1') else
		reg(F2_COMMAND) when ((rd and en(F2_COMMAND))= '1') else
		reg(STATUS_T3) when ((rd and en(STATUS_T3))= '1') else
		reg(QPLL_CONTROL) when ((rd and en(QPLL_CONTROL))= '1') else
		reg(FFTV_VETOLEN) when ((rd and en(FFTV_VETOLEN))= '1') else
		reg(FFTV_MATCHLVL) when ((rd and en(FFTV_MATCHLVL))= '1') else
		reg(FFTV_P_MIN) when ((rd and en(FFTV_P_MIN))= '1') else
		reg(FFTV_P_MAX) when ((rd and en(FFTV_P_MAX))= '1') else
		reg(FFTV_OFLOW) when ((rd and en(FFTV_OFLOW))= '1') else
		reg(FFTV_DELTAT) when ((rd and en(FFTV_DELTAT))= '1') else
		--
		--
		--
		--
		--
		--
		--
		--
		--
		--
		--
		--
		--
		--
		--
		--
		--
		--
		reg(TEST) when ((rd and en(TEST))= '1') else
		reg(TESTSTAT) when ((rd and en(TESTSTAT))= '1') else
		reg(TIMESTAMP_LO) when ((rd and en(TIMESTAMP_LO))= '1') else
		reg(TIMESTAMP_HI) when ((rd and en(TIMESTAMP_HI))= '1') else
		
		(others => 'Z'); 


	-- Output Signal Map	
	--------------------	
	reg_enables_o <= reg(ENABLES);	
	reg_command_o <= reg(COMMAND);	
	reg_burstcount_o <= reg(BURSTCOUNT);	
	reg_frequency_o <= reg(FREQUENCY);	
	reg_window_o <= reg(WINDOW);	
	reg_delay_o <= reg(DELAY);	
	--	
	--
	--
	--
	--
	--
	reg_run_enables_o <= reg(RUN_ENABLES);
	reg_seq_ctrl_o <= reg(SEQ_CTRL);
	reg_seq_end_o <= reg(SEQ_END);
	reg_rb_mask_o <= reg(RB_MASK);
	--
	--
	--
	--
	reg_ttc_select_o <= reg(TTC_SELECT);
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	reg_f2_enables_o <= reg(F2_ENABLES);
	reg_f2_command_o <= reg(F2_COMMAND);
	--
	reg_qpll_control_o <= reg(QPLL_CONTROL);
	reg_fftv_vetolen_o <= reg(FFTV_VETOLEN);
	reg_fftv_matchlvl_o <= reg(FFTV_MATCHLVL);
	reg_fftv_p_min_o <= reg(FFTV_P_MIN);
	reg_fftv_p_max_o <= reg(FFTV_P_MAX);
	reg_fftv_oflow_o <= reg(FFTV_OFLOW);
	reg_fftv_deltat_o <= reg(FFTV_DELTAT);
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	reg_test_o <= reg(TEST);
	--
	--
	--
	-------------------------------------------------------------------------

	-------------------------------------------------------------------------

   -------------------------------------------------------------------------   
	-- Bit Outputs from control registers
	-------------------------------------
	
	fftv_en_o <= reg(F2_ENABLES)(0);


	-- Status Type Register Assignment
	----------------------------------
	--	reg(STATUS)(15) <= bp_laser_ilock_i;
	--	reg(STATUS)(14) <= busy_test_i;
	--	reg(STATUS)(13) <= tim_ok_i;
	--	reg(STATUS)(12) <= extclkon_i
	--	reg(STATUS)(11) <= samode_i;
	--	reg(STATUS)(10) <= runmode_i;
	--	reg(STATUS)( 9) <= saclkon_i;
	--	reg(STATUS)( 8) <= ttcclkon_i;
	--	reg(STATUS)( 7) <= rcbusy_i;
	--	reg(STATUS)( 6) <= sink_busy_i;
	--	reg(STATUS)( 5) <= src_busy_i;
	--	reg(STATUS)( 4) <= burst_busy_i;
	--	reg(STATUS)( 3) <= busyout_i;
	--	reg(STATUS)( 2) <= intbusy_i;
	--	reg(STATUS)( 1) <= busyin_masked_i;
	--	reg(STATUS)( 0) <= busyin_i;


	reg(STATUS_T3) ( 0) <= ffveto_i;
   reg(STATUS_T3) ( 1) <= fftv_enable_link;
   
   reg(STATUS_T3) ( 2) <= qpll_locked_i; 
   reg(STATUS_T3) ( 3) <= qpll_error_i;  
   reg(STATUS_T3) ( 8) <= cc_TTCClkOn_i;  
   reg(STATUS_T3) ( 9) <= cc_SAClkOn_i  ;  
   reg(STATUS_T3) (10) <= cc_ExtClkOn_i;  

   
	reg(TESTSTAT)	( 0)	<= f2_spare_link;

	reg(TESTSTAT)(15 downto 2) 	<= (others => '0');

   reg(TIM_ID) <= (conv_std_logic_vector(FIRMWARE_ID, 8) & tim_ID_i);

   reg(TIMESTAMP_LO) <= timestamp_i(15 downto  0);
   reg(TIMESTAMP_HI) <= timestamp_i(31 downto 16);
   

	-- First Passive Active Reg   
	-- *** not sure if this is the best way yet
 	reg_window_wr_o <= en(WINDOW) and db_wr_i;
				   
end rtl;	