-- hds header_start
--
-- VHDL Entity TIM_fpga2.pulse_trap.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:36:35 03/05/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

--  Small helper entity to work around problem of using functions
-- 
--  
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

-- ----------------------------------------------------------------------------
--  ENTITY
-- ----------------------------------------------------------------------------
-- 
entity pulse_trap is
   port( 
      rst  : in     std_logic;
      clk  : in     std_logic;
      sin  : in     std_logic;
      en   : in     std_logic;
      clr  : in     std_logic;
      sout : out    std_logic
   );

-- Declarations

end pulse_trap ;


-- hds interface_end


------------------------------------------------------------------------------
-- ARCHITECTURE
------------------------------------------------------------------------------
architecture tim of pulse_trap is



------------------------------------------------------------------------------
-- SIGNAL DECLARATIONS
------------------------------------------------------------------------------
      
   signal sig0     : std_logic;
   signal sig1     : std_logic;
               
-------------------------------------------------------------------------------
--	MAIN CODE
-------------------------------------------------------------------------------
begin
      
   -- edge to level
   --sig0 <= (sin and en) or (sig0 and (not clr));
      
   --*** this does not capture short pulses due to clocking -- more investigation needed
   
   -- clocked rising edge detector
   process (rst, clk)
   begin
   
      if (rst = '1') then
         sig1 <= '0';
         sig0 <= '0';
                     
      elsif rising_edge(clk) then
      
      	sig0 <= (sin and en) or (sig0 and (not clr));

         if    (sig1 = '1') and (sig0 = '0') then 
         	sig1 <= '0';
         	
         elsif (sig1 = '1') and (sig0 = '1') then 
         	sig1 <= '1';
         	
         else								         	  
         	sig1 <= '0';
         	
         end if;
         
      end if;
   end process;

   sout <= sig1;
      

end tim;     