-- hds header_start
--
-- VHDL Architecture TIM_fpga2.samode_tester.test
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:30:12 03/29/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
--
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity samode_tester is
   port( 
      RCBUSY              : out    std_logic;
      RCBUSYen            : out    std_logic;
      Reg00               : out    std_logic;
      Reg02               : out    std_logic;
      Reg04               : out    std_logic;
      Reg06               : out    std_logic;
      Reg08               : out    std_logic;
      Reg0A               : out    std_logic;
      Reg0C               : out    std_logic;
      SeqBusy             : out    std_logic;
      SinkBusy            : out    std_logic;
      bp_laserntlck_state : out    std_logic;
      cc_ExtClkOn         : out    std_logic;
      cc_SAClkOn          : out    std_logic;
      cc_TTCClkOn         : out    std_logic;
      clk                 : out    std_logic;
      ext_BCRin_ecl       : out    std_logic;
      ext_BCRin_nim       : out    std_logic;
      ext_BUSYin_ecl      : out    std_logic;
      ext_BUSYin_nim      : out    std_logic;
      ext_CALin_ecl       : out    std_logic;
      ext_CALin_nim       : out    std_logic;
      ext_ECRin_ecl       : out    std_logic;
      ext_ECRin_nim       : out    std_logic;
      ext_FERin_ecl       : out    std_logic;
      ext_FERin_nim       : out    std_logic;
      ext_SPRin_ecl       : out    std_logic;
      ext_SPRin_nim       : out    std_logic;
      ext_TRIG_sw         : out    std_logic;
      ext_TRIGin_ecl      : out    std_logic;
      ext_TRIGin_nim      : out    std_logic;
      int_ECRin           : out    std_logic;
      int_FERin           : out    std_logic;
      int_TRIGin          : out    std_logic;
      rst                 : out    std_logic;
      setTTCClk           : out    std_logic;
      trw_Win_open        : out    std_logic;
      db_rd               : out    std_logic;
      db_wr               : out    std_logic;
      db                  : inout  std_logic_vector (15 downto 0)
   );

-- Declarations

end samode_tester ;


-- hds interface_end

-------------------------------------------------------------------------------

architecture test of samode_tester is
	signal clkosc 	 		: std_logic := '1';                                     
	
	-- Commands
	constant CMD_TRG 	: integer := 2#00000010#;
	constant CMD_ECR 	: integer := 2#00000100#;
	constant CMD_BCR 	: integer := 2#00001000#;
	constant CMD_CAL 	: integer := 2#00010000#;
	constant CMD_FER 	: integer := 2#00100000#;
	constant CMD_SPR 	: integer := 2#01000000#;
	constant CMD_RST 	: integer := 2#10000000_00000000#;
                                                                                
	constant REG_ENABLES  	: std_logic_vector(6 downto 0) := "0000001";             
	constant REG_COMMANDS	: std_logic_vector(6 downto 0) := "0000010";             
	constant REG_BURSTCOUNT : std_logic_vector(6 downto 0) := "0000100";             
	constant REG_FREQUENCY	: std_logic_vector(6 downto 0) := "0001000";             
	constant REG_WINDOW  	: std_logic_vector(6 downto 0) := "0010000";             
	constant REG_DELAY		: std_logic_vector(6 downto 0) := "0100000";             
	constant REG_STATUS		: std_logic_vector(6 downto 0) := "1000000";             

-------------------------------------------------------------------------------
begin
                                                                   
	-- clock generator                                                
	------------------                                                
	clkosc	<= not clkosc after 12500 ps;                            
	clk 		<= clkosc;                                               
                                                            
                                                                                
	---------------------------------------------------------------------------
	sim : process
	
		-- Procedures
		----------------------------------------------------------------
		procedure DB_Write( reg_en	: in std_logic_vector(6 downto 0);  
								  idata 	: in integer ) is
			variable data : std_logic_vector(15 downto 0);
		begin
			data := conv_std_logic_vector(idata, 16);
			Reg00 	<= reg_en(0);
      	Reg02 	<= reg_en(1);
      	Reg04 	<= reg_en(2);
      	Reg06 	<= reg_en(3);
      	Reg08 	<= reg_en(4);
      	Reg0A 	<= reg_en(5);
         Reg0C 	<= reg_en(6); 		wait for 25 ns;
			db  	<= data;					wait for 25 ns;
			db_wr	<= '1';			   	wait for 25 ns;
			db_wr	<= '0';			   	wait for 25 ns;
			Reg00 	<= '0';
      	Reg02 	<= '0';
      	Reg04 	<= '0';
      	Reg06 	<= '0';
      	Reg08 	<= '0';
      	Reg0A 	<= '0';
      	Reg0C 	<= '0'; 
			db    <= (others => 'Z');	wait for 25 ns;

		end procedure; 
		----------------------------------------------------------------
		procedure DB_Read( reg_en	: in std_logic_vector(6 downto 0) ) is
		begin
			Reg00	<= reg_en(0);
      	Reg02	<= reg_en(1);
      	Reg04	<= reg_en(2);
      	Reg06	<= reg_en(3);
      	Reg08	<= reg_en(4);
      	Reg0A	<= reg_en(5);
      	Reg0C	<= reg_en(6);				wait for 25 ns;
			db_rd	<= '1';						wait for 25 ns;
			db_rd	<= '0';						wait for 25 ns;
			Reg00	<= '0';
      	Reg02	<= '0';
      	Reg04	<= '0';
      	Reg06	<= '0';
      	Reg08	<= '0';
      	Reg0A	<= '0';
      	Reg0C	<= '0';						wait for 25 ns;
		end procedure; 
		
		
		
		--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==
		procedure Send_Fast_Trigs(m : integer) is
		begin
			for n in 1 to m loop
		   	ext_TRIG_sw <= '1';
		   	wait for 25 ns;
		   	ext_TRIG_sw <= '0';
		   	wait for 25 ns;
		   end loop;
		end procedure;

		--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==
		procedure Send_vCals(m : integer) is
		begin
	  		for n in 1 to m loop
	   		DB_Write(REG_COMMANDS, CMD_CAL);
	   		DB_Write(REG_COMMANDS, 0);
	   		wait for 700 ns;
	   	end loop;
		end procedure;
		
		--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==

		--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==
		procedure Send_vTRGs(m : integer) is
		begin

		   for n in 1 to m loop
		   	DB_Write(REG_COMMANDS, CMD_TRG);
		   	DB_Write(REG_COMMANDS, 0);
		   	wait for 200 ns;
		   end loop;

		end procedure;
		
		--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==
		procedure Burst_Trig_Test is
		begin
			
			DB_Write(REG_BURSTCOUNT, 5);
  	   	
  	   	DB_Write(REG_COMMANDS, 16#0200#); -- Burst Mode
  	   	Send_Fast_Trigs(5);	  	   
  	   	
  	   	DB_Write(REG_COMMANDS, 16#0600#); -- Burst Go
  	   	
			Send_Fast_Trigs(40);
  	   	
  	   	DB_Write(REG_COMMANDS, 16#0000#); -- Burst Clear
  	   	
			wait for 500 ns;
			
		end procedure;
		
		--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==
		procedure Burst_Cal_Test is
		begin
		
			DB_Write(REG_BURSTCOUNT, 5);
			DB_Write(REG_ENABLES,  16#0000#);
			
			DB_Write(REG_COMMANDS, 16#0200#); -- Burst Mode       	   	
  	   	Send_Fast_Trigs(20);	  	   
			
			DB_Write(REG_COMMANDS, 16#0600#); -- Burst Go
			DB_Write(REG_COMMANDS, 16#0610#); -- vCAL  	   	
			
			wait for 7 * (27+10) * 25 ns;	  	   
			

			DB_Write(REG_COMMANDS, 16#0000#); -- Clear Go
			
		
		end procedure;
		
		
		procedure Send_vCommands_Badly(m : integer) is
		begin

		   for n in 1 to m loop
		   	DB_Write(REG_COMMANDS, CMD_TRG);
				wait for 5 * 25 ns;	  	   
				
		   	DB_Write(REG_COMMANDS, CMD_ECR);
		   	wait for 5 * 25 ns;	  	   

		   	DB_Write(REG_COMMANDS, CMD_BCR);
				wait for 5 * 25 ns;	  	   

		   	DB_Write(REG_COMMANDS, CMD_CAL);
				wait for 5 * 25 ns;	  	   

		   	DB_Write(REG_COMMANDS, CMD_FER);
				wait for 5 * 25 ns;
				
		   	DB_Write(REG_COMMANDS, CMD_SPR);
				wait for 5 * 25 ns;	  	   

			end loop;

		end procedure;



	--==========================================================================
	-- Simulation
	--==========================================================================
	begin
	
		-- Start-up values
		----------------------------------------------------------

		rst      		<= '0';    
      db_rd    		<= '0';
      db_wr    		<= '0';      
      db       		<= (others => 'Z');

      RCBUSY              <= '0';
      RCBUSYen            <= '0';
      Reg00               <= '0';
      Reg02               <= '0';
      Reg04               <= '0';
      Reg06               <= '0';
      Reg08               <= '0';
      Reg0A               <= '0';
      Reg0C               <= '0';
      SeqBusy             <= '0';
      SinkBusy            <= '0';
      bp_laserntlck_state <= '0';
      cc_ExtClkOn         <= '0';
      cc_SAClkOn          <= '0';
      cc_TTCClkOn         <= '0';
      ext_BCRin_ecl       <= '0';
      ext_BCRin_nim       <= '0';
      ext_BUSYin_ecl      <= '0';
      ext_BUSYin_nim      <= '0';
      ext_CALin_ecl       <= '0';
      ext_CALin_nim       <= '0';
      ext_ECRin_ecl       <= '0';
      ext_ECRin_nim       <= '0';
      ext_FERin_ecl       <= '0';
      ext_FERin_nim       <= '0';
      ext_SPRin_ecl       <= '0';
      ext_SPRin_nim       <= '0';
      ext_TRIG_sw         <= '0';
      ext_TRIGin_ecl      <= '0';
      ext_TRIGin_nim      <= '0';
      int_ECRin           <= '0';
      int_FERin           <= '0';
      int_TRIGin          <= '0';
      setTTCClk           <= '0';
      trw_Win_open        <= '0';


      -------------------------------------------------------------------------
      -- Main Simulation
		-------------------------------------------------------------------------
	   
		-- Reset
		wait for 25 ns;		
	   rst <= '1';
	   wait for 100 ns;		
	   rst <= '0';
	   
	   wait for 105 ns; -- Setup signals to arrive after the clock

	   Send_vTRGs(10); 
	   wait for 1000 ns;
	
	   --Send_Fast_Trigs(1);
	   --
	
	   Send_vCals(10);
	   wait for 1000 ns;

 		Burst_Trig_Test;
 		wait for 1000 ns;

		Burst_Cal_Test;
		wait for 1000 ns;

 		Send_vCommands_Badly(100);
		wait for 1000 ns; 		
   	 
 	   wait;
	end process;
end test;

