-- hds header_start
--
-- VHDL Entity TIM_fpga2.samode.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 21:39:12 02/29/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity samode is
   port( 
      rst                     : in     std_logic;
      clk                     : in     std_logic;
      db                      : inout  std_logic_vector (15 downto 0);
      vmeRD                   : in     std_logic;
      vmeWR                   : in     std_logic;
      --vmeCLK         : in	std_logic;
      Reg00                   : in     std_logic;                       -- 0. Enables
      Reg02                   : in     std_logic;                       -- 1. Command
      Reg04                   : in     std_logic;                       -- 2. Burst Count
      Reg06                   : in     std_logic;                       -- 3. Frequency
      Reg08                   : in     std_logic;                       -- 4. Window
      Reg0A                   : in     std_logic;                       -- 5. Delay
      Reg0C                   : in     std_logic;                       -- 6. Status
      SeqBusy_i               : in     std_logic;
      SinkBusy_i              : in     std_logic;
      RCBUSY_i                : in     std_logic;                       -- from rod_busys.vhd
      RCBUSYen_i              : in     std_logic;                       -- from mixer.vhd
      ext_TRIG_sw_i           : in     std_logic;
      ext_TRIGin_ecl_i        : in     std_logic;
      ext_TRIGin_nim_i        : in     std_logic;
      ext_BCRin_ecl_i         : in     std_logic;
      ext_BCRin_nim_i         : in     std_logic;
      ext_ECRin_ecl_i         : in     std_logic;
      ext_ECRin_nim_i         : in     std_logic;
      ext_CALin_ecl_i         : in     std_logic;
      ext_CALin_nim_i         : in     std_logic;
      ext_FERin_ecl_i         : in     std_logic;
      ext_FERin_nim_i         : in     std_logic;
      ext_SPRin_ecl_i         : in     std_logic;
      ext_SPRin_nim_i         : in     std_logic;
      ext_BUSYin_ecl_i        : in     std_logic;
      ext_BUSYin_nim_i        : in     std_logic;
      ext_ETRIGout_o          : out    std_logic;
      ext_BUSYout_o           : out    std_logic;
      ext_BUSYin_masked_o     : out    std_logic;
      led_RunMode_o           : out    std_logic;
      led_SAMode_o            : out    std_logic;
      int_TRIGin_i            : in     std_logic;
      int_ECRin_i             : in     std_logic;
      int_FERin_i             : in     std_logic;
      int_oscFERen_o          : out    std_logic;
      int_oscTRIGen_o         : out    std_logic;
      --ext_Reset_sw_i 	: in  std_logic;
      		--OA_reset_no 		: out std_logic;
      		--OA_reset_o 		: out std_logic;
      RunMode_o               : out    std_logic;
      int_oscR_o              : out    std_logic_vector (5 downto 1);
      int_oscS_o              : out    std_logic_vector (5 downto 1);
      -- Trigger Window
      	   -----------------
      trw_delayWD_o           : out    std_logic_vector (5 downto 0);
      trw_delayWS_o           : out    std_logic_vector (5 downto 0);
      trw_Win_en_o            : out    std_logic;
      trw_Win_open_i          : in     std_logic;
      trw_StopClk_o           : out    std_logic;
      -- Clock Control
      	   ----------------
      setTTCClk_i             : in     std_logic;                       -- from reg on mixer.vhd
      cc_delayCT_o            : out    std_logic_vector (5 downto 0);
      cc_enIntClk_o           : out    std_logic;
      cc_enSAClk_o            : out    std_logic;
      cc_ExtClkOn_i           : in     std_logic;
      cc_SAClkOn_i            : in     std_logic;
      cc_TTCClkOn_i           : in     std_logic;
      bp_TIM_OK_out_o         : out    std_logic;
      -- SA Signals Out
      		--------------
      SATRIG_o                : out    std_logic;
      SABCR_o                 : out    std_logic;
      SAECR_o                 : out    std_logic;
      SACAL_o                 : out    std_logic;
      SAFER_o                 : out    std_logic;
      SASPR_o                 : out    std_logic;
      --EDTRIG_o       : out	std_logic; -- early delayed trig
      v_RCBUSY_o              : out    std_logic;
      bp_laser_intlck_state_i : in     std_logic;
      StartSeq_o              : out    std_logic;
      StartSink_o             : out    std_logic;
      -- Debug Bus     
      		----------------
      DebugBus                : out    std_logic_vector (15 downto 0)
   );

-- Declarations

end samode ;

-- hds interface_end

------------------------------------------------------------------------------
-- ARCHITECTURE                                                                
------------------------------------------------------------------------------
architecture tim of samode is


------------------------------------------------------------------------------
-- SIGNAL DECLARATIONS
------------------------------------------------------------------------------

 
 
 	signal RegEnables 	: std_logic_vector(15 downto 0);
 	signal RegCommands	: std_logic_vector(15 downto 0);
 	signal RegBurstCnt	: std_logic_vector(15 downto 0);
 	signal RegFreq		   : std_logic_vector(15 downto 0);	
 	signal RegTrigWin		: std_logic_vector(15 downto 0);
 	signal RegDelays 		: std_logic_vector(15 downto 0);
 	signal RegStatus		: std_logic_vector(15 downto 0);
 	
 	--BUSYs
 	------------------------------------
 
   signal ext_BUSYout   : std_logic;

   signal int_BUSY		: std_logic; -- OA_busy
	signal int_BUSYen		: std_logic;

   signal ext_BUSYin      : std_logic;
	signal ext_BUSYinen		: std_logic;
	signal v_BUSY			: std_logic;

	signal OA_busy			: std_logic;
	signal ext_BUSYin_masked : std_logic;
	

   -- General
   ---------------------------------
	signal RunMode			: std_logic;
 	signal SAMode			: std_logic;
 	
 	signal v_OAReset   	: std_logic;
 	
 	
 	--CLOCK CONTROL
 	----------------------------------
 	
	signal ext_CLKen  	: std_logic;
   signal TIM_OK   	   : std_logic;

   signal BurstBusy  	: std_logic;
   signal Burst_Ready 	: std_logic;   	
 	signal v_BurstMode	: std_logic;
	signal v_BurstGo  	: std_logic;


	signal TestBUSY      : std_logic;
   signal TestBUSYen  	: std_logic;
	signal TestBUSYclr 	: std_logic;

   signal Window_open   : std_logic;
   signal Window_en     : std_logic;   	



   signal ext_TRIG,   ext_BCR,   ext_ECR,   ext_CAL,   ext_FER,   ext_SPR   : std_logic;
   signal ext_TRIGen, ext_BCRen, ext_ECRen, ext_CALen, ext_FERen, ext_SPRen : std_logic;


   signal int_TRIG, int_BCR, int_ECR, int_FER : std_logic;    
   signal int_TRIG2     : std_logic;
   signal int_RanTRIG   : std_logic;

   
   signal int_TRIGen, int_BCRen, int_ECRen, int_FERen : std_logic;    
   signal int_TRIG2en   : std_logic;
   signal int_RanTRIGen : std_logic;

            
  
   
   signal syncTRIG,  syncBCR,  syncECR,  syncCAL,  syncFER,  syncSPR    : std_logic;
   signal syncCALP   : std_logic;
   signal syncDTRIG  : std_logic; --*** clocked signal
   
   signal busyTRIG,  busyBCR,  busyECR,  busyCAL,  busyFER,  busySPR    : std_logic;
   signal busyCALP   : std_logic;
   signal busyCALTRIG  : std_logic;
   signal busyDTRIG  : std_logic;
   signal busyRTRIG  : std_logic;
   signal busyANY    : std_logic;
   
   signal asyncTRIG, asyncCAL, asyncBCR, asyncECR, asyncFER, asyncSPR   : std_logic;
   

   signal v_TRIG,    v_CAL,    v_BCR,    v_ECR,    v_FER,    v_SPR   : std_logic;

   signal DTRIG       : std_logic; -- delayed trig   
      
   signal disableTRIG : std_logic;
   
   component pulse_trap
      port (
         rst 	: in	std_logic;
         clk  	: in	std_logic;
         
         sin	: in  std_logic;
         en  	: in  std_logic;
         clr   : in  std_logic;
         
         sout 	: out std_logic

      );
   end component;
   
  	
  	
-------------------------------------------------------------------------------
--	MAIN CODE                                                                   
-------------------------------------------------------------------------------
begin

   
   

	RunMode_o <= RunMode;    
	SAMode <= (not RunMode); 
	
	led_runmode_o <= RunMode;
	led_samode_o  <= SAMode;
   
   ext_BUSYout_o  <= ext_BUSYout;   
   
   StartSeq_o   <= syncSPR;
	StartSink_o	 <= syncTRIG;

   
   ------------------------------------------------------------------   
   -- Internal Signals (i.e. from on-board sources)
   ------------------------------------------------------------------
   
   -- Signal name sequence
   -- int_TRIGin --> int_TRIG
   
   
   int_TRIG2en <= int_TRIGen and (not int_RanTRIGen);
   
   
   Upti1: pulse_trap port map ( sin=> int_TRIGin_i, en=> int_TRIG2en, clr=> busyTRIG, sout=> int_TRIG2, rst=> rst, clk=> clk );
   Upti2: pulse_trap port map ( sin=> int_ECRin_i,  en=> int_ECRen,   clr=> busyANY,  sout=> int_ECR,   rst=> rst, clk=> clk );
   Upti3: pulse_trap port map ( sin=> int_FERin_i,  en=> int_FERen,   clr=> busyANY,  sout=> int_FER,   rst=> rst, clk=> clk );

  
   --int_RanTRIG generated here
   --int_BCR     generated here
   int_TRIG <= int_TRIG2 OR int_RanTRIG;
   
   
   int_oscFERen_o  <= int_FERen OR int_ECRen;
   int_oscTRIGen_o <= int_TRIGen OR int_RanTRIGen;
   
   	-- Int Signal programmable oscillators
	--------------------------------------
	int_oscR_o <= RegFreq( 4 downto 0);
	int_oscS_o <= RegFreq(12 downto 8);
   
   
   -- pseudo-randomiser - generate int_RanTRIG
   ---------------------------------------------------------------------------
   rnd: block
      signal   shiftreg    : std_logic_vector(39 downto 1);
      signal   shiftreg_in : std_logic;
      
   begin
   
      process (rst, clk)
      begin
      
         if (rst = '1') then
            shiftreg <= (others => '1');
      
         elsif rising_edge(clk) then
         
            if (int_TRIG = '1') then --*** this won't work ... need to check for rising edge

               shiftreg(39 downto 2) <= shiftreg(38 downto 1);
               shiftreg(1)           <= shiftreg(39) xor shiftreg(35);
               
            end if;
         end if;
      end process;
            
      int_RanTRIG <= shiftreg(39);
      
   end block;
   
   
   ------------------------------------------------------------------   
   -- External Signals (i.e. from front panel sources)
   ------------------------------------------------------------------

   ext_in: block
   
      signal ext_TRIGin, ext_BCRin, ext_ECRin, ext_CALin, ext_FERin, ext_SPRin : std_logic;      

   begin

      ext_TRIGin <= (ext_TRIGin_nim_i or ext_TRIGin_ecl_i) and Window_open; --*** not sure if window open should go here
      ext_CALin  <= (ext_CALin_nim_i  or ext_CALin_ecl_i);
      ext_BCRin  <= (ext_BCRin_nim_i  or ext_BCRin_ecl_i);
      ext_FERin  <= (ext_FERin_nim_i  or ext_FERin_ecl_i);
      ext_ECRin  <= (ext_ECRin_nim_i  or ext_ECRin_ecl_i);
      ext_SPRin  <= (ext_SPRin_nim_i  or ext_SPRin_ecl_i);
      
      Upte1: pulse_trap port map ( sin=> ext_TRIGin, en=> ext_TRIGen, clr=> busyTRIG, sout=> ext_TRIG, rst=> rst, clk=> clk );
      Upte2: pulse_trap port map ( sin=> ext_CALin , en=> ext_CALen,  clr=> busyANY,  sout=> ext_CAL,  rst=> rst, clk=> clk );
      Upte3: pulse_trap port map ( sin=> ext_BCRin , en=> ext_BCRen,  clr=> busyANY,  sout=> ext_BCR,  rst=> rst, clk=> clk );
      Upte4: pulse_trap port map ( sin=> ext_FERin , en=> ext_FERen,  clr=> busyANY,  sout=> ext_FER,  rst=> rst, clk=> clk );
      Upte5: pulse_trap port map ( sin=> ext_ECRin , en=> ext_ECRen,  clr=> busyANY,  sout=> ext_ECR,  rst=> rst, clk=> clk );
      Upte6: pulse_trap port map ( sin=> ext_SPRin , en=> ext_SPRen,  clr=> busyANY,  sout=> ext_SPR,  rst=> rst, clk=> clk );


   end block;

  
   ------------------------------------------------------------------   
   -- Combined Signals
   ------------------------------------------------------------------
   
      asyncTRIG <= (ext_TRIG or int_TRIG or v_TRIG  or ext_TRIG_sw_i);
      asyncBCR  <= (ext_BCR  or int_BCR  or v_BCR             );
      asyncECR  <= (ext_ECR  or int_ECR  or v_ECR             );
      asyncCAL  <= (ext_CAL              or v_CAL             );
      asyncFER  <= (ext_FER  or int_FER  or v_FER             );
      asyncSPR  <= (ext_SPR  or             v_SPR             );
         

	syncroniser: block
	
		signal 	sync_ff : std_logic_vector(5 downto 0);

   begin
      process (rst, clk)
      begin
         if (rst = '1') then
            syncTRIG <= '0';  
            syncBCR  <= '0'; 
            syncECR  <= '0';
            syncCAL  <= '0';
            syncFER  <= '0';
            syncSPR  <= '0';
            
            sync_ff  <= (others => '0');
            
         elsif rising_edge(clk) then
         
            sync_ff(0) <=  asyncTRIG;
            sync_ff(1) <=  asyncBCR; 
            sync_ff(2) <=  asyncECR; 
            sync_ff(3) <=  asyncCAL; 
            sync_ff(4) <=  asyncFER; 
            sync_ff(5) <=  asyncSPR;
   
            syncTRIG <=  sync_ff(0); 
            syncBCR  <=  sync_ff(1); 
            syncECR  <=  sync_ff(2); 
            syncCAL  <=  sync_ff(3); 
            syncFER  <=  sync_ff(4); 
            syncSPR  <=  sync_ff(5); 
            
         end if;
         
      end process;
   end block;
   
   syncDTRIG	<= DTRIG AND ((not busyANY) OR busyCALTRIG);
   ext_eTRIGout_o   <= syncTRIG;
   	
   
   
   ---------------------------------------------------------------------------
	-- OUTPUTs
	---------------------------------------------------------------------------

   -- *** this is not the way it should be
   --     it is for testing synth etc.
   
   SATRIG_o	<= syncTRIG;
   SABCR_o	<= syncBCR;
   SAECR_o	<= syncECR;
   SACAL_o	<= syncCAL;
   SAFER_o	<= syncFER;
   SASPR_o	<= syncSPR;
	


 	---------------------------------------------------------------------------
	-- Internal Busys
	---------------------------------------------------------------------------

	sabusys: block
		signal clrDTRIG, clrBCR, clrECR, clrCAL, clrFER, clrSPR : std_logic;
      signal clrCALP : std_logic;
		signal xbusyDTRIG : std_logic;
		
		signal doneDTRIG,  doneBCR,  doneECR,  doneCAL,  doneFER,  doneSPR    : std_logic;
   	signal doneCALP   : std_logic;
   	signal doneANY    : std_logic;
   	
   	signal dt3, dt7, dt27 : std_logic;
   	
   	signal   DeadTimerGO : std_logic;
		signal   DeadTimerEn : std_logic;
	
	begin
		busyTRIG  <= syncTRIG OR busyCAL OR disableTRIG; --allows trigs to be stacked-up
		
		Uptb1: pulse_trap port map ( sin=> syncCAL, en=> '1', clr=> clrCAL, sout=> busyCAL, rst=> rst, clk=> clk ); 	
		Uptb2: pulse_trap port map ( sin=> syncBCR, en=> '1', clr=> clrBCR, sout=> busyBCR, rst=> rst, clk=> clk ); 	
		Uptb3: pulse_trap port map ( sin=> syncECR, en=> '1', clr=> clrECR, sout=> busyECR, rst=> rst, clk=> clk ); 	
		Uptb4: pulse_trap port map ( sin=> syncFER, en=> '1', clr=> clrFER, sout=> busyFER, rst=> rst, clk=> clk ); 	
		Uptb5: pulse_trap port map ( sin=> syncSPR, en=> '1', clr=> clrSPR, sout=> busySPR, rst=> rst, clk=> clk ); 	
		
		Uptb6: pulse_trap port map ( sin=> syncDTRIG, en=> '1', clr=> clrDTRIG, sout=> xbusyDTRIG, rst=> rst, clk=> clk ); 	
		busyDTRIG <= xbusyDTRIG or TestBusy;		
		
		busyRTRIG <= busyDTRIG AND ((not busyCAL) OR busyCALP); -- busy Real TRIG ie. not CAL_TRIG
		
        --Uptb7: pulse_trap port map ( sin=> syncCALP, en=> '1', clr=> clrCALP, sout=> busyCALP, rst=> rst, clk=> clk ); 	
		
		
		
		busyANY <= busyDTRIG or busyCAL or busyBCR or busyECR or busyFER or busySPR or disableTRIG;

		disableTRIG <= Burst_Ready or (Reg0A AND vmeWR);  		
		
		OA_busy <=   asyncTRIG or asyncCAL or asyncBCR or asyncECR or asyncFER or asyncSPR
                or busyANY   or busyDTRIG or disableTRIG or rst;
	

		-- Dead Timer
		---------------------------


      DeadTimerGO <= syncDTRIG or syncCALP or syncBCR or syncECR or syncFER or syncSPR;

      doneANY <= doneDTRIG or doneCALP or doneBCR or doneECR or doneFER or doneSPR or disableTRIG or rst;


		process (rst, clk)
			subtype int5 is integer range 0 to 32;
			variable DeadTimer : int5; 		
		begin
			if (rst = '1') then
				DeadTimer := 0;
            DeadTimerEn <= '0';
            dt3  <= '0';
            dt7  <= '0';
            dt27 <= '0';
            				
			elsif rising_edge(clk) then
				if (doneANY = '1') then
					DeadTimer := 0;
					DeadTimerEn <= '0';
					
				elsif (DeadTimerGo = '1') or (DeadTimerEn = '1') then
					DeadTimerEn <= '1';
					DeadTimer := DeadTimer + 1;
					
				else
					DeadTimerEn <= '0';
					DeadTimer := 0;
					
				end if;
			
			
				if (DeadTimer =  3) then dt3  <= '1'; else dt3  <= '0'; end if;
				if (DeadTimer =  7) then dt7  <= '1'; else dt7  <= '0'; end if;
				if (DeadTimer = 27) then dt27 <= '1'; else dt27 <= '0'; end if;		

			end if;
			
      end process;

    		
      


		-- Control Signals
		-----------------------------------------------

      doneDTRIG <= (dt3  and busyDTRIG);
      doneCALP  <= (dt27 and busyCALP);
      doneCAL   <= (dt27 and busyCAL); -- *** should be dealt with by CAL machine
      doneBCR   <= (dt7  and busyBCR);
      doneECR   <= (dt7  and busyECR);
      doneFER   <= (dt7  and busyFER);
      doneSPR   <= (dt7  and busySPR);


      clrBCR   <= doneBCR                                                            or disableTRIG or rst;
      clrFER   <= doneFER   or busyBCR                                               or disableTRIG or rst;
      clrECR   <= doneECR   or busyBCR or busyFER                                    or disableTRIG or rst;
      clrDTRIG <= doneDTRIG or busyBCR or busyFER or busyECR                         or disableTRIG or rst;
      clrCAL   <= doneCAL   or busyBCR or busyFER or busyECR or busyRTRIG            or disableTRIG or rst;
      clrCALP  <= doneCALP  or clrCAL;
      clrSPR	<= doneSPR   or busyBCR or busyFER or busyECR or busyDTRIG or busyCAL or disableTRIG or rst;
		
		-- *** for PAR only        
		DebugBus(0) <= doneDTRIG;   
		DebugBus(1) <= doneCALP;   
		DebugBus(2) <= doneCAL;    
		DebugBus(3) <= doneBCR;    
		DebugBus(4) <= doneECR;    
		DebugBus(5) <= doneFER;    
		DebugBus(6) <= doneSPR;    
		DebugBus(7) <= v_OAreset;
		
		DebugBus( 8) <= '0';
		DebugBus( 9) <= busyDTRIG;   
		DebugBus(10) <= busyCALP;   
		DebugBus(11) <= busyCAL;    
		DebugBus(12) <= busyBCR;    
		DebugBus(13) <= busyECR;    
		DebugBus(14) <= busyFER;    
		DebugBus(15) <= busySPR;    
		
		busyCALP <= '1';
		syncCALP <= '1';
		
	
	end block;
   
		
   
      
      
      
	---------------------------------------------------------------------------
	-- CAL generation                                                                 
	---------------------------------------------------------------------------
 	
 	busyCALTRIG <= '0';
  
 
    
      
   ------------------------------------------------------------------
	-- Trigger Pipeline delay
   ------------------------------------------------------------------
   shift144: block
      
      signal shift_a    : std_logic_vector(127 downto 0);
      signal shift_b    : std_logic_vector( 15 downto 0);
      
      signal sel_a      : std_logic_vector(3 downto 0);
      signal sel_b      : std_logic_vector(3 downto 0);
      
      signal out_a      : std_logic;
      signal out_b      : std_logic;
                                    
      signal shift_in   : std_logic;                                    
      signal shift_clr  : std_logic;

   begin 

      shift_clr <= syncCAL or disableTRIG;
      
      sel_a <= RegDelays(7 downto 4);
      sel_b <= RegDelays(3 downto 0);

      process (rst, clk)
      begin
         if (rst = '1') then
            shift_a  <= (others => '0');
            shift_b  <= (others => '0');
            
            shift_in <= '0';
            
            out_b <= '0';
            
         
         elsif rising_edge(clk) then
         
            if (shift_clr = '1') then
               shift_a  <= (others => '0');
               shift_b  <= (others => '0');
               shift_in <= '0';
               
            else
            
               shift_in <= syncTRIG; -- 1 extra clock delay
               
               shift_a(0)            <= shift_in;
               shift_a(127 downto 1) <= shift_a(126 downto 0);
   
               
               case sel_a is
                  when "0000" => shift_b(0) <= shift_in;
                  when "0001" => shift_b(0) <= shift_a(15);
                  when "0010" => shift_b(0) <= shift_a(31);
                  when "0011" => shift_b(0) <= shift_a(47);
                  when "0100" => shift_b(0) <= shift_a(63);
                  when "0101" => shift_b(0) <= shift_a(79);
                  when "0110" => shift_b(0) <= shift_a(95);
                  when "0111" => shift_b(0) <= shift_a(111);
                  when "1000" => shift_b(0) <= shift_a(127);
                  when "1001" => shift_b(0) <= shift_a(127);
                  when "1010" => shift_b(0) <= shift_a(127);
                  when "1011" => shift_b(0) <= shift_a(127);
                  when "1100" => shift_b(0) <= shift_a(127);
                  when "1101" => shift_b(0) <= shift_a(127);
                  when "1110" => shift_b(0) <= shift_a(127);
                  when "1111" => shift_b(0) <= shift_a(127);
                  
                  when others => out_a <= '0';
               end case;
               
               
               shift_b(15 downto 1) <= shift_b(14 downto 0);
   
               case sel_b is
                  when "0000" => out_b <= shift_b(0); 
                  when "0001" => out_b <= shift_b(1); 
                  when "0010" => out_b <= shift_b(2); 
                  when "0011" => out_b <= shift_b(3); 
                  when "0100" => out_b <= shift_b(4); 
                  when "0101" => out_b <= shift_b(5); 
                  when "0110" => out_b <= shift_b(6); 
                  when "0111" => out_b <= shift_b(7); 
                  when "1000" => out_b <= shift_b(8); 
                  when "1001" => out_b <= shift_b(9); 
                  when "1010" => out_b <= shift_b(10);
                  when "1011" => out_b <= shift_b(11);
                  when "1100" => out_b <= shift_b(12);
                  when "1101" => out_b <= shift_b(13);
                  when "1110" => out_b <= shift_b(14);
                  when "1111" => out_b <= shift_b(15);
                  
                  when others => out_a <= '0';
               end case;
         
            end if;
         end if;
      end process;
         
      --EDTRIG_o <= shift_b(0);
      DTRIG    <= out_b;

   end block;


	---------------------------------------------------------------------------
	-- Trigger Window
	---------------------------------------------------------------------------
  
   Window_open <= trw_Win_open_i and Window_en;
   trw_win_en_o <= Window_en;

	-- Programmable delay lines
	trw_delayWS_o <= RegTrigWin( 5 downto 0);
	trw_delayWD_o <= RegTrigWin(13 downto 8);

	trw_StopClk_o <= (Reg08 and vmeWR);


	---------------------------------------------------------------------------
	-- SA BCR Generator
	---------------------------------------------------------------------------

   --synchronous 11.2456kHz pulse generator
      
   BCR_gen: block

      signal bcr_timer_max : std_logic;
   
   begin
  
      process (rst, clk)

         subtype int12 is integer range 0 to 16#FFF#; 
         variable bcr_timer : int12;

      begin
         if (rst = '1') then
            bcr_timer := 0;
            bcr_timer_max <= '0';
            
         elsif rising_edge(clk) then
         
            if bcr_timer = 3564 then  --### set rollover (should be 3564?)
               bcr_timer := 0;
               bcr_timer_max <= '1';
               
            else
               bcr_timer := bcr_timer + 1;
               bcr_timer_max <= '0';
               
            end if;
         end if; 
      end process;
           
      
      int_BCR <= bcr_timer_max and int_BCRen;

   end block;


	
	
	
	---------------------------------------------------------------------------
	-- TIM BUSYs
	---------------------------------------------------------------------------

	-- *** synchronise?
	ext_BUSYin <= ext_BUSYin_ecl_i OR ext_BUSYin_nim_i;
	
	int_BUSY	<= OA_busy;
	
	ext_BUSYout <= 	(int_BUSY and int_BUSYen) 
						or (ext_BUSYin and ext_BUSYinen)
						or (RCBUSY_i and RCBUSYen_i)
						or v_Busy;
						
	

	-- masked version of BusyIn
	ext_BUSYin_masked	<= ext_BUSYin and ext_BUSYinen;
	ext_BUSYin_masked_o <= ext_BUSYin_masked;	
	
	
	---------------------------------------------------------------------------
	-- Test Busy
	---------------------------------------------------------------------------
	process (rst, clk)
	begin
		if (rst = '1') then
			TestBUSY <= '0';
			
		elsif rising_edge(clk) then
		
			if (TestBUSYclr = '1') then
				TestBUSY <= '0';
			
			else
				TestBUSY <= (syncDTRIG or TestBUSY) and TestBUSYen;
				
			end if;
		end if;
	end process;
	        

   ----------------------------------------------------------------------------
  	-- Burst Mode
  	----------------------------------------------------------------------------

   Burst: block

      signal burst_cntr_en : std_logic;
      signal burst_done    : std_logic;
      signal burst_cntr    : std_logic_vector(15 downto 0);
   
   begin
  
      process (rst, clk)
         --subtype int16 is integer range 0 to 16#FFFF#; 
         --variable burst_cntr : int16;
      begin
         if (rst = '1') then
            burst_cntr <= "0000000000000000";
            burst_done <= '0'; 
            burst_cntr_en <= '0';
                        
         elsif rising_edge(clk) then
         
            if (burst_cntr_en = '1') then
               burst_cntr <= burst_cntr - '1';
               
            else
               burst_cntr <= RegBurstCnt;

            end if;

         
            if (v_burstmode = '1') then
               
               if (v_BurstGo = '0') then
                  burst_cntr_en <= '0';
                  burst_done <= '0';               
            
               elsif (v_BurstGo = '1') and (burst_done = '0') then
                  burst_cntr_en <= '1';
                  burst_done <= '0';
               
               elsif (burst_cntr = "0000000000000000") then
                  burst_cntr_en <= '0';
                  burst_done <= '1';

               end if;
            
            else
               burst_cntr_en <= '0';
               burst_done <= '0';

            end if;
               
         end if; 
      end process;
       
      BurstBusy <= burst_cntr_en;
      Burst_Ready <= BurstBusy or (v_BurstMode);
           
      
   end block;


  	----------------------------------------------------------------------------
  	-- Clock Control
  	----------------------------------------------------------------------------
  
   cc_delayCT_o <= RegDelays(13 downto 8);

   cc_enSAClk_o 	<= not setTTCClk_i;
   cc_enIntClk_o	<= not ext_clken;

   -- this is way too simplified -- just for pin count now
   TIM_OK <= cc_SACLKOn_i or cc_TTCClkOn_i or cc_ExtClkOn_i;

   bp_TIM_OK_out_o <= TIM_OK;

	---------------------------------------------------------------------------
	-- Status Register
	--------------------------

	RegStatus(15) <= bp_laser_intlck_state_i;
	RegStatus(14) <= TestBUSY;
	RegStatus(13) <= TIM_OK;
	RegStatus(12) <= '0'; -- *** extclkon?
	RegStatus(11) <= SAMode;
	RegStatus(10) <= RunMode;
	RegStatus( 9) <= cc_SAClkOn_i;
	RegStatus( 8) <= cc_TTCClkOn_i;
	RegStatus( 7) <= RCBUSY_i;
	RegStatus( 6) <= SinkBusy_i;
	RegStatus( 5) <= SeqBusy_i;
	RegStatus( 4) <= BurstBusy;
	RegStatus( 3) <= ext_BUSYout;
	RegStatus( 2) <= int_BUSY;
	RegStatus( 1) <= ext_BUSYin_masked;
	RegStatus( 0) <= ext_BUSYin;

  	---------------------------------------------------------------------------
	-- Enables Register
	--------------------------
     
	int_TRIGen     <= RegEnables( 1);
   int_ECRen  		<= RegEnables( 2);
   int_BCRen  		<= RegEnables( 3);
   int_RanTRIGen  <= RegEnables( 4);
   int_FERen      <= RegEnables( 5);
  	Window_en 		<= RegEnables( 6);	 
  	int_BUSYen	   <= RegEnables( 7);
 	ext_CLKen  		<= RegEnables( 8);
   ext_TRIGen 		<= RegEnables( 9) and (Window_open or (not Window_en));
   ext_ECRen  		<= RegEnables(10);                  
   ext_BCRen  		<= RegEnables(11);                  
   ext_CALen  		<= RegEnables(12);                  
   ext_FERen  		<= RegEnables(13);                  
   ext_SPRen 		<= RegEnables(14);                  
 	ext_BUSYinen	<= RegEnables(15);


  	---------------------------------------------------------------------------
	-- Commands Register
	--------------------------

   --reserved    <= RegCommands( 0);
   v_TRIG  		  <= RegCommands( 1);
   v_ECR 		  <= RegCommands( 2);
   v_BCR 		  <= RegCommands( 3);
   v_CAL 		  <= RegCommands( 4);
   v_FER			  <= RegCommands( 5);
   v_SPR 		  <= RegCommands( 6);    
	v_BUSY   	  <= RegCommands( 7);
	v_RCBUSY_o 	  <= RegCommands( 8);
   v_BurstMode	  <= RegCommands( 9);
   v_BurstGo  	  <= RegCommands(10);
   --reserved    <= RegCommands(11);
	RunMode 		  <= RegCommands(12);
   TestBUSYen    <= RegCommands(13);
   TestBUSYclr   <= RegCommands(14);
   v_OAReset     <= RegCommands(15);
                   
	
 
  	----------------------------------------------------------------------------
  	-- Data Bus
  	----------------------------------------------------------------------------

  	process (rst, clk)
  	begin

    	if (rst = '1') then
      	RegEnables 	<= "0000000000000000";
      	RegCommands <= "0000000000000000";
			RegBurstCnt	<= "0000000000000000";
      	RegFreq		<= "0000000000000000";      	
      	RegTrigWin	<= "0000000000000000";
      	RegDelays 	<= "0000000000000000";

    	elsif rising_edge(clk) then
    	
    		-- Writes
    		---------
      	if 	(Reg00 and vmeWR) = '1' then RegEnables  <= db;
     		elsif (Reg02 and vmeWR) = '1' then RegCommands <= db;
        	elsif (Reg04 and vmeWR) = '1' then RegBurstCnt <= db;
       	elsif (Reg06 and vmeWR) = '1' then RegFreq	  <= db;
       	elsif (Reg08 and vmeWR) = '1' then RegTrigWin  <= db;
        	elsif (Reg0A and vmeWR) = '1' then RegDelays   <= db; 
        	end if;

    	end if;
  	end process;


	-- Read Data
	------------
	
	db <= RegEnables  when ((Reg00 and vmeRD) = '1') else
			RegCommands when ((Reg02 and vmeRD) = '1') else
			RegBurstCnt when ((Reg04 and vmeRD) = '1') else
			RegFreq     when ((Reg06 and vmeRD) = '1') else
			RegTrigWin  when ((Reg08 and vmeRD) = '1') else
			RegDelays   when ((Reg0A and vmeRD) = '1') else
			RegStatus   when ((Reg0C and vmeRD) = '1') else (others => 'Z');

	-----------------------------------------------------
	-- Debug Bus
  	----------------------------------------------------

	--DebugBus <= "0000000000000000";
		
	--DebugBus(15 downto 8) <= "00000000";
	

  
end tim;
