-- hds header_start
--
-- VHDL Architecture TIM_fpga2.seq_control.rtl2
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:52:13 02/03/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity seq_control is
   port( 
      rst       	: in     std_logic;
      clk         : in     std_logic;
      db          : inout  std_logic_vector (15 downto 0);
      vmeWR       : in     std_logic;
      vmeRD       : in     std_logic;
      Reg1A       : in     std_logic;
      Reg1C       : in     std_logic;
      RAMselect   : in     std_logic;
      ab_i        : in     std_logic_vector (15 downto 0);
      AllL1A_i    : in     std_logic;
      AllBCR_i    : in     std_logic;
      AllECR_i    : in     std_logic;
      AllCAL_i    : in     std_logic;
      AllFER_i    : in     std_logic;
      AllSPR_i    : in     std_logic;
      AllEVS_i    : in     std_logic;
      AllTTS_i    : in     std_logic;
      StartSeq_i  : in     std_logic;
      StartSink_i : in     std_logic;
      SeqBusy_o   : out    std_logic;
      SinkBusy_o  : out    std_logic;
      SeqTRIG_o   : out    std_logic;
      SeqBCR_o    : out    std_logic;
      SeqECR_o    : out    std_logic;
      SeqCAL_o    : out    std_logic;
      SeqFER_o    : out    std_logic;
      SeqSPR_o    : out    std_logic;
      SeqEVS_o    : out    std_logic;
      SeqTTS_o    : out    std_logic;
      
		SeqRAM_data_o     : out std_logic_vector( 7 downto 0);
		SeqRAM_data_i     : in  std_logic_vector( 7 downto 0);
		SeqRAM_addr_o   	: out std_logic_vector(13 downto 0);
		SeqRAM_wr_o     	: out std_logic;                    
		SeqRAM_en_o     	: out std_logic;                    
		                                              
		SinkRAM_data_o    : out std_logic_vector( 7 downto 0);
		SinkRAM_data_i    : in  std_logic_vector( 7 downto 0);
		SinkRAM_addr_o  	: out std_logic_vector(13 downto 0);
		SinkRAM_wr_o    	: out std_logic;                    
		SinkRAM_en_o		: out std_logic;                    
    
      
      -- Spare Signals
      DebugBus    : out    std_logic_vector (15 downto 0)
   );

-- Declarations

end seq_control ;

-- hds interface_end
architecture rtl2 of seq_control is


   -- Registers
   ------------
   signal RegEnSeqSink  : std_logic_vector(15 downto 0);
   signal RegSeqEnd     : std_logic_vector(15 downto 0);

   signal enSeqTRIG     : std_logic;   --RegEnSeqSink(0);
   signal enSeqBCR      : std_logic;   --RegEnSeqSink(2);
   signal enSeqECR      : std_logic;   --RegEnSeqSink(1);
   signal enSeqCAL      : std_logic;   --RegEnSeqSink(3);
   signal enSeqFER      : std_logic;   --RegEnSeqSink(6);
   signal enSeqSPR      : std_logic;   --RegEnSeqSink(7);
   signal enSeqEVS      : std_logic;   --RegEnSeqSink(4);
   signal enSeqTTS      : std_logic;   --RegEnSeqSink(5);


--   -- RAM BLOCK
--   -------------------
--   component cg_ram_16kx8
--      port (
--			addr	: in  std_logic_vector(13 downto 0);
--			clk	: in  std_logic;
--			din	: in  std_logic_vector(7 downto 0);
--			dout	: out std_logic_vector(7 downto 0);
--			en		: in  std_logic;
--			sinit	: in  std_logic;
--			we		: in  std_logic
--  		);
--   end component;

--   signal SeqRAM_rst    : std_logic;
--   signal SeqRAM_clk    : std_logic;
--   signal SeqRAM_do     : std_logic_vector( 7 downto 0);
--   signal SeqRAM_di     : std_logic_vector( 7 downto 0);
--   signal SeqRAM_addr   : std_logic_vector(13 downto 0);
--   signal SeqRAM_wr     : std_logic;
--   signal SeqRAM_en     : std_logic;
--
--   signal SinkRAM_rst   : std_logic;
--   signal SinkRAM_clk   : std_logic;
--   signal SinkRAM_do    : std_logic_vector( 7 downto 0);
--   signal SinkRAM_di    : std_logic_vector( 7 downto 0);
--   signal SinkRAM_addr  : std_logic_vector(13 downto 0);
--   signal SinkRAM_wr    : std_logic;
--   signal SinkRAM_en    : std_logic;


   -- sequencer Operation


   signal SeqReset      : std_logic;   -- RegEnSeqSink( 9);
   signal SeqGo         : std_logic;   -- RegEnSeqSink(10);
   signal SeqCyclicEn   : std_logic;   -- RegEnSeqSink(11);


   signal SeqCount      : std_logic_vector(13 downto 0);
   signal SeqCountEn    : std_logic;
   signal SeqCountMax   : std_logic;
   signal SeqGo2        : std_logic;


   -------------------------------------------

   signal SinkReset     : std_logic;   -- RegEnSeqSink(13);
   signal SinkGo        : std_logic;   -- RegEnSeqSink(14);
   signal SinkStartEn   : std_logic;   -- RegEnSeqSink(15);

   signal SinkCount     : std_logic_vector(13 downto 0);
   signal SinkCountEn   : std_logic;
   signal SinkCountMax  : std_logic;
   signal SinkGo2       : std_logic;

   -------------------------------------------



-------------------------------------------------------------------------------
-- MAIN CODE
-------------------------------------------------------------------------------
begin



--   --------------------------------------------------
--   USeqRAM : cg_ram_16kx8
--      port map (
--         addr   	=> SeqRAM_addr,
--         clk      => SeqRAM_clk,
--         din   	=> SeqRAM_di,
--         dout		=> SeqRAM_do,
--         en 		=> SeqRAM_en,
--         sinit    => SeqRAM_rst,
--         we  		=> SeqRAM_wr
--      );

--   SeqRAM_clk_o  	<= clk;
--   SeqRAM_rst_o 	<= rst;

   SeqRAM_addr_o 	<= ab_i(14 downto 1) when (RAMselect = '1') else SinkCount;
   SeqRAM_data_o 	<= db( 7 downto 0);

   SeqRAM_wr_o 	<= RAMselect and vmeWR;
   SeqRAM_en_o 	<= RAMselect or SeqCountEn;

   --------------------------------------------------------

   SeqReset    <= RegEnSeqSink( 9);
   SeqGo      	<= RegEnSeqSink(10);
   SeqCyclicEn	<= RegEnSeqSink(11);

   SeqGo2 		<= SeqGo or StartSeq_i or SinkGo;


   SeqCounter: process (rst, clk) --SeqGo, SeqReset, RegSeqEnd)
   begin
		if (rst = '1') then
			SeqCount    <= "00000000000000";
			SeqCountEn  <= '0';
			SeqCountMax <= '0';


		elsif rising_edge(clk) then	-- rising clock edge

	      -- SeqCounter -----------------------------------------------
		   if SeqCountEn = '1' then
			   SeqCount <= SeqCount + '1';

         end if;

         -- SeqCountMax ----------------------------------------------
		   if SeqCount = "11111111111111" then
			   SeqCountMax <= '1';

			else
            SeqCountMax <= '0';

         end if;

         --SeqCountMax <= '1' when count = 16#3FFF# else '0';


         -- SeqCountEn assignment ------------------------------------
         if (SeqReset = '1') then
            SeqCountEn  <= '0';

         elsif (SeqCount = RegSeqEnd(13 downto 0) ) then
            SeqCountEn  <= '0';

         elsif (SeqCountMax and not SeqCyclicEn) = '1' then
            SeqCountEn  <= '0';

         elsif (SeqGo2 = '1') then
            SeqCountEn  <= '1';

         --*** is this needed?
         --else
            --SeqCountEn <= SeqCountEn;

		   end if;
		   --------------------------------------------------------------

		end if;

	end process SeqCounter;

	-- Clock out Seq Signals
	-------------------------
	process (rst, clk)
	begin

		if (rst = '1') then
			SeqTRIG_o	<= '0';
			SeqBCR_o		<= '0';
			SeqECR_o 	<= '0';
			SeqCAL_o 	<= '0';
			SeqFER_o 	<= '0';
			SeqSPR_o 	<= '0';
			SeqEVS_o 	<= '0';
			SeqTTS_o 	<= '0';

		elsif rising_edge(clk) then
			SeqTRIG_o	<= SeqRAM_data_i(0) and enSeqTRIG and SeqCountEn;
			SeqBCR_o		<= SeqRAM_data_i(2) and enSeqBCR  and SeqCountEn;
			SeqECR_o 	<= SeqRAM_data_i(1) and enSeqECR  and SeqCountEn;
			SeqCAL_o 	<= SeqRAM_data_i(3) and enSeqCAL  and SeqCountEn;
			SeqFER_o 	<= SeqRAM_data_i(6) and enSeqFER  and SeqCountEn;
			SeqSPR_o 	<= SeqRAM_data_i(7) and enSeqSPR  and SeqCountEn;
			SeqEVS_o 	<= SeqRAM_data_i(4) and enSeqEVS  and SeqCountEn;
			SeqTTS_o 	<= SeqRAM_data_i(5) and enSeqTTS  and SeqCountEn;

		end if;

	end process;

	SeqBusy_o <= SeqCountEn;



   -------------------------------------------------
--   USinkRAM : cg_ram_16kx8
--      port map (
--         addr   	=> SinkRAM_addr,
--         clk      => SinkRAM_clk,
--         din   	=> SinkRAM_di,
--         dout		=> SinkRAM_do,
--         en 		=> SinkRAM_en,
--         sinit    => SinkRAM_rst,
--         we  		=> SinkRAM_wr
--      );

--   SinkRAM_clk    <= clk;
--   SinkRAM_rst    <= rst;

   SinkRAM_addr_o   <= ab_i(14 downto 1) when (RAMselect = '1') else SinkCount;
   SinkRAM_wr_o     <= vmeWR;
   SinkRAM_en_o     <= RAMselect or SeqCountEn;

   process (rst, clk)
   begin
   	if (rst = '1') then
   		SinkRAM_data_o <= "00000000";

   	elsif rising_edge(clk) then

   		if (RAMselect and vmeWR) = '1' then
   			SinkRAM_data_o <= db(15 downto 8);

   		else
   			SinkRAM_data_o(0) <= AllL1A_i;
   	   	SinkRAM_data_o(2) <= AllBCR_i;
   	   	SinkRAM_data_o(1) <= AllECR_i;
   			SinkRAM_data_o(3) <= AllCAL_i;
   			SinkRAM_data_o(6) <= AllFER_i;
   			SinkRAM_data_o(7) <= AllSPR_i;
   			SinkRAM_data_o(4) <= AllEVS_i;
   			SinkRAM_data_o(5) <= AllTTS_i;

   		end if;
   	end if;
   end process;

	----------------------------------------------------------


   SinkReset      <= RegEnSeqSink(13);
   SinkGo         <= RegEnSeqSink(14);
   SinkStartEn    <= RegEnSeqSink(15);

   SinkGo2        <= SinkGo or (StartSink_i and SinkStartEn);



   -------------------------------------------------------------------------
   SinkCounter: process (rst, clk)
   begin
   	if (rst = '1') then
   		SinkCountEn  <= '0';
   		SinkCountMax <= '0';
   		SinkCount 	 <= "00000000000000";


   	elsif rising_edge(clk) then	-- rising clock edge

         -- SinkCounter ----------------------------------------------------
   	   if SinkCountEn = '1' then
   		   SinkCount <= SinkCount + '1';

         end if;

         -- SinkCountMax ---------------------------------------------------
   	   if SinkCount = "11111111111111" then
   		   SinkCountMax <= '1';

   		else
            SinkCountMax <= '0';

         end if;

         --SinkCountMax <= '1' when count = 16#3FFF# else '0';


         -- SinkCountEn assignment -----------------------------------------
         if (SinkReset = '1') then
            SinkCountEn  <= '0';

         elsif (SinkCount = RegSeqEnd(13 downto 0) ) then
            SinkCountEn  <= '0';

         elsif (SinkCountMax and not SeqCyclicEn) = '1' then
            SinkCountEn  <= '0';

         elsif (SinkGo2 = '1') then
            SinkCountEn  <= '1';

         else
            SinkCountEn <= SinkCountEn;

   	   end if;
   	   -------------------------------------------------------------------

   	end if;

   end process SinkCounter;

	SinkBusy_o <= SinkCountEn;


   ------------------------------------------------

   enSeqTRIG	<= RegEnSeqSink(0);
   enSeqBCR 	<= RegEnSeqSink(2);
   enSeqECR		<= RegEnSeqSink(1);
   enSeqCAL		<= RegEnSeqSink(3);
   enSeqFER		<= RegEnSeqSink(6);
   enSeqSPR		<= RegEnSeqSink(7);
   enSeqEVS		<= RegEnSeqSink(4);
   enSeqTTS		<= RegEnSeqSink(5);

   -------------------------------------------------




   ----------------------------------------------------
   -- Registers
   ----------------------------------------------------


   -- RegEnSeqSink - Reg1A
   ----------------------------------------------------
   process (rst, clk)
   begin  -- process Register1E

      if (rst = '1') then                 -- async reset
         RegEnSeqSink <= "0000000000000000";

      elsif rising_edge(clk) then

         if (Reg1A and vmeWR) = '1' then
            RegEnSeqSink <= db;
         end if;

      end if;
   end process;



   -- RegSeqEnd - Reg1C
   ----------------------------------------------------
   process (rst, clk)
   begin  -- process Register1E

      if (rst = '1') then                 -- async reset
         RegSeqEnd <= "0000000000000000";

      elsif rising_edge(clk) then

         if (Reg1C and vmeWR) = '1' then
            RegSeqEnd <= db;
         end if;

      end if;
   end process;




  	-- Data Bus
  	----------------------------------------------------
	bd_read : block 
		signal	RAM_do : std_logic_vector(15 downto 0);
		
	begin
	
   	RAM_do(15 downto 8) <= SeqRAM_data_i ;
   	RAM_do( 7 downto 0) <= SinkRAM_data_i;
   
   	db <= RAM_do  			when ((vmeRD and RAMselect) = '1') else
				RegEnSeqSink 	when ((vmeRD and Reg1A)     = '1') else
   			RegSeqEnd    	when ((vmeRD and Reg1C)     = '1') else (others => 'Z');
   			
   end block;


  	-- Debug Bus
  	----------------------------------------------------
	DebugBus <= "0000000000000000";


end rtl2;
