-- hds header_start
--
-- VHDL Entity TIM_fpga2.sequencer.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 18:21:45 05/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

ENTITY sequencer IS
   PORT( 
      clk                  : IN     std_logic;
      --RunMode        : in    std_logic;
      db                   : INOUT  std_logic_vector (15 DOWNTO 0);
      db_wr                : IN     std_logic;                       -- was bWriteb
      db_rd                : IN     std_logic;                       -- was bReadb
      --vmeCLK         : in    std_logic;   -- was LEb2
      reg_sequencer_i      : IN     std_logic_vector (15 DOWNTO 0);
      reg_seq_end_i        : IN     std_logic_vector (15 DOWNTO 0);
      ram_select_i         : IN     std_logic;
      ab_i                 : IN     std_logic_vector (15 DOWNTO 0);
      AllL1A_i             : IN     std_logic;
      AllBCR_i             : IN     std_logic;
      AllECR_i             : IN     std_logic;
      AllCAL_i             : IN     std_logic;
      AllFER_i             : IN     std_logic;
      AllSPR_i             : IN     std_logic;
      AllEXS_i             : IN     std_logic;
      AllTTS_i             : IN     std_logic;
      StartSeq_i           : IN     std_logic;
      StartSink_i          : IN     std_logic;
      SeqBusy_o            : OUT    std_logic;
      SinkBusy_o           : OUT    std_logic;
      SeqTRIG_o            : OUT    std_logic;
      SeqBCR_o             : OUT    std_logic;
      SeqECR_o             : OUT    std_logic;
      SeqCAL_o             : OUT    std_logic;
      SeqFER_o             : OUT    std_logic;
      SeqSPR_o             : OUT    std_logic;
      SeqEXS_o             : OUT    std_logic;
      SeqTTS_o             : OUT    std_logic;
      ren_seq_sink_count_i : IN     std_logic;
      ren_seq_src_count_i  : IN     std_logic;
      rst                  : IN     std_logic;
      ttcl1a_i             : IN     std_logic;
      busy_bst_i           : IN     std_logic;
      trigseq_mode_en_i    : IN     std_logic
   );

-- Declarations

END sequencer ;

-- hds interface_end
--
-- VHDL Architecture TIM_fpga2.sequencer.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 18:21:46 05/10/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

LIBRARY TIM_fpga2;
LIBRARY TIM_lib;

ARCHITECTURE struct OF sequencer IS

   -- Architecture declarations

   -- Internal signal declarations
   SIGNAL SrcRAM_addr  : std_logic_vector(13 DOWNTO 0);
   SIGNAL SrcRAM_dout  : std_logic_vector(7 DOWNTO 0);
   SIGNAL SrcRAM_din   : std_logic_vector(7 DOWNTO 0);
   SIGNAL SrcRAM_en    : std_logic;
   SIGNAL SrcRAM_wr    : std_logic;
   SIGNAL SinkRAM_addr : std_logic_vector(13 DOWNTO 0);
   SIGNAL SinkRAM_dout : std_logic_vector(7 DOWNTO 0);
   SIGNAL SinkRAM_din  : std_logic_vector(7 DOWNTO 0);
   SIGNAL SinkRAM_en   : std_logic;
   SIGNAL SinkRAM_we   : std_logic;


   -- Component Declarations
   COMPONENT cg_ram_16kx8
   PORT (
      addr  : IN     std_logic_VECTOR (13 DOWNTO 0);
      clk   : IN     std_logic ;
      din   : IN     std_logic_VECTOR (7 DOWNTO 0);
      dout  : OUT    std_logic_VECTOR (7 DOWNTO 0);
      en    : IN     std_logic ;
      sinit : IN     std_logic ;
      we    : IN     std_logic 
   );
   END COMPONENT;
   COMPONENT seq_control
   PORT (
      rst                  : IN     std_logic ;
      clk                  : IN     std_logic ;
      db                   : INOUT  std_logic_vector (15 DOWNTO 0);
      db_wr                : IN     std_logic ;
      db_rd                : IN     std_logic ;
      reg_sequencer_i      : IN     std_logic_vector (15 DOWNTO 0);
      reg_seq_end_i        : IN     std_logic_vector (15 DOWNTO 0);
      ren_seq_sink_count_i : IN     std_logic ;
      ren_seq_src_count_i  : IN     std_logic ;
      ram_select_i         : IN     std_logic ;
      ab_i                 : IN     std_logic_vector (15 DOWNTO 0);
      AllL1A_i             : IN     std_logic ;
      AllBCR_i             : IN     std_logic ;
      AllECR_i             : IN     std_logic ;
      AllCAL_i             : IN     std_logic ;
      AllFER_i             : IN     std_logic ;
      AllSPR_i             : IN     std_logic ;
      AllEXS_i             : IN     std_logic ;
      AllTTS_i             : IN     std_logic ;
      StartSeq_i           : IN     std_logic ;
      StartSink_i          : IN     std_logic ;
      SeqBusy_o            : OUT    std_logic ;
      SinkBusy_o           : OUT    std_logic ;
      SeqTRIG_o            : OUT    std_logic ;
      SeqBCR_o             : OUT    std_logic ;
      SeqECR_o             : OUT    std_logic ;
      SeqCAL_o             : OUT    std_logic ;
      SeqFER_o             : OUT    std_logic ;
      SeqSPR_o             : OUT    std_logic ;
      SeqEXS_o             : OUT    std_logic ;
      SeqTTS_o             : OUT    std_logic ;
      SrcRAM_data_o        : OUT    std_logic_vector (7 DOWNTO 0);
      SrcRAM_data_i        : IN     std_logic_vector (7 DOWNTO 0);
      SrcRAM_addr_o        : OUT    std_logic_vector (13 DOWNTO 0);
      SrcRAM_wr_o          : OUT    std_logic ;
      SrcRAM_en_o          : OUT    std_logic ;
      SinkRAM_data_o       : OUT    std_logic_vector (7 DOWNTO 0);
      SinkRAM_data_i       : IN     std_logic_vector (7 DOWNTO 0);
      SinkRAM_addr_o       : OUT    std_logic_vector (13 DOWNTO 0);
      SinkRAM_wr_o         : OUT    std_logic ;
      SinkRAM_en_o         : OUT    std_logic ;
      ttcl1a_i             : IN     std_logic ;
      busy_bst_i           : IN     std_logic ;
      trigseq_mode_en_i    : IN     std_logic 
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : cg_ram_16kx8 USE ENTITY TIM_lib.cg_ram_16kx8;
   FOR ALL : seq_control USE ENTITY TIM_fpga2.seq_control;
   -- pragma synthesis_on


BEGIN
   -- Instance port mappings.
   UsrcRAM : cg_ram_16kx8
      PORT MAP (
         addr  => SrcRAM_addr,
         clk   => clk,
         din   => SrcRAM_din,
         dout  => SrcRAM_dout,
         en    => SrcRAM_en,
         sinit => rst,
         we    => SrcRAM_wr
      );
   UsinkRAM : cg_ram_16kx8
      PORT MAP (
         addr  => SinkRAM_addr,
         clk   => clk,
         din   => SinkRAM_din,
         dout  => SinkRAM_dout,
         en    => SinkRAM_en,
         sinit => rst,
         we    => SinkRAM_we
      );
   seq_control_1 : seq_control
      PORT MAP (
         rst                  => rst,
         clk                  => clk,
         db                   => db,
         db_wr                => db_wr,
         db_rd                => db_rd,
         reg_sequencer_i      => reg_sequencer_i,
         reg_seq_end_i        => reg_seq_end_i,
         ren_seq_sink_count_i => ren_seq_sink_count_i,
         ren_seq_src_count_i  => ren_seq_src_count_i,
         ram_select_i         => ram_select_i,
         ab_i                 => ab_i,
         AllL1A_i             => AllL1A_i,
         AllBCR_i             => AllBCR_i,
         AllECR_i             => AllECR_i,
         AllCAL_i             => AllCAL_i,
         AllFER_i             => AllFER_i,
         AllSPR_i             => AllSPR_i,
         AllEXS_i             => AllEXS_i,
         AllTTS_i             => AllTTS_i,
         StartSeq_i           => StartSeq_i,
         StartSink_i          => StartSink_i,
         SeqBusy_o            => SeqBusy_o,
         SinkBusy_o           => SinkBusy_o,
         SeqTRIG_o            => SeqTRIG_o,
         SeqBCR_o             => SeqBCR_o,
         SeqECR_o             => SeqECR_o,
         SeqCAL_o             => SeqCAL_o,
         SeqFER_o             => SeqFER_o,
         SeqSPR_o             => SeqSPR_o,
         SeqEXS_o             => SeqEXS_o,
         SeqTTS_o             => SeqTTS_o,
         SrcRAM_data_o        => SrcRAM_din,
         SrcRAM_data_i        => SrcRAM_dout,
         SrcRAM_addr_o        => SrcRAM_addr,
         SrcRAM_wr_o          => SrcRAM_wr,
         SrcRAM_en_o          => SrcRAM_en,
         SinkRAM_data_o       => SinkRAM_din,
         SinkRAM_data_i       => SinkRAM_dout,
         SinkRAM_addr_o       => SinkRAM_addr,
         SinkRAM_wr_o         => SinkRAM_we,
         SinkRAM_en_o         => SinkRAM_en,
         ttcl1a_i             => ttcl1a_i,
         busy_bst_i           => busy_bst_i,
         trigseq_mode_en_i    => trigseq_mode_en_i
      );

END struct;
