-- hds header_start
--
-- VHDL Entity TIM_fpga2.serialser.symbol
--
-- Created:
--          by - warren.UNKNOWN (POSITRON)
--          at - 17:28:51 12/07/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity serialser is
   port( 
      clk             : in     std_logic;
      --RunMode        : in  std_logic;
      db              : inout  std_logic_vector (15 downto 0);
      db_rd           : in     std_logic;                       -- was bReadb
      db_wr           : in     std_logic;                       -- was bWriteb
      EX_Strobe_i     : in     std_logic;
      EXID_i          : in     std_logic_vector (35 downto 0);
      SerEXS_o        : out    std_logic;
      TT_Strobe_i     : in     std_logic;
      TTID_i          : in     std_logic_vector (9 downto 0);
      SerTTS_o        : out    std_logic;
      rst             : in     std_logic;
      ren_fifostat_i  : in     std_logic;
      ren_tts_count_i : in     std_logic
   );

-- Declarations

end serialser ;

-- hds interface_end
--
-- VHDL Architecture TIM_fpga2.serialser.struct
--
-- Created:
--          by - warren.UNKNOWN (POSITRON)
--          at - 17:28:51 12/07/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library TIM_fpga2;
library TIM_lib;

architecture struct of serialser is

   -- Architecture declarations

   -- Internal signal declarations
   signal exf_depth  : std_logic_vector(5 downto 0);
   signal exf_empty  : std_logic;
   signal exf_full   : std_logic;
   signal exf_rddata : std_logic_vector(35 downto 0);
   signal exf_read   : std_logic;
   signal exf_wrdata : std_logic_vector(35 downto 0);
   signal exf_write  : std_logic;
   signal ttf_depth  : std_logic_vector(5 downto 0);
   signal ttf_empty  : std_logic;
   signal ttf_full   : std_logic;
   signal ttf_rddata : std_logic_vector(9 downto 0);
   signal ttf_read   : std_logic;
   signal ttf_wrdata : std_logic_vector(9 downto 0);
   signal ttf_write  : std_logic;


   -- Component Declarations
   component cg_fifo_64x10
   port (
      clk        : in     std_logic ;
      sinit      : in     std_logic ;
      din        : in     std_logic_VECTOR (9 downto 0);
      wr_en      : in     std_logic ;
      rd_en      : in     std_logic ;
      dout       : out    std_logic_VECTOR (9 downto 0);
      full       : out    std_logic ;
      empty      : out    std_logic ;
      data_count : out    std_logic_VECTOR (5 downto 0)
   );
   end component;
   component cg_fifo_64x36
   port (
      clk        : in     std_logic ;
      sinit      : in     std_logic ;
      din        : in     std_logic_VECTOR (35 downto 0);
      wr_en      : in     std_logic ;
      rd_en      : in     std_logic ;
      dout       : out    std_logic_VECTOR (35 downto 0);
      full       : out    std_logic ;
      empty      : out    std_logic ;
      data_count : out    std_logic_VECTOR (5 downto 0)
   );
   end component;
   component ser_control
   port (
      rst             : in     std_logic ;
      clk             : in     std_logic ;
      db              : inout  std_logic_vector (15 downto 0);
      db_rd           : in     std_logic ;
      db_wr           : in     std_logic ;
      ren_fifostat_i  : in     std_logic ;
      EX_Strobe_i     : in     std_logic ;
      EXID_i          : in     std_logic_vector (35 downto 0);
      SerEXS_o        : out    std_logic ;
      TT_Strobe_i     : in     std_logic ;
      TTID_i          : in     std_logic_vector (9 downto 0);
      SerTTS_o        : out    std_logic ;
      exf_read_o      : out    std_logic ;
      exf_write_o     : out    std_logic ;
      exf_data_o      : out    std_logic_vector (35 downto 0);
      exf_data_i      : in     std_logic_vector (35 downto 0);
      exf_full_i      : in     std_logic ;
      exf_empty_i     : in     std_logic ;
      exf_depth_i     : in     std_logic_vector (5 downto 0);
      ttf_read_o      : out    std_logic ;
      ttf_write_o     : out    std_logic ;
      ttf_data_o      : out    std_logic_vector (9 downto 0);
      ttf_data_i      : in     std_logic_vector (9 downto 0);
      ttf_full_i      : in     std_logic ;
      ttf_empty_i     : in     std_logic ;
      ttf_depth_i     : in     std_logic_vector (5 downto 0);
      ren_tts_count_i : in     std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : cg_fifo_64x10 use entity TIM_lib.cg_fifo_64x10(cg_fifo_64x10_a);
   for all : cg_fifo_64x36 use entity TIM_lib.cg_fifo_64x36(cg_fifo_64x36_a);
   for all : ser_control use entity TIM_fpga2.ser_control(rtl);
   -- exemplar synthesis_on


begin
   -- Instance port mappings.
   Uttfifo : cg_fifo_64x10
      port map (
         clk        => clk,
         sinit      => rst,
         din        => ttf_wrdata,
         wr_en      => ttf_write,
         rd_en      => ttf_read,
         dout       => ttf_rddata,
         full       => ttf_full,
         empty      => ttf_empty,
         data_count => ttf_depth
      );
   Uexfifo : cg_fifo_64x36
      port map (
         clk        => clk,
         sinit      => rst,
         din        => exf_wrdata,
         wr_en      => exf_write,
         rd_en      => exf_read,
         dout       => exf_rddata,
         full       => exf_full,
         empty      => exf_empty,
         data_count => exf_depth
      );
   ser_control_1 : ser_control
      port map (
         rst             => rst,
         clk             => clk,
         db              => db,
         db_rd           => db_rd,
         db_wr           => db_wr,
         ren_fifostat_i  => ren_fifostat_i,
         EX_Strobe_i     => EX_Strobe_i,
         EXID_i          => EXID_i,
         SerEXS_o        => SerEXS_o,
         TT_Strobe_i     => TT_Strobe_i,
         TTID_i          => TTID_i,
         SerTTS_o        => SerTTS_o,
         exf_read_o      => exf_read,
         exf_write_o     => exf_write,
         exf_data_o      => exf_wrdata,
         exf_data_i      => exf_rddata,
         exf_full_i      => exf_full,
         exf_empty_i     => exf_empty,
         exf_depth_i     => exf_depth,
         ttf_read_o      => ttf_read,
         ttf_write_o     => ttf_write,
         ttf_data_o      => ttf_wrdata,
         ttf_data_i      => ttf_rddata,
         ttf_full_i      => ttf_full,
         ttf_empty_i     => ttf_empty,
         ttf_depth_i     => ttf_depth,
         ren_tts_count_i => ren_tts_count_i
      );

end struct;
