-- hds header_start
--
-- VHDL Entity TIM_fpga2.trig_monitor.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 20:19:25 08/15/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity trig_monitor is
   port( 
      clk            : in     std_logic;
      --RunMode        : in  std_logic;
      db             : inout  std_logic_vector (15 downto 0);
      db_rd          : in     std_logic;                       -- was bReadb
      db_wr          : in     std_logic;                       -- was bWriteb
      rst            : in     std_logic;
      ren_tp_fifol_i : in     std_logic;
      ren_tp_fifoh_i : in     std_logic;
      trigger_i      : in     std_logic;
      db_rd0         : in     std_logic;
      fftveto_i      : in     std_logic;
      db_d32         : in     std_logic;
      dbh_io         : inout  std_logic_vector (15 downto 0)
   );

-- Declarations

end trig_monitor ;

-- hds interface_end
--
-- VHDL Architecture TIM_fpga2.trig_monitor.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 20:19:25 08/15/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library TIM_fpga2;
library TIM_lib;

architecture struct of trig_monitor is

   -- Architecture declarations

   -- Internal signal declarations
   signal fh_datai : std_logic_vector(13 downto 0);
   signal fh_datao : std_logic_vector(13 downto 0);
   signal fh_empty : std_logic;
   signal fh_full  : std_logic;
   signal fh_read  : std_logic;
   signal fh_write : std_logic;
   signal fl_datai : std_logic_vector(15 downto 0);
   signal fl_datao : std_logic_vector(15 downto 0);
   signal fl_empty : std_logic;
   signal fl_full  : std_logic;
   signal fl_read  : std_logic;
   signal fl_write : std_logic;
   signal fifo_rst : std_logic;


   -- Component Declarations
   component cg_fifo1kx14
   port (
      clk   : in     std_logic ;
      sinit : in     std_logic ;
      din   : in     std_logic_VECTOR (13 downto 0);
      wr_en : in     std_logic ;
      rd_en : in     std_logic ;
      dout  : out    std_logic_VECTOR (13 downto 0);
      full  : out    std_logic ;
      empty : out    std_logic 
   );
   end component;
   component cg_fifo1kx16
   port (
      clk   : in     std_logic ;
      sinit : in     std_logic ;
      din   : in     std_logic_VECTOR (15 downto 0);
      wr_en : in     std_logic ;
      rd_en : in     std_logic ;
      dout  : out    std_logic_VECTOR (15 downto 0);
      full  : out    std_logic ;
      empty : out    std_logic 
   );
   end component;
   component tmon_control
   port (
      rst            : in     std_logic ;
      clk            : in     std_logic ;
      db             : inout  std_logic_vector (15 downto 0);
      db_rd          : in     std_logic ;
      db_wr          : in     std_logic ;
      dbh_io         : inout  std_logic_vector (15 downto 0);
      db_d32         : in     std_logic ;
      ren_tp_fifol_i : in     std_logic ;
      fl_read_o      : out    std_logic ;
      fl_write_o     : out    std_logic ;
      fl_data_o      : out    std_logic_vector (15 downto 0);
      fl_data_i      : in     std_logic_vector (15 downto 0);
      fl_full_i      : in     std_logic ;
      fl_empty_i     : in     std_logic ;
      fh_read_o      : out    std_logic ;
      fh_write_o     : out    std_logic ;
      fifo_rst_o     : out    std_logic ;
      fh_data_o      : out    std_logic_vector (13 downto 0);
      fh_data_i      : in     std_logic_vector (13 downto 0);
      fh_full_i      : in     std_logic ;
      fh_empty_i     : in     std_logic ;
      ren_tp_fifoh_i : in     std_logic ;
      trigger_i      : in     std_logic ;
      fftveto_i      : in     std_logic ;
      db_rd0         : in     std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : cg_fifo1kx14 use entity TIM_lib.cg_fifo1kx14(cg_fifo1kx14_a);
   for all : cg_fifo1kx16 use entity TIM_lib.cg_fifo1kx16(cg_fifo1kx16_a);
   for all : tmon_control use entity TIM_fpga2.tmon_control(rtl);
   -- exemplar synthesis_on


begin
   -- Instance port mappings.
   to_fifoh : cg_fifo1kx14
      port map (
         clk   => clk,
         sinit => fifo_rst,
         din   => fh_datao,
         wr_en => fh_write,
         rd_en => fh_read,
         dout  => fh_datai,
         full  => fh_full,
         empty => fh_empty
      );
   tp_fifol : cg_fifo1kx16
      port map (
         clk   => clk,
         sinit => fifo_rst,
         din   => fl_datao,
         wr_en => fl_write,
         rd_en => fl_read,
         dout  => fl_datai,
         full  => fl_full,
         empty => fl_empty
      );
   tmon_control_1 : tmon_control
      port map (
         rst            => rst,
         clk            => clk,
         db             => db,
         db_rd          => db_rd,
         db_wr          => db_wr,
         dbh_io         => dbh_io,
         db_d32         => db_d32,
         ren_tp_fifol_i => ren_tp_fifol_i,
         fl_read_o      => fl_read,
         fl_write_o     => fl_write,
         fl_data_o      => fl_datao,
         fl_data_i      => fl_datai,
         fl_full_i      => fl_full,
         fl_empty_i     => fl_empty,
         fh_read_o      => fh_read,
         fh_write_o     => fh_write,
         fifo_rst_o     => fifo_rst,
         fh_data_o      => fh_datao,
         fh_data_i      => fh_datai,
         fh_full_i      => fh_full,
         fh_empty_i     => fh_empty,
         ren_tp_fifoh_i => ren_tp_fifoh_i,
         trigger_i      => trigger_i,
         fftveto_i      => fftveto_i,
         db_rd0         => db_rd0
      );

end struct;
