-- hds header_start
--
-- VHDL Architecture TIM_fpga2.ttcrx.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 15:52:07 04/14/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity ttcrq_sim is
   port( 
      rst        : in     std_logic;
      clk        : in     std_logic;
      L1Accept   : out    std_logic;
      EvCntRes   : out    std_logic;
      BCntRes    : out    std_logic;
      BCnt       : out    std_logic_vector (11 downto 0);
      BCntStr    : out    std_logic;
      EvCntHStr  : out    std_logic;
      EvCntLStr  : out    std_logic;
      DoutStr    : out    std_logic;
      Dout       : out    std_logic_vector (7 downto 0);
      DQ         : out    std_logic_vector (3 downto 0);
      SubAddr    : out    std_logic_vector (7 downto 0);
     
      L1Areq_i : in     std_logic;
      BCRreq_i : in     std_logic;
      ECRreq_i : in     std_logic
   ); 

-- Declarations

end ttcrq_sim ;


-- hds interface_end

architecture rtl of ttcrq_sim is
	signal	L1Areq_q  		: std_logic;
	signal	BCRreq_q  		: std_logic;
	signal	ECRreq_q  		: std_logic;
	signal	L1Areq_rising  : std_logic;
	signal	BCRreq_rising  : std_logic;
	signal	ECRreq_rising  : std_logic;
	signal	L1A    			: std_logic;
   signal	L1Aq   			: std_logic;
	signal	L1Aq2  			: std_logic;
	signal	L1Aq3  			: std_logic;
	
	signal	l1id_counter : std_logic_vector(23 downto 0);
	signal	bcid_counter : std_logic_vector(11 downto 0);
         
	
-------------------------------------------------------------------------------
-- MAIN CODE
-------------------------------------------------------------------------------
begin

	---------------------------------------------------------------------------
  	-- Requests Rising det.
 	---------------------------------------------------------------------------


	process (clk, rst)
	begin
		if (rst ='1') then
		  L1Areq_q <= '0';
		  BCRreq_q <= '0';
		  ECRreq_q <= '0';
		  
		  	L1Areq_rising <= '0';
			BCRreq_rising <= '0';
			ECRreq_rising <= '0';
		
		  
		elsif rising_edge(clk) then
			
			L1Areq_q <= L1Areq_i after 1 ns;
		  	BCRreq_q <= BCRreq_i after 1 ns;
		  	ECRreq_q <= ECRreq_i after 1 ns;
		  	
		  	L1Areq_rising <= (not(L1Areq_q) and L1Areq_i);
			BCRreq_rising <= (not(BCRreq_q) and BCRreq_i);	
			ECRreq_rising <= (not(ECRreq_q) and ECRreq_i);
		
		end if;
	end process;
	
	--L1Areq_rising <= '1' when ((L1Areq_q = '0') and (L1Areq_i='1')) else '0';
	--BCRreq_rising <= '1' when ((BCRreq_q = '0') and (BCRreq_i='1')) else '0';	
	--ECRreq_rising <= '1' when ((ECRreq_q = '0') and (ECRreq_i='1')) else '0';
	
	
	
	
	---------------------------------------------------------------------------
  	-- L1ID/ECR Gen
 	---------------------------------------------------------------------------

	process (clk, rst)
	begin
		if (rst = '1')  then
			l1id_counter <= (others => '0');

		elsif rising_edge(clk) then
			if (ECRreq_rising = '1') then
				l1id_counter <= (others => '0');
			
			elsif (L1Areq_rising = '1') then
				l1id_counter <= l1id_counter + '1';
			
			end if; 
	   end if;
	end process;
	
	EvCntRes <= ECRreq_rising;

	
	---------------------------------------------------------------------------
  	-- BCID/BCR Gen
 	---------------------------------------------------------------------------

	process (clk, rst)
	begin
		if (rst ='1') then
			bcid_counter <= (others => '0');

		elsif rising_edge(clk) then
			if (BCRreq_rising = '1') then
				bcid_counter <= (others => '0');
			else
				bcid_counter <= bcid_counter + '1';
			
			end if;
	   end if;
	end process;
	
	BCntRes <= BCRreq_rising;


	-----------------------------------------------------------------------
  	-- Event ID mux and output
 	---------------------------------------------------------------------------

	process (clk, rst)
	begin

		if (rst ='1') then
		
			L1A   <= '0';
			L1Aq  <= '0';
			L1Aq2 <= '0';
			
      
      elsif rising_edge(clk) then
      
         L1A   <= L1Areq_rising;
         L1Aq  <= L1A;
         L1Aq2 <= L1Aq;
         L1Aq3 <= L1Aq2;
         
         
       	-- defaults
      	L1Accept  <= '0';
      	BCntStr   <= '0';
			EvCntLStr <= '0';
			EvCntHStr <= '0';
			BCnt      <= (others => '0');
			DoutStr   <= '0';
			DQ     	 <= (others => '0'); 
			SubAddr   <= (others => '0'); 
			Dout 	    <= (others => '0'); 
   
        	-- BCID -------------------------------
			if (L1A = '1') then
				L1Accept <= '1';
				BCntStr 	<= '1';
				BCnt   	<= bcid_counter;
		   		   
		   -- L1IDL -------------------------------
			elsif (L1Aq = '1') then
				L1Accept  <= '0';
				EvCntLStr <= '1';
				BCnt  	 <= l1id_counter(11 downto 0);
		   		
			-- L1IDH -------------------------------
			elsif (L1Aq2 = '1') then
				EvCntHStr <= '1';
				BCnt 		 <= l1id_counter(23 downto 12);
		   
			elsif (L1Aq3 = '1') then
					DoutStr <= '1';
					DQ <= (others => '0'); 
					SubAddr <= (others => '0'); 
				   Dout <= "00010010";
		
			end if;
	
			
		end if;
	end process;
	
	


		

end rtl;
