-- hds header_start
--
-- VHDL Architecture TIM_fpga2.ttcrx.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 15:52:07 04/14/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity ttcrx is
   port( 
      rst              : in     std_logic;                       -- was NOT nOA_rst
      clk              : in     std_logic;
      TTCCLK_i         : in     std_logic;
      db               : inout  std_logic_vector (15 downto 0);
      db_rd            : in     std_logic;                       -- was bReadb
      db_wr            : in     std_logic;                       -- was bWriteb
      Reg26            : in     std_logic;
      reg_ttc_select_i : in     std_logic_vector (15 downto 0);
      Reg2C            : in     std_logic;
      Reg2E            : in     std_logic;
      trx_L1Accept_i   : in     std_logic;
      trx_EvCntRes_i   : in     std_logic;
      trx_BCntRes_i    : in     std_logic;
      trx_BCnt_i       : in     std_logic_vector (11 downto 0);
      trx_BCntStr_i    : in     std_logic;
      trx_EvCntHStr_i  : in     std_logic;
      trx_Brcst_i      : in     std_logic_vector (7 downto 2);
      trx_EvCntLStr_i  : in     std_logic;
      trx_BrcstStr1_i  : in     std_logic;
      trx_BrcstStr2_i  : in     std_logic;
      trx_DbErrStr_i   : in     std_logic;
      trx_DoutStr_i    : in     std_logic;
      trx_Dout_i       : in     std_logic_vector (7 downto 0);
      trx_DQ_i         : in     std_logic_vector (3 downto 0);
      trx_SinErrStr_i  : in     std_logic;
      trx_SubAddr_i    : in     std_logic_vector (7 downto 0);
      trx_TTCready_i   : in     std_logic;
      trx_Resetb_o     : out    std_logic;
      trx_SCL_io       : inout  std_logic;
      trx_SDA_io       : inout  std_logic;
      ttc_l1a_fast_o   : out    std_logic;
      ttc_ecr_fast_o   : out    std_logic;
      ttc_bcr_fast_o   : out    std_logic;
      ttc_l1a_o        : out    std_logic;
      ttc_ecr_o        : out    std_logic;
      ttc_bcr_o        : out    std_logic;
      ttc_cal_o        : out    std_logic;
      ttc_fer_o        : out    std_logic;
      ttc_spr_o        : out    std_logic;
      TTCL1ID_o        : out    std_logic_vector (23 downto 0);
      TTCL1ID_strb_o   : out    std_logic;
      TTCBCID_o        : out    std_logic_vector (11 downto 0);
      TTCBCID_strb_o   : out    std_logic;
      TTCTTID_o        : out    std_logic_vector (9 downto 0);
      TTCTTID_strb_o   : out    std_logic;
      ren_tt_count_i   : in     std_logic;
      ttc_ready_o      : out    std_logic
   );

-- Declarations

end ttcrx ;


-- hds interface_end

architecture rtl of ttcrx is

	signal RegTTCdata		: std_logic_vector(15 downto 0);
   signal RegTTCCmd		: std_logic_vector(15 downto 0);

 	signal SinErrStr_q		: std_logic;
 	signal DbErrStr_q		: std_logic;
  	signal DoutStr_q		: std_logic;
  	signal BrcstStr1_q		: std_logic;
 	signal BrcstStr2_q		: std_logic;
 	signal BCntStr_q		: std_logic;
 	signal EvCntLStr_q		: std_logic;
 	signal EvCntHStr_q		: std_logic;
 	signal BCnt_q			: std_logic_vector(11 downto 0);
 	signal Brcst_q			: std_logic_vector( 7 downto 2);
 	signal Dout_q			: std_logic_vector( 7 downto 0);
 	signal SubAddr_q		: std_logic_vector( 7 downto 0);
 	signal DQ_q      		: std_logic_vector( 3 downto 0);
 	signal L1Accept_q		: std_logic;
 	signal BCntRes_q		: std_logic;
 	signal EvCntRes_q		: std_logic;
 	
 	signal TTCTTID_strb  : std_logic;
	signal ttype_count	: std_logic_vector(15 downto 0);
 	

-------------------------------------------------------------------------------
-- MAIN CODE
-------------------------------------------------------------------------------
begin

	-- Send low latency sigs out unclocked
	
	ttc_l1a_fast_o <= trx_L1Accept_i;
	ttc_ecr_fast_o <= trx_EvCntRes_i;
	ttc_bcr_fast_o <= trx_BCntRes_i;


	-- Clock TTCrx sigs in on TTC clock and the sync to TIM clock
	
	process (TTCCLK_i)
	begin
		if falling_edge(TTCCLK_i) then -- edge depends on delays in buffers on board
			if (trx_TTCReady_i = '0') then
				SinErrStr_q	<= '0';
	         DbErrStr_q	<= '0';
	         DoutStr_q	<= '0';
	         BrcstStr1_q	<= '0';
	         BrcstStr2_q	<= '0';
	         BCntStr_q	<= '0';
	         EvCntLStr_q	<= '0';
	         EvCntHStr_q	<= '0';
	         BCnt_q		<= (others => '0');
	         Brcst_q		<= (others => '0');
	         Dout_q		<= (others => '0');
	         SubAddr_q	<= (others => '0');
	         DQ_q      	<= (others => '0');
	         L1Accept_q	<= '0';
	         EvCntRes_q	<= '0';
  	         BCntRes_q	<= '0';
	         
	      else
	         SinErrStr_q <= trx_SinErrStr_i;
	         DbErrStr_q 	<= trx_DbErrStr_i;
	         DoutStr_q  	<= trx_DoutStr_i;
	         BrcstStr1_q	<= trx_BrcstStr1_i;
	         BrcstStr2_q	<= trx_BrcstStr2_i;
	         BCntStr_q  	<= trx_BCntStr_i;
	         EvCntLStr_q	<= trx_EvCntLStr_i;
	         EvCntHStr_q	<= trx_EvCntHStr_i;
				BCnt_q		<= trx_BCnt_i;
				Brcst_q		<= trx_Brcst_i;
				Dout_q		<= trx_Dout_i;
				SubAddr_q	<= trx_SubAddr_i;
				DQ_q			<= trx_DQ_i;
				L1Accept_q	<= trx_L1Accept_i;
	         EvCntRes_q	<= trx_EvCntRes_i;
	         BCntRes_q	<= trx_BCntRes_i;	         
	
	       end if;
	    end if;
    end process;



	---------------------------------------------------------------------------
	-- TTCrx reset pulse generator (~50us)
	---------------------------------------------------------------------------

	process (clk)
      variable resetb_timer : std_logic_vector(10 downto 0);
	begin
		if rising_edge(clk) then
			if (rst = '1') then
				resetb_timer := "00000000000";
				trx_resetb_o <= '1';
			
			else
				if (resetb_timer = "11111111111") then
					resetb_timer := "11111111111";
					trx_resetb_o <= '0';
	
				else
					resetb_timer := resetb_timer + '1';
					trx_resetb_o <= '1';
	
				end if;
			end if;
		end if;
	end process;

	-------------
	-- OUTPUTS
	-------------


	ttc_ready_o <= trx_TTCready_i;


	---------------------------------------------------------------------------
	-- TTC Signals: (Decode and) TIM-Clock Out
	---------------------------------------------------------------------------

	process (clk)
	begin
		if rising_edge(clk) then
			if (rst = '1') then
	
				ttc_l1a_o <= '0';
				ttc_ecr_o <= '0';
				ttc_bcr_o <= '0';
				ttc_cal_o <= '0';
				ttc_fer_o <= '0';
			   ttc_spr_o <= '0';
			
			else
				ttc_l1a_o <= L1Accept_q;
				ttc_ecr_o <= EvCntRes_q;
				ttc_bcr_o <= BCntRes_q;
				ttc_cal_o <= Brcst_q(6) and BrcstStr2_q ;
				ttc_fer_o <= Brcst_q(2) and BrcstStr1_q ;
			   ttc_spr_o <= '0';

			end if;
		end if;
   end process;
   


	---------------------------------------------------------------------------
  	-- Event ID demux and output
 	---------------------------------------------------------------------------

	process (clk)
	begin

		if rising_edge(clk) then
			if (rst ='1') then
				TTCL1ID_o      <= (others => '0');
	         TTCL1ID_strb_o <= '0';
	
	   		TTCBCID_o      <= (others => '0');
	         TTCBCID_strb_o <= '0';
	      
	      else
	      
	      	--*** FPGA version does decoding here, rather than on
	      	--'pld4'
	      	
	      	-- defaults
	      	TTCBCID_strb_o <= '0';
	      	TTCL1ID_strb_o <= '0';
		
				
				-- BCID -------------------------------
				if (BCntStr_q = '1') then
   				TTCBCID_o(11 downto 0) <= BCnt_q;
   				
   				TTCBCID_strb_o 	     <= '1';
   			end if;
				
	
				-- L1ID -------------------------------
				if (EvCntLStr_q = '1') then
	   			TTCL1ID_o(11 downto 0) <= BCnt_q;
				end if;
	
				if (EvCntHStr_q = '1') then
		         TTCL1ID_o(23 downto 12) <= BCnt_q;
		         
		         -- uses H strobe as it comes second ...
	   			TTCL1ID_strb_o <= '1';
	   		end if;


			end if;
		end if;
	end process;





	---------------------------------------------------------------------------
  	-- Trigger Type decode and clock out
 	---------------------------------------------------------------------------

	process (clk)
	begin
		if rising_edge(clk) then
			if (rst ='1') then
				TTCTTID_o <= (others => '0');
				TTCTTID_strb <= '0';
	
			else
				--default
				TTCTTID_strb <= '0';
	
				if (DoutStr_q = '1') then
					if ((DQ_q & SubAddr_q ) = "000000000000") then
						TTCTTID_o 	 <= ("00" & Dout_q);
						TTCTTID_strb <= '1';
						
					end if;
				end if;
			end if;
		end if;
	end process;
	
	TTCTTID_strb_o <= TTCTTID_strb;
	
	
	-- TType Count register - counts number of TType strobes
   -------------------------------------------------------------------------
   process (clk)
   begin

      if rising_edge(clk) then

         if (rst = '1') then
         	ttype_count <= (others => '0');

			else
         	if ((ren_tt_count_i and db_wr )= '1') then
         		ttype_count <= (others => '0');
         		
         	elsif (TTCTTID_strb = '1') then
   				ttype_count <= ttype_count + '1';
   
            end if;
         end if;
      end if;
   end process;
   
	db <= ttype_count when ((ren_tt_count_i and db_rd) = '1') else (others => 'Z');
	


	---------------------------------------------------------------------------
  	-- Register TTC Data and TTC Select -- reg26, reg28
	---------------------------------------------------------------------------
	process (clk)
	begin
		if rising_edge(clk) then
			if (rst ='1') then
				RegTTCdata 	 <= (others => '0');
				
			else
				-- RegTTCData ---------------------------------
				if (Reg26 and db_wr) = '1'  then
					RegTTCdata <= (others => '0');

	      	elsif (DoutStr_q = '1') then
	      		if (DQ_q = reg_ttc_select_i(3 downto 0)) then
						RegTTCdata <= (SubAddr_q & Dout_q);
						
					end if;
		   	end if;
			end if;
		end if;
	end process;
	
	db <= RegTTCdata 	 when ((db_rd and Reg26) = '1') else (others => 'Z');


	---------------------------------------------------------------------------
  	-- Command and Control
  	---------------------------------------------------------------------------

	-- Command Reg
	--------------------------------------
	process (clk)
	begin
		
		if rising_edge(clk) then
			if (rst = '1') then
				RegTTCcmd <= (others => '0');
			
			else
				if (Reg2E and db_wr) = '1' then
					RegTTCcmd <= (others => '0');
	
				else
					RegTTCCmd(15) <= '0';
		   		RegTTCCmd(14) <= trx_TTCReady_i;

		   		-- 'catch' registers:					
			   	RegTTCCmd(13) <= SinErrStr_q or RegTTCCmd(13);
			   	RegTTCCmd(12) <= DbErrStr_q  or RegTTCCmd(12);
			   	RegTTCCmd(11) <= DoutStr_q   or RegTTCCmd(11);
			   	RegTTCCmd(10) <= BrcstStr2_q or RegTTCCmd(10);
			   	RegTTCCmd( 9) <= BrcstStr1_q or RegTTCCmd( 9);
			   	RegTTCCmd( 8) <= L1Accept_q  or RegTTCCmd( 8);
			   	
			   	if (BrcstStr2_q = '1') then
						RegTTCCmd(7 downto 6) 	<= Brcst_q(7 downto 6);
		 	 		end if;
			   	
			   	if (BrcstStr1_q = '1') then
						RegTTCCmd(5 downto 2) <= Brcst_q(5 downto 2);
						RegTTCCmd(1) 			 <= EvCntRes_q;
						RegTTCCmd(0) 			 <= BCntRes_q;
			   	end if;

			   end if;
	   	end if;
	   end if;
	end process;
	
	db <=	RegTTCCmd	 when ((db_rd and Reg2E) = '1') else (others => 'Z');
			
	
		

end rtl;
