-- hds header_start
--
-- VHDL Entity TIM_fpga2.ttcrx.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:59:43 03/05/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity ttcrx is
   port( 
      -- Common Signals
      	-----------------
      rst             : in     std_logic;                       -- was NOT nOA_rst
      clk             : in     std_logic;
      --RunMode		: in	std_logic;
      db              : inout  std_logic_vector (15 downto 0);
      vmeRD           : in     std_logic;                       -- was bReadb
      vmeWR           : in     std_logic;                       -- was bWriteb
      --vmeCLK		: in	std_logic;	-- was LEb2
      Reg26           : in     std_logic;
      Reg28           : in     std_logic;
      Reg2C           : in     std_logic;
      Reg2E           : in     std_logic;
      -- ttcrx Signals
      	----------------
      	--trx_BCclk1b_i		: in	std_logic; --CLOCK pin
      	--trx_BCclk2b_i		: in	std_logic; --CLOCK pin
      TTCCLK_i        : in     std_logic;
      trx_L1Accept_i  : in     std_logic;
      trx_EvCntRes_i  : in     std_logic;
      trx_BCntRes_i   : in     std_logic;
      trx_BCnt_i      : in     std_logic_vector (11 downto 0);
      trx_BCntStr_i   : in     std_logic;
      trx_EvCntHStr_i : in     std_logic;
      trx_EvCntLStr_i : in     std_logic;
      trx_Brcst_i     : in     std_logic_vector (7 downto 2);
      trx_BrcstStr1_i : in     std_logic;
      trx_BrcstStr2_i : in     std_logic;
      trx_DbErrStr_i  : in     std_logic;
      trx_DoutStr_i   : in     std_logic;
      trx_Dout_i      : in     std_logic_vector (7 downto 0);
      trx_DQ_i        : in     std_logic_vector (3 downto 0);
      trx_SinErrStr_i : in     std_logic;
      trx_SubAddr_i   : in     std_logic_vector (7 downto 0);
      trx_TTCready_i  : in     std_logic;
      trx_Resetb_o    : out    std_logic;
      trx_SCL_io      : inout  std_logic;
      trx_SDA_io      : inout  std_logic;
      -- Other Outputs
      	-----------------
      TTCL1A_o        : out    std_logic;
      TTCBCR_o        : out    std_logic;
      TTCECR_o        : out    std_logic;
      TTCCAL_o        : out    std_logic;
      TTCFER_o        : out    std_logic;
      TTCSPR_o        : out    std_logic;
      TTCL1ID_o       : out    std_logic_vector (23 downto 0);
      TTCL1ID_strb_o  : out    std_logic;
      TTCBCID_o       : out    std_logic_vector (11 downto 0);
      TTCBCID_strb_o  : out    std_logic;
      TTCTTID_o       : out    std_logic_vector (9 downto 0);
      TTCTTID_strb_o  : out    std_logic;
      trxReady_o      : out    std_logic;                       -- was TTCready_in
      -- Debug Bus
      	----------------
      DebugBus        : out    std_logic_vector (15 downto 0)
   );

-- Declarations

end ttcrx ;


-- hds interface_end


-------------------------------------------------------------------------------

architecture tim of ttcrx is

-------------------------------------------------------------------------------
-- SIGNAL DECLARATIONS
-------------------------------------------------------------------------------

	signal RegTTCdata		: std_logic_vector(15 downto 0);
  	signal RegTTCselect	: std_logic_vector( 3 downto 0);
   signal RegI2C			: std_logic_vector(15 downto 0);
   signal RegTTCCmd		: std_logic_vector(15 downto 0);

	--signal SCLoe		 	: std_logic;
 	--signal SDAoe		 	: std_logic;

 	--signal TTCrxClk		: std_logic;



	-- Clocked (by TTCrxClk) versions of TTCrx signal inputs
	--------------------------------------------------------
 	signal qSinErrStr		: std_logic;
 	signal qDbErrStr		: std_logic;
  	signal qDoutStr		: std_logic;
  	signal qBrcstStr1		: std_logic;
 	signal qBrcstStr2		: std_logic;
 	signal qBCntStr		: std_logic;
 	signal qEvCntLStr		: std_logic;
 	signal qEvCntHStr		: std_logic;
 	signal qBCnt			: std_logic_vector(11 downto 0);
 	signal qBrcst			: std_logic_vector( 7 downto 2);
 	signal qDout			: std_logic_vector( 7 downto 0);
 	signal qSubAddr		: std_logic_vector( 7 downto 0);
 	signal qDQ      		: std_logic_vector( 3 downto 0);
 	signal qL1Accept		: std_logic;
 	signal qBCntRes		: std_logic;
 	signal qEvCntRes		: std_logic;




-------------------------------------------------------------------------------
-- MAIN CODE
-------------------------------------------------------------------------------
begin


	process (rst, TTCCLK_i, trx_ttcready_i)
	begin
		if (rst = '1') or (trx_TTCReady_i = '0') then

			qSinErrStr	<= '0';
         qDbErrStr	<= '0';
         qDoutStr		<= '0';
         qBrcstStr1	<= '0';
         qBrcstStr2	<= '0';
         qBCntStr		<= '0';
         qEvCntLStr	<= '0';
         qEvCntHStr	<= '0';
         qBCnt			<= "000000000000";
         qBrcst		<= "000000";
         qDout			<= "00000000";
         qSubAddr		<= "00000000";
         qDQ      	<= "0000";
         qL1Accept	<= '0';
         qBCntRes		<= '0';
         qEvCntRes	<= '0';

		elsif rising_edge(TTCCLK_i) then -- edge depends on delays in buffers on board

         qSinErrStr 	<= trx_SinErrStr_i;
         qDbErrStr 	<= trx_DbErrStr_i;
         qDoutStr  	<= trx_DoutStr_i;
         qBrcstStr1	<= trx_BrcstStr1_i;
         qBrcstStr2	<= trx_BrcstStr2_i;
         qBCntStr  	<= trx_BCntStr_i;
         qEvCntLStr	<= trx_EvCntLStr_i;
         qEvCntHStr	<= trx_EvCntHStr_i;
			qBCnt			<= trx_BCnt_i;
			qBrcst		<= trx_Brcst_i;
			qDout			<= trx_Dout_i;
			qSubAddr		<= trx_SubAddr_i;
			qDQ			<= trx_DQ_i;
			qL1Accept	<= trx_L1Accept_i;
         qBCntRes		<= trx_BCntRes_i;
         qEvCntRes	<= trx_EvCntRes_i;

       end if;

    end process;



	---------------------------------------------------------------------------
	-- TTCrx reset pulse generator (~50us)
	---------------------------------------------------------------------------

	process (rst, clk)
      variable resetb_timer : integer;
	begin
		if (rst = '1') then
			resetb_timer:= 0;
			trx_resetb_o <= '1';

		elsif rising_edge(clk) then

			if (resetb_timer = 2#11111111111#) then
							resetb_timer := 2#11111111111#;
							trx_resetb_o <= '0';

			else
				resetb_timer := resetb_timer + 1;
				trx_resetb_o <= '1';

			end if;

		end if;
	end process;




	-------------
	-- OUTPUTS
	-------------


	trxReady_o <= trx_TTCready_i;


	---------------------------------------------------------------------------
	-- TTC Signals: (Decode and) TIM-Clock Out
	---------------------------------------------------------------------------

	process (rst, clk)
	begin
		if (rst = '1') then

			TTCL1A_o <= '0';
			TTCBCR_o <= '0';
			TTCECR_o <= '0';
			TTCCAL_o <= '0';
			TTCFER_o <= '0';

		elsif rising_edge(clk) then

			TTCL1A_o <= qL1Accept;
			TTCBCR_o <= qBCntRes;
			TTCECR_o <= qEvCntRes;

			if (qBrcstStr2 = '1') then
				TTCCAL_o <= qBrcst(6);
			end if;

			if (qBrcstStr1 = '1') then
				TTCFER_o <= qBrcst(2);
			end if;

		end if;
   end process;

   TTCSPR_o <= '0';



	---------------------------------------------------------------------------
  	-- Event ID demux and clock
 	---------------------------------------------------------------------------



	process (rst, clk)
	begin
		if (rst ='1') then
			TTCL1ID_o      <= (others => '0');
         TTCL1ID_strb_o <= '0';

   		TTCBCID_o      <= (others => '0');
         TTCBCID_strb_o <= '0';

		elsif rising_edge(clk) then

			-- BCID
			if (qBCntStr = '1') then
   			TTCBCID_o(11 downto 0) <= qBcnt;
			end if;

			TTCBCID_strb_o <= qBCntStr;


			-- L1ID Low
			if (qEvCntLStr = '1') then
   			TTCL1ID_o(11 downto 0) <= qBcnt;
			end if;

			-- L1ID High
			if (qEvCntHStr = '1') then
	         TTCL1ID_o(23 downto 12) <= qBcnt;
   		end if;

   		TTCL1ID_strb_o <= qEvCntHStr;


		end if;
	end process;
	-- *** what do un-else'd ifs default to??




	---------------------------------------------------------------------------
  	-- Trigger Type decode and clock out
 	---------------------------------------------------------------------------

	TTCTTID_o(9 downto 8) <= "00";
	
	process (rst, clk)
	begin

		if (rst ='1') then
			TTCTTID_o(7 downto 0) <= (others => '0');
			TTCTTID_strb_o <= '0';

		elsif rising_edge(clk) then

			

			if (qDoutStr='1') and (qSubAddr="00000000") and (qDQ="0000") then

				TTCTTID_o(7 downto 0) 	<= qDout;
				TTCTTID_strb_o 			<= '1';

			else
				TTCTTID_strb_o 			<= '0';

			end if;

		end if;
	end process;



  	-- Register TTC Data - Reg26
  	----------------------------

	process (rst, clk)
	begin
		if (rst ='1') then
			RegTTCdata <= (others => '0');

		elsif rising_edge(clk) then

			if (Reg26 and vmeWR) = '1'  then
				RegTTCdata <= (others => '0');

	      elsif (qDoutStr = '1') and (qDQ = RegTTCselect) then
				RegTTCdata(15 downto 8) <= qSubAddr(7 downto 0);
				RegTTCdata( 7 downto 0) <= qDout(7 downto 0);

		   end if;

		end if;
	end process;




  	-- Register TTC Select - Reg28
  	------------------------------

	process (rst, clk)
	begin
		if (rst = '1') then
			RegTTCselect <= "0000";

		elsif rising_edge(clk) then

			if (Reg28 and vmeWR) = '1' then
				RegTTCselect <= db(3 downto 0);

			end if;
      end if;
	end process;



	---------------------------------------------------------------------------
  	-- Command and Control
  	---------------------------------------------------------------------------


	-- Command Reg (High)
	--------------------------------------
	RegTTCCmd(15)  <= '0';
	
	process (rst, clk) --RegTTCCmd(14 downto 8), Reg2E, vmeWR, trx_ttcready_i,
            --qsinerrstr, qdberrstr, qdoutstr, qbrcststr2, qbrcststr1, ql1accept)
	begin
		if (rst = '1') then
			RegTTCcmd(14 downto 8) <= (others => '0');

		
		elsif rising_edge(clk) then
		
			if (Reg2E and vmeWR) = '1' then
				RegTTCcmd(14 downto 8) <= (others => '0');

			else
	   		RegTTCCmd(14)  <= trx_TTCReady_i;
		   	RegTTCCmd(13)  <= qSinErrStr  or RegTTCCmd(13);
		   	RegTTCCmd(12)  <= qDbErrStr   or RegTTCCmd(12);
		   	RegTTCCmd(11)  <= qDoutStr    or RegTTCCmd(11);
		   	RegTTCCmd(10)  <= qBrcstStr2  or RegTTCCmd(10);
		   	RegTTCCmd( 9)  <= qBrcstStr1  or RegTTCCmd( 9);
		   	RegTTCCmd( 8)  <= qL1Accept   or RegTTCCmd( 8);

	   	end if;
	   end if;
	end process;


	-- Command Reg (Low)
	--------------------
	process (rst, clk)
	begin
		if (rst ='1') then
			RegTTCCmd(7 downto 0) <= "00000000";

		elsif rising_edge(clk) then

			if (qBrcstStr2 = '1') then
				RegTTCCmd(7 downto 6) 	<= qBrcst(7 downto 6);
		   end if;

		   if (qBrcstStr1 = '1') then
				RegTTCCmd(5 downto 2) 	<= qBrcst(5 downto 2);
				RegTTCCmd(1) 				<= qEvCntRes;
				RegTTCCmd(0) 				<= qBCntRes;
		   end if;

		end if;
	end process;



	---------------------------------------------------------------------------
  	-- I2C Section
  	---------------------------------------------------------------------------

	-- Register I2C - Reg2C
  	-----------------------
	process (rst, clk)
	begin
		if (rst = '1') then
			RegI2C <= "0000000000000000";

		elsif rising_edge(clk) then

			if (Reg2C and vmeWR) = '1' then
				RegI2C <= db(15 downto 0);

			end if;
      end if;
	end process;

	--

	-- I2C is a pull-up bus
	--*** adding logic here for PAR
	trx_SDA_io <= RegI2C(15) when (RegI2C(14) = '1') else 'Z'; -- =1 : I2C is a pull-up bus
	trx_SCL_io <= RegI2C(13) when (RegI2C(12) = '1') else 'Z';



	---------------------------------------------------------------------------
  	-- Read Data
  	---------------------------------------------------------------------------

	read_db : block
	
		signal RegTTCsel_db 	:	std_logic_vector(15 downto 0);
				
	begin
	
		RegTTCsel_db(15 downto 4) <= (others => '0');
		RegTTCsel_db( 3 downto 0) <= RegTTCselect;
  	
  		db <= RegTTCdata 	 when ((vmeRD and Reg26) = '1') else
				RegTTCsel_db when ((vmeRD and Reg28) = '1') else
				RegI2C		 when ((vmeRD and Reg2C) = '1') else
				RegTTCCmd	 when ((vmeRD and Reg2E) = '1') else (others => 'Z');
				
	end block;


	-- Debug Bus
  	----------------------------------------------------
	DebugBus <= "0000000000000000";

end tim;

-------------------------------------------------------------------------------
