-- FPGA2 Global Declarations
--
-- Generated by Matts TIM_Register_List.xls
-- 31/08/2007 09:48:32
--
--

library ieee;
use ieee.std_logic_1164.all;

package f2_globals is

   constant NREG : integer := 80; -- max number of registers

   subtype  d16            is std_logic_vector(15 downto 0);
   type     d16_reg_array  is array ((NREG-1) downto 0) of d16;
   subtype  ren_array      is std_logic_vector((NREG-1) downto 0);
   
   
constant ENABLES    : integer := 0; -- 0x00
constant COMMAND    : integer := 1; -- 0x02
constant BURST      : integer := 2; -- 0x04
constant FREQUENCY  : integer := 3; -- 0x06
constant WINDOW     : integer := 4; -- 0x08
constant DELAYS     : integer := 5; -- 0x0A
constant STATUS     : integer := 6; -- 0x0C
constant FIFO       : integer := 7; -- 0x0E
constant L1IDL      : integer := 8; -- 0x10
constant L1IDH      : integer := 9; -- 0x12
constant BCID       : integer := 10; -- 0x14
constant TTID       : integer := 11; -- 0x16
constant RUN_ENABLE : integer := 12; -- 0x18
constant SEQ_CTL    : integer := 13; -- 0x1A
constant SEQ_END    : integer := 14; -- 0x1C
constant RB_MASK    : integer := 15; -- 0x1E
constant RB_STAT    : integer := 16; -- 0x20
constant RB_LATCH   : integer := 17; -- 0x22
constant RB_MON     : integer := 18; -- 0x24
constant TTC_DATA   : integer := 19; -- 0x26
constant TTC_SELECT : integer := 20; -- 0x28
constant TTC_BCID   : integer := 21; -- 0x2A
constant TTCRX_CTL  : integer := 22; -- 0x2C
constant TTC_STATUS : integer := 23; -- 0x2E
constant TIM_OUTPUT : integer := 24; -- 0x30
constant TIM_ID     : integer := 25; -- 0x32

constant ENABLES3   : integer := 33; -- 0x42

constant CONTROL    : integer := 35; -- 0x46

constant STATUS3    : integer := 37; -- 0x4A
constant STATUS_LCH : integer := 38; -- 0x4C
constant STAT3_LCH  : integer := 39; -- 0x4E

constant QPLL_CTL   : integer := 41; -- 0x52

constant BUSY_EN3   : integer := 43; -- 0x56

constant BUSY_STAT3 : integer := 45; -- 0x5A

constant BSTAT3_LCH : integer := 47; -- 0x5E
constant BCOUNTL    : integer := 48; -- 0x60
constant BCOUNTH    : integer := 49; -- 0x62
constant BCOUNTX    : integer := 50; -- 0x64

constant FV_VETOLEN : integer := 52; -- 0x68
constant FV_MATCH   : integer := 53; -- 0x6A
constant FV_P_MIN   : integer := 54; -- 0x6C
constant FV_P_MAX   : integer := 55; -- 0x6E
constant FV_OFLOW   : integer := 56; -- 0x70
constant FV_DELTAT  : integer := 57; -- 0x72
constant FV_COUNTL  : integer := 58; -- 0x74
constant FV_COUNTH  : integer := 59; -- 0x76
constant FV_COUNTX  : integer := 60; -- 0x78

constant FV_TCOUNTL : integer := 62; -- 0x7C
constant FV_TCOUNTH : integer := 63; -- 0x7E
constant TP_FIFOL   : integer := 64; -- 0x80
constant TP_FIFOH   : integer := 65; -- 0x82
constant FV_IDL     : integer := 66; -- 0x84
constant FV_IDH     : integer := 67; -- 0x86
constant TRIG_OSC2L : integer := 68; -- 0x88
constant TRIG_OSC2H : integer := 69; -- 0x8A

constant BURST_HI   : integer := 71; -- 0x8E
constant TT_COUNT   : integer := 72; -- 0x90
constant TTS_COUNT  : integer := 73; -- 0x92
constant TSTAMPL    : integer := 74; -- 0x94
constant TSTAMPH    : integer := 75; -- 0x96
constant SRC_ADDR   : integer := 76; -- 0x98
constant SINK_ADDR  : integer := 77; -- 0x9A
constant DEBUG_CTL  : integer := 78; -- 0x9C
constant DEBUG_STAT : integer := 79; -- 0x9E

end f2_globals;
