-- hds header_start
--
-- VHDL Architecture TIM_fpga2.i2c_ttc_vme.rtl2
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 13:59:51 07/09/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;



entity i2c_ttc_vme is
   port(
      rst           : in     std_logic;
      clk           : in     std_logic;
      db            : inout  std_logic_vector (15 downto 0);
      db_rd         : in     std_logic;
      db_wr         : in     std_logic;
      reg2C         : in     std_logic;
      i2c_go_o      : out    std_logic;
      i2c_busy_i    : in     std_logic;
      i2c_err_i     : in     std_logic;
      ttcrx_data_i  : in     std_logic_vector (7 downto 0);
      ttcrx_data_o  : out    std_logic_vector (7 downto 0);
      i2c_abort_o   : out    std_logic;
      i2c_rd_nwr_o  : out    std_logic;
      i2c_pointer_o : out    std_logic_vector (4 downto 0);
      ttc_ready_i   : in     std_logic
   );

-- Declarations

end i2c_ttc_vme ;


-- hds interface_end

architecture rtl of i2c_ttc_vme is

	signal i2c_pointer 	: std_logic_vector(4 downto 0);
	signal i2c_data 		: std_logic_vector(7 downto 0);
	signal i2c_rd_nwr		: std_logic;
	signal reg_i2c			: std_logic_vector(15 downto 0);
	signal i2c_busy_q		: std_logic;
	signal i2c_err_q		: std_logic;

	signal reg2c_wr		: std_logic;

begin


	reg2c_wr <= db_wr and Reg2C;


	-- Control
	------------------------------------------------------------------
	process (clk)
 	begin
		if rising_edge(clk) then
			if (rst = '1') then
				i2c_go_o		<= '0';
				i2c_abort_o <= '0';

				i2c_rd_nwr	<= '0';
        		i2c_pointer	<= (others => '0');

			else
				-- defaults
				i2c_go_o 	<= '0';
				i2c_abort_o <= '0';

				if (reg2c_wr = '1') then
					i2c_go_o 	<= db(15) and ttc_ready_i;
					i2c_abort_o <= db(14);
         		i2c_rd_nwr	<= db(13);
         		i2c_pointer <= db(12 downto 8);

				end if;
			end if;
		end if;
	end process;

	i2c_rd_nwr_o  <= i2c_rd_nwr;
   i2c_pointer_o <= i2c_pointer;


	-- Data map
	------------------------------------------------------------------
   process (clk)
   begin
   	if rising_edge(clk) then
   		if (rst = '1') then
   			i2c_data   <= (others => '0');
   			i2c_busy_q <= '0';
	   		i2c_err_q  <= '0';

   		else
  			 	i2c_err_q  <= (i2c_err_i or i2c_err_q) and (not (reg2c_wr and not db(14)));

   			i2c_busy_q <= i2c_busy_i and ttc_ready_i;

   			if (i2c_busy_i = '0') and (i2c_busy_q = '1') then --falling edge
   				i2c_data <= ttcrx_data_i;

   			elsif (Reg2C = '1') and (db_wr = '1') then
   				i2c_data <= db(7 downto 0);

   			end if;
   		end if;
   	end if;
   end process;

   ttcrx_data_o <= i2c_data;


   -------------------------------------------------------------------

	reg_i2c(15) 			<= i2c_busy_q;
	reg_i2c(14) 			<= i2c_err_q;
	reg_i2c(13) 			<= i2c_rd_nwr;
	reg_i2c(12 downto 8)	<= i2c_pointer;
	reg_i2c( 7 downto 0) <= i2c_data;

	db <= reg_i2c when ((db_rd and Reg2C) = '1') else (others => 'Z');

end rtl;
