-- hds header_start
--
-- VHDL Entity TIM_fpga2.i2c_ttc_vme.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 13:43:13 07/09/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

entity i2c_ttc_vme is
   port( 
      TTC_control    : in     std_logic_vector (15 downto 0);
      data_from_ttc  : in     std_logic_vector (7 downto 0);
      i2c_busy       : in     std_logic;
      i2c_err        : in     std_logic;
      i2c_rst        : in     std_logic;
      iclk40         : in     std_logic;
      set_vme_status : in     std_logic;
      data_to_ttc    : out    std_logic_vector (7 downto 0);
      i2c_abort      : out    std_logic;
      i2c_rd_nwr     : out    std_logic;
      ttc_pointer    : out    std_logic_vector (4 downto 0);
      ttc_status     : out    std_logic_vector (15 downto 0)
   );

-- Declarations

end i2c_ttc_vme ;


-- hds interface_end

--
-- VHDL Architecture TIM_fpga2.i2c_ttc_vme.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 13:43:13 07/09/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

library TIM_fpga2;

architecture struct of i2c_ttc_vme is

   signal i2c_err_held  : std_logic;
   signal ipb_high      : std_logic;
   signal rst_status    : std_logic;
   signal ttc_data_held : std_logic_vector(7 downto 0);

begin
   ttc_status <= "000000" & i2c_err_held & i2c_busy & ttc_data_held;

   ipb_high <= '1';

   i2c_abort <= TTC_control(15);
   rst_status <= TTC_control(15) or i2c_rst;
   -- don't use   TTC_control(14)
   ttc_pointer <= TTC_control(13 downto 9);
   i2c_rd_nwr  <=  TTC_control(8);
   data_to_ttc <= TTC_control(7 downto 0);

      
  	process (rst_status, iclk40)
  	begin
    	if (rst_status = '1') then
      	i2c_err_held <= '0';
      	
    	elsif (iclk40'event and iclk40 = '1') then
	  		if (i2c_err = '1') then
        		i2c_err_held <= ipb_high;
        		
        		-- functional timing stuff:
        		-- pragma synthesis_off
        		if (ipb_high'stable(1 ns) = false) then
          		i2c_err_held <= ipb_high'last_value;
        		end if;
        		-- pragma synthesis_on
        	
	  		end if;
		end if;
	end process;
      
      
      
	process (rst, iclk40)
  	begin
    	if (rst_status = '1') then
      	ttc_data_held <= (others=>'0');
    	
    	elsif (iclk40'event and iclk40 = '1') then
	  		if (set_vme_status = '1') then
        		ttc_data_held <= data_from_ttc;
        		
        		-- functional timing stuff:
		      -- pragma synthesis_off
        		if (data_from_ttc'stable(1 ns) = false) then
          		ttc_data_held <= data_from_ttc'last_value;
          		
        		end if;
     			-- pragma synthesis_on
        		
	  		end if;
   	end if;
	end process;
      
      

end struct;
