-- hds header_start
--
-- VHDL Architecture TIM_fpga2.mixer.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:42:11 04/01/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


ENTITY mix_out IS
   PORT( 
      clk               : IN     std_logic;
      rst               : IN     std_logic;
      short_fpsigs_en_i : IN     std_logic;
      l1a_fast_i        : IN     std_logic;
      ecr_fast_i        : IN     std_logic;
      bcr_fast_i        : IN     std_logic;
      l1a_i             : IN     std_logic;
      bcr_i             : IN     std_logic;
      ecr_i             : IN     std_logic;
      cal_i             : IN     std_logic;
      fer_i             : IN     std_logic;
      spr_i             : IN     std_logic;
      exs_i             : IN     std_logic;
      tts_i             : IN     std_logic;
      -- Combined Signals
      AllL1A_o          : OUT    std_logic;
      AllBCR_o          : OUT    std_logic;
      AllECR_o          : OUT    std_logic;
      AllCAL_o          : OUT    std_logic;
      AllFER_o          : OUT    std_logic;
      AllSPR_o          : OUT    std_logic;
      AllEXS_o          : OUT    std_logic;
      AllTTS_o          : OUT    std_logic;
      -- FrontPanel	(ECL/NIM) Signals
      AllL1Afp_o        : OUT    std_logic;
      AllBCRfp_o        : OUT    std_logic;
      AllECRfp_o        : OUT    std_logic;
      AllCALfp_o        : OUT    std_logic;
      AllFERfp_o        : OUT    std_logic;
      AllSPRfp_o        : OUT    std_logic;
      --Backplane Sigs Bus
      TTCbus_o          : OUT    std_logic_vector (7 DOWNTO 0)
   );

-- Declarations

END mix_out ;

-- hds interface_end

architecture rtl of mix_out is

	
	signal L1A					: std_logic;
	signal BCR					: std_logic;
	signal ECR					: std_logic;
	signal CAL					: std_logic;
	signal FER					: std_logic;
	signal SPR					: std_logic;
	signal TTS					: std_logic;
	signal EXS					: std_logic;
	
	signal ttc_l1a 			: std_logic;		
	signal ttc_ecr				: std_logic;		
	signal ttc_bcr				: std_logic;		
	signal ttc_cal				: std_logic;		
	signal ser_exs				: std_logic;		
	signal ser_tts				: std_logic;		
	signal ttc_fer				: std_logic;		
	signal ttc_spr				: std_logic;		
	
	signal ttc_l1a_fast  	: std_logic;		
	signal ttc_ecr_fast  	: std_logic;		
	signal ttc_bcr_fast  	: std_logic;	
	signal alltrg_pre_fv    : std_logic;
	
	signal AllL1A_q         : std_logic;                       -- Combined Signals
	signal AllBCR_q         : std_logic;                       -- Also FrontPanel	(ECL/NIM) Signals
	signal AllECR_q         : std_logic;
	signal AllCAL_q         : std_logic;
	signal AllFER_q         : std_logic;
	signal AllSPR_q         : std_logic;
	signal AllEXS_q         : std_logic;
	signal AllTTS_q         : std_logic;
	
	signal AllL1A_q180      : std_logic;
	signal AllBCR_q180      : std_logic;
	signal AllECR_q180      : std_logic;
	signal AllCAL_q180      : std_logic;
	signal AllFER_q180      : std_logic;
	signal AllSPR_q180      : std_logic;
	
	

-------------------------------------------------------------------------------
--	MAIN CODE
-------------------------------------------------------------------------------
begin

	L1A 		<= l1a_i;
	ECR 		<= ecr_i;
	BCR 		<= bcr_i;
	CAL 		<= cal_i;
	EXS 		<= exs_i;
	TTS 		<= tts_i;
	FER 		<= fer_i;
	SPR 		<= spr_i;
	
	-- Backplane
	------------
	TTCbus_o(0)	<=	l1a_fast_i;
	TTCbus_o(1)	<=	ecr_fast_i;
	TTCbus_o(2)	<=	bcr_fast_i;
	TTCbus_o(3)	<=	CAL;
	TTCbus_o(4)	<=	EXS;
	TTCbus_o(5)	<=	TTS;
	TTCbus_o(6)	<=	FER;
	TTCbus_o(7)	<=	SPR;


	--	Clocked for	on	board	use
	process (clk)
	begin
		if	rising_edge(clk) then
			if	(rst = '1') then
				AllL1A_q	 <= '0';
				AllECR_q	 <= '0';
				AllBCR_q	 <= '0';			
				AllCAL_q	 <= '0';
				AllEXS_q	 <= '0';
				AllTTS_q	 <= '0';
				AllFER_q	 <= '0';
				AllSPR_q	 <= '0';

			else
				AllL1A_q	 <= L1A;
				AllECR_q	 <= ECR;
				AllBCR_q	 <= BCR;			
				AllCAL_q	 <= CAL;
				AllEXS_q	 <= EXS;
				AllTTS_q	 <= TTS;
				AllFER_q	 <= FER;
				AllSPR_q	 <= SPR;

			end if;
		end if;
		
		if	falling_edge(clk) then
			if	(rst = '1') then
				
				AllL1A_q180	 <= '0';
				AllECR_q180	 <= '0';
				AllBCR_q180	 <= '0';			
				AllCAL_q180	 <= '0';
				AllFER_q180	 <= '0';
				AllSPR_q180	 <= '0';
			
			else
				AllL1A_q180	 <= AllL1A_q;
				AllECR_q180	 <= AllECR_q;
				AllBCR_q180	 <= AllBCR_q;			
				AllCAL_q180	 <= AllCAL_q;
				AllFER_q180	 <= AllFER_q;
				AllSPR_q180	 <= AllSPR_q;

			end if;
		end if;
		
	end process;
	
	AllL1A_o	<=	AllL1A_q;
	AllECR_o	<=	AllECR_q;
	AllBCR_o	<=	AllBCR_q;
	AllCAL_o	<=	AllCAL_q;
	AllEXS_o	<=	AllEXS_q;
	AllTTS_o	<=	AllTTS_q;
	AllFER_o	<=	AllFER_q;
	AllSPR_o	<=	AllSPR_q;

	-- Added this to stretch signal for for bad LED driver 
	AllL1Afp_o	<=	AllL1A_q or ( AllL1A_q180 and not(short_fpsigs_en_i) );
	AllECRfp_o	<=	AllECR_q or ( AllECR_q180 and not(short_fpsigs_en_i) );
	AllBCRfp_o	<=	AllBCR_q or ( AllBCR_q180 and not(short_fpsigs_en_i) );
	AllCALfp_o	<=	AllCAL_q or ( AllCAL_q180 and not(short_fpsigs_en_i) );
	AllFERfp_o	<=	AllFER_q or ( AllFER_q180 and not(short_fpsigs_en_i) );
	AllSPRfp_o	<=	AllSPR_q or ( AllSPR_q180 and not(short_fpsigs_en_i) );

	
end rtl;
