-- hds header_start
--
-- VHDL Architecture TIM_fpga2.mixer.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:42:11 04/01/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


-- *** log start
-- 2007-03-28 MW disabled TTCL1A when sa_ttcl1a is en
-- *** log end


entity mixer is
   port( 
      clk               : in     std_logic;
      rst               : in     std_logic;
      db                : inout  std_logic_vector (15 downto 0);
      db_rd             : in     std_logic;
      db_wr             : in     std_logic;
      reg_run_enables_i : in     std_logic_vector (15 downto 0);
      Reg30             : in     std_logic;
      SATRG_i           : in     std_logic;
      SABCR_i           : in     std_logic;
      SAECR_i           : in     std_logic;
      SACAL_i           : in     std_logic;
      SAFER_i           : in     std_logic;
      SASPR_i           : in     std_logic;
      SABCR2_i          : in     std_logic;
      SAECR2_i          : in     std_logic;
      ttc_l1a_fast_i    : in     std_logic;
      ttc_ecr_fast_i    : in     std_logic;
      ttc_bcr_fast_i    : in     std_logic;
      TTCL1A_i          : in     std_logic;
      TTCBCR_i          : in     std_logic;
      TTCECR_i          : in     std_logic;
      TTCCAL_i          : in     std_logic;
      TTCFER_i          : in     std_logic;
      TTCSPR_i          : in     std_logic;
      SerEXS_i          : in     std_logic;
      SerTTS_i          : in     std_logic;
      SeqTRG_i          : in     std_logic;
      SeqBCR_i          : in     std_logic;
      SeqECR_i          : in     std_logic;
      SeqCAL_i          : in     std_logic;
      SeqFER_i          : in     std_logic;
      SeqSPR_i          : in     std_logic;
      SeqEXS_i          : in     std_logic;
      SeqTTS_i          : in     std_logic;
      enSABCR2_o        : out    std_logic;
      enSAECR2_o        : out    std_logic;
      ext_RodBUSYinen_o : out    std_logic;
      enRodBusy_o       : out    std_logic;
      enttcclk_o        : out    std_logic;
      L1A_o             : out    std_logic;
      BCR_o             : out    std_logic;
      ECR_o             : out    std_logic;
      CAL_o             : out    std_logic;
      FER_o             : out    std_logic;
      SPR_o             : out    std_logic;
      EXS_o             : out    std_logic;
      TTS_o             : out    std_logic;
      l1a_fast_o        : out    std_logic;
      ecr_fast_o        : out    std_logic;
      bcr_fast_o        : out    std_logic;
      bst_busy_i        : in     std_logic;
      fftv_busy_i        : in     std_logic;
      alltrg_pre_fv_o   : out    std_logic;
      ren_fv_tcountl_i  : in     std_logic;
      ren_fv_tcounth_i  : in     std_logic;
      sa_ttcl1a_en_i : in     std_logic
   );

-- Declarations

end mixer ;

-- hds interface_end

architecture rtl of mixer is

	signal l1a_fast  			: std_logic;		
	signal ecr_fast  			: std_logic;		
	signal bcr_fast  			: std_logic;		
	signal L1A					: std_logic;
	signal BCR					: std_logic;
	signal ECR					: std_logic;
	signal CAL					: std_logic;
	signal FER					: std_logic;
	signal SPR					: std_logic;
	signal TTS					: std_logic;
	signal EXS					: std_logic;
	signal enTTCSPR			: std_logic;
	signal enTTCFER			: std_logic;
	signal enTTCCAL			: std_logic;
	signal enTTCBCR			: std_logic;
	signal enTTCECR			: std_logic;
	signal enTTCL1A			: std_logic;
	signal enSerEXS			: std_logic;	
	signal enSerTTS			: std_logic;		
	signal RegTestTTCbus		: std_logic_vector(15 downto 0);
	signal reg_fv_tcount		: std_logic_vector(31 downto 0);
	signal ttc_l1a 			: std_logic;		
	signal ttc_ecr				: std_logic;		
	signal ttc_bcr				: std_logic;		
	signal ttc_cal				: std_logic;		
	signal ser_exs				: std_logic;		
	signal ser_tts				: std_logic;		
	signal ttc_fer				: std_logic;		
	signal ttc_spr				: std_logic;		
	signal ttc_l1a_fast  	: std_logic;		
	signal ttc_ecr_fast  	: std_logic;		
	signal ttc_bcr_fast  	: std_logic;
	signal alltrg_pre_fv    : std_logic;	

	
	
	

-------------------------------------------------------------------------------
--	MAIN CODE
-------------------------------------------------------------------------------
begin

	-- Signals Enabled
	------------------	
	ttc_l1a 		 <= TTCL1A_i 		 and enTTCL1A;
	ttc_l1a_fast <= ttc_l1a_fast_i and enTTCL1A;
	
	ttc_ecr 		 <= TTCECR_i 		 and enTTCECR;
	ttc_ecr_fast <= ttc_ecr_fast_i and enTTCECR;
	
	ttc_bcr 		 <= TTCBCR_i 		 and enTTCBCR;
	ttc_bcr_fast <= ttc_bcr_fast_i and enTTCBCR;
	
	
	ttc_cal <= TTCCAL_i and enTTCCAL;
	ser_exs <= SerEXS_i and enSerEXS;
	ser_tts <= SerTTS_i and enSerTTS;
	ttc_fer <= TTCFER_i and enTTCFER;
	ttc_spr <= TTCSPR_i and enTTCSPR;
	
	
	-- Aggregated
	--------------
	L1A 		<= ttc_l1a 		 or ((SATRG_i or  SeqTRG_i) and (not(fftv_busy_i or bst_busy_i)));
	l1a_fast <= ttc_l1a_fast or ((SATRG_i or  SeqTRG_i) and (not(fftv_busy_i or bst_busy_i)));
	                           
	ECR 		<= ttc_ecr 		 or  SAECR_i or  SeqECR_i or SAECR2_i;
	ecr_fast <= ttc_ecr_fast or  SAECR_i or  SeqECR_i or SAECR2_i;
	                           
	BCR 		<= ttc_bcr 		 or  SABCR_i or  SeqBCR_i or SABCR2_i;
	bcr_fast <= ttc_bcr_fast or  SABCR_i or  SeqBCR_i or SABCR2_i;	
	                           
	CAL 		<= ttc_cal 		 or  SACAL_i or  SeqCAL_i;
	EXS 		<= ser_exs 		 or              SeqEXS_i; 
	TTS 		<= ser_tts 		 or              SeqTTS_i;
	FER 		<= ttc_fer 		 or  SAFER_i or  SeqFER_i;
	SPR 		<= ttc_spr 		 or  SASPR_i or  SeqSPR_i;
	
	-- pre veto
	alltrg_pre_fv 	 <= (SATRG_i or ttc_l1a or SeqTRG_i);
	alltrg_pre_fv_o <= alltrg_pre_fv;
	
		
	-- Outputs
	----------
	L1A_o 		<=  L1A;
	ECR_o 		<=  ECR;
	BCR_o 		<=  BCR;
	CAL_o 		<=  CAL;
	EXS_o 		<=  EXS;
	TTS_o 		<=  TTS;
	FER_o 		<=  FER;
	SPR_o 		<=  SPR;
	
	l1a_fast_o  <=  l1a_fast;
	ecr_fast_o  <=  ecr_fast;
	bcr_fast_o  <=  bcr_fast;
	
	----------------------------------------------------

	enSABCR2_o		   <=	reg_run_enables_i(15);
	enSAECR2_o		   <=	reg_run_enables_i(14);
	enSerTTS			   <=	reg_run_enables_i(10);
	enSerEXS			   <=	reg_run_enables_i( 9);
	ext_RodBUSYinen_o	<=	reg_run_enables_i( 8);
	enRodBusy_o			<=	reg_run_enables_i( 7); -- Enable oa_rodbusy in timbusy
	enTTCSPR			   <=	reg_run_enables_i( 6);
	enTTCFER			   <=	reg_run_enables_i( 5);
	enTTCCAL			   <=	reg_run_enables_i( 4);
	enTTCBCR			   <=	reg_run_enables_i( 3);
	enTTCECR			   <=	reg_run_enables_i( 2);
	enTTCL1A			   <=	reg_run_enables_i( 1) and not(sa_ttcl1a_en_i); -- *** added 28/3/07
	enttcclk_o	   	<=	reg_run_enables_i( 0);


	--	Reg_TestTTCbus	(was TTCbus) -- self-holding
	----------------------------------------------------
	process (clk)
	begin

		if rising_edge(clk) then
		
			if	(rst = '1') then
				RegTestTTCbus	<=	(others => '0');

			else
				if (Reg30 and db_wr) = '1' then
					RegTestTTCbus <= (others => '0');

				else	--	Self Holding Test Register
					RegTestTTCbus(0) <= L1A or RegTestTTCbus(0);
					RegTestTTCbus(1) <= ECR or RegTestTTCbus(1);
					RegTestTTCbus(2) <= BCR or RegTestTTCbus(2);
					RegTestTTCbus(3) <= CAL or RegTestTTCbus(3);
					RegTestTTCbus(4) <= EXS or RegTestTTCbus(4);
					RegTestTTCbus(5) <= TTS or RegTestTTCbus(5);
					RegTestTTCbus(6) <= FER or RegTestTTCbus(6);
					RegTestTTCbus(7) <= SPR or RegTestTTCbus(7);
		
	      	end if;
	      end if;
	   end if;
	end process;

	db <= RegTestTTCbus when ((Reg30 and db_rd) = '1') else (others => 'Z');


	--	reg_fv_tcount
	----------------------------------------------------
	process (clk)
	begin

		if rising_edge(clk) then
		
			if	(rst = '1') or (((ren_fv_tcounth_i or ren_fv_tcountl_i) and db_wr) = '1') then
				reg_fv_tcount	<=	(others => '0');
			
			elsif (alltrg_pre_fv = '1') and (fftv_busy_i = '1') then 
				reg_fv_tcount	<= reg_fv_tcount + '1';
	      	
	      end if;
	   end if;
	end process;

	db <= reg_fv_tcount(31 downto 16) when ((ren_fv_tcounth_i and db_rd) = '1') else (others => 'Z');
	db <= reg_fv_tcount(15 downto  0) when ((ren_fv_tcountl_i and db_rd) = '1') else (others => 'Z');


end rtl;
