-- hds header_start
--
-- VHDL Architecture TIM_fpga2.mixer.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:42:11 04/01/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity mixer is
   port( 
      clk               : in     std_logic;
      rst               : in     std_logic;
      db                : inout  std_logic_vector (15 downto 0);
      db_rd             : in     std_logic;                       -- was bReadb
      db_wr             : in     std_logic;                       -- was bWriteb
      reg_run_enables_i : in     std_logic_vector (15 downto 0);
      Reg30             : in     std_logic;
      SATRG_i           : in     std_logic;
      SABCR_i           : in     std_logic;
      SAECR_i           : in     std_logic;
      SACAL_i           : in     std_logic;
      SAFER_i           : in     std_logic;
      SASPR_i           : in     std_logic;
      SABCR2_i          : in     std_logic;
      SAECR2_i          : in     std_logic;
      ttc_l1a_fast_i    : in     std_logic;
      ttc_ecr_fast_i    : in     std_logic;
      ttc_bcr_fast_i    : in     std_logic;
      TTCL1A_i          : in     std_logic;
      TTCBCR_i          : in     std_logic;
      TTCECR_i          : in     std_logic;
      TTCCAL_i          : in     std_logic;
      TTCFER_i          : in     std_logic;
      TTCSPR_i          : in     std_logic;
      SerEXS_i          : in     std_logic;
      SerTTS_i          : in     std_logic;
      SeqTRG_i          : in     std_logic;
      SeqBCR_i          : in     std_logic;
      SeqECR_i          : in     std_logic;
      SeqCAL_i          : in     std_logic;
      SeqFER_i          : in     std_logic;
      SeqSPR_i          : in     std_logic;
      SeqEXS_i          : in     std_logic;
      SeqTTS_i          : in     std_logic;
      enSABCR2_o        : out    std_logic;
      enSAECR2_o        : out    std_logic;
      --enSerEVS_o		: out	std_logic;
      --enSerTTS_o		: out	std_logic;
      ext_RodBUSYinen_o : out    std_logic;
      enRodBusy_o       : out    std_logic;
      enttcclk_o        : out    std_logic;
      AllL1A_o          : out    std_logic;                       -- Combined Signals
      AllBCR_o          : out    std_logic;
      AllECR_o          : out    std_logic;
      AllCAL_o          : out    std_logic;
      AllFER_o          : out    std_logic;
      AllSPR_o          : out    std_logic;
      AllEXS_o          : out    std_logic;
      AllTTS_o          : out    std_logic;
      AllL1Afp_o        : out    std_logic;                       -- FrontPanel	(ECL/NIM) Signals
      AllBCRfp_o        : out    std_logic;
      AllECRfp_o        : out    std_logic;
      AllCALfp_o        : out    std_logic;
      AllFERfp_o        : out    std_logic;
      AllSPRfp_o        : out    std_logic;
      TTCbus_o          : out    std_logic_vector (7 downto 0);
      ffveto_i          : in     std_logic;
      bst_busy_i        : in     std_logic;
      ren_fv_tcounth_i  : in     std_logic;
      alltrg_pre_fv_o   : out    std_logic;
      short_fpsigs_en_i : in     std_logic;
      ren_fv_tcountl_i  : in     std_logic
   );

-- Declarations

end mixer ;


-- hds interface_end

architecture rtl1 of mixer is

	signal l1a_fast  			: std_logic;		
	signal ecr_fast  			: std_logic;		
	signal bcr_fast  			: std_logic;		
	signal L1A					: std_logic;
	signal BCR					: std_logic;
	signal ECR					: std_logic;
	signal CAL					: std_logic;
	signal FER					: std_logic;
	signal SPR					: std_logic;
	signal TTS					: std_logic;
	signal EXS					: std_logic;
	signal enTTCSPR			: std_logic;
	signal enTTCFER			: std_logic;
	signal enTTCCAL			: std_logic;
	signal enTTCBCR			: std_logic;
	signal enTTCECR			: std_logic;
	signal enTTCL1A			: std_logic;
	signal enSerEXS			: std_logic;	
	signal enSerTTS			: std_logic;		
	signal RegTestTTCbus		: std_logic_vector(15 downto 0);
	signal reg_fv_tcount		: std_logic_vector(31 downto 0);
	signal ttc_l1a 			: std_logic;		
	signal ttc_ecr				: std_logic;		
	signal ttc_bcr				: std_logic;		
	signal ttc_cal				: std_logic;		
	signal ser_exs				: std_logic;		
	signal ser_tts				: std_logic;		
	signal ttc_fer				: std_logic;		
	signal ttc_spr				: std_logic;		
	signal ttc_l1a_fast  	: std_logic;		
	signal ttc_ecr_fast  	: std_logic;		
	signal ttc_bcr_fast  	: std_logic;	
	signal alltrg_pre_fv    : std_logic;
	
	signal AllL1A_q         : std_logic;                       -- Combined Signals
	signal AllBCR_q         : std_logic;                       -- Also FrontPanel	(ECL/NIM) Signals
	signal AllECR_q         : std_logic;
	signal AllCAL_q         : std_logic;
	signal AllFER_q         : std_logic;
	signal AllSPR_q         : std_logic;
	signal AllEXS_q         : std_logic;
	signal AllTTS_q         : std_logic;
	
	signal AllL1A_q180      : std_logic;
	signal AllBCR_q180      : std_logic;
	signal AllECR_q180      : std_logic;
	signal AllCAL_q180      : std_logic;
	signal AllFER_q180      : std_logic;
	signal AllSPR_q180      : std_logic;
	
	

-------------------------------------------------------------------------------
--	MAIN CODE
-------------------------------------------------------------------------------
begin


	-- Signals Enabled
	------------------	
	ttc_l1a 		 <= TTCL1A_i 		 and enTTCL1A;
	ttc_l1a_fast <= ttc_l1a_fast_i and enTTCL1A;
	
	ttc_ecr 		 <= TTCECR_i 		 and enTTCECR;
	ttc_ecr_fast <= ttc_ecr_fast_i and enTTCECR;
	
	ttc_bcr 		 <= TTCBCR_i 		 and enTTCBCR;
	ttc_bcr_fast <= ttc_bcr_fast_i and enTTCBCR;
	
	
	ttc_cal <= TTCCAL_i and enTTCCAL;
	ser_exs <= SerEXS_i and enSerEXS;
	ser_tts <= SerTTS_i and enSerTTS;
	ttc_fer <= TTCFER_i and enTTCFER;
	ttc_spr <= TTCSPR_i and enTTCSPR;
	
	

	-- Aggregated
	--------------
	L1A 		<= (SATRG_i or ttc_l1a 		 or SeqTRG_i) and (not(ffveto_i) and not(bst_busy_i));
	l1a_fast <= (SATRG_i or ttc_l1a_fast or SeqTRG_i) and (not(ffveto_i) and not(bst_busy_i));
	
	ECR 		<=  SAECR_i or ttc_ecr 		 or SeqECR_i or SAECR2_i;
	ecr_fast <=  SAECR_i or ttc_ecr_fast or SeqECR_i or SAECR2_i;
	
	BCR 		<=  SABCR_i or ttc_bcr 		 or SeqBCR_i or SABCR2_i;
	bcr_fast <=  SABCR_i or ttc_bcr_fast or SeqBCR_i or SABCR2_i;	
	
	CAL 		<=  SACAL_i or ttc_cal 		 or SeqCAL_i;
	EXS 		<=             ser_exs 		 or SeqEXS_i; 
	TTS 		<=             ser_tts 		 or SeqTTS_i;
	FER 		<=  SAFER_i or ttc_fer 		 or SeqFER_i;
	SPR 		<=  SASPR_i or ttc_spr 		 or SeqSPR_i;
	
	-- pre veto
	alltrg_pre_fv 	 <= (SATRG_i or ttc_l1a or SeqTRG_i);
	alltrg_pre_fv_o <= alltrg_pre_fv;
	
	

	-- Backplane
	-------------------------------------
	
	TTCbus_o(0)	<=	l1a_fast;
	TTCbus_o(1)	<=	ecr_fast;
	TTCbus_o(2)	<=	bcr_fast;
	TTCbus_o(3)	<=	CAL;
	TTCbus_o(4)	<=	EXS;
	TTCbus_o(5)	<=	TTS;
	TTCbus_o(6)	<=	FER;
	TTCbus_o(7)	<=	SPR;


	--	Clocked for	on	board	use
	process (clk)
	begin
		if	rising_edge(clk) then
			if	(rst = '1') then
				AllL1A_q	 <= '0';
				AllECR_q	 <= '0';
				AllBCR_q	 <= '0';			
				AllCAL_q	 <= '0';
				AllEXS_q	 <= '0';
				AllTTS_q	 <= '0';
				AllFER_q	 <= '0';
				AllSPR_q	 <= '0';

			else
				AllL1A_q	 <= L1A;
				AllECR_q	 <= ECR;
				AllBCR_q	 <= BCR;			
				AllCAL_q	 <= CAL;
				AllEXS_q	 <= EXS;
				AllTTS_q	 <= TTS;
				AllFER_q	 <= FER;
				AllSPR_q	 <= SPR;

			end if;
		end if;
		
		if	falling_edge(clk) then
			if	(rst = '1') then
				
				AllL1A_q180	 <= '0';
				AllECR_q180	 <= '0';
				AllBCR_q180	 <= '0';			
				AllCAL_q180	 <= '0';
				AllFER_q180	 <= '0';
				AllSPR_q180	 <= '0';
			
			else
				AllL1A_q180	 <= AllL1A_q;
				AllECR_q180	 <= AllECR_q;
				AllBCR_q180	 <= AllBCR_q;			
				AllCAL_q180	 <= AllCAL_q;
				AllFER_q180	 <= AllFER_q;
				AllSPR_q180	 <= AllSPR_q;

			end if;
		end if;
		
	end process;
	
	AllL1A_o	<=	AllL1A_q;
	AllECR_o	<=	AllECR_q;
	AllBCR_o	<=	AllBCR_q;
	AllCAL_o	<=	AllCAL_q;
	AllEXS_o	<=	AllEXS_q;
	AllTTS_o	<=	AllTTS_q;
	AllFER_o	<=	AllFER_q;
	AllSPR_o	<=	AllSPR_q;

	-- Added this to stretch signal for for bad LED driver 
	AllL1Afp_o	<=	AllL1A_q or ( AllL1A_q180 and not(short_fpsigs_en_i) );
	AllECRfp_o	<=	AllECR_q or ( AllECR_q180 and not(short_fpsigs_en_i) );
	AllBCRfp_o	<=	AllBCR_q or ( AllBCR_q180 and not(short_fpsigs_en_i) );
	AllCALfp_o	<=	AllCAL_q or ( AllCAL_q180 and not(short_fpsigs_en_i) );
	AllFERfp_o	<=	AllFER_q or ( AllFER_q180 and not(short_fpsigs_en_i) );
	AllSPRfp_o	<=	AllSPR_q or ( AllSPR_q180 and not(short_fpsigs_en_i) );
	
	
	

	----------------------------------------------------

	enSABCR2_o		   <=	reg_run_enables_i(15);
	enSAECR2_o		   <=	reg_run_enables_i(14);
	enSerTTS			   <=	reg_run_enables_i(10);
	enSerEXS			   <=	reg_run_enables_i( 9);
	ext_RodBUSYinen_o	<=	reg_run_enables_i( 8);
	enRodBusy_o			<=	reg_run_enables_i( 7); -- Enable oa_rodbusy in timbusy
	enTTCSPR			   <=	reg_run_enables_i( 6);
	enTTCFER			   <=	reg_run_enables_i( 5);
	enTTCCAL			   <=	reg_run_enables_i( 4);
	enTTCBCR			   <=	reg_run_enables_i( 3);
	enTTCECR			   <=	reg_run_enables_i( 2);
	enTTCL1A			   <=	reg_run_enables_i( 1);
	enttcclk_o	   	<=	reg_run_enables_i( 0);


	--	Reg_TestTTCbus	(was TTCbus) -- self-holding
	----------------------------------------------------
	process (clk)
	begin

		if rising_edge(clk) then
		
			if	(rst = '1') then
				RegTestTTCbus	<=	(others => '0');

			else
				if (Reg30 and db_wr) = '1' then
					RegTestTTCbus <= (others => '0');

				else	--	Self Holding Test Register
					RegTestTTCbus(0) <= L1A or RegTestTTCbus(0);
					RegTestTTCbus(1) <= ECR or RegTestTTCbus(1);
					RegTestTTCbus(2) <= BCR or RegTestTTCbus(2);
					RegTestTTCbus(3) <= CAL or RegTestTTCbus(3);
					RegTestTTCbus(4) <= EXS or RegTestTTCbus(4);
					RegTestTTCbus(5) <= TTS or RegTestTTCbus(5);
					RegTestTTCbus(6) <= FER or RegTestTTCbus(6);
					RegTestTTCbus(7) <= SPR or RegTestTTCbus(7);
		
	      	end if;
	      end if;
	   end if;
	end process;

	db <= RegTestTTCbus when ((Reg30 and db_rd) = '1') else (others => 'Z');


	--	reg_fv_tcount
	----------------------------------------------------
	process (clk)
	begin

		if rising_edge(clk) then
		
			if	(rst = '1') or (((ren_fv_tcounth_i or ren_fv_tcountl_i) and db_wr) = '1') then
				reg_fv_tcount	<=	(others => '0');
			
			elsif (alltrg_pre_fv = '1') and (ffveto_i = '1') then 
				reg_fv_tcount	<= reg_fv_tcount + '1';
	      	
	      end if;
	   end if;
	end process;

	db <= reg_fv_tcount(31 downto 16) when ((ren_fv_tcounth_i and db_rd) = '1') else (others => 'Z');
	db <= reg_fv_tcount(15 downto  0) when ((ren_fv_tcountl_i and db_rd) = '1') else (others => 'Z');

	
end rtl1;
