--
--
-- Generated by Matts TIM_Register_List.xls
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library TIM_fpga2;
use TIM_fpga2.f2_globals.all;


entity passive_regs is
   generic( 
      FIRMWARE_ID : integer := 0
   );
   port( 
      clk               : in     std_logic;
      rst               : in     std_logic;
      -----------------------------------------------------------------------------
      ren_i             : in     ren_array;
      reg_o             : out    d16_reg_array;
      rgw_o             : out    ren_array;
      -- Status bits in
      -----------------
      tim_id_i          : in     std_logic_vector (7 downto 0);
      timestamp_i       : in     std_logic_vector (31 downto 0);
      -- Control Bits Out
      -------------------
      fv_disable_o      : out    std_logic;
      -- Status Bits In (from spreadsheet)
      -------------------------------------------------------------------------
      -------------------------------------------------------------------------
      
-- status3
ttc_ready_i       : in std_logic;
qpll_present_i    : in std_logic;
qpll_error_i      : in std_logic;
qpll_locked_i     : in std_logic;
ttc_clk_ok_i      : in std_logic;

sa_clk_ok_i       : in std_logic;
ttc_clk_enok_i    : in std_logic;
ext_clk_enok_i    : in std_logic;
int_clk_enok_i    : in std_logic;




spare_in_i        : in std_logic;
spare_link_i      : in std_logic;


































-- busy_stat3
oarodbusy_raw_i   : in std_logic;




busy_bst_i        : in std_logic;
busy_tst_i        : in std_logic;
busy_dt_i         : in std_logic;
busy_clk_switch_i : in std_logic;



fv_veto_on_i      : in std_logic;
fv_enlink_stat_i  : in std_logic;



-- stat_latch



      -------------------------------------------------------------------------
      -------------------------------------------------------------------------
      db_rd_i           : in     std_logic;
      db_wr_i           : in     std_logic;
      db_io             : inout  std_logic_vector (15 downto 0)
   );

-- Declarations

end passive_regs ;


-- hds interface_end
architecture rtl of passive_regs is

	--------------------------------------------------------------------------
	-- Signals
	--------------------------------------------------------------------------

	--subtype 	slv16 is std_logic_vector(15 downto 0);
   --type 	  	slv16_nr is array (0 to (NREGISTERS-1)) of slv16;
      
   signal rd	: std_logic;
	signal en	: ren_array;
	signal reg	: d16_reg_array; 
   
	--------------------------------------------------------------------------
	-- Constants
	--------------------------------------------------------------------------
	
	

	-- Status signal inputs
	-----------------------------------------------------
	--	signal bp_laser_ilock_i	: std_logic;
	--	signal busy_test_i		: std_logic;     
	--	signal tim_ok_i			: std_logic;        
	--	signal extclkon_i			: std_logic;       
	--	signal samode_i			: std_logic;        
	--	signal runmode_i			: std_logic;       
	--	signal saclkon_i			: std_logic;       
	--	signal ttcclkon_i			: std_logic;      
	--	signal rcbusy_i			: std_logic;        
	--	signal sink_busy_i		: std_logic;     
	--	signal src_busy_i			: std_logic;      
	--	signal burst_busy_i		: std_logic;    
	--	signal busyout_i			: std_logic;       
	--	signal intbusy_i			: std_logic;       
	--	signal busyin_masked_i	: std_logic; 
	--	signal busyin_i			: std_logic;        



	
begin
   
	rd <= db_rd_i;
	en <= ren_i;
   
	------------------------------------------------------------------
   ------------------------------------------------------------------	
   -- WRITEs	
   ------------------------------------------------------------------	
   process (clk)	
   begin	
      if rising_edge(clk) then	
         if (rst = '1') then	
	
	reg(ENABLES)     <= conv_std_logic_vector(16#0000#, 16);
	reg(COMMAND)     <= conv_std_logic_vector(16#0000#, 16);
	reg(BURST)       <= conv_std_logic_vector(16#0000#, 16);
	reg(FREQUENCY)   <= conv_std_logic_vector(16#0000#, 16);
	reg(WINDOW)      <= conv_std_logic_vector(16#0000#, 16);
	reg(DELAYS)      <= conv_std_logic_vector(16#0000#, 16);
	
	
	
	
	
	
	reg(RUN_ENABLE)  <= conv_std_logic_vector(16#0000#, 16);
	reg(SEQ_CTL)     <= conv_std_logic_vector(16#0000#, 16);
	reg(SEQ_END)     <= conv_std_logic_vector(16#0000#, 16);
	reg(RB_MASK)     <= conv_std_logic_vector(16#0000#, 16);
	
	
	
	
	reg(TTC_SELECT)  <= conv_std_logic_vector(16#0000#, 16);
	
	
	
	
	
	
	
	
	
	
	
	
	reg(ENABLES3)    <= conv_std_logic_vector(16#0000#, 16);
	
	reg(COMMAND3)    <= conv_std_logic_vector(16#0000#, 16);
	
	
	
	reg(QPLL_CTL)    <= conv_std_logic_vector(16#B0#, 16);
	
	reg(BUSY_EN3)    <= conv_std_logic_vector(16#0000#, 16);
	
	
	
	
	
	
	
	
	
	
	reg(FV_VETOLEN)  <= conv_std_logic_vector(16#9C40#, 16);
	reg(FV_MATCH)    <= conv_std_logic_vector(16#000A#, 16);
	reg(FV_P_MIN)    <= conv_std_logic_vector(16#0215#, 16);
	reg(FV_P_MAX)    <= conv_std_logic_vector(16#0A6A#, 16);
	reg(FV_OFLOW)    <= conv_std_logic_vector(16#0ACE#, 16);
	reg(FV_DELTAT)   <= conv_std_logic_vector(16#0028#, 16);
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	reg(DEBUG_CTL)   <= conv_std_logic_vector(16#0000#, 16);
	
	
         elsif (db_wr_i = '1') then	
	
	if(en(ENABLES) = '1') then reg(ENABLES) <= db_io; end if;
	if(en(COMMAND) = '1') then reg(COMMAND) <= db_io; end if;
	if(en(BURST) = '1') then reg(BURST) <= db_io; end if;
	if(en(FREQUENCY) = '1') then reg(FREQUENCY) <= db_io; end if;
	if(en(WINDOW) = '1') then reg(WINDOW) <= db_io; end if;
	if(en(DELAYS) = '1') then reg(DELAYS) <= db_io; end if;
	--
	--
	--
	--
	--
	--
	if(en(RUN_ENABLE) = '1') then reg(RUN_ENABLE) <= db_io; end if;
	if(en(SEQ_CTL) = '1') then reg(SEQ_CTL) <= db_io; end if;
	if(en(SEQ_END) = '1') then reg(SEQ_END) <= db_io; end if;
	if(en(RB_MASK) = '1') then reg(RB_MASK) <= db_io; end if;
	--
	--
	--
	--
	if(en(TTC_SELECT) = '1') then reg(TTC_SELECT) <= db_io; end if;
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	if(en(ENABLES3) = '1') then reg(ENABLES3) <= db_io; end if;
	--
	if(en(COMMAND3) = '1') then reg(COMMAND3) <= db_io; end if;
	--
	--
	--
	if(en(QPLL_CTL) = '1') then reg(QPLL_CTL) <= db_io; end if;
	--
	if(en(BUSY_EN3) = '1') then reg(BUSY_EN3) <= db_io; end if;
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	if(en(FV_VETOLEN) = '1') then reg(FV_VETOLEN) <= db_io; end if;
	if(en(FV_MATCH) = '1') then reg(FV_MATCH) <= db_io; end if;
	if(en(FV_P_MIN) = '1') then reg(FV_P_MIN) <= db_io; end if;
	if(en(FV_P_MAX) = '1') then reg(FV_P_MAX) <= db_io; end if;
	if(en(FV_OFLOW) = '1') then reg(FV_OFLOW) <= db_io; end if;
	if(en(FV_DELTAT) = '1') then reg(FV_DELTAT) <= db_io; end if;
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	if(en(DEBUG_CTL) = '1') then reg(DEBUG_CTL) <= db_io; end if;
	--

         end if;	
      end if;	
   end process;	
	
   ------------------------------------------------------------------	
   -- READs	
   ------------------------------------------------------------------	
   db_io <=	
	reg(ENABLES) when ((rd and en(ENABLES))= '1') else
	reg(COMMAND) when ((rd and en(COMMAND))= '1') else
	reg(BURST) when ((rd and en(BURST))= '1') else
	reg(FREQUENCY) when ((rd and en(FREQUENCY))= '1') else
	reg(WINDOW) when ((rd and en(WINDOW))= '1') else
	reg(DELAYS) when ((rd and en(DELAYS))= '1') else
	--
	--
	--
	--
	--
	--
	reg(RUN_ENABLE) when ((rd and en(RUN_ENABLE))= '1') else
	reg(SEQ_CTL) when ((rd and en(SEQ_CTL))= '1') else
	reg(SEQ_END) when ((rd and en(SEQ_END))= '1') else
	reg(RB_MASK) when ((rd and en(RB_MASK))= '1') else
	--
	--
	--
	--
	reg(TTC_SELECT) when ((rd and en(TTC_SELECT))= '1') else
	--
	--
	--
	--
	reg(TIM_ID) when ((rd and en(TIM_ID))= '1') else
	--
	--
	--
	--
	--
	--
	--
	reg(ENABLES3) when ((rd and en(ENABLES3))= '1') else
	--
	reg(COMMAND3) when ((rd and en(COMMAND3))= '1') else
	--
	reg(STATUS3) when ((rd and en(STATUS3))= '1') else
	--
	reg(QPLL_CTL) when ((rd and en(QPLL_CTL))= '1') else
	--
	reg(BUSY_EN3) when ((rd and en(BUSY_EN3))= '1') else
	--
	reg(BUSY_STAT3) when ((rd and en(BUSY_STAT3))= '1') else
	--
	--
	--
	--
	--
	--
	--
	--
	reg(FV_VETOLEN) when ((rd and en(FV_VETOLEN))= '1') else
	reg(FV_MATCH) when ((rd and en(FV_MATCH))= '1') else
	reg(FV_P_MIN) when ((rd and en(FV_P_MIN))= '1') else
	reg(FV_P_MAX) when ((rd and en(FV_P_MAX))= '1') else
	reg(FV_OFLOW) when ((rd and en(FV_OFLOW))= '1') else
	reg(FV_DELTAT) when ((rd and en(FV_DELTAT))= '1') else
	--
	--
	--
	--
	--
	--
	--
	--
	reg(TSTAMPL) when ((rd and en(TSTAMPL))= '1') else
	reg(TSTAMPH) when ((rd and en(TSTAMPH))= '1') else
	--
	--
	--
	--
	--
	--
	--
	--
	--
	--
	reg(DEBUG_CTL) when ((rd and en(DEBUG_CTL))= '1') else
	--
	
	(others => 'Z'); 
   ------------------------------------------------------------------	

   ------------------------------------------------------------------	
   ------------------------------------------------------------------	
	

   -------------------------------------------------------------------------   
	-- Local Mappings
	-------------------------------------
	
	
	-- Status Type Register Assignment
	----------------------------------
	--	reg(STATUS)(15) <= bp_laser_ilock_i;
	--	reg(STATUS)(14) <= busy_test_i;
	--	reg(STATUS)(13) <= tim_ok_i;
	--	reg(STATUS)(12) <= extclkon_i
	--	reg(STATUS)(11) <= samode_i;
	--	reg(STATUS)(10) <= runmode_i;
	--	reg(STATUS)( 9) <= saclkon_i;
	--	reg(STATUS)( 8) <= ttcclkon_i;
	--	reg(STATUS)( 7) <= rcbusy_i;
	--	reg(STATUS)( 6) <= sink_busy_i;
	--	reg(STATUS)( 5) <= src_busy_i;
	--	reg(STATUS)( 4) <= burst_busy_i;
	--	reg(STATUS)( 3) <= busyout_i;
	--	reg(STATUS)( 2) <= intbusy_i;
	--	reg(STATUS)( 1) <= busyin_masked_i;
	--	reg(STATUS)( 0) <= busyin_i;


	fv_disable_o <= reg(DEBUG_CTL)(8);
   	
   reg(TIM_ID) <= (conv_std_logic_vector(FIRMWARE_ID, 8) & tim_ID_i);

   reg(TSTAMPL) <= timestamp_i(15 downto  0);
   reg(TSTAMPH) <= timestamp_i(31 downto 16);
   
   
   -- From Spreadsheet 'VHDL Assign'
   ------------------------------------------------------------------	
   ------------------------------------------------------------------	
	
reg(STATUS3)(0)    <= ttc_ready_i;
reg(STATUS3)(1)    <= qpll_present_i;
reg(STATUS3)(2)    <= qpll_error_i;
reg(STATUS3)(3)    <= qpll_locked_i;
reg(STATUS3)(4)    <= ttc_clk_ok_i;

reg(STATUS3)(6)    <= sa_clk_ok_i;
reg(STATUS3)(7)    <= ttc_clk_enok_i;
reg(STATUS3)(8)    <= ext_clk_enok_i;
reg(STATUS3)(9)    <= int_clk_enok_i;




reg(STATUS3)(14)    <= spare_in_i;
reg(STATUS3)(15)    <= spare_link_i;



































reg(BUSY_STAT3)(0) <= oarodbusy_raw_i;




reg(BUSY_STAT3)(5) <= busy_bst_i;
reg(BUSY_STAT3)(6) <= busy_tst_i;
reg(BUSY_STAT3)(7) <= busy_dt_i;
reg(BUSY_STAT3)(8) <= busy_clk_switch_i;



reg(BUSY_STAT3)(12) <= fv_veto_on_i;
reg(BUSY_STAT3)(13) <= fv_enlink_stat_i;


   ------------------------------------------------------------------	
   ------------------------------------------------------------------	

 	
 	
 	-- Outputs
 	---------------------------------------------------------------------------------
 	rgw_o <= ren_i when (db_wr_i = '1') else (others => '0');
 	reg_o <= reg;
				   
end rtl;	