-- hds header_start
--
-- VHDL Architecture TIM_fpga2.db_interface.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:21:37 01/14/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity passive_regs is
   generic( 
      FIRMWARE_ID : integer := 0
   );
   port( 
      clk                : in     std_logic;
      rst                : in     std_logic;
      db_rd_i            : in     std_logic;
      db_wr_i            : in     std_logic;
      reg_en_i           : in     std_logic_vector (63 downto 0);
      db_io              : inout  std_logic_vector (15 downto 0);


      -- All TIM Registers
      -----------------------------------------------------------

      reg_enables_o       : out  std_logic_vector (15 downto 0); --  0/0x00 P
      reg_command_o       : out  std_logic_vector (15 downto 0); --  1/0x02 P
      reg_burstcount_o    : out  std_logic_vector (15 downto 0); --  2/0x04 P
      reg_frequency_o     : out  std_logic_vector (15 downto 0); --  3/0x06 P
      reg_window_o        : out  std_logic_vector (15 downto 0); --  4/0x08 P
      reg_delay_o         : out  std_logic_vector (15 downto 0); --  5/0x0A P
	--	reg_status			  : 		std_logic_vector (15 downto 0); --  6/0x0C S
	--	reg_fifo				  : 		std_logic_vector (15 downto 0); --  7/0x0E S
	--	reg_trigid_hi		  : 		std_logic_vector (15 downto 0); --  8/0x10 A
	--	reg_trigid_lo		  : 		std_logic_vector (15 downto 0); --  9/0x12 A
	-- reg_trig_bunch		  : 		std_logic_vector (15 downto 0); -- 10/0x14 A
	--	reg_trig_type		  : 		std_logic_vector (15 downto 0); -- 11/0x16 AP
      reg_run_enables_o   : out  std_logic_vector (15 downto 0); -- 12/0x18 AP
      reg_sequencer_o     : out  std_logic_vector (15 downto 0); -- 13/0x1A P
      reg_seq_end_o       : out  std_logic_vector (15 downto 0); -- 14/0x1C P
      reg_rb_mask_o       : out  std_logic_vector (15 downto 0); -- 15/0x1E P
	--	reg_rb_stat			  : in	std_logic_vector (15 downto 0); -- 16/0x20 S
	--	reg_rb_latch 		  : in	std_logic_vector (15 downto 0); -- 17/0x22 SZ
	--	reg_rb_mon 			  : in	std_logic_vector (15 downto 0); -- 18/0x24 SZ
	--	reg_ttc_data 		  : in	std_logic_vector (15 downto 0); -- 19/0x26 SZ
      reg_ttc_select_o	  : out  std_logic_vector (15 downto 0); -- 20/0x28 P
	--	reg_ttc_bcid		  :     	std_logic_vector (15 downto 0); -- 21/0x2A SZ
	--	reg_ttcrx_access	  :     	std_logic_vector (15 downto 0); -- 22/0x2C AP
	--	reg_ttc_status		  :     	std_logic_vector (15 downto 0); -- 23/0x2E AP
	-- reg_tim_output		  : in	std_logic_vector (15 downto 0); -- 24/0x30 SZ
	-- reg_tim_id			  : 		std_logic_vector (15 downto 0); -- 25/0x32 S
	-- reg_					  : in	std_logic_vector (15 downto 0); -- 26/0x34
	-- reg_					  : in	std_logic_vector (15 downto 0); -- 27/0x36
	-- reg_					  : in	std_logic_vector (15 downto 0); -- 28/0x38
	-- reg_					  : in	std_logic_vector (15 downto 0); -- 29/0x3A
	-- reg_					  : in	std_logic_vector (15 downto 0); -- 30/0x3C
	-- reg_					  : in	std_logic_vector (15 downto 0); -- 31/0x3E
	   reg_fftv_p_min_o    : out  std_logic_vector (15 downto 0); -- 32/0x40 P
	   reg_fftv_p_max_o    : out  std_logic_vector (15 downto 0); -- 33/0x42 P
	   reg_fftv_oflow_o    : out  std_logic_vector (15 downto 0); -- 34/0x44 P
	   reg_fftv_deltat_o   : out  std_logic_vector (15 downto 0); -- 35/0x46 P
	   reg_fftv_vetolen_o  : out  std_logic_vector (15 downto 0); -- 36/0x48 P
	   reg_fftv_match_o    : out  std_logic_vector (15 downto 0); -- 37/0x4A P
   -- reg_fftv_count_hi	  : in	std_logic_vector (15 downto 0); -- 38/0x4C S
   -- reg_fftv_count_lo	  : in	std_logic_vector (15 downto 0); -- 39/0x4E S
   -- reg_					  : in	std_logic_vector (15 downto 0); -- 40/0x50
   -- reg_					  : in	std_logic_vector (15 downto 0); -- 41/0x52
   -- reg_					  : in	std_logic_vector (15 downto 0); -- 42/0x54
   -- reg_					  : in	std_logic_vector (15 downto 0); -- 43/0x56
   -- reg_seq_src_count_i : in	std_logic_vector (15 downto 0); -- 44/0x58 S
   -- reg_seq_sink_count_i: in	std_logic_vector (15 downto 0); -- 45/0x5A S
   -- reg_reg_busy count_lo: in	std_logic_vector (15 downto 0); -- 46/0x5C SL
   -- reg_reg_busy_count_hi: in	std_logic_vector (15 downto 0); -- 47/0x5E SL
   -- reg_reg_busy_count_ex: out std_logic_vector (15 downto 0); -- 48/0x60
   -- reg_					  :		std_logic_vector (15 downto 0); -- 49/0x62
   -- reg_					  : in	std_logic_vector (15 downto 0); -- 50/0x64
   -- reg_					  : in	std_logic_vector (15 downto 0); -- 51/0x66
   -- reg_					  : in	std_logic_vector (15 downto 0); -- 52/0x68
   -- reg_					  : in	std_logic_vector (15 downto 0); -- 53/0x6A
   -- reg_					  : in	std_logic_vector (15 downto 0); -- 54/0x6C
   -- reg_					  : in	std_logic_vector (15 downto 0); -- 55/0x6E
   -- reg_                : out  std_logic_vector (15 downto 0); -- 56/0x70
   -- reg_seq_src_count_i : in	std_logic_vector (15 downto 0); -- 57/0x72
   -- reg_seq_sink_count_i: in	std_logic_vector (15 downto 0); -- 58/0x74
   -- reg_timestamp_lo	  : in	std_logic_vector (15 downto 0); -- 59/0x76
   	reg_timestamp_hi	  : in	std_logic_vector (15 downto 0); -- 60/0x78 P 
   -- reg_test				  : in	std_logic_vector (15 downto 0); -- 61/0x7A PL
   -- reg_test_status	  : in	std_logic_vector (15 downto 0); -- 62/0x7C SL
   -- reg_					  : in	std_logic_vector (15 downto 0); -- 63/0x7E
   
   
   
   
      tim_id_i            : in   std_logic_vector (7 downto 0);
      timestamp_i         : in   std_logic_vector (31 downto 0);
      fftv_enable_i       : in   std_logic;
      f2_spare_link_i     : in   std_logic
   );

-- Declarations

end passive_regs ;


-- hds interface_end
architecture rtl of passive_regs is

	subtype 	slv16 is std_logic_vector(15 downto 0);
   
   type 	  	slv16_64 is array (0 to 63) of slv16;
   signal  	reg 				: slv16_64; 
   	
	--------------------------------------------------
	constant ENABLES  		: integer :=  0; -- 0x00 P  
  	constant COMMAND 			: integer :=  1; -- 0x02 P  
  	constant BURSTCOUNT 		: integer :=  2; -- 0x04 P  
  	constant FREQUENCY   	: integer :=  3; -- 0x06 P  
  	constant WINDOW  			: integer :=  4; -- 0x08 P  
  	constant DELAY   			: integer :=  5; -- 0x0A P  
	constant STATUS			: integer :=  6; -- 0x0C S	
	constant FIFO				: integer :=  7; -- 0x0E S	
	constant TRIGID_HI		: integer :=  8; -- 0x10 A	
	constant TRIGID_LO		: integer :=  9; -- 0x12 A	
	constant TRIG_BUNCH		: integer := 10; -- 0x14 A	
	constant TRIG_TYPE		: integer := 11; -- 0x16 AP
	constant RUN_ENABLES		: integer := 12; -- 0x18 P
	constant SEQUENCER		: integer := 13; -- 0x1A P 
	constant SEQ_END			: integer := 14; -- 0x1C P 
	constant RB_MASK			: integer := 15; -- 0x1E P 
	constant RB_STAT			: integer := 16; -- 0x20 S	
 	constant RB_LATCH 		: integer := 17; -- 0x22 SZ
 	constant RB_MON 			: integer := 18; -- 0x24 SZ
 	constant TTC_DATA		   : integer := 19; -- 0x26 SZ
	constant TTC_SELECT 		: integer := 20; -- 0x28 P 	
	constant TTC_BCID			: integer := 21; -- 0x2A SZ
	constant TTCRX_ACCESS	: integer := 22; -- 0x2C AP
	constant TTC_STATUS		: integer := 23; -- 0x2E AP
 	constant TIM_OUTPUT		: integer := 24; -- 0x30 SZ
 	constant TIM_ID			: integer := 25; -- 0x32 S	
--	constant 					: integer := 26; -- 0x34 	
--	constant 					: integer := 27; -- 0x36 	
--	constant 					: integer := 28; -- 0x38 	
--	constant 					: integer := 29; -- 0x3A 	
--	constant 					: integer := 30; -- 0x3C 	
--	constant 					: integer := 31; -- 0x3E 	
	constant FFTV_P_MIN		: integer := 32; -- 0x40 P	
	constant FFTV_P_MAX		: integer := 33; -- 0x42 P	
	constant FFTV_OFLOW		: integer := 34; -- 0x44 P		
	constant FFTV_DELTAT		: integer := 35; -- 0x46 P	
	constant FFTV_VETOLEN	: integer := 36; -- 0x48 P	 
	constant FFTV_MATCH		: integer := 37; -- 0x4A P	
   constant FFTV_COUNT_HI	: integer := 38; -- 0x4C S	
   constant FFTV_COUNT_LO	: integer := 39; -- 0x4E S	
--	constant 					: integer := 40; -- 0x50 	
--	constant 					: integer := 41; -- 0x52 	
--	constant 					: integer := 42; -- 0x54 	
--	constant 					: integer := 43; -- 0x56 	
	constant SEQ_SRC_COUNT	: integer := 44; -- 0x58 S		
	constant SEQ_SINK_COUNT	: integer := 45; -- 0x5A S	
	constant TIMESTAMP_LO	: integer := 46; -- 0x5C SL
	constant TIMESTAMP_HI	: integer := 47; -- 0x5E SL
--	constant 					: integer := 48; -- 0x60   
--	constant 					: integer := 49; -- 0x62 	
--	constant 					: integer := 50; -- 0x64 	
--	constant 					: integer := 51; -- 0x66 	
--	constant 					: integer := 52; -- 0x68 	
--	constant 					: integer := 53; -- 0x6A 	
--	constant 					: integer := 54; -- 0x6C 	
--	constant 					: integer := 55; -- 0x6E 	
	constant DEBUGBUS			: integer := 56; -- 0x70 P	
	constant TEST				: integer := 57; -- 0x72 PL
	constant DUMMY_STAT		: integer := 58; -- 0x74 SL
--	constant 					: integer := 59; -- 0x76 	
--	constant 					: integer := 60; -- 0x78 	
--	constant 					: integer := 61; -- 0x7A 	
--	constant 					: integer := 62; -- 0x7C 	
--	constant 					: integer := 63; -- 0x7E 	
---------------------------------------------------

	signal rd	: std_logic;
	signal en	: std_logic_vector(63 downto 0);
	
	

	-- Status signal inputs
	-----------------------------------------------------
	signal bp_laser_ilock_i	: std_logic;
	signal busy_test_i		: std_logic;     
	signal tim_ok_i			: std_logic;        
	signal extclkon_i			: std_logic;       
	signal samode_i			: std_logic;        
	signal runmode_i			: std_logic;       
	signal saclkon_i			: std_logic;       
	signal ttcclkon_i			: std_logic;      
	signal rcbusy_i			: std_logic;        
	signal sink_busy_i		: std_logic;     
	signal src_busy_i			: std_logic;      
	signal burst_busy_i		: std_logic;    
	signal busyout_i			: std_logic;       
	signal intbusy_i			: std_logic;       
	signal busyin_masked_i	: std_logic; 
	signal busyin_i			: std_logic;        



	
begin
   
	rd <= db_rd_i;
	en <= reg_en_i;
   
   -- WRITEs
   -------------------------------
   process (clk)
   begin
   	if rising_edge(clk) then
      	if (rst = '1') then
      		reg(ENABLES  		) <= (others => '0'); --  0/0x00 P 
      	   reg(COMMAND 		) <= (others => '0'); --  1/0x02 P 
      	   reg(BURSTCOUNT 	) <= (others => '0'); --  2/0x04 P 
      	   reg(FREQUENCY   	) <= (others => '0'); --  3/0x06 P 
      	   reg(WINDOW  		) <= (others => '0'); --  4/0x08 P 
      	   reg(DELAY   		) <= (others => '0'); --  5/0x0A P 
      	--	reg(STATUS			) <= (others => '0'); --  6/0x0C S	
      	--	reg(FIFO				) <= (others => '0'); --  7/0x0E S	
      	--	reg(TRIGID_HI		) <= (others => '0'); --  8/0x10 A	
      	--	reg(TRIGID_LO		) <= (others => '0'); --  9/0x12 A	
      	-- reg(TRIG_BUNCH		) <= (others => '0'); -- 10/0x14 A	
      	--	reg(TRIG_TYPE		) <= (others => '0'); -- 11/0x16 AP
      	   reg(RUN_ENABLES	) <= (others => '0'); -- 12/0x18 P
      	   reg(SEQUENCER		) <= (others => '0'); -- 13/0x1A P 
      	   reg(SEQ_END			) <= (others => '0'); -- 14/0x1C P 
      	   reg(RB_MASK			) <= (others => '0'); -- 15/0x1E P 
      	--	reg(RB_STAT			) <= (others => '0'); -- 16/0x20 S	
      	--	reg(RB_LATCH 		) <= (others => '0'); -- 17/0x22 SZ
      	--	reg(RB_MON 			) <= (others => '0'); -- 18/0x24 SZ
      	--	reg(TTC_DATA		) <= (others => '0'); -- 19/0x26 SZ
      		reg(TTC_SELECT 	) <= (others => '0'); -- 20/0x28 P 
      	--	reg(TTC_BCID		) <= (others => '0'); -- 21/0x2A SZ
      	--	reg(TTCRX_ACCESS	) <= (others => '0'); -- 22/0x2C AP
      	--	reg(TTC_STATUS		) <= (others => '0'); -- 23/0x2E AP
      	-- reg(TIM_OUTPUT		) <= (others => '0'); -- 24/0x30 SZ
      	-- reg(TIM_ID			) <= (others => '0'); -- 25/0x32 S	
      	-- reg(					) <= (others => '0'); -- 26/0x34 	
      	-- reg(					) <= (others => '0'); -- 27/0x36 	
      	-- reg(					) <= (others => '0'); -- 28/0x38 	
      	-- reg(					) <= (others => '0'); -- 29/0x3A 	
      	-- reg(					) <= (others => '0'); -- 30/0x3C 	
      	-- reg(					) <= (others => '0'); -- 31/0x3E 	
      	-- reg(FFTV_P_MIN		) <= (others => '0'); -- 32/0x40 P	
      	-- reg(FFTV_P_MAX		) <= (others => '0'); -- 33/0x42 P	
      	-- reg(FFTV_OFLOW		) <= (others => '0'); -- 34/0x44 P	
      	-- reg(FFTV_DELTAT	) <= (others => '0'); -- 35/0x46 P	
      	-- reg(FFTV_VETOLEN	) <= (others => '0'); -- 36/0x48 P	
      	-- reg(FFTV_MATCH		) <= (others => '0'); -- 37/0x4A P	
      	-- reg(FFTV_COUNT_HI	) <= (others => '0'); -- 38/0x4C S	
	     	--	reg(FFTV_COUNT_LO	) <= (others => '0'); -- 39/0x4E S	
	     	--	reg(					) <= (others => '0'); -- 40/0x50 	
	     	--	reg(					) <= (others => '0'); -- 41/0x52 	
	     	--	reg(					) <= (others => '0'); -- 42/0x54 	
	     	--	reg(					) <= (others => '0'); -- 43/0x56 	
	     	--	reg(SEQ_SRC_COUNT	) <= (others => '0'); -- 44/0x58 S	
	     	--	reg(SEQ_SINK_COUNT) <= (others => '0'); -- 45/0x5A S	
	     	--	reg(TIMESTAMP_LO	) <= (others => '0'); -- 46/0x5C SL
	     	--	reg(TIMESTAMP_HI	) <= (others => '0'); -- 47/0x5E SL
	     	--	reg(					) <= (others => '0'); -- 48/0x60   
	     	--	reg(					) <= (others => '0'); -- 49/0x62 	
	     	--	reg(					) <= (others => '0'); -- 50/0x64 	
	     	--	reg(					) <= (others => '0'); -- 51/0x66 	
	     	--	reg(					) <= (others => '0'); -- 52/0x68 	
	     	--	reg(					) <= (others => '0'); -- 53/0x6A 	
	     	--	reg(					) <= (others => '0'); -- 54/0x6C 	
	     	--	reg(					) <= (others => '0'); -- 55/0x6E 	
	     	--	reg(DEBUGBUS		) <= (others => '0'); -- 56/0x70 P	
	     	--	reg(TEST				) <= (others => '0'); -- 57/0x72 PL
	     	--	reg(DUMMY_STAT		) <= (others => '0'); -- 58/0x74 SL
	     	--	reg(					) <= (others => '0'); -- 59/0x76 	
	     	--	reg(					) <= (others => '0'); -- 60/0x78 	
      	--	reg(					) <= (others => '0'); -- 61/0x7A 	
      	--	reg(					) <= (others => '0'); -- 62/0x7C 	
	     	--	reg(					) <= (others => '0'); -- 63/0x7E 	
      		
      	
      	elsif (db_wr_i = '1') then
		      if (en(ENABLES  		) = '1') then reg(ENABLES  		) <= db_io; end if;  --  0/0x00 P  
 		      if (en(COMMAND 		) = '1') then reg(COMMAND 			) <= db_io; end if;  --  1/0x02 P  
 		      if (en(BURSTCOUNT 	) = '1') then reg(BURSTCOUNT 		) <= db_io; end if;  --  2/0x04 P  
 		      if (en(FREQUENCY   	) = '1') then reg(FREQUENCY   	) <= db_io; end if;  --  3/0x06 P  
 		      if (en(WINDOW  		) = '1') then reg(WINDOW  			) <= db_io; end if;  --  4/0x08 P  
 		      if (en(DELAY   		) = '1') then reg(DELAY   			) <= db_io; end if;  --  5/0x0A P  
		   --	if (en(STATUS			) = '1') then reg(STATUS			) <= db_io; end if;  --  6/0x0C S	
		   --	if (en(FIFO				) = '1') then reg(FIFO				) <= db_io; end if;  --  7/0x0E S	
		   --	if (en(TRIGID_HI		) = '1') then reg(TRIGID_HI		) <= db_io; end if;  --  8/0x10 A	
		   --	if (en(TRIGID_LO		) = '1') then reg(TRIGID_LO		) <= db_io; end if;  --  9/0x12 A	
		   -- if (en(TRIG_BUNCH		) = '1') then reg(TRIG_BUNCH		) <= db_io; end if;  -- 10/0x14 A	
		   --	if (en(TRIG_TYPE		) = '1') then reg(TRIG_TYPE		) <= db_io; end if;  -- 11/0x16 AP 
 		      if (en(RUN_ENABLES	) = '1') then reg(RUN_ENABLES		) <= db_io; end if;  -- 12/0x18 P 
 		      if (en(SEQUENCER		) = '1') then reg(SEQUENCER		) <= db_io; end if;  -- 13/0x1A P  
 		      if (en(SEQ_END			) = '1') then reg(SEQ_END			) <= db_io; end if;  -- 14/0x1C P  
 		      if (en(RB_MASK			) = '1') then reg(RB_MASK			) <= db_io; end if;  -- 15/0x1E P  
		   --	if (en(RB_STAT			) = '1') then reg(RB_STAT			) <= db_io; end if;  -- 16/0x20 S	
 		   --	if (en(RB_LATCH 		) = '1') then reg(RB_LATCH 		) <= db_io; end if;  -- 17/0x22 SZ 
 		   --	if (en(RB_MON 			) = '1') then reg(RB_MON 			) <= db_io; end if;  -- 18/0x24 SZ 
 		   --	if (en(TTC_DATA		) = '1') then reg(TTC_DATA			) <= db_io; end if;  -- 19/0x26 SZ 
		   	if (en(TTC_SELECT 	) = '1') then reg(TTC_SELECT 		) <= db_io; end if;  -- 20/0x28 P  
		   --	if (en(TTC_BCID		) = '1') then reg(TTC_BCID			) <= db_io; end if;  -- 21/0x2A SZ 
		   --	if (en(TTCRX_ACCESS	) = '1') then reg(TTCRX_ACCESS	) <= db_io; end if;  -- 22/0x2C AP 
		   --	if (en(TTC_STATUS		) = '1') then reg(TTC_STATUS		) <= db_io; end if;  -- 23/0x2E AP 
 		   -- if (en(TIM_OUTPUT		) = '1') then reg(TIM_OUTPUT		) <= db_io; end if;  -- 24/0x30 SZ 
		   -- if (en(TIM_ID			) = '1') then reg(TIM_ID			) <= db_io; end if;  -- 25/0x32 S	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 26/0x34 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 27/0x36 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 28/0x38 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 29/0x3A 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 30/0x3C 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 31/0x3E 	
		   	if (en(FFTV_P_MIN		) = '1') then reg(FFTV_P_MIN		) <= db_io; end if;  -- 32/0x40 P	
		    	if (en(FFTV_P_MAX		) = '1') then reg(FFTV_P_MAX		) <= db_io; end if;  -- 33/0x42 P	
		    	if (en(FFTV_OFLOW		) = '1') then reg(FFTV_OFLOW		) <= db_io; end if;  -- 34/0x44 P	
		    	if (en(FFTV_DELTAT	) = '1') then reg(FFTV_DELTAT		) <= db_io; end if;  -- 35/0x46 P	
		    	if (en(FFTV_VETOLEN	) = '1') then reg(FFTV_VETOLEN	) <= db_io; end if;  -- 36/0x48 P	
		    	if (en(FFTV_MATCH		) = '1') then reg(FFTV_MATCH		) <= db_io; end if;  -- 37/0x4A P	
		   --	if (en(FFTV_COUNT_HI	) = '1') then reg(FFTV_COUNT_HI	) <= db_io; end if;  -- 38/0x4C S	
		   --	if (en(FFTV_COUNT_LO	) = '1') then reg(FFTV_COUNT_LO	) <= db_io; end if;  -- 39/0x4E S	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 40/0x50 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 41/0x52 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 42/0x54 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 43/0x56 	
		   -- if (en(SEQ_SRC_COUNT	) = '1') then reg(SEQ_SRC_COUNT	) <= db_io; end if;  -- 44/0x58 S	
		   -- if (en(SEQ_SINK_COUNT) = '1') then reg(SEQ_SINK_COUNT	) <= db_io; end if;  -- 45/0x5A S	
		   -- if (en(TIMESTAMP_LO	) = '1') then reg(TIMESTAMP_LO	) <= db_io; end if;  -- 46/0x5C SL 
		   -- if (en(TIMESTAMP_HI	) = '1') then reg(TIMESTAMP_HI	) <= db_io; end if;  -- 47/0x5E SL 
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 48/0x60    
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 49/0x62 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 50/0x64 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 51/0x66 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 52/0x68 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 53/0x6A 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 54/0x6C 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 55/0x6E 	
		   -- if (en(DEBUGBUS		) = '1') then reg(DEBUGBUS			) <= db_io; end if;  -- 56/0x70 P	
		   -- if (en(TEST				) = '1') then reg(TEST				) <= db_io; end if;  -- 57/0x72 PL 
		   -- if (en(DUMMY_STAT		) = '1') then reg(DUMMY_STAT		) <= db_io; end if;  -- 58/0x74 SL 
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 59/0x76 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 60/0x78 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 61/0x7A 	
		   -- if (en(					) = '1') then reg(					) <= db_io; end if;  -- 62/0x7C 	
			--	if (en(					) = '1') then reg(					) <= db_io; end if;  -- 63/0x7E 	

      	end if;
      end if;
   end process;
 

	-- Databus Assignment
	--------------------------------------------------------------------------
	db_io	<=
		reg(ENABLES  		) when ((rd and en(ENABLES  		)) = '1') else  --  0/0x00 P 
		reg(COMMAND 		) when ((rd and en(COMMAND 		)) = '1') else  --  1/0x02 P 
		reg(BURSTCOUNT 	) when ((rd and en(BURSTCOUNT 	)) = '1') else  --  2/0x04 P 
		reg(FREQUENCY   	) when ((rd and en(FREQUENCY   	)) = '1') else  --  3/0x06 P 
		reg(WINDOW  		) when ((rd and en(WINDOW  		)) = '1') else  --  4/0x08 P 
		reg(DELAY   		) when ((rd and en(DELAY   		)) = '1') else  --  5/0x0A P 
--		reg(STATUS			) when ((rd and en(STATUS			)) = '1') else  --  6/0x0C S	
--		reg(FIFO				) when ((rd and en(FIFO				)) = '1') else  --  7/0x0E S	
--		reg(TRIGID_HI		) when ((rd and en(TRIGID_HI		)) = '1') else  --  8/0x10 A	
--		reg(TRIGID_LO		) when ((rd and en(TRIGID_LO		)) = '1') else  --  9/0x12 A	
--		reg(TRIG_BUNCH		) when ((rd and en(TRIG_BUNCH		)) = '1') else  -- 10/0x14 A	
--		reg(TRIG_TYPE		) when ((rd and en(TRIG_TYPE		)) = '1') else  -- 11/0x16 AP
		reg(RUN_ENABLES	) when ((rd and en(RUN_ENABLES	)) = '1') else  -- 12/0x18 P
		reg(SEQUENCER		) when ((rd and en(SEQUENCER		)) = '1') else  -- 13/0x1A P 
		reg(SEQ_END			) when ((rd and en(SEQ_END			)) = '1') else  -- 14/0x1C P 
		reg(RB_MASK			) when ((rd and en(RB_MASK			)) = '1') else  -- 15/0x1E P 
--		reg(RB_STAT			) when ((rd and en(RB_STAT			)) = '1') else  -- 16/0x20 S	
--		reg(RB_LATCH 		) when ((rd and en(RB_LATCH 		)) = '1') else  -- 17/0x22 SZ
--		reg(RB_MON 			) when ((rd and en(RB_MON 			)) = '1') else  -- 18/0x24 SZ
--		reg(TTC_DATA		) when ((rd and en(TTC_DATA		)) = '1') else  -- 19/0x26 SZ
		reg(TTC_SELECT 	) when ((rd and en(TTC_SELECT 	)) = '1') else  -- 20/0x28 P 
--		reg(TTC_BCID		) when ((rd and en(TTC_BCID		)) = '1') else  -- 21/0x2A SZ
--		reg(TTCRX_ACCESS	) when ((rd and en(TTCRX_ACCESS	)) = '1') else  -- 22/0x2C AP
--		reg(TTC_STATUS		) when ((rd and en(TTC_STATUS		)) = '1') else  -- 23/0x2E AP
--		reg(TIM_OUTPUT		) when ((rd and en(TIM_OUTPUT		)) = '1') else  -- 24/0x30 SZ
		reg(TIM_ID			) when ((rd and en(TIM_ID			)) = '1') else  -- 25/0x32 S	
--		reg(					) when ((rd and en(					)) = '1') else  -- 26/0x34 	
--		reg(					) when ((rd and en(					)) = '1') else  -- 27/0x36 	
--		reg(					) when ((rd and en(					)) = '1') else  -- 28/0x38 	
--		reg(					) when ((rd and en(					)) = '1') else  -- 29/0x3A 	
--		reg(					) when ((rd and en(					)) = '1') else  -- 30/0x3C 	
--		reg(					) when ((rd and en(					)) = '1') else  -- 31/0x3E 	
		reg(FFTV_P_MIN		) when ((rd and en(FFTV_P_MIN		)) = '1') else  -- 32/0x40 P	
		reg(FFTV_P_MAX		) when ((rd and en(FFTV_P_MAX		)) = '1') else  -- 33/0x42 P	
		reg(FFTV_OFLOW		) when ((rd and en(FFTV_OFLOW		)) = '1') else  -- 34/0x44 P	
		reg(FFTV_DELTAT	) when ((rd and en(FFTV_DELTAT	)) = '1') else  -- 35/0x46 P	
		reg(FFTV_VETOLEN	) when ((rd and en(FFTV_VETOLEN	)) = '1') else  -- 36/0x48 P	
		reg(FFTV_MATCH		) when ((rd and en(FFTV_MATCH		)) = '1') else  -- 37/0x4A P	
--		reg(FFTV_COUNT_HI	) when ((rd and en(FFTV_COUNT_HI	)) = '1') else  -- 38/0x4C S	
--		reg(FFTV_COUNT_LO	) when ((rd and en(FFTV_COUNT_LO	)) = '1') else  -- 39/0x4E S	
		reg(					) when ((rd and en(					)) = '1') else  -- 40/0x50 	
		reg(					) when ((rd and en(					)) = '1') else  -- 41/0x52 	
		reg(					) when ((rd and en(					)) = '1') else  -- 42/0x54 	
		reg(					) when ((rd and en(					)) = '1') else  -- 43/0x56 	
		reg(SEQ_SRC_COUNT	) when ((rd and en(SEQ_SRC_COUNT	)) = '1') else  -- 44/0x58 S	
		reg(SEQ_SINK_COUNT) when ((rd and en(SEQ_SINK_COUNT)) = '1') else  -- 45/0x5A S	
		reg(TIMESTAMP_LO	) when ((rd and en(TIMESTAMP_LO	)) = '1') else  -- 46/0x5C SL
		reg(TIMESTAMP_HI	) when ((rd and en(TIMESTAMP_HI	)) = '1') else  -- 47/0x5E SL
		reg(					) when ((rd and en(					)) = '1') else  -- 48/0x60   
		reg(					) when ((rd and en(					)) = '1') else  -- 49/0x62 	
		reg(					) when ((rd and en(					)) = '1') else  -- 50/0x64 	
		reg(					) when ((rd and en(					)) = '1') else  -- 51/0x66 	
		reg(					) when ((rd and en(					)) = '1') else  -- 52/0x68 	
		reg(					) when ((rd and en(					)) = '1') else  -- 53/0x6A 	
		reg(					) when ((rd and en(					)) = '1') else  -- 54/0x6C 	
		reg(					) when ((rd and en(					)) = '1') else  -- 55/0x6E 	
		reg(DEBUGBUS		) when ((rd and en(DEBUGBUS		)) = '1') else  -- 56/0x70 P	
		reg(TEST				) when ((rd and en(TEST				)) = '1') else  -- 57/0x72 PL
		reg(DUMMY_STAT		) when ((rd and en(DUMMY_STAT		)) = '1') else  -- 58/0x74 SL
		reg(					) when ((rd and en(					)) = '1') else  -- 59/0x76 	
		reg(					) when ((rd and en(					)) = '1') else  -- 60/0x78 	
		reg(					) when ((rd and en(					)) = '1') else  -- 61/0x7A 	
		reg(					) when ((rd and en(					)) = '1') else  -- 62/0x7C 	
		reg(					) when ((rd and en(					)) = '1') else  -- 63/0x7E 	
		
		(others => 'Z'); 
	
	
	-- Output Signal Map
	-------------------------------------------------
	reg_enables_o  		<= reg(ENABLES); 			
	reg_command_o 			<= reg(COMMAND); 			
	reg_burstcount_o 		<= reg(BURSTCOUNT); 		
	reg_frequency_o   	<= reg(FREQUENCY); 		
	reg_window_o  			<= reg(WINDOW); 			
	reg_delay_o   			<= reg(DELAY); 				
	reg_run_enables_o		<= reg(RUN_ENABLES); 		
	reg_sequencer_o		<= reg(SEQUENCER); 		
	reg_seq_end_o			<= reg(SEQ_END); 			
	reg_rb_mask_o			<= reg(RB_MASK); 	
	reg_ttc_select_o 		<= reg(TTC_SELECT);
	reg_fftv_p_min_o		<= reg(FFTV_P_MIN); 		
	reg_fftv_p_max_o		<= reg(FFTV_P_MAX);
	reg_fftv_oflow_o		<= reg(FFTV_OFLOW);	
   reg_fftv_deltat_o		<= reg(FFTV_DELTAT);
   reg_fftv_vetolen_o	<= reg(FFTV_VETOLEN);
   reg_fftv_match_o		<= reg(FFTV_MATCH);
   reg_debugbus_o			<= reg(DEBUGBUS);
      		

	-- Status Type Register Assignment
	---------------------------------------------------------------

--	reg(STATUS)(15) <= bp_laser_ilock_i;
--	reg(STATUS)(14) <= busy_test_i;
--	reg(STATUS)(13) <= tim_ok_i;
--	reg(STATUS)(12) <= extclkon_i
--	reg(STATUS)(11) <= samode_i;
--	reg(STATUS)(10) <= runmode_i;
--	reg(STATUS)( 9) <= saclkon_i;
--	reg(STATUS)( 8) <= ttcclkon_i;
--	reg(STATUS)( 7) <= rcbusy_i;
--	reg(STATUS)( 6) <= sink_busy_i;
--	reg(STATUS)( 5) <= src_busy_i;
--	reg(STATUS)( 4) <= burst_busy_i;
--	reg(STATUS)( 3) <= busyout_i;
--	reg(STATUS)( 2) <= intbusy_i;
--	reg(STATUS)( 1) <= busyin_masked_i;
--	reg(STATUS)( 0) <= busyin_i;


	reg(DUMMY_STAT)(15 downto 2) 	<= (others => '0');
   reg(DUMMY_STAT)(1) 				<= f2_spare_link_i;
   reg(DUMMY_STAT)(0) 				<= fftv_enable_i;
   

   reg(TIM_ID) 		<= (conv_std_logic_vector(FIRMWARE_ID, 8) & tim_ID_i);

   reg(TIMESTAMP_HI) <= timestamp_i(31 downto 16);
   reg(TIMESTAMP_LO) <= timestamp_i(15 downto  0);
			
			   
end rtl;	