-- hds header_start
--
-- VHDL Architecture TIM_fpga2.db_interface.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:21:37 01/14/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity reg_block is
   port( 
      clk          : in     std_logic;
      rst          : in     std_logic;
      db_rd_i      : in     std_logic;
      db_wr_i      : in     std_logic;
      db_io        : inout  std_logic_vector (15 downto 0);
      reg_en_i     : in     std_logic_vector (63 downto 0);
      tim_id_i     : in     std_logic_vector (7 downto 0);
      Register40_o : out    std_logic_vector (15 downto 0);
      Register42_o : out    std_logic_vector (15 downto 0);
      debugout     : out    std_logic_vector (15 downto 0)
   );

-- Declarations

end reg_block ;

-- hds interface_end
architecture rtl of reg_block is

	signal register32	: std_logic_vector(15 downto 0);
	signal register40	: std_logic_vector(15 downto 0);
	signal register42	: std_logic_vector(15 downto 0);
	signal register44	: std_logic_vector(15 downto 0);
	
	

	
begin

   register32 <= ("00111010" & tim_ID_i);
   
   --register44 <= conv_std_logic_vector(%(dd),16);
   
   register40_o <= register40;
   register42_o <= register42;
   

   -- Some Test Registers
   ----------------------

   process (rst, clk)
   begin
      if (rst = '1') then 
         register40 <= (others => '0');
         register42 <= (others => '0'); 

      elsif rising_edge(clk) then
      
      	if (db_wr_i = '1') then 
      		if (reg_en_i(32) = '1') then register40 <= db_io; end if; 
         	if (reg_en_i(33) = '1') then register42 <= db_io; end if; 

      	end if;
      end if;
   end process;
 

	db_io <= register32 when ((db_rd_i and reg_en_i(25)) = '1') else --Reg32
				register40 when ((db_rd_i and reg_en_i(32)) = '1') else --Reg40
      		register42 when ((db_rd_i and reg_en_i(33)) = '1') else --Reg42
      		register44 when ((db_rd_i and reg_en_i(34)) = '1') else --Reg44
      		(others => 'Z');


end rtl;
