-- hds header_start
--
-- VHDL Architecture TIM_fpga2.samode.rtl_new
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:11:45 03/05/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity samode is
   port( 
      rst                     : in     std_logic;
      clk                     : in     std_logic;
      db                      : inout  std_logic_vector (15 downto 0);
      db_rd                   : in     std_logic;
      db_wr                   : in     std_logic;
      Reg00                   : in     std_logic;                       -- 0. Enables
      Reg02                   : in     std_logic;                       -- 1. Command
      Reg04                   : in     std_logic;                       -- 2. Burst Count
      Reg06                   : in     std_logic;                       -- 3. Frequency
      Reg08                   : in     std_logic;                       -- 4. Window
      Reg0A                   : in     std_logic;                       -- 5. Delay
      Reg0C                   : in     std_logic;                       -- 6. Status
      SeqBusy_i               : in     std_logic;
      SinkBusy_i              : in     std_logic;
      RCBUSY_i                : in     std_logic;                       -- from rod_busys.vhd
      RCBUSYen_i              : in     std_logic;                       -- from mixer.vhd
      ext_TRG_sw_i            : in     std_logic;
      ext_TRGin_ecl_i         : in     std_logic;
      ext_TRGin_nim_i         : in     std_logic;
      ext_BCRin_ecl_i         : in     std_logic;
      ext_BCRin_nim_i         : in     std_logic;
      ext_ECRin_ecl_i         : in     std_logic;
      ext_ECRin_nim_i         : in     std_logic;
      ext_CALin_ecl_i         : in     std_logic;
      ext_CALin_nim_i         : in     std_logic;
      ext_FERin_ecl_i         : in     std_logic;
      ext_FERin_nim_i         : in     std_logic;
      ext_SPRin_ecl_i         : in     std_logic;
      ext_SPRin_nim_i         : in     std_logic;
      ext_BUSYin_ecl_i        : in     std_logic;
      ext_BUSYin_nim_i        : in     std_logic;
      ext_ETRGout_o           : out    std_logic;
      ext_BUSYout_o           : out    std_logic;
      ext_BUSYin_masked_o     : out    std_logic;
      led_RunMode_o           : out    std_logic;
      led_SAMode_o            : out    std_logic;
      int_TRGin_i             : in     std_logic;
      int_ECRin_i             : in     std_logic;
      int_FERin_i             : in     std_logic;
      int_oscFERen_o          : out    std_logic;
      int_oscTRGen_o          : out    std_logic;
      RunMode_o               : out    std_logic;
      int_oscR_o              : out    std_logic_vector (5 downto 1);
      int_oscS_o              : out    std_logic_vector (5 downto 1);
      trw_delayWD_o           : out    std_logic_vector (5 downto 0);
      trw_delayWS_o           : out    std_logic_vector (5 downto 0);
      trw_Win_en_o            : out    std_logic;
      trw_Win_open_i          : in     std_logic;
      trw_StopClk_o           : out    std_logic;
      setTTCClk_i             : in     std_logic;                       -- from reg on mixer.vhd
      cc_delayCT_o            : out    std_logic_vector (5 downto 0);
      cc_enIntClk_o           : out    std_logic;
      cc_enSAClk_o            : out    std_logic;
      cc_ExtClkOn_i           : in     std_logic;
      cc_SAClkOn_i            : in     std_logic;
      cc_TTCClkOn_i           : in     std_logic;
      bp_TIM_OK_out_o         : out    std_logic;
      SATRG_o                 : out    std_logic;
      SABCR_o                 : out    std_logic;
      SAECR_o                 : out    std_logic;
      SACAL_o                 : out    std_logic;
      SAFER_o                 : out    std_logic;
      SASPR_o                 : out    std_logic;
      --EDTRG_o       : out	std_logic; -- early delayed trig
      v_RCBUSY_o              : out    std_logic;
      v_f2_reset_o            : out    std_logic;
      bp_laser_intlck_state_i : in     std_logic;
      StartSeq_o              : out    std_logic;
      StartSink_o             : out    std_logic;
      DebugBus                : out    std_logic_vector (15 downto 0)
   );

-- Declarations

end samode ;


-- hds interface_end

architecture rtlold of samode is

 	signal RegEnables 	: std_logic_vector(15 downto 0);
 	signal RegCommands	: std_logic_vector(15 downto 0);
 	signal RegBurstCount	: std_logic_vector(15 downto 0);
 	signal RegFreq		   : std_logic_vector(15 downto 0);	
 	signal RegTrigWin		: std_logic_vector(15 downto 0);
 	signal RegDelays 		: std_logic_vector(15 downto 0);
 	signal RegStatus		: std_logic_vector(15 downto 0);
 	
 	--BUSYs
 	------------------------------------
 
   signal ext_BUSYout   : std_logic;

   signal int_BUSY		: std_logic; -- OA_busy
	signal int_BUSYen		: std_logic;

   signal ext_BUSYin      : std_logic;
	signal ext_BUSYinen		: std_logic;
	signal v_BUSY			: std_logic;

	signal OA_busy			: std_logic;
	signal ext_BUSYin_masked : std_logic;
	

   -- General
   ---------------------------------
	signal RunMode			: std_logic;
 	signal SAMode			: std_logic;
 	
 	signal v_f2_reset 	: std_logic;
 	
 	--CLOCK CONTROL
 	----------------------------------
 	
	signal ext_CLKen  	: std_logic;
   signal TIM_OK   	   : std_logic;

   signal BurstBusy  	: std_logic;
   signal BurstWaiting 	: std_logic;   	
 	signal v_BurstMode	: std_logic;
	signal v_BurstGo  	: std_logic;


	signal TestBUSY      : std_logic;
   signal TestBUSYen  	: std_logic;
	signal TestBUSYclr 	: std_logic;

   signal Window_open   : std_logic;
   signal Window_en     : std_logic;   	



   signal ext_TRG,   ext_BCR,   ext_ECR,   ext_CAL,   ext_FER,   ext_SPR   : std_logic;
   signal ext_TRGen, ext_BCRen, ext_ECRen, ext_CALen, ext_FERen, ext_SPRen : std_logic;


   signal int_TRG, int_BCR, int_ECR, int_FER : std_logic;    
   signal int_TRG2     : std_logic;
   signal int_RanTRG   : std_logic;

   
   signal int_TRGen, int_BCRen, int_ECRen, int_FERen : std_logic;    
   signal int_TRG2en   : std_logic;
   signal int_RanTRGen : std_logic;

              
   signal syncTRG,  syncBCR,  syncECR,  syncCAL,  syncFER,  syncSPR    : std_logic;
   signal syncCALP   : std_logic;
   signal syncETRG  : std_logic;
   signal syncDTRG  : std_logic;
   
   signal busyTRG,  busyBCR,  busyECR,  busyCAL,  busyFER,  busySPR    : std_logic;
   signal busyCALP   : std_logic;
   signal busyCALTRG  : std_logic;
   signal busyDTRG  : std_logic;
   signal busyRTRG  : std_logic;
   signal busyANY    : std_logic;
   
   signal asyncTRG, asyncCAL, asyncBCR, asyncECR, asyncFER, asyncSPR   : std_logic;
   

   signal v_TRG,    v_CAL,    v_BCR,    v_ECR,    v_FER,    v_SPR   : std_logic;

   signal DTRG       : std_logic; -- delayed trig   
      
   signal disableTRG : std_logic;
   
   component pulse_trap
      port (
         rst 	: in	std_logic;
         clk  	: in	std_logic;
         
         sin	: in  std_logic;
         en  	: in  std_logic;
         clr   : in  std_logic;
         
         sout 	: out std_logic

      );
   end component;
   
  	
  	
-------------------------------------------------------------------------------
--	MAIN CODE                                                                   
-------------------------------------------------------------------------------
begin

   
   

	RunMode_o <= RunMode;    
	SAMode <= (not RunMode); 
	
	led_runmode_o <= RunMode;
	led_samode_o  <= SAMode;
   
   ext_BUSYout_o  <= ext_BUSYout;   
   
   StartSeq_o   <= syncSPR;
	StartSink_o	 <= syncETRG or syncCAL;

   
   ------------------------------------------------------------------   
   -- Internal Signals (i.e. from on-board sources)
   ------------------------------------------------------------------
   

   
   int_TRG2en <= int_TRGen and (not int_RanTRGen);
   
   
   --Upti1: pulse_trap port map ( sin=> int_TRGin_i, en=> int_TRG2en, clr=> busyTRG, sout=> int_TRG2, rst=> rst, clk=> clk );
   --Upti2: pulse_trap port map ( sin=> int_ECRin_i,  en=> int_ECRen,   clr=> busyANY,  sout=> int_ECR,   rst=> rst, clk=> clk );
   --Upti3: pulse_trap port map ( sin=> int_FERin_i,  en=> int_FERen,   clr=> busyANY,  sout=> int_FER,   rst=> rst, clk=> clk );
	-- *** Removed Pulse traps etc for testing.
	int_TRG2 <= int_TRGin_i and int_TRG2en;
	int_ECR   <= int_ECRin_i  and int_ECRen; 
	int_FER   <= int_FERin_i  and int_FERen;

   --int_RanTRG generated here
   --int_BCR     generated here
   
   int_TRG <= int_TRG2 OR int_RanTRG;
   
   int_oscFERen_o  <= int_FERen OR int_ECRen;
   int_oscTRGen_o <= int_TRGen OR int_RanTRGen;
   
   	-- Int Signal programmable oscillators
	--------------------------------------
	int_oscR_o <= RegFreq( 4 downto 0);
	int_oscS_o <= RegFreq(12 downto 8);
   
   
   -- pseudo-randomiser - generate int_RanTRG
   ---------------------------------------------------------------------------
   rnd: block
      signal   shiftreg    : std_logic_vector(39 downto 1);
      signal   shiftreg_in : std_logic;
      
      signal   int_TRGin_q : std_logic_vector(2 downto 0);
      
   begin
   
      process (rst, clk)
      begin
      	if rising_edge(clk) then
      		if (rst = '1') then
	            shiftreg <= (others => '1');
	            int_TRGin_q <= (others => '0');
	            
	         else
	         	-- syncronise (extra ff for edgedet)
	         	int_TRGin_q(0) <= int_TRGin_i;
	         	int_TRGin_q(1) <= int_TRGin_q(0);
	         	int_TRGin_q(2) <= int_TRGin_q(1);
	         
         	-- rising edge detect
	            if (int_TRGin_q(2 downto 1) = "01") then
	
	               shiftreg(39 downto 2) <= shiftreg(38 downto 1);
	               shiftreg(1)           <= shiftreg(39) xor shiftreg(35);
	               
	            end if;
	         end if;
         end if;
      end process;
            
      int_RanTRG <= shiftreg(39) and int_RanTRGen;
      
   end block;
   
   
   ------------------------------------------------------------------   
   -- External Signals (i.e. from front panel sources)
   ------------------------------------------------------------------

   ext_in: block
   
      signal ext_TRGin, ext_BCRin, ext_ECRin, ext_CALin, ext_FERin, ext_SPRin : std_logic;      

   begin

      ext_TRGin <= (ext_TRGin_nim_i or ext_TRGin_ecl_i) and Window_open; --*** not sure if window open should go here
      ext_CALin  <= (ext_CALin_nim_i  or ext_CALin_ecl_i);
      ext_BCRin  <= (ext_BCRin_nim_i  or ext_BCRin_ecl_i);
      ext_FERin  <= (ext_FERin_nim_i  or ext_FERin_ecl_i);
      ext_ECRin  <= (ext_ECRin_nim_i  or ext_ECRin_ecl_i);
      ext_SPRin  <= (ext_SPRin_nim_i  or ext_SPRin_ecl_i);
      
      --Upte1: pulse_trap port map ( sin=> ext_TRGin, en=> ext_TRGen, clr=> busyTRG, sout=> ext_TRG, rst=> rst, clk=> clk );
      --Upte2: pulse_trap port map ( sin=> ext_CALin , en=> ext_CALen,  clr=> busyANY,  sout=> ext_CAL,  rst=> rst, clk=> clk );
      --Upte3: pulse_trap port map ( sin=> ext_BCRin , en=> ext_BCRen,  clr=> busyANY,  sout=> ext_BCR,  rst=> rst, clk=> clk );
      --Upte4: pulse_trap port map ( sin=> ext_FERin , en=> ext_FERen,  clr=> busyANY,  sout=> ext_FER,  rst=> rst, clk=> clk );
      --Upte5: pulse_trap port map ( sin=> ext_ECRin , en=> ext_ECRen,  clr=> busyANY,  sout=> ext_ECR,  rst=> rst, clk=> clk );
      --Upte6: pulse_trap port map ( sin=> ext_SPRin , en=> ext_SPRen,  clr=> busyANY,  sout=> ext_SPR,  rst=> rst, clk=> clk );
      -- *** Removed above for easier testing
		ext_TRG <= ext_TRGin and ext_TRGen; 
		ext_CAL  <= ext_CALin  and ext_CALen;
		ext_BCR  <= ext_BCRin  and ext_BCRen;
		ext_FER  <= ext_FERin  and ext_FERen;
		ext_ECR  <= ext_ECRin  and ext_ECRen;
		ext_SPR  <= ext_SPRin  and ext_SPRen;

   end block;

  
   ------------------------------------------------------------------   
   -- Combined Signals
   ------------------------------------------------------------------
   
      asyncTRG <= (ext_TRG or int_TRG or v_TRG  or ext_TRG_sw_i);
      asyncBCR  <= (ext_BCR  or int_BCR  or v_BCR             );
      asyncECR  <= (ext_ECR  or int_ECR  or v_ECR             );
      asyncCAL  <= (ext_CAL              or v_CAL             );
      asyncFER  <= (ext_FER  or int_FER  or v_FER             );
      asyncSPR  <= (ext_SPR  or             v_SPR             );
         

	synch_pulser : block
	
		signal 	sync_q0 : std_logic_vector(5 downto 0);
		signal 	sync_q1 : std_logic_vector(5 downto 0);
		signal 	DCAL    : std_logic_vector(31 downto 0);

   begin
      process ( clk)
      begin
            
         if rising_edge(clk) then
         
            if (rst = '1') then
	            syncETRG <= '0';  
	            syncBCR  <= '0'; 
	            syncECR  <= '0';
	            syncCAL  <= '0';
	            syncFER  <= '0';
	            syncSPR  <= '0';
	            
	            sync_q0  <= (others => '0');
	            sync_q1  <= (others => '0');
	            
	            DCAL 		<= (others => '0');
	         
	         else
	         	DCAL(0) <= syncCAL;
					DCAL(31 downto 1) <= DCAL(30 downto 0);
	        
	            sync_q0(0) <=  asyncTRG or DCAL(22); --*** CAL is here for testing
	            sync_q0(1) <=  asyncBCR; 
	            sync_q0(2) <=  asyncECR; 
	            sync_q0(3) <=  asyncCAL;
	            sync_q0(4) <=  asyncFER; 
	            sync_q0(5) <=  asyncSPR;
	            
	            sync_q1 <= sync_q0;
	            
	            -- rising edge detector
	            syncETRG <=  sync_q0(0) and (not sync_q1(0) ); 
	            syncBCR   <=  sync_q0(1) and (not sync_q1(1) ); 
	            syncECR   <=  sync_q0(2) and (not sync_q1(2) ); 
	            syncCAL   <=  sync_q0(3) and (not sync_q1(3) ); 
	            syncFER   <=  sync_q0(4) and (not sync_q1(4) ); 
	            syncSPR   <=  sync_q0(5) and (not sync_q1(5) ); 
	            
	      	end if;
         end if;
      end process;
   end block;
   
   --syncDTRG	<= DTRG AND ((not busyANY) OR busyCALTRG);
	syncTRG	<= syncDTRG and (not disableTRG); -- *** symplified for now
   ext_eTRGout_o   <= syncETRG;
   
   
   ---------------------------------------------------------------------------
	-- OUTPUTs
	---------------------------------------------------------------------------

   -- *** this is not the way it should be
   --     it is for testing synth etc.
   
   SATRG_o	<= syncTRG;
   SABCR_o	<= syncBCR;
   SAECR_o	<= syncECR;
   SACAL_o	<= syncCAL;
   SAFER_o	<= syncFER;
   SASPR_o	<= syncSPR;
	


 	---------------------------------------------------------------------------
	-- Internal Busys
	---------------------------------------------------------------------------

	sabusys: block
		signal clrDTRG, clrBCR, clrECR, clrCAL, clrFER, clrSPR : std_logic;
      signal clrCALP : std_logic;
		signal xbusyDTRG : std_logic;
		
		signal doneDTRG,  doneBCR,  doneECR,  doneCAL,  doneFER,  doneSPR    : std_logic;
   	signal doneCALP   : std_logic;
   	signal doneANY    : std_logic;
   	
   	signal dt3, dt7, dt27 : std_logic;
   	
   	signal   DeadTimerGO : std_logic;
		signal   DeadTimerEn : std_logic;
	
	begin
	
		busyTRG  <= syncTRG OR busyCAL OR disableTRG; --allows trigs to be stacked-up
		
		Uptb1: pulse_trap port map ( sin=> syncCAL, en=> '1', clr=> clrCAL, sout=> busyCAL, rst=> rst, clk=> clk ); 	
		Uptb2: pulse_trap port map ( sin=> syncBCR, en=> '1', clr=> clrBCR, sout=> busyBCR, rst=> rst, clk=> clk ); 	
		Uptb3: pulse_trap port map ( sin=> syncECR, en=> '1', clr=> clrECR, sout=> busyECR, rst=> rst, clk=> clk ); 	
		Uptb4: pulse_trap port map ( sin=> syncFER, en=> '1', clr=> clrFER, sout=> busyFER, rst=> rst, clk=> clk ); 	
		Uptb5: pulse_trap port map ( sin=> syncSPR, en=> '1', clr=> clrSPR, sout=> busySPR, rst=> rst, clk=> clk ); 	
		
		Uptb6: pulse_trap port map ( sin=> syncDTRG, en=> '1', clr=> clrDTRG, sout=> xbusyDTRG, rst=> rst, clk=> clk ); 	
		busyDTRG <= xbusyDTRG or TestBusy;		
		
		busyRTRG <= busyDTRG AND ((not busyCAL) OR busyCALP); -- busy Real TRG ie. not CAL_TRG
		
        --Uptb7: pulse_trap port map ( sin=> syncCALP, en=> '1', clr=> clrCALP, sout=> busyCALP, rst=> rst, clk=> clk ); 	
		
		
		
		busyANY <= busyDTRG or busyCAL or busyBCR or busyECR or busyFER or busySPR or disableTRG;

		disableTRG <= BurstWaiting or (Reg0A AND db_wr);  		
		
		-- *** was all asyncXXX ....
		OA_busy <=   syncTRG or syncCAL or syncBCR or syncECR or syncFER or syncSPR
                or busyANY   or busyDTRG or disableTRG or rst;
	

		-- Dead Timer
		---------------------------


      DeadTimerGO <= syncDTRG or syncCALP or syncBCR or syncECR or syncFER or syncSPR;

      doneANY <= doneDTRG or doneCALP or doneBCR or doneECR or doneFER or doneSPR or disableTRG or rst;


		process (rst, clk)
			subtype int5 is integer range 0 to 32;
			variable DeadTimer : int5; 		
		begin
			if (rst = '1') then
				DeadTimer := 0;
            DeadTimerEn <= '0';
            dt3  <= '0';
            dt7  <= '0';
            dt27 <= '0';
            				
			elsif rising_edge(clk) then
				if (doneANY = '1') then
					DeadTimer := 0;
					DeadTimerEn <= '0';
					
				elsif (DeadTimerGo = '1') or (DeadTimerEn = '1') then
					DeadTimerEn <= '1';
					DeadTimer := DeadTimer + 1;
					
				else
					DeadTimerEn <= '0';
					DeadTimer := 0;
					
				end if;
			
			
				if (DeadTimer =  3) then dt3  <= '1'; else dt3  <= '0'; end if;
				if (DeadTimer =  7) then dt7  <= '1'; else dt7  <= '0'; end if;
				if (DeadTimer = 27) then dt27 <= '1'; else dt27 <= '0'; end if;		

			end if;
			
      end process;

    		
      


		-- Control Signals
		-----------------------------------------------

      doneDTRG <= (dt3  and busyDTRG);
      doneCALP  <= (dt27 and busyCALP);
      doneCAL   <= (dt27 and busyCAL); -- *** should be dealt with by CAL machine
      doneBCR   <= (dt7  and busyBCR);
      doneECR   <= (dt7  and busyECR);
      doneFER   <= (dt7  and busyFER);
      doneSPR   <= (dt7  and busySPR);


      clrBCR   <= doneBCR                                                            or disableTRG or rst;
      clrFER   <= doneFER   or busyBCR                                               or disableTRG or rst;
      clrECR   <= doneECR   or busyBCR or busyFER                                    or disableTRG or rst;
      clrDTRG <= doneDTRG or busyBCR or busyFER or busyECR                         or disableTRG or rst;
      clrCAL   <= doneCAL   or busyBCR or busyFER or busyECR or busyRTRG            or disableTRG or rst;
      clrCALP  <= doneCALP  or clrCAL;
      clrSPR	<= doneSPR   or busyBCR or busyFER or busyECR or busyDTRG or busyCAL or disableTRG or rst;
		
		-- *** for PAR only        
		DebugBus(0) <= doneDTRG;   
		DebugBus(1) <= doneCALP;   
		DebugBus(2) <= doneCAL;    
		DebugBus(3) <= doneBCR;    
		DebugBus(4) <= doneECR;    
		DebugBus(5) <= doneFER;    
		DebugBus(6) <= doneSPR;    
		DebugBus(7) <= v_f2_reset;
		
		DebugBus( 8) <= '0';
		DebugBus( 9) <= busyDTRG;   
		DebugBus(10) <= busyCALP;   
		DebugBus(11) <= busyCAL;    
		DebugBus(12) <= busyBCR;    
		DebugBus(13) <= busyECR;    
		DebugBus(14) <= busyFER;    
		DebugBus(15) <= busySPR;    
		
		busyCALP <= '1';
		syncCALP <= '1';
		
	
	end block;
   
		
   
      
      
      
	---------------------------------------------------------------------------
	-- CAL generation                                                                 
	---------------------------------------------------------------------------
 	
 	busyCALTRG <= '0';
  
 
    
      
   ------------------------------------------------------------------
	-- Trigger Pipeline delay
   ------------------------------------------------------------------
   shift144: block
      
      signal shift_a    : std_logic_vector(127 downto 0);
      signal shift_b    : std_logic_vector( 15 downto 0);
      
      signal sel_a      : std_logic_vector(3 downto 0);
      signal sel_b      : std_logic_vector(3 downto 0);
      
      signal out_b      : std_logic;
                                    
      signal shift_in   : std_logic;                                    
      signal shift_clr  : std_logic;
      
      signal syncETRG_q : std_logic;

   begin 

      shift_clr <= syncCAL or disableTRG;
      
      sel_a <= RegDelays(7 downto 4);
      sel_b <= RegDelays(3 downto 0);

      process (clk)
      begin
         
         if rising_edge(clk) then
         	if (rst = '1') then
	            shift_a  <= (others => '0');
	            shift_b  <= (others => '0');
	            
	            shift_in <= '0';
	            
	            out_b <= '0';
	            
	   		else
	         	if (shift_clr = '1') then
	               shift_a  <= (others => '0');
	               shift_b  <= (others => '0');
	               shift_in <= '0';
	               
	            else
	            	syncETRG_q <= syncETRG;
	               shift_in <= syncETRG_q; -- 1 extra clock delay for TIM2 compat
	               
	               shift_a(0)            <= shift_in;
	               shift_a(127 downto 1) <= shift_a(126 downto 0);
	   
	               
	               case sel_a is
	                  when "0000" => shift_b(0) <= shift_in;
	                  when "0001" => shift_b(0) <= shift_a(15);
	                  when "0010" => shift_b(0) <= shift_a(31);
	                  when "0011" => shift_b(0) <= shift_a(47);
	                  when "0100" => shift_b(0) <= shift_a(63);
	                  when "0101" => shift_b(0) <= shift_a(79);
	                  when "0110" => shift_b(0) <= shift_a(95);
	                  when "0111" => shift_b(0) <= shift_a(111);
	                  when "1000" => shift_b(0) <= shift_a(127);
	                  
	                  when others => shift_b(0) <= shift_a(127);
	               end case;
	               
	               
	               shift_b(15 downto 1) <= shift_b(14 downto 0);
	   
	               case sel_b is
	                  when "0000" => out_b <= shift_b(0); 
	                  when "0001" => out_b <= shift_b(1); 
	                  when "0010" => out_b <= shift_b(2); 
	                  when "0011" => out_b <= shift_b(3); 
	                  when "0100" => out_b <= shift_b(4); 
	                  when "0101" => out_b <= shift_b(5); 
	                  when "0110" => out_b <= shift_b(6); 
	                  when "0111" => out_b <= shift_b(7); 
	                  when "1000" => out_b <= shift_b(8); 
	                  when "1001" => out_b <= shift_b(9); 
	                  when "1010" => out_b <= shift_b(10);
	                  when "1011" => out_b <= shift_b(11);
	                  when "1100" => out_b <= shift_b(12);
	                  when "1101" => out_b <= shift_b(13);
	                  when "1110" => out_b <= shift_b(14);
	                  when "1111" => out_b <= shift_b(15);
	                  
	                  when others => null;
	               end case;
	         
	            end if;
	         end if;
	   	end if;
      end process;
         
      --EDTRG_o <= shift_b(0);
      syncDTRG <= out_b;

   end block;


	---------------------------------------------------------------------------
	-- Trigger Window
	---------------------------------------------------------------------------
  
   Window_open <= trw_Win_open_i and Window_en;
   trw_win_en_o <= Window_en;

	-- Programmable delay lines
	trw_delayWS_o <= RegTrigWin( 5 downto 0);
	trw_delayWD_o <= RegTrigWin(13 downto 8);

	trw_StopClk_o <= (Reg08 and db_wr);


	---------------------------------------------------------------------------
	-- SA BCR Generator
	---------------------------------------------------------------------------

   --synchronous 11.2456kHz pulse generator
      
   BCR_gen: block

      signal bcr_timer_max : std_logic;
   
   begin
  
      process (rst, clk)

         subtype int12 is integer range 0 to 16#FFF#; 
         variable bcr_timer : int12;

      begin
         if (rst = '1') then
            bcr_timer := 0;
            bcr_timer_max <= '0';
            
         elsif rising_edge(clk) then
         
            if bcr_timer = 3564 then  --### set rollover (should be 3564?)
               bcr_timer := 0;
               bcr_timer_max <= '1';
               
            else
               bcr_timer := bcr_timer + 1;
               bcr_timer_max <= '0';
               
            end if;
         end if; 
      end process;
           
      
      int_BCR <= bcr_timer_max and int_BCRen;

   end block;


	
	
	
	---------------------------------------------------------------------------
	-- TIM BUSYs
	---------------------------------------------------------------------------

	-- *** synchronise?
	ext_BUSYin <= ext_BUSYin_ecl_i OR ext_BUSYin_nim_i;
	
	int_BUSY	<= OA_busy;
	
	ext_BUSYout <= 	(int_BUSY and int_BUSYen) 
						or (ext_BUSYin and ext_BUSYinen)
						or (RCBUSY_i and RCBUSYen_i)
						or v_Busy;
						
	

	-- masked version of BusyIn
	ext_BUSYin_masked	<= ext_BUSYin and ext_BUSYinen;
	ext_BUSYin_masked_o <= ext_BUSYin_masked;	
	
	
	---------------------------------------------------------------------------
	-- Test Busy
	---------------------------------------------------------------------------
	process (rst, clk)
	begin
		if (rst = '1') then
			TestBUSY <= '0';
			
		elsif rising_edge(clk) then
		
			if (TestBUSYclr = '1') then
				TestBUSY <= '0';
			
			else
				TestBUSY <= (syncDTRG or TestBUSY) and TestBUSYen;
				
			end if;
		end if;
	end process;
	        

   ----------------------------------------------------------------------------
  	-- Burst Mode
  	----------------------------------------------------------------------------

   Burst: block

      signal burst_count_en	: std_logic;
      signal burst_done    	: std_logic;
      signal burst_counter   	: std_logic_vector(15 downto 0);
      signal v_burstgo_q		: std_logic_vector(1 downto 0);
      signal burst_fire			: std_logic;
      
   
   begin
  
		v_burstgo_q(0) <= v_BurstGo;
  			
      process (clk)
      begin
                        
         if rising_edge(clk) then
         	if (rst = '1') then
            	burst_counter 	<= (others => '0');
           	 	burst_done 		<= '0'; 
            	burst_count_en <= '0';
            	burst_fire 		<= '0';
            	v_burstgo_q(1) <= '0';

         	else
         	
         		-- Burst Go rising edge detect ----------------
         		v_burstgo_q(1) <= v_BurstGo;
         		        		
         		--default
         		burst_fire <= '0';
         		if v_burstgo_q = "01" then
         			burst_fire <= '1';
         		end if;
         		
         		         		
         		-- Burst Counter Control -----------------------
	         	if (v_BurstMode = '1') then
	         	
	         		if (v_BurstGo = '0') then
	         			burst_count_en <= '0';
	                           
	            	elsif (burst_counter = "0000000000000000") then
	                  burst_count_en <= '0';
	                  
	               elsif (burst_fire = '1') then
	                  burst_count_en <= '1';
	                  	               	
	               end if;
	            
	            else
	               burst_count_en <= '0';
	
	            end if;
	            
	            
					-- Burst Counter  ------------------------------------------
	            if (burst_count_en = '1') then 
	            	if (syncTRG = '1') then
	            		burst_counter <= burst_counter - '1';
	            		
	               end if;
	               
	            else
	               burst_counter <= RegBurstCount;
	
	            end if;
         	end if;
         end if; 
      end process;
       
      BurstBusy <= burst_count_en;
      BurstWaiting <= v_BurstMode and (not burst_count_en);
           
      
   end block;


  	----------------------------------------------------------------------------
  	-- Clock Control
  	----------------------------------------------------------------------------
  
   cc_delayCT_o <= RegDelays(13 downto 8);

   cc_enSAClk_o 	<= not setTTCClk_i;
   cc_enIntClk_o	<= not ext_clken;

   -- *** this is way too simplified -- just for pin count now
   TIM_OK <= cc_SACLKOn_i or cc_TTCClkOn_i or cc_ExtClkOn_i;

   bp_TIM_OK_out_o <= TIM_OK;

	---------------------------------------------------------------------------
	-- Status Register
	--------------------------

	RegStatus(15) <= bp_laser_intlck_state_i;
	RegStatus(14) <= TestBUSY;
	RegStatus(13) <= TIM_OK;
	RegStatus(12) <= '0'; -- *** extclkon?
	RegStatus(11) <= SAMode;
	RegStatus(10) <= RunMode;
	RegStatus( 9) <= cc_SAClkOn_i;
	RegStatus( 8) <= cc_TTCClkOn_i;
	RegStatus( 7) <= RCBUSY_i;
	RegStatus( 6) <= SinkBusy_i;
	RegStatus( 5) <= SeqBusy_i;
	RegStatus( 4) <= BurstBusy;
	RegStatus( 3) <= ext_BUSYout;
	RegStatus( 2) <= int_BUSY;
	RegStatus( 1) <= ext_BUSYin_masked;
	RegStatus( 0) <= ext_BUSYin;

  	---------------------------------------------------------------------------
	-- Enables Register
	--------------------------
     
	int_TRGen     <= RegEnables( 1);
   int_ECRen  		<= RegEnables( 2);
   int_BCRen  		<= RegEnables( 3);
   int_RanTRGen  <= RegEnables( 4);
   int_FERen      <= RegEnables( 5);
  	Window_en 		<= RegEnables( 6);	 
  	int_BUSYen	   <= RegEnables( 7);
 	ext_CLKen  		<= RegEnables( 8);
   ext_TRGen 		<= RegEnables( 9) and (Window_open or (not Window_en));
   ext_ECRen  		<= RegEnables(10);                  
   ext_BCRen  		<= RegEnables(11);                  
   ext_CALen  		<= RegEnables(12);                  
   ext_FERen  		<= RegEnables(13);                  
   ext_SPRen 		<= RegEnables(14);                  
 	ext_BUSYinen	<= RegEnables(15);


  	---------------------------------------------------------------------------
	-- Commands Register
	--------------------------

   --reserved    <= RegCommands( 0);
   v_TRG  		  <= RegCommands( 1);
   v_ECR 		  <= RegCommands( 2);
   v_BCR 		  <= RegCommands( 3);
   v_CAL 		  <= RegCommands( 4);
   v_FER			  <= RegCommands( 5);
   v_SPR 		  <= RegCommands( 6);    
	v_BUSY   	  <= RegCommands( 7);
	v_RCBUSY_o 	  <= RegCommands( 8);
   v_BurstMode	  <= RegCommands( 9);
   v_BurstGo  	  <= RegCommands(10);
   --reserved    <= RegCommands(11);
	RunMode 		  <= RegCommands(12);
   TestBUSYen    <= RegCommands(13);
   TestBUSYclr   <= RegCommands(14);
   v_f2_reset    <= RegCommands(15);
                   
	
	v_f2_reset_o  <= v_f2_reset;
 	
  	----------------------------------------------------------------------------
  	-- Data Bus
  	----------------------------------------------------------------------------

  	process (rst, clk)
  	begin

    	if (rst = '1') then
      	RegEnables 	<= "0000000000000000";
      	RegCommands <= "0000000000000000";
			RegBurstCount	<= "0000000000000000";
      	RegFreq		<= "0000000000000000";      	
      	RegTrigWin	<= "0000000000000000";
      	RegDelays 	<= "0000000000000000";

    	elsif rising_edge(clk) then
    	
    		-- Writes
    		---------
      	if 	(Reg00 and db_wr) = '1' then RegEnables  <= db;
     		elsif (Reg02 and db_wr) = '1' then RegCommands <= db;
        	elsif (Reg04 and db_wr) = '1' then RegBurstCount <= db;
       	elsif (Reg06 and db_wr) = '1' then RegFreq	  <= db;
       	elsif (Reg08 and db_wr) = '1' then RegTrigWin  <= db;
        	elsif (Reg0A and db_wr) = '1' then RegDelays   <= db; 
        	end if;

    	end if;
  	end process;


	-- Read Data
	------------
	
	db <= RegEnables  when ((Reg00 and db_rd) = '1') else
			RegCommands when ((Reg02 and db_rd) = '1') else
			RegBurstCount when ((Reg04 and db_rd) = '1') else
			RegFreq     when ((Reg06 and db_rd) = '1') else
			RegTrigWin  when ((Reg08 and db_rd) = '1') else
			RegDelays   when ((Reg0A and db_rd) = '1') else
			RegStatus   when ((Reg0C and db_rd) = '1') else (others => 'Z');

	-----------------------------------------------------
	-- Debug Bus
  	----------------------------------------------------

	--DebugBus <= "0000000000000000";
		
	--DebugBus(15 downto 8) <= "00000000";
	


end rtlold;
