-- hds header_start
--
-- VHDL Architecture TIM_fpga2.samode.rtl_new
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:11:45 03/05/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity samode is
   port( 
      rst                     : in     std_logic;
      clk                     : in     std_logic;
      db                      : inout  std_logic_vector (15 downto 0);
      db_rd                   : in     std_logic;
      db_wr                   : in     std_logic;
      Reg00                   : in     std_logic;                       -- 0. Enables
      Reg02                   : in     std_logic;                       -- 1. Command
      Reg04                   : in     std_logic;                       -- 2. Burst Count
      Reg06                   : in     std_logic;                       -- 3. Frequency
      Reg08                   : in     std_logic;                       -- 4. Window
      Reg0A                   : in     std_logic;                       -- 5. Delay
      Reg0C                   : in     std_logic;                       -- 6. Status
      SeqBusy_i               : in     std_logic;
      SinkBusy_i              : in     std_logic;
      RCBUSY_i                : in     std_logic;                       -- from rod_busys.vhd
      RCBUSYen_i              : in     std_logic;                       -- from mixer.vhd
      ext_TRG_sw_i            : in     std_logic;
      ext_TRGin_ecl_i         : in     std_logic;
      ext_TRGin_nim_i         : in     std_logic;
      ext_ECRin_ecl_i         : in     std_logic;
      ext_ECRin_nim_i         : in     std_logic;
      ext_BCRin_ecl_i         : in     std_logic;
      ext_BCRin_nim_i         : in     std_logic;
      ext_CALin_ecl_i         : in     std_logic;
      ext_CALin_nim_i         : in     std_logic;
      ext_FERin_ecl_i         : in     std_logic;
      ext_FERin_nim_i         : in     std_logic;
      ext_SPRin_ecl_i         : in     std_logic;
      ext_SPRin_nim_i         : in     std_logic;
      ext_BUSYin_ecl_i        : in     std_logic;
      ext_BUSYin_nim_i        : in     std_logic;
      ext_ETRGout_o           : out    std_logic;
      ext_BUSYout_o           : out    std_logic;
      ext_BUSYin_masked_o     : out    std_logic;
      led_RunMode_o           : out    std_logic;
      led_SAMode_o            : out    std_logic;
      int_TRGin_i             : in     std_logic;
      int_ECRin_i             : in     std_logic;
      int_FERin_i             : in     std_logic;
      int_oscFERen_o          : out    std_logic;
      int_oscTRGen_o          : out    std_logic;
      RunMode_o               : out    std_logic;
      int_oscR_o              : out    std_logic_vector (5 downto 1);
      int_oscS_o              : out    std_logic_vector (5 downto 1);
      trw_delayWD_o           : out    std_logic_vector (5 downto 0);
      trw_delayWS_o           : out    std_logic_vector (5 downto 0);
      trw_Win_en_o            : out    std_logic;
      trw_Win_open_i          : in     std_logic;
      trw_StopClk_o           : out    std_logic;
      setTTCClk_i             : in     std_logic;                       -- from reg on mixer.vhd
      cc_delayCT_o            : out    std_logic_vector (5 downto 0);
      cc_enIntClk_o           : out    std_logic;
      cc_enSAClk_o            : out    std_logic;
      cc_ExtClkOn_i           : in     std_logic;
      cc_SAClkOn_i            : in     std_logic;
      cc_TTCClkOn_i           : in     std_logic;
      bp_TIM_OK_out_o         : out    std_logic;
      SATRG_o                 : out    std_logic;
      SAECR_o                 : out    std_logic;
      SABCR_o                 : out    std_logic;
      SACAL_o                 : out    std_logic;
      SAFER_o                 : out    std_logic;
      SASPR_o                 : out    std_logic;
      --EDTRG_o       : out	std_logic; -- early delayed trig
      v_RCBUSY_o              : out    std_logic;
      v_f2_reset_o            : out    std_logic;
      bp_laser_intlck_state_i : in     std_logic;
      StartSeq_o              : out    std_logic;
      StartSink_o             : out    std_logic;
      DebugBus                : out    std_logic_vector (15 downto 0)
   );

-- Declarations

end samode ;


-- hds interface_end

architecture rtl of samode is

 	signal 	RegEnables 	: std_logic_vector(15 downto 0);
 	signal 	RegCommands	: std_logic_vector(15 downto 0);
 	signal 	RegBurstCnt	: std_logic_vector(15 downto 0);
 	signal 	RegFreq		: std_logic_vector(15 downto 0);
 	signal 	RegTrigWin	: std_logic_vector(15 downto 0);
 	signal 	RegDelays 	: std_logic_vector(15 downto 0);
 	signal 	RegStatus	: std_logic_vector(15 downto 0);



 	--BUSYs
 	------------------------------------

   signal ext_BUSYout   : std_logic;

   signal int_BUSY		: std_logic; -- OA_busy
	signal int_BUSYen		: std_logic;

   signal ext_BUSYin		: std_logic;
	signal ext_BUSYinen	: std_logic;
	signal v_busy			: std_logic;

	signal OA_busy			: std_logic;
	signal ext_BUSYin_masked : std_logic;


   -- General
   ---------------------------------
	signal RunMode			: std_logic;
 	signal SAMode			: std_logic;

 	signal v_f2_reset 	: std_logic;

 	--CLOCK CONTROL
 	----------------------------------

	signal ext_CLKen  	: std_logic;
   signal TIM_OK   	   : std_logic;

   signal burst_busy  	: std_logic;
   signal burst_waiting 	: std_logic;
 	signal v_BurstMode	: std_logic;
	signal v_BurstGo  	: std_logic;


	signal TestBUSY      : std_logic;
   signal TestBUSYen  	: std_logic;
	signal TestBUSYclr 	: std_logic;

   signal Window_open   : std_logic;
   signal Window_en     : std_logic;


   signal int_trg, int_trg_en : std_logic;
   signal int_ecr, int_ecr_en : std_logic;
   signal int_bcr, int_bcr_en : std_logic;
   signal int_fer, int_fer_en : std_logic;

   signal ran_trg, random_en  : std_logic;

   signal ext_TRG, ext_trg_en	: std_logic;
   signal ext_ECR, ext_ecr_en	: std_logic;
   signal ext_BCR, ext_bcr_en	: std_logic;
   signal ext_CAL, ext_cal_en	: std_logic;
   signal ext_FER, ext_fer_en	: std_logic;
   signal ext_SPR, ext_spr_en	: std_logic;

   signal v_trg 					: std_logic;
   signal v_ecr 					: std_logic;
   signal v_bcr 					: std_logic;
   signal v_cal 					: std_logic;
   signal v_fer 					: std_logic;
   signal v_spr 					: std_logic;

	
	signal sigs_raw_q1 			: std_logic_vector(5 downto 0);
	signal sigs_raw_q2 			: std_logic_vector(5 downto 0);
	signal sigs_raw_q3 			: std_logic_vector(5 downto 0);

   signal sigs_raw 				: std_logic_vector(5 downto 0);
   signal sigs_in 				: std_logic_vector(5 downto 0);
   signal sigs_out 				: std_logic_vector(5 downto 1); --trg dealt with seperately
      
   signal pre_trg  				: std_logic;
   signal trg_out  				: std_logic;
  
  	signal trg_out_q 				: std_logic_vector(2 downto 0);
  	signal trg_out_busy			: std_logic;
  	
   signal pipeln_in				: std_logic;
	signal pipeln_out				: std_logic;
	signal clr_pipeln				: std_logic;
	
	signal sigs_busy				: std_logic;
	
	signal burst_tick				: std_logic;
	

	-- Constants
	--------------------------------------------------------------------------
 	constant TRG 			: integer := 0;
 	constant ECR 			: integer := 1;
 	constant BCR 			: integer := 2;
 	constant CAL 			: integer := 3;
 	constant FER 			: integer := 4;
 	constant SPR 			: integer := 5;

	constant TRG_DEADTIME 	 : integer :=   3;
	constant ECR_DEADTIME 	 : integer :=   7;
	constant BCR_DEADTIME 	 : integer :=   7;
	constant CAL_DEADTIME 	 : integer :=  27;
	constant FER_DEADTIME 	 : integer :=   7;
	constant SPR_DEADTIME 	 : integer :=   7;
	constant BURST_CAL_DELAY : integer :=   5;


-------------------------------------------------------------------------------
--	MAIN CODE
-------------------------------------------------------------------------------
begin

	RunMode_o <= RunMode;
	SAMode <= (not RunMode);

	led_runmode_o <= RunMode;
	led_samode_o  <= SAMode;

   ext_BUSYout_o  <= ext_BUSYout;

   StartSeq_o   <= sigs_out(SPR);
	StartSink_o	 <= pre_trg or sigs_out(CAL);


   ------------------------------------------------------------------
   -- Internal Signals (i.e. from on-board sources)
   ------------------------------------------------------------------

   int_oscFERen_o <= int_fer_en or int_ecr_en;
   int_oscTRGen_o <= int_trg_en;

  	-- Int Signal programmable oscillators
	--------------------------------------
	int_oscR_o <= RegFreq( 4 downto 0);
	int_oscS_o <= RegFreq(12 downto 8);


   int_trg <= (int_TRGin_i and not random_en) or (ran_trg and random_en);
   int_ecr <= int_ECRin_i and int_ecr_en;
	int_fer <= int_FERin_i and int_fer_en;


   ------------------------------------------------------------------
   -- External Signals (i.e. from front panel sources)
   ------------------------------------------------------------------
	ext_TRG <= (ext_TRGin_nim_i or ext_TRGin_ecl_i) and ext_trg_en;
	ext_ECR <= (ext_ECRin_nim_i or ext_ECRin_ecl_i) and ext_ecr_en;
	ext_BCR <= (ext_BCRin_nim_i or ext_BCRin_ecl_i) and ext_bcr_en;
	ext_CAL <= (ext_CALin_nim_i or ext_CALin_ecl_i) and ext_cal_en;
	ext_FER <= (ext_FERin_nim_i or ext_FERin_ecl_i) and ext_fer_en;
	ext_SPR <= (ext_SPRin_nim_i or ext_SPRin_ecl_i) and ext_spr_en;

   ------------------------------------------------------------------
   -- Combined Signal Inputs
   ------------------------------------------------------------------

   sigs_raw(0) <= (ext_TRG or int_trg or v_trg or ext_TRG_sw_i	);
   sigs_raw(2) <= (ext_ECR or int_ecr or v_ecr						);
   sigs_raw(1) <= (ext_BCR or int_bcr or v_bcr						);
   sigs_raw(3) <= (ext_CAL            or v_cal						);
   sigs_raw(4) <= (ext_FER or int_fer or v_fer						);
   sigs_raw(5) <= (ext_SPR            or v_spr						);

	-- Synchronise and generate 1 clk wide signals
   sigs_in_synch_pulser : process (clk)
   begin
   	if rising_edge(clk) then
   		-- synchroniser+
   		sigs_raw_q1 <= sigs_raw;
  		   sigs_raw_q2 <= sigs_raw_q1;
  		   sigs_raw_q3 <= sigs_raw_q2;

			-- Edge detector (no rst to prevent spurios sigs after a reset)
			sigs_in     <= sigs_raw_q2 and not sigs_raw_q3;

   	end if;
   end process;


	----------------------------------------------------
	sa_sigs_control : block
		type state_type is (SM_RESET, SM_IDLE, SM_DEADTIMER);
     	signal state : state_type;
 		
 		signal dead_timer			: std_logic_vector(11 downto 0);
 		
 		signal cal_trg_next  	: std_logic;
     	signal burst_cal_next 	: std_logic;
     	signal cal_burst_busy 	: std_logic;
     	
     	signal trg_dt 		 		: std_logic_vector(11 downto 0);
     	signal ecr_dt 		 		: std_logic_vector(11 downto 0);
     	signal bcr_dt 		 		: std_logic_vector(11 downto 0);
     	signal cal_dt 		 		: std_logic_vector(11 downto 0);
     	signal fer_dt 		 		: std_logic_vector(11 downto 0);
     	signal spr_dt 		 		: std_logic_vector(11 downto 0);
     	signal bcal_delay  		: std_logic_vector(11 downto 0);
     	
	begin
		trg_dt 		<= conv_std_logic_vector(TRG_DEADTIME, 	12);
		ecr_dt 		<= conv_std_logic_vector(ECR_DEADTIME, 	12);
		bcr_dt 		<= conv_std_logic_vector(BCR_DEADTIME, 	12);
		cal_dt 		<= conv_std_logic_vector(CAL_DEADTIME, 	12);
		fer_dt 		<= conv_std_logic_vector(FER_DEADTIME, 	12);
		spr_dt 		<= conv_std_logic_vector(SPR_DEADTIME, 	12);
		bcal_delay 	<= conv_std_logic_vector(BURST_CAL_DELAY, 12);

		--------------------------------------------------
      sa_machine : process (clk)
     	begin
     		if rising_edge(clk) then
     			if (rst = '1') then
     				state 		<= SM_RESET;
	      		sigs_out  	<= (others => '0');
	      		dead_timer  <= (others => '0');
	  				pre_trg 		<= '0';
     				clr_pipeln  <= '0';

     				cal_trg_next <= '0'; -- note no default value below
     				burst_cal_next <= '0';
 					cal_burst_busy <= '0';


     			else
     				--defaults
     				sigs_out 	<= (others => '0');
     				pre_trg 		<= '0';
     				clr_pipeln  <= '0';

		      	case state is

			      	when SM_RESET =>
			      		sigs_out  	<= (others => '0');
			      		dead_timer  <= (others => '0');
	      				pre_trg 	<= '0';

			      		state <= SM_IDLE;

			      	when SM_IDLE =>
			      		--defaults
			      		state <= SM_DEADTIMER;
			      		sigs_busy <= '1';

			     		   if (burst_waiting = '1') then
			     		   	clr_pipeln 	   <= '1';
	      					cal_burst_busy <= '0';
	      								     		   	
			     		   	state <= SM_IDLE;
			     		   
			     			elsif	(trg_out = '1') then
		     					if (cal_burst_busy = '1') then
			      				burst_cal_next <= '1';
									dead_timer     <= bcal_delay;
								else
					      		state <= SM_IDLE;
			      			end if;

    		   		   elsif (trg_out_busy = '1') then
			     		   	state <= SM_IDLE;

			     			elsif	(burst_cal_next = '1') then
		      				burst_cal_next <= '0';
		      				cal_trg_next  <= '1';
			     				sigs_out(CAL) <= '1';
			     				dead_timer 	  <= cal_dt;
			     				
		     				elsif	(cal_trg_next = '1') then
		      				cal_trg_next <= '0';
			     				pre_trg 	 <= '1';
			     				
			     				state <= SM_IDLE; --*** this is wrong 
			     										-- leaves a hole in the busy signal
			     										-- allows incoming sigs too sigs too
			     				
			      				      			
			      		elsif (cal_burst_busy = '1') then
			      			state <= SM_IDLE; --*** this uses the heirachy
			      			-- if we get this far we are cal_bursting, 
			      			-- but waiting for the trigger to leave the pipeline
			      			
			     			
			     			-- below is the 'normal' hierachy
			     			---------------------------------
			     			elsif	(sigs_in(TRG) = '1') then
			     				pre_trg 	  <= '1';
			     				dead_timer 	  <= trg_dt;
			     				
		     				elsif (sigs_in (CAL) = '1') then
			      			sigs_out(CAL) <= '1';
		      				cal_trg_next  <= '1';
			      			dead_timer 	  <= cal_dt;
			      			
			      			if (burst_busy = '1') then
			      				cal_burst_busy <= '1';
			      			end if;

			      		elsif (sigs_in (BCR) = '1') and (burst_busy = '0') then
			      			sigs_out(BCR) <= '1';
			      			dead_timer 	  <= bcr_dt;

			      		elsif (sigs_in (ECR) = '1') and (burst_busy = '0') then
			      			sigs_out(ECR) <= '1';
			      			dead_timer	  <= ecr_dt;

			      		elsif (sigs_in (FER) = '1') and (burst_busy = '0') then
			      			sigs_out(FER) <= '1';
			      			dead_timer  	 <= fer_dt;

			      		elsif (sigs_in (SPR) = '1') and (burst_busy = '0') then
			      			dead_timer 	 <= spr_dt;

			      		else
			      			sigs_busy <= '0';
			      			
			      			state <= SM_IDLE;

			      		end if;


			      	when SM_DEADTIMER =>
							sigs_busy <= '1';

			      		--default
			     			state <= SM_DEADTIMER;

			      		if (dead_timer = "000000000000") then
			      			state <= SM_IDLE;

			      		else
				     			dead_timer <= dead_timer - '1';

			      		end if;

		      		when others => null;
		   		end case;
		   	end if;
		   end if;
		end process;
		
		-- Trigger Out Deadtime
		process (clk)
		begin
			if rising_edge(clk) then
				if (rst = '1') then 
					trg_out_q <= "000";
					
				else
					trg_out_q <= (trg_out_q(1 downto 0) & trg_out);
				
				end if;
			end if;
		end process;
		
	end block;
	
	trg_out <= pipeln_out;
	trg_out_busy <= '0' when (trg_out & trg_out_q) = "0000" else '1';
	

	burst_tick <= trg_out;
	pipeln_in <= pre_trg;
	
	OA_busy <= sigs_busy or trg_out_busy;

   ---------------------------------------------------------------------------
	-- OUTPUTs
	---------------------------------------------------------------------------

   ext_eTRGout_o   <= pre_trg;

	SATRG_o <= trg_out;
   SAECR_o <= sigs_out(ECR);
   SABCR_o <= sigs_out(BCR);
   SACAL_o <= sigs_out(CAL);
   SAFER_o <= sigs_out(FER);
   SASPR_o <= sigs_out(SPR);


	---------------------------------------------------------------------------
   -- Pseudo-Randomiser
   ---------------------------------------------------------------------------

   -- generates ran_trg

   rnd: block
      signal shiftreg    : std_logic_vector(39 downto 1);
      signal shiftreg_in : std_logic;

      signal int_trgin_q : std_logic_vector(2 downto 0);

   begin

      process (clk)
      begin
      	if rising_edge(clk) then
         	-- syncronise (extra ff for edgedet)
         	int_trgin_q(0) <= int_TRGin_i;
         	int_trgin_q(1) <= int_trgin_q(0);
         	int_trgin_q(2) <= int_trgin_q(1);

      	-- rising edge detect
            if (int_trgin_q(2 downto 1) = "01") then

               shiftreg(39 downto 2) <= shiftreg(38 downto 1);
               shiftreg(1)           <= shiftreg(39) xor shiftreg(35);

	         end if;
         end if;
      end process;

      ran_trg <= shiftreg(39);

   end block;



   ------------------------------------------------------------------
	-- Trigger pipeln delay
   ------------------------------------------------------------------
   shift144: block

      signal shift_a    : std_logic_vector(127 downto 0);
      signal shift_b    : std_logic_vector( 15 downto 0);

      signal sel_a      : std_logic_vector(3 downto 0);
      signal sel_b      : std_logic_vector(3 downto 0);

      signal sr_a_out   : std_logic;
      signal sr_b_out   : std_logic;

      signal shift_clr  : std_logic;

      signal shift_in   : std_logic;
      signal shift_in_q	: std_logic_vector(2 downto 0);


   begin

      shift_in  <= pipeln_in;
      shift_clr <= clr_pipeln;

      sel_a <= RegDelays(7 downto 4);
      sel_b <= RegDelays(3 downto 0);

      process (clk)
      begin

         if rising_edge(clk) then
         	if (rst = '1') or (shift_clr = '1') then
  	            shift_in_q 	<= (others => '0');
	            shift_a  	<= (others => '0');
	            shift_b  	<= (others => '0');
 	            sr_a_out		<= '0';
	            sr_b_out 	<= '0';

	   		else
				 	-- extra delay for TIM2 compat
               shift_in_q  <= (shift_in_q(1 downto 0) & shift_in);

               shift_a <= (shift_a(126 downto 0) & shift_in_q(2));


               case sel_a is
                  when "0000" => sr_a_out <= shift_in;
                  when "0001" => sr_a_out <= shift_a(15);
                  when "0010" => sr_a_out <= shift_a(31);
                  when "0011" => sr_a_out <= shift_a(47);
                  when "0100" => sr_a_out <= shift_a(63);
                  when "0101" => sr_a_out <= shift_a(79);
                  when "0110" => sr_a_out <= shift_a(95);
                  when "0111" => sr_a_out <= shift_a(111);
                  when "1000" => sr_a_out <= shift_a(127);

                  when others => sr_a_out <= shift_a(127);
               end case;

               shift_b <= (shift_b(14 downto 0) & sr_a_out);

               case sel_b is
                  when "0000" => sr_b_out <= shift_b(0);
                  when "0001" => sr_b_out <= shift_b(1);
                  when "0010" => sr_b_out <= shift_b(2);
                  when "0011" => sr_b_out <= shift_b(3);
                  when "0100" => sr_b_out <= shift_b(4);
                  when "0101" => sr_b_out <= shift_b(5);
                  when "0110" => sr_b_out <= shift_b(6);
                  when "0111" => sr_b_out <= shift_b(7);
                  when "1000" => sr_b_out <= shift_b(8);
                  when "1001" => sr_b_out <= shift_b(9);
                  when "1010" => sr_b_out <= shift_b(10);
                  when "1011" => sr_b_out <= shift_b(11);
                  when "1100" => sr_b_out <= shift_b(12);
                  when "1101" => sr_b_out <= shift_b(13);
                  when "1110" => sr_b_out <= shift_b(14);
                  when "1111" => sr_b_out <= shift_b(15);

                  when others => null;
               end case;
	         end if;
	   	end if;
      end process;

      pipeln_out <= sr_b_out;

   end block;


	---------------------------------------------------------------------------
	-- Trigger Window
	---------------------------------------------------------------------------

   Window_open <= trw_Win_open_i and Window_en;
   trw_win_en_o <= Window_en;

	-- Programmable delay lines
	trw_delayWS_o <= RegTrigWin( 5 downto 0);
	trw_delayWD_o <= RegTrigWin(13 downto 8);

	trw_StopClk_o <= (Reg08 and db_wr);


	---------------------------------------------------------------------------
	-- SA BCR Generator
	---------------------------------------------------------------------------

   --synchronous 11.2456kHz pulse generator

   BCR_gen: block

      signal bcr_timer_max : std_logic;

   begin

      process (rst, clk)

         subtype int12 is integer range 0 to 16#FFF#;
         variable bcr_timer : int12;

      begin
         if (rst = '1') then
            bcr_timer := 0;
            bcr_timer_max <= '0';

         elsif rising_edge(clk) then

            if bcr_timer = 3564 then  --### set rollover (should be 3564?)
               bcr_timer := 0;
               bcr_timer_max <= '1';

            else
               bcr_timer := bcr_timer + 1;
               bcr_timer_max <= '0';

            end if;
         end if;
      end process;


      int_bcr <= bcr_timer_max and int_bcr_en;

   end block;





	---------------------------------------------------------------------------
	-- TIM BUSYs
	---------------------------------------------------------------------------

	-- *** synchronise?
	ext_BUSYin <= ext_BUSYin_ecl_i OR ext_BUSYin_nim_i;

	int_BUSY	<= OA_busy;

	ext_BUSYout <= 	(int_BUSY and int_BUSYen)
						or (ext_BUSYin and ext_BUSYinen)
						or (RCBUSY_i and RCBUSYen_i)
						or v_Busy;



	-- masked version of BusyIn
	ext_BUSYin_masked	<= ext_BUSYin and ext_BUSYinen;
	ext_BUSYin_masked_o <= ext_BUSYin_masked;


	---------------------------------------------------------------------------
	-- Test Busy
	---------------------------------------------------------------------------
	process (rst, clk)
	begin
		if (rst = '1') then
			TestBUSY <= '0';

		elsif rising_edge(clk) then

			if (TestBUSYclr = '1') then
				TestBUSY <= '0';

			else
				TestBUSY <= (trg_out or TestBUSY) and TestBUSYen;

			end if;
		end if;
	end process;


   ----------------------------------------------------------------------------
  	-- Burst Mode
  	----------------------------------------------------------------------------

   Burst: block

      signal burst_count_en	: std_logic;
      signal burst_done    	: std_logic;
      signal burst_counter   	: std_logic_vector(15 downto 0);
      signal v_burstgo_q		: std_logic_vector(1 downto 0);
      signal burst_fire			: std_logic;


   begin

		v_burstgo_q(0) <= v_BurstGo;

      process (clk)
      begin

         if rising_edge(clk) then
         	if (rst = '1') then
            	burst_counter 	<= (others => '0');
           	 	burst_done 		<= '0';
            	burst_count_en <= '0';
            	burst_fire 		<= '0';
            	v_burstgo_q(1) <= '0';

         	else

         		-- Burst Go rising edge detect ----------------
         		v_burstgo_q(1) <= v_BurstGo;

         		--default
         		burst_fire <= '0';
         		
         		if v_burstgo_q = "01" then
         			burst_fire <= '1';
         		end if;


         		-- Burst Counter Control -----------------------
	         	if (v_BurstMode = '1') then

	         		if (v_BurstGo = '0') then
	         			burst_count_en <= '0';

	            	elsif (burst_counter = "0000000000000000") then
	                  burst_count_en <= '0';

	               elsif (burst_fire = '1') then
	                  burst_count_en <= '1';

	               end if;

	            else
	               burst_count_en <= '0';

	            end if;


					-- Burst Counter  ------------------------------------------
	            if (burst_count_en = '1') then
	            	if (burst_tick = '1') then
	            		burst_counter <= burst_counter - '1';

	               end if;

	            else
	               burst_counter <= RegBurstCnt;

	            end if;
         	end if;
         end if;
      end process;

      burst_busy 	 <= burst_count_en;
      burst_waiting <= v_BurstMode and (not burst_count_en);


   end block;


  	----------------------------------------------------------------------------
  	-- Clock Control
  	----------------------------------------------------------------------------

   cc_delayCT_o <= RegDelays(13 downto 8);

   cc_enSAClk_o 	<= not setTTCClk_i;
   cc_enIntClk_o	<= not ext_clken;

   -- *** this is way too simplified -- just for pin count now
   TIM_OK <= cc_SACLKOn_i or cc_TTCClkOn_i or cc_ExtClkOn_i;

   bp_TIM_OK_out_o <= TIM_OK;

	---------------------------------------------------------------------------
	-- Status Register
	--------------------------

	RegStatus(15) <= bp_laser_intlck_state_i;
	RegStatus(14) <= TestBUSY;
	RegStatus(13) <= TIM_OK;
	RegStatus(12) <= '0'; -- *** extclkon?
	RegStatus(11) <= SAMode;
	RegStatus(10) <= RunMode;
	RegStatus( 9) <= cc_SAClkOn_i;
	RegStatus( 8) <= cc_TTCClkOn_i;
	RegStatus( 7) <= RCBUSY_i;
	RegStatus( 6) <= SinkBusy_i;
	RegStatus( 5) <= SeqBusy_i;
	RegStatus( 4) <= burst_busy;
	RegStatus( 3) <= ext_BUSYout;
	RegStatus( 2) <= int_BUSY;
	RegStatus( 1) <= ext_BUSYin_masked;
	RegStatus( 0) <= ext_BUSYin;

  	---------------------------------------------------------------------------
	-- Enables Register
	--------------------------

	int_trg_en     <= RegEnables( 1);
   int_ecr_en  	<= RegEnables( 2);
   int_bcr_en 		<= RegEnables( 3);
   random_en  		<= RegEnables( 4);
   int_fer_en     <= RegEnables( 5);
  	Window_en 		<= RegEnables( 6);
  	int_BUSYen	   <= RegEnables( 7);
 	ext_CLKen  		<= RegEnables( 8);
   ext_trg_en 		<= RegEnables( 9) and (Window_open or (not Window_en));
   ext_ecr_en  	<= RegEnables(10);
   ext_bcr_en  	<= RegEnables(11);
   ext_cal_en  	<= RegEnables(12);
   ext_fer_en  	<= RegEnables(13);
   ext_spr_en 		<= RegEnables(14);
 	ext_BUSYinen	<= RegEnables(15);


  	---------------------------------------------------------------------------
	-- Commands Register
	--------------------------

   --reserved	<= RegCommands( 0);
   v_trg 		<= RegCommands( 1);
   v_ecr 		<= RegCommands( 2);
   v_bcr 		<= RegCommands( 3);
   v_cal 		<= RegCommands( 4);
   v_fer			<= RegCommands( 5);
   v_spr			<= RegCommands( 6);
	v_busy   	<= RegCommands( 7);
	v_RCBUSY_o 	<= RegCommands( 8);
   v_BurstMode	<= RegCommands( 9);
   v_BurstGo  	<= RegCommands(10);
   --reserved	<= RegCommands(11);
	RunMode 		<= RegCommands(12);
   TestBUSYen  <= RegCommands(13);
   TestBUSYclr <= RegCommands(14);
   v_f2_reset  <= RegCommands(15);


	v_f2_reset_o  <= v_f2_reset;

  	----------------------------------------------------------------------------
  	-- Data Bus
  	----------------------------------------------------------------------------

  	process (rst, clk)
  	begin

    	if (rst = '1') then
      	RegEnables 	<= "0000000000000000";
      	RegCommands <= "0000000000000000";
			RegBurstCnt	<= "0000000000000000";
      	RegFreq		<= "0000000000000000";
      	RegTrigWin	<= "0000000000000000";
      	RegDelays 	<= "0000000000000000";

    	elsif rising_edge(clk) then

    		-- Writes
    		---------
      	if 	(Reg00 and db_wr) = '1' then RegEnables  <= db;
     		elsif (Reg02 and db_wr) = '1' then RegCommands <= db;
        	elsif (Reg04 and db_wr) = '1' then RegBurstCnt <= db;
       	elsif (Reg06 and db_wr) = '1' then RegFreq	  <= db;
       	elsif (Reg08 and db_wr) = '1' then RegTrigWin  <= db;
        	elsif (Reg0A and db_wr) = '1' then RegDelays   <= db;
        	end if;

    	end if;
  	end process;


	-- Read Data
	------------

	db <= RegEnables  when (Reg00 and db_rd) = '1' else
			RegCommands when (Reg02 and db_rd) = '1' else
			RegBurstCnt when (Reg04 and db_rd) = '1' else
			RegFreq     when (Reg06 and db_rd) = '1' else
			RegTrigWin  when (Reg08 and db_rd) = '1' else
			RegDelays   when (Reg0A and db_rd) = '1' else
			RegStatus   when (Reg0C and db_rd) = '1' else (others => 'Z');

	-----------------------------------------------------
	-- Debug Bus
  	----------------------------------------------------

	DebugBus <= (others => '0');





end rtl;
