-- hds header_start
--
-- VHDL Architecture TIM_fpga2.seq_control.rtl2
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:52:13 02/03/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity seq_control is
   port( 
      rst                  : in     std_logic;
      clk                  : in     std_logic;
      db                   : inout  std_logic_vector (15 downto 0);
      db_wr                : in     std_logic;
      db_rd                : in     std_logic;
      reg_sequencer_i      : in     std_logic_vector (15 downto 0);
      reg_seq_end_i        : in     std_logic_vector (15 downto 0);
      ren_seq_sink_count_i : in     std_logic;
      ren_seq_src_count_i  : in     std_logic;
      ram_select_i         : in     std_logic;
      ab_i                 : in     std_logic_vector (15 downto 0);
      AllL1A_i             : in     std_logic;
      AllBCR_i             : in     std_logic;
      AllECR_i             : in     std_logic;
      AllCAL_i             : in     std_logic;
      AllFER_i             : in     std_logic;
      AllSPR_i             : in     std_logic;
      AllEXS_i             : in     std_logic;
      AllTTS_i             : in     std_logic;
      StartSeq_i           : in     std_logic;
      StartSink_i          : in     std_logic;
      SeqBusy_o            : out    std_logic;
      SinkBusy_o           : out    std_logic;
      SeqTRIG_o            : out    std_logic;
      SeqBCR_o             : out    std_logic;
      SeqECR_o             : out    std_logic;
      SeqCAL_o             : out    std_logic;
      SeqFER_o             : out    std_logic;
      SeqSPR_o             : out    std_logic;
      SeqEXS_o             : out    std_logic;
      SeqTTS_o             : out    std_logic;
      SrcRAM_data_o        : out    std_logic_vector (7 downto 0);
      SrcRAM_data_i        : in     std_logic_vector (7 downto 0);
      SrcRAM_addr_o        : out    std_logic_vector (13 downto 0);
      SrcRAM_wr_o          : out    std_logic;
      SrcRAM_en_o          : out    std_logic;
      SinkRAM_data_o       : out    std_logic_vector (7 downto 0);
      SinkRAM_data_i       : in     std_logic_vector (7 downto 0);
      SinkRAM_addr_o       : out    std_logic_vector (13 downto 0);
      SinkRAM_wr_o         : out    std_logic;
      SinkRAM_en_o         : out    std_logic;
      ttcl1a_i             : in     std_logic;
      busy_bst_i           : in     std_logic;
      trigseq_mode_en_i	   : in     std_logic
   );

-- Declarations

end seq_control ;


-- hds interface_end

architecture rtl of seq_control is

   --signal reg_sequencer  : std_logic_vector(15 downto 0);
   --signal reg_seq_end     : std_logic_vector(15 downto 0);

	-- Common
   signal cyclic_en   	: std_logic;	-- reg_sequencer_i(11);
   signal seq_go   		: std_logic;
   signal seq_go_q		: std_logic_vector(1 downto 0);
   signal seq_go_rising : std_logic;
  	signal seq_go_rise_q : std_logic_vector(2 downto 0);
	signal seq_end	   	: std_logic_vector(13 downto 0);


	-- Source ---------------------------------------------------
   signal SrcReset      : std_logic;
   signal SrcGo         : std_logic;
   signal SrcGo_q			: std_logic_vector(1 downto 0);
   signal SrcGo_rising	: std_logic;

	signal SrcCount      : std_logic_vector(13 downto 0);
   signal SrcCountEn    : std_logic;
   signal SrcCountEn_q  : std_logic;
   signal SrcFire       : std_logic;
   signal src_run			: std_logic;

   signal SrcRAMsel		: std_logic;
	signal SrcRAMwr		: std_logic;

	signal SrcRollCount : std_logic_vector(1 downto 0);


	-- Sink -----------------------------------------------------
   signal SinkReset     : std_logic;
   signal StartSinkEn   : std_logic;

   signal SinkCount     : std_logic_vector(13 downto 0);
   signal SinkCountEn   : std_logic;

   signal SinkFire		: std_logic;
   signal sink_run		: std_logic;

   signal SinkRAMsel		: std_logic;
	signal SinkRAMwr		: std_logic;

   signal SinkRollCount : std_logic_vector(1 downto 0);


   ------------------------------------------------------------

	signal all_sigs_in 	: std_logic_vector(7 downto 0);
	signal all_sigs_out 	: std_logic_vector(7 downto 0);

	signal seq_busy		: std_logic;


-------------------------------------------------------------------------------
-- MAIN CODE
-------------------------------------------------------------------------------
begin

	------------------------------------------------------
	-- SEQUENCER CONTROL
	------------------------------------------------------

   SrcReset    <= reg_sequencer_i( 9);
   SrcGo      	<= reg_sequencer_i(10);
   cyclic_en	<= reg_sequencer_i(11);

   SinkReset   <= reg_sequencer_i(13);
   seq_go 		<= reg_sequencer_i(14); -- was SinkGo
   StartSinkEn	<= reg_sequencer_i(15);


	-- Generate Src/Sink Fire pulses
   SrcGo_q(0)  <= SrcGo;
   seq_go_q(0) <= seq_go;

	SrcFire  <= (SrcGo_rising or seq_go_rising or StartSeq_i);
	SinkFire <= seq_go_rise_q(2) or ((StartSink_i or ttcl1a_i) and StartSinkEn);


	-- get rising edge of Sequ/Src Go's
	process (clk)
   begin
   	if rising_edge(clk) then

   		if (rst = '1') then
				SrcGo_rising  <= '0';
				seq_go_rising <= '0';

				SrcGo_q(1)    <= '0';
   			seq_go_q(1)   <= '0';
				seq_go_rise_q <= (others => '0');

   		else
				SrcGo_q(1) 		  <= SrcGo_q(0);
				seq_go_q(1) 	  <= seq_go_q(0);
				seq_go_rise_q(0) <= seq_go_rising;
				seq_go_rise_q(1) <= seq_go_rise_q(0);
				seq_go_rise_q(2) <= seq_go_rise_q(1);

   			-- defaults
				SrcGo_rising  <= '0';
				seq_go_rising <= '0';

				-- rising_edge detect
				if (SrcGo_q  = "01") then SrcGo_rising  <= '1'; end if;
				if (seq_go_q = "01") then seq_go_rising <= '1';	end if;

   		end if;
   	end if;
   end process;

	seq_busy   <= SrcCountEn or SinkCountEn;
  	SeqBusy_o  <= seq_busy;
	SinkBusy_o <= SinkCountEn;


	------------------------------------------------------
	-- SOURCE
	------------------------------------------------------

	SrcRAMsel <= ram_select_i and (not SrcCountEn) after 1 ns;
	SrcRAMwr  <= SrcRAMsel and db_wr  after 1 ns;

   SrcRAM_addr_o 	<= ab_i(14 downto 1) after 1 ns when (SrcRAMsel = '1') else SrcCount after 1 ns;
   SrcRAM_data_o 	<= db( 7 downto 0) after 1 ns;

   SrcRAM_wr_o 	<= SrcRAMwr;
   SrcRAM_en_o 	<= SrcRAMsel or SrcCountEn  after 1 ns;

   -----------------------------------------------------------------
   SrcCounter: process (clk)
   begin

		if rising_edge(clk) then
 			if (rst = '1') or (SrcReset = '1') then
				SrcCount    <= (others => '0');
				src_run  <= '0';
	         
			else
	         if (SrcCount = seq_end) then
	         	--default
	         	src_run <= '0';
	         			
	         	-- reset counter to zero if cyclic or in trigseq mode			   
				   if (cyclic_en = '1') or (trigseq_mode_en_i = '1') then
	            	SrcCount <= (others => '0');
				   end if;
				   
				   -- keep running if cyclic
        			if (cyclic_en = '1') then
 		         	src_run  <= '1';
				   end if;

	         elsif (SrcCountEn = '1') then
	         	SrcCount <= SrcCount + '1';
	         	
	         elsif (SrcFire = '1') then
	         	src_run  <= '1';
	         	         
	         end if;
			end if;
		end if;
	end process;
		
	SrcCountEn <= src_run and not(busy_bst_i);
	
	
	-----------------------------------------------------------------

	-- *** This is just for debug
	-- Tests if the Seq runs beyond it's end reg by accidents (2 go's)
	Src_Rollover_Counter: process (clk)
	begin
		if rising_edge(clk) then
 			if (rst = '1') or (SrcReset = '1') then
	         SrcRollCount  <= "00";

	      else
	      	if (SrcCount = "11111111111111") then
	      		SrcRollCount  <= SrcRollCount + '1';
	      	end if;
	      end if;
	   end if;
	end process;



	-- Clock Out Src Signals
	-------------------------
   --enSeqTRIG	<= reg_sequencer_i(0);
   --enSeqECR	<= reg_sequencer_i(1);
	--enSeqBCR 	<= reg_sequencer_i(2);
	--enSeqCAL	<= reg_sequencer_i(3);
	--enSeqEXS	<= reg_sequencer_i(4);
	--enSeqTTS	<= reg_sequencer_i(5);
   --enSeqFER	<= reg_sequencer_i(6);
	--enSeqSPR	<= reg_sequencer_i(7);

	process (rst, clk)
	begin

		if (rst = '1') then
			all_sigs_out <= (others => '0');
			SrcCountEn_q <= '0';

		elsif rising_edge(clk) then
			SrcCountEn_q <= SrcCountEn;

			-- default
			all_sigs_out <= (others => '0');

			if (SrcCountEn_q = '1') then
				all_sigs_out <= SrcRAM_data_i and reg_sequencer_i(7 downto 0);

			end if;
		end if;
	end process;

	SeqTRIG_o <= all_sigs_out(0);
	SeqECR_o  <= all_sigs_out(1);
	SeqBCR_o	 <= all_sigs_out(2);
	SeqCAL_o  <= all_sigs_out(3);
	SeqEXS_o  <= all_sigs_out(4);
	SeqTTS_o  <= all_sigs_out(5);
	SeqFER_o  <= all_sigs_out(6);
	SeqSPR_o  <= all_sigs_out(7);


	---------------------------------------------------------------------------
	-- SINK
	---------------------------------------------------------------------------

	all_sigs_in(0) <= AllL1A_i;
  	all_sigs_in(1) <= AllECR_i;
   all_sigs_in(2) <= AllBCR_i;
	all_sigs_in(3) <= AllCAL_i;
	all_sigs_in(4) <= AllEXS_i;
	all_sigs_in(5) <= AllTTS_i;
	all_sigs_in(6) <= AllFER_i;
	all_sigs_in(7) <= AllSPR_i;


	SinkRAMsel <= ram_select_i and (not SinkCountEn) after 1 ns;
	SinkRAMwr  <= SinkRAMsel and db_wr after 1 ns;

   SinkRAM_en_o   <= SinkRAMsel or SinkCountEn after 1 ns;
   SinkRAM_wr_o   <= SinkRAMwr or SinkCountEn after 1 ns;

   SinkRAM_addr_o <= ab_i(14 downto 1) after 1 ns when (SinkRAMsel = '1') else
   						SinkCount         after 1 ns;

	SinkRAM_data_o <= db(15 downto 8) after 1 ns when (SinkRAMwr = '1') else
							all_sigs_in     after 1 ns;

   -----------------------------------------------------------------
   SinkCounter: process (clk)
   begin

		if rising_edge(clk) then
 			if (rst = '1') or (SinkReset = '1') then
				SinkCount <= (others => '0');
				sink_run  <= '0';
	         
			else
	         if (SinkCount = seq_end) then
	         	--default
	         	sink_run <= '0';
	         	
        			if (cyclic_en = '1') then
	            	SinkCount <= (others => '0');
 		         	sink_run  <= '1';
				   end if;

				elsif (SinkCountEn = '1') then
	         	SinkCount <= SinkCount + '1';
	         	
	         elsif (SinkFire = '1') then
	         	sink_run  <= '1';

	         end if;
			end if;
		end if;
	end process;
	
	SinkCountEn <= sink_run and not(busy_bst_i);
	
	
	-----------------------------------------------------------------

	-- *** This is just for debug
	-- Tests if the Seq runs beyond it's end reg by accidents (2 go's)
	Sink_Rollover_Counter: process (clk)
	begin
		if rising_edge(clk) then
 			if (rst = '1') or (SinkReset = '1') then
	         SinkRollCount  <= "00";

	      else
	      	if (SinkCount = "11111111111111") then
	      		SinkRollCount  <= SinkRollCount + '1';

	      	end if;
	      end if;
	   end if;
	end process;


   ---------------------------------------------------------------------------
   -- Data Bus
   ---------------------------------------------------------------------------

	-- DB Writes
	---------------------------------------------------------------------------

   --process (clk)
   --begin
      --if rising_edge(clk) then
			--if (rst = '1') then
         	--reg_sequencer <= (others => '0');
  	         --reg_seq_end <= (others => '0');

			--else
	         --if (Reg1A = '1') and (db_wr = '1') then reg_sequencer <= db; end if;
            --if (Reg1C = '1') and (db_wr = '1') then reg_seq_end    <= db; end if;

		   --end if;
      --end if;
   --end process;
   
   seq_end <= reg_seq_end_i(13 downto 0);

	-- DB Reads
	---------------------------------------------------------------------------
	db_read : block
		signal	ram_db16 		: std_logic_vector(15 downto 0);
		signal	srccount_db16 	: std_logic_vector(15 downto 0);
		signal	sinkcount_db16 : std_logic_vector(15 downto 0);

		constant RAM_BUSY_VAL : std_logic_vector(15 downto 0)
					:= "1111111111111111";

	begin
   	ram_db16( 7 downto 0) 		  <= SrcRAM_data_i;
   	ram_db16(15 downto 8) 		  <= SinkRAM_data_i;
	  	srccount_db16(15 downto 14)  <= SrcRollCount;
   	srccount_db16(13 downto 0)	  <= SrcCount;
   	sinkcount_db16(15 downto 14) <= SinkRollCount;
   	sinkcount_db16(13 downto 0)  <= SinkCount;

   	db <= RAM_BUSY_VAL   after 1 ns when ((db_rd and ram_select_i and seq_busy) = '1') else
   			ram_db16 		after 1 ns when ((db_rd and ram_select_i) = '1') else
   			srccount_db16  after 1 ns when ((db_rd and ren_seq_src_count_i)  = '1') else
   			sinkcount_db16 after 1 ns when ((db_rd and ren_seq_sink_count_i) = '1') else
   			(others => 'Z');
   			
  			--	reg_sequencer 	when ((db_rd and Reg1A)     = '1') else
   		--	reg_seq_end    when ((db_rd and Reg1C)     = '1') else
   			
   end block;

end rtl;
