-- hds header_start
--
-- VHDL Architecture TIM_fpga2.seq_control.rtl2
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:52:13 02/03/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity seq_control is
   port( 
      rst            : in     std_logic;
      clk            : in     std_logic;
      db             : inout  std_logic_vector (15 downto 0);
      db_wr          : in     std_logic;
      db_rd          : in     std_logic;
      Reg1A          : in     std_logic;
      Reg1C          : in     std_logic;
      Reg48          : in     std_logic;
      Reg46          : in     std_logic;
      RAMselect      : in     std_logic;
      ab_i           : in     std_logic_vector (15 downto 0);
      AllL1A_i       : in     std_logic;
      AllBCR_i       : in     std_logic;
      AllECR_i       : in     std_logic;
      AllCAL_i       : in     std_logic;
      AllFER_i       : in     std_logic;
      AllSPR_i       : in     std_logic;
      AllEXS_i       : in     std_logic;
      AllTTS_i       : in     std_logic;
      StartSeq_i     : in     std_logic;
      StartSink_i    : in     std_logic;
      SeqBusy_o      : out    std_logic;
      SinkBusy_o     : out    std_logic;
      SeqTRIG_o      : out    std_logic;
      SeqBCR_o       : out    std_logic;
      SeqECR_o       : out    std_logic;
      SeqCAL_o       : out    std_logic;
      SeqFER_o       : out    std_logic;
      SeqSPR_o       : out    std_logic;
      SeqEXS_o       : out    std_logic;
      SeqTTS_o       : out    std_logic;
      SrcRAM_data_o  : out    std_logic_vector (7 downto 0);
      SrcRAM_data_i  : in     std_logic_vector (7 downto 0);
      SrcRAM_addr_o  : out    std_logic_vector (13 downto 0);
      SrcRAM_wr_o    : out    std_logic;
      SrcRAM_en_o    : out    std_logic;
      SinkRAM_data_o : out    std_logic_vector (7 downto 0);
      SinkRAM_data_i : in     std_logic_vector (7 downto 0);
      SinkRAM_addr_o : out    std_logic_vector (13 downto 0);
      SinkRAM_wr_o   : out    std_logic;
      SinkRAM_en_o   : out    std_logic
   );

-- Declarations

end seq_control ;


-- hds interface_end

architecture rtl_test of seq_control is

   signal RegSequencer  : std_logic_vector(15 downto 0);
   signal RegSeqEnd     : std_logic_vector(15 downto 0);

   signal enSeqTRIG     : std_logic;   --RegSequencer(0);
   signal enSeqBCR      : std_logic;   --RegSequencer(2);
   signal enSeqECR      : std_logic;   --RegSequencer(1);
   signal enSeqCAL      : std_logic;   --RegSequencer(3);
   signal enSeqFER      : std_logic;   --RegSequencer(6);
   signal enSeqSPR      : std_logic;   --RegSequencer(7);
   signal enSeqEXS      : std_logic;   --RegSequencer(4);
   signal enSeqTTS      : std_logic;   --RegSequencer(5);

	-- Common
   signal SeqCyclicEn   : std_logic;   -- RegSequencer(11);
   signal SequencerGo   : std_logic;


	-- Source
   signal SrcReset      : std_logic;
   signal SrcGo         : std_logic;

	signal SrcCount      : std_logic_vector(13 downto 0);
   signal SrcCountEn    : std_logic;
   signal SrcCountEn_q  : std_logic;
   signal SrcCountClr   : std_logic;
 	signal SrcCountMax	: std_logic;
   signal SrcFire       : std_logic;

	signal SrcFire_q  	: std_logic_vector(1 downto 0);
	
   signal SrcRAMsel		: std_logic;
	signal SrcRAMwr		: std_logic;
	
	


	-- Sink
   signal SinkReset     : std_logic;
   signal StartSinkEn   : std_logic;

   signal SinkCount     : std_logic_vector(13 downto 0);
   signal SinkCountEn   : std_logic;
   signal SinkCountEn_q : std_logic;
   signal SinkCountClr  : std_logic;
	signal SinkCountMax	: std_logic;

   signal SinkFire		: std_logic;
   signal SinkFire_q		: std_logic_vector(1 downto 0);
   
   signal SinkGo			: std_logic;
   signal SinkGo_q 		: std_logic_vector(4 downto 0);
   
   signal SinkRAMsel		: std_logic;
	signal SinkRAMwr		: std_logic;
	



   -------------------------------------------

	signal allsig_i_bus 	: std_logic_vector(7 downto 0);

   
-------------------------------------------------------------------------------
-- MAIN CODE
-------------------------------------------------------------------------------
begin
	
	------------------------------------------------------
	-- SEQUENCER CONTROL
	------------------------------------------------------
  
   SrcReset    <= RegSequencer( 9);
   SrcGo      	<= RegSequencer(10);
   SeqCyclicEn	<= RegSequencer(11);

   SinkReset   <= RegSequencer(13);
   SequencerGo <= RegSequencer(14); -- was SinkGo
   StartSinkEn	<= RegSequencer(15);
   
	-- Sink Go Delay
   process (clk)
   begin
   	if rising_edge(clk) then
   		if (rst = '1') then
   			SinkGo_q <= (others => '0');
   			
   		else
   			SinkGo_q(4 downto 1) <= SinkGo_q (3 downto 0);
   			SinkGo_q(0) <= SinkGo;
   		
   		end if;
   	end if;
   end process;


	-- Generate Src/Sink Fire pulses
	
   SinkGo		  <= SequencerGo;
		
	SrcFire_q(0)  <= SrcGo or SequencerGo or StartSeq_i;
	SinkFire_q(0) <= SinkGo_q(2) or (StartSink_i and StartSinkEn);

	process (clk)
   begin
   	if rising_edge(clk) then
   	
   		if (rst = '1') then
				SrcFire  <= '0';
				SinkFire <= '0';				
				
				SrcFire_q(1)  <= '0'; 
   			SinkFire_q(1) <= '0';
   			
   		else
				SrcFire_q(1)  <= SrcFire_q(0);
				SinkFire_q(1) <= SinkFire_q(0);
				
				-- defaults
				SrcFire <= '0';
				SinkFire <= '0';		
						
				-- rising_edge detect
				if (SrcFire_q  = "01") then SrcFire  <= '1'; end if;
				if (SinkFire_q = "01") then SinkFire <= '1';	end if;

   		end if;
   	end if;
   end process;


  	SeqBusy_o 	<= SrcCountEn or SinkCountEn;
	SinkBusy_o  <= SinkCountEn;

	------------------------------------------------------
	-- SOURCE
	------------------------------------------------------

	SrcRAMsel <= RAMselect and (not SrcCountEn);
	SrcRAMwr  <= SrcRAMsel and db_wr;

   SrcRAM_addr_o 	<= ab_i(14 downto 1) when (SrcRAMsel = '1') else SrcCount;
   SrcRAM_data_o 	<= db( 7 downto 0);

   SrcRAM_wr_o 	<= SrcRAMwr;
   SrcRAM_en_o 	<= SrcRAMsel or SrcCountEn;
   

   --------------------------------------------------------


	-- Using async counter control here to speed the system up by a clk,
	-- and have proper stop at max value
	
	SrcCountMax <= '1' when (SrcCount = RegSeqEnd(13 downto 0)) else '0';	
	
	SrcCountEn  <= '0' when ( rst = '1') else
				 	 	'0' when ( SrcReset = '1') else
				 	 	'1' when ( SrcFire = '1') else
						'1' when ((SrcCountMax and SeqCyclicEn) = '1') else
						'0' when ((SrcCountMax and (not SeqCyclicEn)) = '1') else
						 SrcCountEn_q;
						
	SrcCountClr <= '0' when ( rst = '1') else
						'1' when ( SrcReset = '1') else
						'1' when ((SrcCountMax and SeqCyclicEn) = '1') else
						'0';
      
   SrcCounter: process (clk)
   begin
		
		if rising_edge(clk) then	-- rising clock edge
			
			if (rst = '1') then
				SrcCount    <= (others => '0');
	         SrcCountEn_q <= '0';
	
			else
				SrcCountEn_q <= SrcCountEn;
							   
  		      -- SrcCounter -----------------------------------------------
			   if (SrcCountClr = '1') then
			   	SrcCount <= (others => '0');
			   	
			   elsif	(SrcCountEn = '1') then
		   		SrcCount <= SrcCount + '1';
	   		
	         end if;
			end if;
		end if;

	end process;
	

	-- Clock out Src Signals
	-------------------------
	process (rst, clk)
	begin

		if (rst = '1') then
			SeqTRIG_o	<= '0';
			SeqBCR_o		<= '0';
			SeqECR_o 	<= '0';
			SeqCAL_o 	<= '0';
			SeqFER_o 	<= '0';
			SeqSPR_o 	<= '0';
			SeqEXS_o 	<= '0';
			SeqTTS_o 	<= '0';
			
			
		elsif rising_edge(clk) then
			SeqTRIG_o	<= SrcRAM_data_i(0) and enSeqTRIG and SrcCountEn_q;
			SeqECR_o 	<= SrcRAM_data_i(1) and enSeqECR  and SrcCountEn_q;
			SeqBCR_o		<= SrcRAM_data_i(2) and enSeqBCR  and SrcCountEn_q;
			SeqCAL_o 	<= SrcRAM_data_i(3) and enSeqCAL  and SrcCountEn_q;
			SeqEXS_o 	<= SrcRAM_data_i(4) and enSeqEXS  and SrcCountEn_q;
			SeqTTS_o 	<= SrcRAM_data_i(5) and enSeqTTS  and SrcCountEn_q;
			SeqFER_o 	<= SrcRAM_data_i(6) and enSeqFER  and SrcCountEn_q;
			SeqSPR_o 	<= SrcRAM_data_i(7) and enSeqSPR  and SrcCountEn_q;

		end if;

	end process;

	------------------------------------------------------
	-- SINK
	------------------------------------------------------

	allsig_i_bus(0) <= AllL1A_i;
  	allsig_i_bus(1) <= AllECR_i;
   allsig_i_bus(2) <= AllBCR_i;
	allsig_i_bus(3) <= AllCAL_i;
	allsig_i_bus(4) <= AllEXS_i;
	allsig_i_bus(5) <= AllTTS_i;
	allsig_i_bus(6) <= AllFER_i;
	allsig_i_bus(7) <= AllSPR_i;
	
	SinkRAMsel <= RAMselect and (not SinkCountEn);
	SinkRAMwr  <= SinkRAMsel and db_wr;

   SinkRAM_en_o   <= SinkRAMsel or SinkCountEn;
   SinkRAM_wr_o   <= SinkRAMwr or SinkCountEn;

   SinkRAM_addr_o <= ab_i(14 downto 1) when (SinkRAMsel = '1') else 
   						SinkCount;

	SinkRAM_data_o <= db(15 downto 8) when (SinkRAMwr = '1') else 
							allsig_i_bus;

	----------------------------------------------------------

	-- Using async counter control here to speed the system up by a clk,
	-- and have proper stop at max value
	
	SinkCountMax <= '1' when (SinkCount = RegSeqEnd(13 downto 0)) else '0';	
	
	SinkCountEn  <= '0' when ( rst = '1') else
				 	 	'0' when ( SinkReset = '1') else
				 	 	'1' when ( SinkFire = '1') else
						'1' when ((SinkCountMax and SeqCyclicEn) = '1') else
						'0' when ((SinkCountMax and (not SeqCyclicEn)) = '1') else
						 SinkCountEn_q;
						
	SinkCountClr <= '0' when ( rst = '1') else
						'1' when ( SinkReset = '1') else
						'1' when ((SinkCountMax and SeqCyclicEn) = '1') else
						'0';
      
   SinkCounter: process (clk)
   begin
		
		if rising_edge(clk) then	-- rising clock edge
			
			if (rst = '1') then
				SinkCount    <= (others => '0');
	         SinkCountEn_q <= '0';
	
			else
				SinkCountEn_q <= SinkCountEn;
							   
  		      -- SinkCounter -----------------------------------------------
			   if (SinkCountClr = '1') then
			   	SinkCount <= (others => '0');
			   	
			   elsif	(SinkCountEn = '1') then
		   		SinkCount <= SinkCount + '1';
	   		
	         end if;
			end if;
		end if;

	end process;
	
   -------------------------------------------------




   ----------------------------------------------------
   -- Registers
   ----------------------------------------------------


	-- DB Writes --------------------------------
   process (clk)
   begin

      if rising_edge(clk) then
      
			if (rst = '1') then
         	RegSequencer <= (others => '0');
  	         RegSeqEnd <= (others => '0');

			else
	         if (Reg1A = '1') and (db_wr = '1') then
	            RegSequencer <= db;

		      end if;

            if (Reg1C = '1') and (db_wr = '1') then
	            RegSeqEnd <= db;

   	      end if;
		   end if;
      end if;
   end process;

   enSeqTRIG	<= RegSequencer(0);
   enSeqBCR 	<= RegSequencer(2);
   enSeqECR		<= RegSequencer(1);
   enSeqCAL		<= RegSequencer(3);
   enSeqFER		<= RegSequencer(6);
   enSeqSPR		<= RegSequencer(7);
   enSeqEXS		<= RegSequencer(4);
   enSeqTTS		<= RegSequencer(5);


	-- DB Reads  ------------------------------------
	db_read : block 
		signal	ram_db16 		: std_logic_vector(15 downto 0);
		signal	srccount_db16 	: std_logic_vector(15 downto 0);
		signal	sinkcount_db16 : std_logic_vector(15 downto 0);

	begin
	
   	ram_db16( 7 downto 0) <= SrcRAM_data_i;
   	ram_db16(15 downto 8) <= SinkRAM_data_i;   
   	
   	srccount_db16(15 downto 14) <= "00";
   	srccount_db16(13 downto 0)	 <=  SrcCount;
   	sinkcount_db16(15 downto 14) <= "00";
   	sinkcount_db16(13 downto 0)  <= SinkCount;
   	
   	db <= "0001000110001000" when ((db_rd and RAMselect and (SrcCountEn or SinkCountEn)) = '1') else
   			ram_db16 		when ((db_rd and RAMselect) = '1') else
  				RegSequencer 	when ((db_rd and Reg1A)     = '1') else
   			RegSeqEnd    	when ((db_rd and Reg1C)     = '1') else 
   			srccount_db16 	when ((db_rd and Reg46)     = '1') else 
   			sinkcount_db16 when ((db_rd and Reg48)     = '1') else 
   			(others => 'Z');
   end block;

end rtl_test;
