-- hds header_start
--
-- VHDL Entity TIM_lib.clk_rst_mgr.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 16:22:21 09/06/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity clk_rst_mgr is
   generic( 
      RST_DEADTIME  : integer := 255;
      CLKDV_DIVIDER : real    := 2.0
   );
   port( 
      dll_clk_in      : in     std_logic;
      reset1_i        : in     std_logic;
      reset2_i        : in     std_logic;
      reset3_i        : in     std_logic;
      reset4_i        : in     std_logic;
      cfg_rst_o       : out    std_logic;
      clk0            : out    std_logic;
      clk180_nobufg   : out    std_logic;
      clk2x           : out    std_logic;
      clk2x180_nobufg : out    std_logic;
      clkdv_nobufg    : out    std_logic;
      dll_locked_o    : out    std_logic;
      reset_o         : out    std_logic
   );

-- Declarations

end clk_rst_mgr ;


-- hds interface_end

--
-- VHDL Architecture TIM_lib.clk_rst_mgr.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 16:22:22 09/06/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use ieee.vital_timing.all;
library unisim;
use unisim.VPKG.all;
use unisim.VCOMPONENTS.all;
library std;
use std.textio.all;

library TIM_lib;
library unisim;

architecture struct of clk_rst_mgr is

   -- Architecture declarations

   -- Internal signal declarations
   signal ONE         : std_logic;
   signal ZERO        : std_logic;
   signal dll1_locked : std_logic;
   signal dll_reset   : std_logic;
   signal init_pulse  : STD_ULOGIC;
   signal init_q1     : STD_ULOGIC;
   signal init_q2     : STD_ULOGIC;


   -- Component Declarations
   component FDS
   generic (
      INIT : bit := '1'
   );
   port (
      Q : out    std_ulogic ;
      C : in     std_ulogic ;
      D : in     std_ulogic ;
      S : in     std_ulogic 
   );
   end component;
   component clk_mgr
   generic (
      CLKDV_DIVIDER : real := 2.0
   );
   port (
      dll_clk_in      : in     std_logic ;
      rst_in          : in     std_logic ;
      clk0            : out    std_logic ;
      clk180_nobufg   : out    std_logic ;
      clk2x           : out    std_logic ;
      clk2x180_nobufg : out    std_logic ;
      clkdv_nobufg    : out    STD_LOGIC ;
      dll_locked      : out    std_logic 
   );
   end component;
   component m_buff
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;
   component reset_gen
   generic (
      RST_DEADTIME : integer := 255
   );
   port (
      clk_in       : in     std_logic ;
      reset1_i     : in     std_logic ;
      reset2_i     : in     std_logic ;
      reset3_i     : in     std_logic ;
      dll_locked_i : in     std_logic ;
      dll_reset_o  : out    std_logic ;
      reset_o      : out    std_logic ;
      cfg_rst_o    : out    std_logic ;
      init_i       : in     std_logic ;
      reset4_i     : in     std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : FDS use entity unisim.FDS;
   for all : clk_mgr use entity TIM_lib.clk_mgr;
   for all : m_buff use entity TIM_lib.m_buff;
   for all : m_power use entity TIM_lib.m_power;
   for all : reset_gen use entity TIM_lib.reset_gen;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   I0 : FDS
      generic map (
         INIT => '1'
      )
      port map (
         Q => init_q1,
         C => dll_clk_in,
         D => ZERO,
         S => ZERO
      );
   I1 : FDS
      generic map (
         INIT => '1'
      )
      port map (
         Q => init_q2,
         C => dll_clk_in,
         D => init_q1,
         S => ZERO
      );
   I2 : FDS
      generic map (
         INIT => '1'
      )
      port map (
         Q => init_pulse,
         C => dll_clk_in,
         D => init_q2,
         S => ZERO
      );
   clk_mgr_1 : clk_mgr
      generic map (
         CLKDV_DIVIDER => CLKDV_DIVIDER
      )
      port map (
         dll_clk_in      => dll_clk_in,
         rst_in          => dll_reset,
         clk0            => clk0,
         clk180_nobufg   => clk180_nobufg,
         clk2x           => clk2x,
         clk2x180_nobufg => clk2x180_nobufg,
         clkdv_nobufg    => clkdv_nobufg,
         dll_locked      => dll1_locked
      );
   I3 : m_buff
      port map (
         I => dll1_locked,
         O => dll_locked_o
      );
   m_power_1 : m_power
      port map (
         ONE  => ONE,
         ZERO => ZERO
      );
   reset_gen_1 : reset_gen
      generic map (
         RST_DEADTIME => RST_DEADTIME
      )
      port map (
         clk_in       => dll_clk_in,
         reset1_i     => reset1_i,
         reset2_i     => reset2_i,
         reset3_i     => reset3_i,
         dll_locked_i => ONE,
         dll_reset_o  => dll_reset,
         reset_o      => reset_o,
         cfg_rst_o    => cfg_rst_o,
         init_i       => init_pulse,
         reset4_i     => reset4_i
      );

end struct;
