-- hds header_start
--
-- VHDL Architecture CALICE_lib.addr_decoder.rtl2
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:52:36 11/30/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity addr_decoder is
   port( 
      rst        : in     std_logic;
      clk        : in     std_logic;
      enable     : in     std_logic;
      addr       : in     std_logic_vector (15 downto 0);
      ram8000_en : out    std_logic;
      reg0_en    : out    std_logic_vector (63 downto 0);
      f2_sel     : out    std_logic;
      f1_sel     : out    std_logic;
      reg100_en  : out    std_logic_vector (63 downto 0);
      ram1000_en : out    std_logic;
      ab16_o     : out    std_logic_vector (15 downto 0)
   );

-- Declarations

end addr_decoder ;


-- hds interface_end
architecture rtl of addr_decoder is

	signal f1_select 	: std_logic;
	signal f2_select 	: std_logic;
	signal enable_q	: std_logic;

begin

	process (clk, addr)
		variable iaddr : integer range 0 to 16#3F#; 
		
	begin
		  	
  		iaddr := CONV_INTEGER( addr(6 downto 1) ); --16 bit data addressing
  		
  		if rising_edge(clk) then
  		
			enable_q <= enable;

  			if (rst = '1') or (enable = '0') then
				f2_select	<= '0';
				reg0_en 		<= (others => '0');
				ram8000_en 	<= '0';

   	 		f1_select	<= '0';  								
				reg100_en 	<= (others => '0');
 				ram1000_en 	<= '0';
 				
 				ab16_o		<= (others => '0');
 	  		
	    	else

 				-- detects rising edge of enable
	   	 	if (enable_q = '0') and (enable = '1') then
	   	 	
	 				ab16_o		<= addr;
	   	 	
		   	 	-- defaults
		   	 	f2_select	<= '0';
					reg0_en 		<= (others => '0');
					ram8000_en 	<= '0';
	
		   	 	f1_select	<= '0';
					reg100_en 	<= (others => '0');
	 				ram1000_en 	<= '0';
			
					-- reg range 0x0 to 0x0FF
					if (addr(15 downto 8) = "00000000") then
						f2_select 		<= '1';
						reg0_en(iaddr) <= '1';
					end if;
		
			    	-- ram above 0x8000 enable
		  			if (addr(15) = '1') then
			  			f2_select  <= '1';				
		  				ram8000_en <= '1';
		  			end if;
		  			
		  				
					-- reg range 0x100 to 0x1FF
					if (addr(15 downto 8) = "00000001") then
		   	 		f1_select	<= '1';  				
						reg100_en(iaddr) <= '1';
					end if;
		
		  			-- ram 0x1000 to 0x1FFF enable
		  			if (addr(15 downto 12) = "0001") then
		   	 		f1_select	<= '1';  					  			
		  				ram1000_en <= '1';
		  			end if;
				end if;				
    		end if;
		end if;
  	end process;

	f1_sel <= f1_select and (not f2_select); --ensures bus is only driven by one fpga
	f2_sel <= f2_select;


end rtl;
