-- hds header_start
--
-- VHDL Architecture TIM_lib.bus_latch_bidir.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 10:45:09 02/23/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity bus_latch_bidir is
   generic( 
      PD_FACTOR : integer := 0
   );
   port( 
      data_a  : inout  std_logic_vector (31 downto 0);
      data_b  : inout  std_logic_vector (31 downto 0);
      ce_ab_n : in     std_logic;
      le_ab_n : in     std_logic;
      oe_ab_n : in     std_logic;
      ce_ba_n : in     std_logic;
      le_ba_n : in     std_logic;
      oe_ba_n : in     std_logic
   );

-- Declarations

end bus_latch_bidir ;


-- hds interface_end
architecture rtl of bus_latch_bidir is
	
	signal data_a_latched : std_logic_vector(31 downto 0);
	signal data_b_latched : std_logic_vector(31 downto 0);

	signal latch_ab : std_logic;
	signal outen_ab : std_logic;

	signal latch_ba : std_logic;
	signal outen_ba : std_logic;


begin          
	
	latch_ab	<= (not le_ab_n) and (not ce_ab_n); --after (PD_FACTOR * 1 ns);
	outen_ab	<= (not oe_ab_n) and (not ce_ab_n); --after (PD_FACTOR * 1 ns);
	
	latch_ba	<= (not le_ba_n) and (not ce_ba_n); --after (PD_FACTOR * 1 ns);
	outen_ba	<= (not oe_ba_n) and (not ce_ba_n); --after (PD_FACTOR * 1 ns);
   
	
	data_a_latched	<= data_a          when (latch_ab = '1');	                     --after (PD_FACTOR * 1 ns)
	data_a 			<= data_b_latched  when (outen_ba = '1') else (others => 'Z'); --after (PD_FACTOR * 1 ns)
	                                                                                                        
	data_b_latched	<= data_b          when (latch_ba = '1');	                     --after (PD_FACTOR * 1 ns)
	data_b 			<= data_a_latched  when (outen_ab = '1') else (others => 'Z'); --after (PD_FACTOR * 1 ns)


end rtl;
