-- hds header_start
--
-- VHDL Architecture TIM_lib.db_control.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:50:52 02/17/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity db_control is
   generic( 
      PD_FACTOR : integer := 0
   );
   port( 
      clk       : in     std_logic;
      rst       : in     std_logic;
      sel       : in     std_logic;
      vmeRD     : in     std_logic;
      vmeWR     : in     std_logic;
      vmeD32    : in     std_logic;
      dbh_io    : inout  std_logic_vector (15 downto 0);
      dbl_io    : inout  std_logic_vector (15 downto 0);
      vme_db_io : inout  std_logic_vector (31 downto 0);
      db_rd     : out    std_logic;
      db_rd0    : out    std_logic;
      db_d32    : out    std_logic;
      db_wr     : out    std_logic
   );

-- Declarations

end db_control ;


-- hds interface_end
architecture rtl of db_control is

	signal sel_q 			: std_logic;
	signal sel_rising		: std_logic;
	

begin

	db_d32 <= vmeD32; -- *** for now ...

	clock_in : process (clk)
	begin
	
		if rising_edge(clk) then
			if (rst = '1') then
			
				db_rd			<= '0';
				db_wr 		<= '0';
				dbh_io		<= (others => 'Z');
				dbl_io		<= (others => 'Z');
				vme_db_io 	<= (others => 'Z');
				
				sel_q			<= '0';

								
			else
							
				-- defaults
				db_rd <= '0' after 1 ns;
				db_wr <= '0' after 1 ns;
				
				dbh_io		<= (others => 'Z');
				dbl_io		<= (others => 'Z');
				vme_db_io 	<= (others => 'Z') after (PD_FACTOR * 1 ns);
				
				
				sel_q <= sel after 1 ns;
				
				if (sel = '1') then
				
					if (sel_q = '0') then --rising edge of sel
						db_rd <= vmeRD after 1 ns;
						db_wr <= vmeWR after 1 ns;
						
					end if;
				 
					if (vmeRD = '1') then
						vme_db_io(15 downto 0) <= dbl_io after (PD_FACTOR * 1 ns);
						
						if (vmeD32 = '1') then
							vme_db_io(31 downto 16) <= dbh_io after (PD_FACTOR * 1 ns);
						end if;
						
					end if;
				
					if (vmeWR = '1') then
						dbl_io <= vme_db_io(15 downto 0) after 1 ns;
						
						if (vmeD32 = '1') then
							dbh_io <= vme_db_io(31 downto 16) after 1 ns;
						end if;

						
					end if;

				end if;
			end if;
		end if;
	end process;
	
	db_rd0 <= vmeRD and sel and not(sel_q); --Terrible async cludge to get an early db_rd.

end rtl;
