-- hds header_start
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity debug_switch is
   port( 
      debug_bus_o  : out    std_logic;
      dbg0_00      : in     std_logic;
      dbg0_01      : in     std_logic;
      dbg0_02      : in     std_logic;
      dbg0_03      : in     std_logic;
      dbg0_04      : in     std_logic;
      dbg0_05      : in     std_logic;
      dbg0_06      : in     std_logic;
      dbg0_07      : in     std_logic;
      dbg0_08      : in     std_logic;
      dbg0_09      : in     std_logic;
      dbg0_10      : in     std_logic;
      dbg0_11      : in     std_logic;
      dbg0_12      : in     std_logic;
      dbg0_13      : in     std_logic;
      dbg0_14      : in     std_logic;
      dbg0_15      : in     std_logic;
      dbg1         : in     std_logic_vector (15 downto 0);
      dbg2         : in     std_logic_vector (15 downto 0);
      dbg3         : in     std_logic_vector (15 downto 0);
      dbg4         : in     std_logic_vector (15 downto 0);
      dbg5         : in     std_logic_vector (15 downto 0);
      dbg6         : in     std_logic_vector (15 downto 0);
      dbg7         : in     std_logic_vector (15 downto 0);
      dbg8         : in     std_logic_vector (15 downto 0);
      dbg9         : in     std_logic_vector (15 downto 0);
      dbga         : in     std_logic_vector (15 downto 0);
      dbgb         : in     std_logic_vector (15 downto 0);
      dbgc         : in     std_logic_vector (15 downto 0);
      dbgd         : in     std_logic_vector (15 downto 0);
      dbge         : in     std_logic_vector (15 downto 0);
      dbgf         : in     std_logic_vector (15 downto 0);
      debug_mode_i : in     std_logic_vector
   );

-- Declarations

end debug_switch ;


-- hds interface_end
architecture rtl of debug_switch is

	signal dbg0 : std_logic_vector(15 downto 0);
begin

	dbg0 <= (dbg0_15 &
				dbg0_14 &
				dbg0_13 &
				dbg0_12 &
				dbg0_11 &
				dbg0_10 &
				dbg0_09 &
				dbg0_08 &
				dbg0_07 &
				dbg0_06 &
				dbg0_05 &
				dbg0_04 &
				dbg0_03 &
				dbg0_02 &
				dbg0_01 &
				dbg0_00	);
				

	 
	debug_mode_sel : process (debug_mode_i)
	begin
		case debug_mode_i is
      	when "0000" => debug_bus_o <= dbg0;
      	when "0001" => debug_bus_o <= dbg1;
      	when "0010" => debug_bus_o <= dbg2;
      	when "0011" => debug_bus_o <= dbg3;
      	when "0100" => debug_bus_o <= dbg4;
      	when "0101" => debug_bus_o <= dbg5;
      	when "0110" => debug_bus_o <= dbg6;
      	when "0111" => debug_bus_o <= dbg7;
      	when "1000" => debug_bus_o <= dbg8;
      	when "1001" => debug_bus_o <= dbg9;
      	when "1010" => debug_bus_o <= dbga;
      	when "1011" => debug_bus_o <= dbgb;
      	when "1100" => debug_bus_o <= dbgc;
      	when "1101" => debug_bus_o <= dbgd;
      	when "1110" => debug_bus_o <= dbge;
      	when "1111" => debug_bus_o <= dbgf;
			
			when others					=> null;
		end case;
	end process;
end rtl;
