--Virtex CLKDLLE instantiation
-- Customised from the ISE CLKDLL instantiation by Matt

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library unisim;
use unisim.vpkg.all;

entity xilinx_clkdlle is
	generic (
		CLKDV_DIVIDER : real := 2.0
		);
		
	port (
	  	clkin 	: in  std_logic;
		clkfb 	: in  std_logic;	  	
  		rst   	: in  std_logic;
  		clk0  	: out std_logic;
  		clk90  	: out std_logic;
  		clk180  	: out std_logic;
  		clk270  	: out std_logic;
  		clk2x  	: out std_logic;
  		clk2x180	: out std_logic;
  		clkdv  	: out std_logic;
  		locked  	: out std_logic
  	);

-- Declarations

end xilinx_clkdlle ;

-- hds interface_end
architecture rtl of xilinx_clkdlle is
 
	component CLKDLLE
	   generic (
	   --	TimingChecksOn        : boolean          := TRUE;
	   --	InstancePath          : STRING           := "*";
	   --	Xon                   : boolean          := TRUE;
	   --	MsgOn                 : boolean          := FALSE;
	   --	tipd_CLKIN            : VitalDelayType01 := (0.000 ns, 0.000 ns);
	   --	tipd_CLKFB            : VitalDelayType01 := (0.000 ns, 0.000 ns);
	   --	tipd_RST              : VitalDelayType01 := (0.000 ns, 0.000 ns);
	   --	tpd_CLKIN_LOCKED      : VitalDelayType01 := (0.100 ns, 0.100 ns);
	   --	tperiod_CLKIN_POSEDGE : VitalDelayType   := 0.010 ns;
	   --	MAXPERCLKIN           : time             := 1000000 ps;
	   --	tpw_CLKIN_posedge     : VitalDelayType   := 0.010 ns;
	   --	tpw_CLKIN_negedge     : VitalDelayType   := 0.010 ns;
	   --	tpw_RST_posedge       : VitalDelayType   := 0.010 ns;
	   --	FACTORY_JF            : bit_vector       := X"C080";
	   --	STARTUP_WAIT          : boolean          := false;
	   --	DUTY_CYCLE_CORRECTION : boolean          := TRUE;
	   	CLKDV_DIVIDE          : real             := 2.0
	   );
	   port (
	      	CLKIN		: in  std_logic;
	      	CLKFB		: in  std_logic;
	      	RST 		: in  std_logic;
	      	CLK0		: out std_logic; 
	      	CLK90		: out std_logic; 
	      	CLK180	: out std_logic; 
	      	CLK270	: out std_logic; 
	      	CLK2X		: out std_logic; 
	      	CLK2X180	: out std_logic; 
	      	CLKDV		: out std_logic;
	      	LOCKED 	: out std_logic
	      );
	end component;
 
begin

	clkdlle1: CLKDLLE
	   generic map (
      --	TimingChecksOn        => TRUE,
      --	InstancePath          => "*",
      --	Xon                   => TRUE,
      --	MsgOn                 => FALSE,
      --	tipd_CLKIN            => (0.000 ns, 0.000 ns),
      --	tipd_CLKFB            => (0.000 ns, 0.000 ns),
      --	tipd_RST              => (0.000 ns, 0.000 ns),
      --	tpd_CLKIN_LOCKED      => (0.100 ns, 0.100 ns),
      --	tperiod_CLKIN_POSEDGE => 0.010 ns,
      --	MAXPERCLKIN           => 1000000 ps,
      --	tpw_CLKIN_posedge     => 0.010 ns,
      --	tpw_CLKIN_negedge     => 0.010 ns,
      --	tpw_RST_posedge       => 0.010 ns,
      --	FACTORY_JF            => X"C080",
      --	STARTUP_WAIT          => false,
      --	DUTY_CYCLE_CORRECTION => TRUE,
      	CLKDV_DIVIDE          => CLKDV_DIVIDER
      ) 
	
		port map (
			CLKIN		=>	clkin, 
			CLKFB		=>	clkfb, 
			RST		=>	rst, 
	   	CLK0		=>	clk0,
	   	CLK90 	=>	clk90, 
	   	CLK180  	=>	clk180,
	   	CLK270  	=>	clk270,
	   	CLK2X   	=> clk2x, 
	   	CLK2X180 => clk2x180,
	   	CLKDV    => clkdv,  
	   	LOCKED	=>	locked
	   );

end rtl;


